SystemOrganization addCategory: #CMakeVMMakerSqueak!
SystemOrganization addCategory: #'CMakeVMMakerSqueak-Android'!
SystemOrganization addCategory: #'CMakeVMMakerSqueak-BSD32x86'!
SystemOrganization addCategory: #'CMakeVMMakerSqueak-Builder'!
SystemOrganization addCategory: #'CMakeVMMakerSqueak-Help'!
SystemOrganization addCategory: #'CMakeVMMakerSqueak-IA32-Bochs'!
SystemOrganization addCategory: #'CMakeVMMakerSqueak-IOS'!
SystemOrganization addCategory: #'CMakeVMMakerSqueak-IslandOfMisfitToys'!
SystemOrganization addCategory: #'CMakeVMMakerSqueak-Libs'!
SystemOrganization addCategory: #'CMakeVMMakerSqueak-Linux32ARMv6'!
SystemOrganization addCategory: #'CMakeVMMakerSqueak-Linux32x86'!
SystemOrganization addCategory: #'CMakeVMMakerSqueak-LinuxX86-64'!
SystemOrganization addCategory: #'CMakeVMMakerSqueak-Linux64X86-32BitCompatibility'!
SystemOrganization addCategory: #'CMakeVMMakerSqueak-MacOS'!
SystemOrganization addCategory: #'CMakeVMMakerSqueak-MacOSPowerPC'!
SystemOrganization addCategory: #'CMakeVMMakerSqueak-MacOSX32x86'!
SystemOrganization addCategory: #'CMakeVMMakerSqueak-SunOS32x86'!
SystemOrganization addCategory: #'CMakeVMMakerSqueak-Tests'!
SystemOrganization addCategory: #'CMakeVMMakerSqueak-Win32x86'!

Trait named: #TCPlatformConfigForSqueak
	uses: {}
	category: 'CMakeVMMakerSqueak'!

!TCPlatformConfigForSqueak commentStamp: 'tty 6/8/2014 10:47' prior: 0!
A TSqueakCPlatformConfig provides a template of methods which must be customized for Squeak compatibility with  pharo CMakeVMMaker classes. I also act as a repository of paths and directories. 

I exist because tty does not have (and, should not have) permission to modify  to the existing inheritence tree in the pharo CMakeVMMaker categories.


my protocol 'squeak compatibility' are the pharo override methods.
my protocol 'cmake' contains helper methods unique to the squeak implementation of CMakeVMMakerSqueak and do not exist in the pharo stack.






!

!TCPlatformConfigForSqueak classSide methodsFor: 'accessing' stamp: 'tty 5/16/2014 16:03'!
licenseTemplate
	^'Squeak {1} license information
==============================

About Squeak
-----------
Squeak is a modern, open source, full-featured implementation of the powerful Smalltalk programming language and environment. Squeak is highly-portable, running on almost any platform you could name and you can really truly write once run anywhere.  Squeak is the vehicle for a wide range of projects from multimedia applications and educational platforms to commercial web application development.

LIcense
Note: The current release of Squeak is a combination of source code originating from it''s origins at Apple which Apple agreed to license under the Apache license and more recent contributions licensed under the MIT license. The vast majority of the code is under the MIT license.
MIT License

Copyright (c) The individual, corporate, and institutional contributors who have collectively contributed elements to this software ("The Squeak Community"), 1996-2010 All rights reserved.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
Portions of Squeak are covered by the following license:
Apache License, Version 2.0

Copyright (c) Xerox Corp. 1981, 1982 All rights reserved. Copyright (c) Apple Computer, Inc. 1985-1996 All rights reserved.

Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.


About Cog
---------

Cog is a virtual machine designed for Smalltalk and other similar dynamic languages.  Cog builds on the
Squeak virtual machine adding a stack-to-register-mapping just-in-time compiler, aggressive in-line message
cacheing and effective optimization of Smalltalk?s first-class activation records.  Cog is the virtual machine
underlying Teleplace''s Croquet-based enterprise virtual collaboration spaces software, the fastest virtual
machine for Squeak, and for Gilad Bracha''s Newspeak modular language inspired by Beta and Smalltalk.  
Like the original Squeak VM, Cog is implemented and developed in Smalltalk, and translated into a lower-level
language to produce the production VM.  Being a Smalltalk program it is a delight to develop.  Cog is
available under the MIT open source license and is unencumbered for commercial deployment.

Cog''s performance relative to the existing Squeak interpreter varies, depending on the benchmark chosen.
As of early-2011, the Cog JIT uses strong inline cacheing techniques and stack-to-register mapping that
results in a register-based calling convention for low-arity methods.  Due to the complexity of the Squeak
object representation it has a limited set of primitives implemented in machine code that, for example,
exclude object allocation.  Performance of the early-2011 JIT for the nbody, binarytrees and chameneos
redux benchmarks from the computer language shootout is in the range of 4 to 6 times faster than the
interpreter.
'! !

!TCPlatformConfigForSqueak classSide methodsFor: 'accessing' stamp: 'tty 5/16/2014 16:03'!
pluginsTemplate
	^'{4} {1} ships with this plugins already built:
		
Internal: 
=========
{2}

External: 
=========
{3}

'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake configuration' stamp: 'tty 6/8/2014 14:25'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder  default  allBuildConfigurations

	" ^SqueakCMakeVMMakerAbstractBuilder  default  noBuildConfigurations.
	  ^(SqueakCMakeVMMakerAbstractBuilder  default  allBuildConfigurations 
			copyWithoutAll: #( #assertWithHeartbeatTimer #debugWithHeartbeatTimer debugMultiThreadedFFI.....etc))   
	"! !

!TCPlatformConfigForSqueak methodsFor: 'squeak compatibility' stamp: 'tty 6/7/2014 15:51'!
buildDir
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'squeak compatibility' stamp: 'tty 5/16/2014 16:40'!
buildDirName
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake configuration' stamp: 'tty 6/12/2014 14:45'!
buildType: aSymbol	
	"force suclass to implement instance var accessor"
	self required.! !

!TCPlatformConfigForSqueak methodsFor: 'source generation' stamp: 'tty 6/13/2014 11:59'!
cogitClass
	"answer a class for machine code generation or nil"
	^ StackToRegisterMappingCogit 


! !

!TCPlatformConfigForSqueak methodsFor: 'compiler flags' stamp: 'tty 6/13/2014 12:18'!
commonCompilerFlags
	^#()! !

!TCPlatformConfigForSqueak methodsFor: 'compiler flags' stamp: 'tty 6/13/2014 11:12'!
compilerFlags
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/13/2014 11:27'!
compilerFlagsAssert
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/13/2014 11:27'!
compilerFlagsAssertITimerHeartbeat
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/13/2014 09:21'!
compilerFlagsBuild
	"backwards compatability with pharo. If adding, override compilerFlagsRelease in your configuration."
	^self compilerFlagsRelease.! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/13/2014 11:27'!
compilerFlagsDebug
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/13/2014 11:27'!
compilerFlagsDebugITimerHeartbeat
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/13/2014 11:27'!
compilerFlagsIHeartbeatTimer
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/13/2014 11:27'!
compilerFlagsMultiThreaded
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/13/2014 11:28'!
compilerFlagsMultiThreadedAssert
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/13/2014 11:28'!
compilerFlagsMultiThreadedDebug
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/13/2014 09:15'!
compilerFlagsNoBuildType
	self shouldNotImplement.! !

!TCPlatformConfigForSqueak methodsFor: 'headers generation' stamp: 'tty 6/16/2014 17:36'!
configH
"ONLY USED ON UNIX CONFIGS included here for completeness and consistency CogUnixConfig browse.
"
"
Use  configH to tell your plugins where to find its libraries etc.
The version of this is platform dependent.
You may also need to edit your oscogvm/platforms/YOUR PLATFORM/plugins/ThePLuginDirectory/acinclude.m4 file so that it conforms to your system.

tty needed a custom version of this in Linux32x86SqueakCogV3NoGLConfig in order to build the UUIDPlugin.

Go to oscogvm/platforms/YOUR PLATFORM/plugins/ThePLuginDirectory and look at the acinclude.m4 file
you may need to edit that .

NOTE: CPlatformConfig contains a useable version of this that you can modify. 

I reproduce it here, but with double quotes changed to two single quotes so that the commenting will hold.
I provide a <---N.B quotes need changing at each place they have been modified.

Again. it is easier to copy the one in CPlatformConfig.


	^ '
#ifndef __sq_config_h
#define __sq_config_h

/* explicit image width */

#define HAVE_INTERP_H 1

/* package options */

#define USE_X11 1
#define USE_X11_GLX 1
/* #undef       USE_QUARTZ */
/* #undef       USE_QUARTZ_CGL */
/* #undef       USE_RFB */

/* libraries */

/* #undef       HAVE_LIBX11 */
#define HAVE_LIBXEXT 1
#define HAVE_LIBDL 1
/* #undef       HAVE_DYLD */
/* #undef       HAVE_LIBFFI */
/* #undef       HAVE_ICONV */

/* #undef       USE_AUDIO_NONE */
/* #undef       USE_AUDIO_SUN */
/* #undef       USE_AUDIO_NAS */
/* #undef       USE_AUDIO_OSS */
/* #undef       USE_AUDIO_MACOSX */
/* #undef       OSS_DEVICE */

/* header files */

#define HAVE_UNISTD_H 1
/* #undef       NEED_GETHOSTNAME_P */

#define HAVE_DIRENT_H 1
/* #undef       HAVE_SYS_NDIR_H */
/* #undef       HAVE_SYS_DIR_H */
/* #undef       HAVE_NDIR_H */
#define HAVE_DLFCN_H 1
/* #undef       HAVE_ICONV_H */

#define HAVE_SYS_TIME_H 1
#define TIME_WITH_SYS_TIME 1

#define HAVE_SYS_FILIO_H 1

/* #undef       HAVE_SYS_AUDIOIO_H */
/* #undef       HAVE_SUN_AUDIOIO_H */

/* #undef       HAVE_PTY_H */
/* #undef       HAVE_UTIL_H */
#define HAVE_LIBUTIL_H 1
/* #undef       HAVE_STROPTS_H */

#define HAVE_GL_GL_H 1
/* #undef       HAVE_OPENGL_GL_H */

/* #undef       NEED_SUNOS_H */


#define HAVE_UUID_H
/* system calls/library functions */

#define AT_EXIT atexit

#define HAVE_TZSET 1

#define HAVE_OPENPTY 1
/* #undef       HAVE_UNIX98_PTYS */

#define HAVE_SNPRINTF 1
/* #undef       HAVE___SNPRINTF */

#define HAVE_MMAP 1

/* #undef       HAVE_DYLD */

#define HAVE_LANGINFO_CODESET 1

#define HAVE_ALLOCA 1
/* #undef       HAVE_ALLOCA_H */

#define HAVE_UNSETENV 1

#define HAVE_NANOSLEEP 1

/* widths of primitive types */

#define SIZEOF_INT 4
#define SIZEOF_LONG 4
#define SIZEOF_LONG_LONG 8
#define SIZEOF_VOID_P 4

/* structures */

#define HAVE_TM_GMTOFF 1
#define HAVE_TIMEZONE 1

/* typedefs */

/* #undef       size_t */
/* #undef       socklen_t */

#define squeakInt64 long long

/* architecture */

#define OS_TYPE ''unix''    <---N.B quotes need changing at each place they have been modifying.

#define VM_HOST ''i386-freebsd8.2''    <---N.B quotes need changing at each place they have been modifying.
#define VM_HOST_CPU ''i386''    <---N.B quotes need changing at each place they have been modifying.
/* #undef       VM_HOST_VENDOR */
#define VM_HOST_OS ''freebsd8.2''   <---N.B quotes need changing at each place they have been modifying.
#define VM_BUILD_STRING ''Unix built on ''__DATE__ '' ''__TIME__'' Compiler: ''__VERSION__          <---N.B quotes need changing at each place they have been modifying.

/* #undef       WORDS_BIGENDIAN */
/* #undef       DOUBLE_WORD_ALIGNMENT */

/* damage containment */

/* #undef       DARWIN */

#ifdef NEED_SUNOS_H
# include ''sunos.h''    <---N.B quotes need changing at each place they have been modifying.
#endif

/* other configured variables */

#define SQ_VERSION ''3.9a-7024''    <---N.B quotes need changing at each place they have been modifying.
#define VM_VERSION ''3.9-7''    <---N.B quotes need changing at each place they have been modifying.
#define VM_MODULE_PREFIX ''    <---N.B quotes need changing at each place they have been modifying.
/* #undef VM_DLSYM_PREFIX */    
#define VM_X11DIR '/usr/X11R6/lib'    <---N.B quotes need changing at each place they have been modifying.

/* avoid dependencies on glibc2.3 */

/* #undef HAVE_FEATURES_H */

#if defined(HAVE_FEATURES_H)
# include ''glibc.h''    <---N.B quotes need changing at each place they have been modifying.
#endif

#endif /* __sq_config_h */
																																																																					
																																																																				'
"! !

!TCPlatformConfigForSqueak methodsFor: 'headers generation' stamp: 'tty 6/16/2014 15:58'!
configHBuild
	"convenience method to customize configH for this buildType. default is self configH"
	^self configH
! !

!TCPlatformConfigForSqueak methodsFor: 'headers generation' stamp: 'tty 6/16/2014 15:59'!
configHBuildAssert
	"convenience method to customize configH for this buildType. default is self configH"
	^self configH
! !

!TCPlatformConfigForSqueak methodsFor: 'headers generation' stamp: 'tty 6/16/2014 15:59'!
configHBuildAssertITimerHeartbeat
	"convenience method to customize configH for this buildType. default is self configH"
	^self configH
! !

!TCPlatformConfigForSqueak methodsFor: 'headers generation' stamp: 'tty 6/16/2014 16:00'!
configHBuildDebug
	"convenience method to customize configH for this buildType. default is self configH"
	^self configH
! !

!TCPlatformConfigForSqueak methodsFor: 'headers generation' stamp: 'tty 6/16/2014 16:01'!
configHBuildDebugITimerHeartbeat
	"convenience method to customize configH for this buildType. default is self configH"
	^self configH
! !

!TCPlatformConfigForSqueak methodsFor: 'headers generation' stamp: 'tty 6/16/2014 16:02'!
configHBuildITimerHeartbeat
	"convenience method to customize configH for this buildType. default is self configH"
	^self configH
! !

!TCPlatformConfigForSqueak methodsFor: 'headers generation' stamp: 'tty 6/16/2014 16:05'!
configHBuildMultiThreaded
	"convenience method to customize configH for this buildType. default is self configH"
	^self configH
! !

!TCPlatformConfigForSqueak methodsFor: 'headers generation' stamp: 'tty 6/16/2014 16:06'!
configHBuildMultiThreadedAssert
	"convenience method to customize configH for this buildType. default is self configH"
	^self configH
! !

!TCPlatformConfigForSqueak methodsFor: 'headers generation' stamp: 'tty 6/16/2014 16:07'!
configHBuildMultiThreadedDebug
	"convenience method to customize configH for this buildType. default is self configH"
	^self configH
! !

!TCPlatformConfigForSqueak methodsFor: 'headers generation' stamp: 'tty 6/16/2014 17:52'!
configHNoBuildType
	"SHOULD NOT GET HERE"	
	self halt.! !

!TCPlatformConfigForSqueak methodsFor: 'cmake configuration' stamp: 'tty 6/16/2014 21:00'!
configureBuild
	"configure this Configuration for a buildType #build"
	self 
		preferredIncludesBuild;
		standardIncludesBuild;
		compilerFlagsBuild;
		internalPluginsBuild;
		externalPluginsBuild;
		thirdpartyLibsBuild
		


		
		
		! !

!TCPlatformConfigForSqueak methodsFor: 'cmake configuration' stamp: 'tty 6/12/2014 16:21'!
configureBuildAssert
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake configuration' stamp: 'tty 6/12/2014 16:22'!
configureBuildAssertITimerHeartbeat
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake configuration' stamp: 'tty 6/12/2014 16:40'!
configureBuildDebug
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake configuration' stamp: 'tty 6/12/2014 16:41'!
configureBuildDebugITimerHeartbeat
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake configuration' stamp: 'tty 6/12/2014 16:41'!
configureBuildDebugMultiThreaded
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake configuration' stamp: 'tty 6/12/2014 16:24'!
configureBuildIHeartbeatTimer
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake configuration' stamp: 'tty 6/12/2014 16:25'!
configureBuildMultiThreaded
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake configuration' stamp: 'tty 6/12/2014 16:25'!
configureBuildMultiThreadedAssert
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake configuration' stamp: 'tty 6/12/2014 16:26'!
configureBuildMultiThreadedDebug
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake configuration' stamp: 'tty 6/16/2014 20:17'!
configureForBuildType: aSymbol
	| d |
	"provide a concrete builder with the buildType and configureBuildX method to invoke"
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	self configureNoBuildType.                "reset all internal flags"
	d 
		at: #build 
		put: [self buildType:#build.  self configureBuild];

		at: #buildAssert 
		put: [self buildType: #buildAssert.  	self configureBuildAssert];

		at: #buildAssertITimerHeartbeat 
		put:     [ self buildType: #buildAssertITimerHeartbeat.   self configureBuildAssertITimerHeartbeat];

            at:#buildDebug 
		put: [self buildType: #buildDebug.  self configureBuildDebug];

		at: #buildDebugITimerHeartbeat 
		put:  [self buildType: #buildDebugITimerHeartbeat.   self configureBuildDebugITimerHeartbeat];

		at: #buildITimerHeartbeat 
		put: [self buildType:#buildITimerHeartbeat.    self configureBuildIHeartbeatTimer];

		at: #buildMultiThreaded 
		put:  [self buildType:#buildMultiThreaded . self configureBuildMultiThreaded];

		at: #buildMultiThreadedAssert 
		put: [self buildType: #buildMultiThreadedAssert. self configureBuildMultiThreadedAssert];

		at: #buildMultiThreadedDebug  
		put: [self buildType: #buildMultiThreadedDebug. self configureBuildMultiThreadedDebug].

     ^(d at: aSymbol).! !

!TCPlatformConfigForSqueak methodsFor: 'cmake configuration' stamp: 'tty 6/12/2014 16:33'!
configureNoBuildType
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/12/2014 13:08'!
dirARMv6
	^'cmake.build.arm.v6'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/8/2014 12:28'!
dirAndroid
	^'Do Not Build. See Class Comment'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/12/2014 12:16'!
dirBSD32x86
	^'cmake.build.bsd32x86'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/12/2014 15:59'!
dirBuild
	^SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo at: #build! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/12/2014 16:09'!
dirBuildAssert
	^SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo at: #buildAssert! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/12/2014 16:09'!
dirBuildAssertITimerHeartbeat
	^SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo at: #buildAssertITimerHeartbeat! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/12/2014 16:36'!
dirBuildDebug
	^SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo at: #debug! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/12/2014 16:37'!
dirBuildDebugITimerHeartbeat
	^SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo at: #debugITimerHeartbeat! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/12/2014 16:37'!
dirBuildDebugMultiThreaded
	^SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo at: #debugMultiThreaded! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/12/2014 16:11'!
dirBuildITimerHeartbeat
	^SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo at: #buildITimerHeartbeat! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/7/2014 16:23'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/12/2014 16:12'!
dirBuildMultiThreaded
	^SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo at: #buildMultiThreaded! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/12/2014 16:12'!
dirBuildMultiThreadedAssert
	^SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo at: #buildMultiThreadedAssert! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/12/2014 16:12'!
dirBuildMultiThreadedDebug
	^SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo at: #buildMultiThreadedDebug! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/7/2014 15:52'!
dirBuildPlatform
	"the directory for the platform. example: build.linux32x86"
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'squeak compatibility' stamp: 'tty 5/16/2014 16:17'!
dirFrom: aStringOrDir
	^ aStringOrDir isString
		ifTrue: [ FileDirectory forFileName: aStringOrDir  ]
		ifFalse: [ aStringOrDir ]! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/12/2014 12:16'!
dirIA32Bochs
	^'cmake.build.ia32bochs'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/12/2014 12:16'!
dirIOS
	^'cmake.build.ios'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/14/2014 15:40'!
dirInstall
	"the directory of the finished product.. the place where 'make install' puts stuff.
	SystemNavigation default browseMethodsWhoseNamesContain: 'outputDir'
      "
self required.
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/12/2014 12:16'!
dirLinux32Armv6
	^'cmake.build.linux32armv6'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/12/2014 12:16'!
dirLinux32x86
	^'cmake.build.linux32x86'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/12/2014 13:04'!
dirLinux32x8664
	^'cmake.build.linux32_64x86'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/12/2014 12:17'!
dirMacOS
	^'cmake.build.macos'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/12/2014 12:17'!
dirMacOSPowerPC
	^'cmake.build.macospowerpc'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/12/2014 12:17'!
dirMacOSX32x86
	^'cmake.build.macosx32x86'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/12/2014 12:17'!
dirOutput
	^'cmake.products'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/7/2014 17:57'!
dirSource
	^'src'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/12/2014 12:17'!
dirSunOS32x86
	^'cmake.build.sunos32x86'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/12/2014 13:04'!
dirWin32x86
	^'cmake.build.win32x86'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake executable names' stamp: 'tty 6/10/2014 10:59'!
eventStackV3
	"needed by Android config to pass internal tests. Android config is not built"
	^'do not build'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake configuration' stamp: 'tty 6/9/2014 17:01'!
excludeFromBuild
"	^false"   "build this configuration"
"	^true"   "do not build this configuration"
	self required
! !

!TCPlatformConfigForSqueak methodsFor: 'accessing' stamp: 'tty 6/13/2014 12:33'!
executableName
	self required.

"browse subclasses of CPLatformConfig for context
^'CogVM'
^ 'CogMTVM'
^ 'EventVM'.
^'iStackVMSimulator'
^ 'iStackVM'
^'Squeak'
^ 'StackVM'



"! !

!TCPlatformConfigForSqueak methodsFor: 'accessing' stamp: 'tty 6/13/2014 17:11'!
executableType
	self required.

"
SystemNavigation default browseMethodsWhoseNamesContain: ''executableType''
	^ 'MACOSX_BUNDLE'
	^ 'WIN32'\
	^ ''
"! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:27'!
externalPluginsBuild 
	"convenience method to customize plugins for this build.  default is self  externalPluins"
	^self externalPlugins
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:27'!
externalPluginsBuildAssert 
	"convenience method to customize plugins for this build.  default is self  externalPluins"
	^self externalPlugins
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:28'!
externalPluginsBuildAssertITimerHeartbeat 
	"convenience method to customize plugins for this build.  default is self  externalPluins"
	^self externalPlugins
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:29'!
externalPluginsBuildDebug 
	"convenience method to customize plugins for this build.  default is self  externalPluins"
	^self externalPlugins
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:29'!
externalPluginsBuildDebugITimerHeartbeat 
	"convenience method to customize plugins for this build.  default is self  externalPluins"
	^self externalPlugins
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:29'!
externalPluginsBuildITimerHeartbeat 
	"convenience method to customize plugins for this build.  default is self  externalPluins"
	^self externalPlugins
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:30'!
externalPluginsBuildMultiThreaded 
	"convenience method to customize plugins for this build.  default is self  externalPluins"
	^self externalPlugins
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:30'!
externalPluginsBuildMultiThreadedAssert
	"convenience method to customize plugins for this build.  default is self  externalPluins"
	^self externalPlugins
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:30'!
externalPluginsBuildMultiThreadedDebug 
	"convenience method to customize plugins for this build.  default is self  externalPluins"
	^self externalPlugins
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:30'!
externalPluginsBuildNone
	"convenience method to customize plugins for this build.  default is self  externalPluins"
	^self externalPlugins
! !

!TCPlatformConfigForSqueak methodsFor: 'plugin extra rules' stamp: 'tty 6/13/2014 12:49'!
extraPluginSettings: maker
	super extraPluginSettings: maker.  
"	This is a very active method depending on Platform 

	CPlatformConfig browse.
	
"! !

!TCPlatformConfigForSqueak methodsFor: 'settings' stamp: 'tty 6/14/2014 12:17'!
extraVMSettings: maker
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 10:56'!
extraVMSettingsBuild 
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 10:57'!
extraVMSettingsBuildAssert 
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 10:58'!
extraVMSettingsBuildAssertITimerHeartbeat 
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 10:58'!
extraVMSettingsBuildDebug 
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 10:58'!
extraVMSettingsBuildDebugITimerHeartbeat 
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 10:59'!
extraVMSettingsBuildITimerHeartbeat 
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 10:59'!
extraVMSettingsBuildMultiThreaded 
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 10:59'!
extraVMSettingsBuildMultiThreadedAssert
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:00'!
extraVMSettingsBuildMultiThreadedDebug 
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:00'!
extraVMSettingsBuildNone 
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'accessing' stamp: 'tty 6/13/2014 17:11'!
frameworks
	"leave empty for all platforms but Mac OS"
	^ #()! !

!TCPlatformConfigForSqueak methodsFor: 'accessing' stamp: 'tty 6/13/2014 12:42'!
generate
	self generatePluginsList. 
	self generateLicense. 
	^ CMakeVMGeneratorForSqueak generate: self ! !

!TCPlatformConfigForSqueak methodsFor: 'headers generation' stamp: 'tty 6/16/2014 17:58'!
generateConfigH
	"	
	used to be: 	
		self write: self configH toFile: 'config.h'
      but with variable buildTypes we need:
		self write: (generateConfigH: (self buildType))toFile: 'config.h'   
      However, I cannot use an instanceVariable in a Trait. so must implement in concrete class
"
	self required.

! !

!TCPlatformConfigForSqueak methodsFor: 'headers generation' stamp: 'tty 6/16/2014 20:18'!
generateConfigH: aBuildType
	"self write: self configH toFile: 'config.h'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self configHBuild];
		at: #buildAssert  put: [self configHBuildAssert];
		at: #buildAssertITimerHeartbeat  put: [self configHBuildAssertITimerHeartbeat];
            at:#buildDebug  put: [self configHBuildDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self configHBuildDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self configHBuildITimerHeartbeat];
		at: #buildMultiThreaded  put: [self configHBuildMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self configHBuildMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self configHBuildMultiThreadedDebug ];
		at: #buildNone put:[self configHNoBuildType].


	 ^(d at: ( aBuildType)) value



! !

!TCPlatformConfigForSqueak methodsFor: 'accessing' stamp: 'tty 6/13/2014 12:43'!
generateLicense 
	self 
		write:  (self class licenseTemplate 
			format: { self version })
		toFile: 'LICENSE.txt'
	! !

!TCPlatformConfigForSqueak methodsFor: 'accessing' stamp: 'tty 6/13/2014 12:43'!
generatePluginsList 
	self 
		write:  (self class pluginsTemplate 
			format: {
				self version. 
				String streamContents: [ :stream | self internalPlugins asStringOn: stream delimiter: String cr ].
				String streamContents: [ :stream | self externalPlugins asStringOn: stream delimiter: String cr ].
				self executableName })
		toFile: 'PLUGINS.txt'
	! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:21'!
internalPluginsBuild 
	"convenience method to customize plugins for this build default to internalPluins"
	^self internalPlugins
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:21'!
internalPluginsBuildAssert 
	"convenience method to customize plugins for this build default to internalPluins"
	^self internalPlugins
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:22'!
internalPluginsBuildAssertITimerHeartbeat 
	"convenience method to customize plugins for this build default to internalPluins"
	^self internalPlugins
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:23'!
internalPluginsBuildDebug 
	"convenience method to customize plugins for this build.  default is self  internalPluins"
	^self internalPlugins
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:23'!
internalPluginsBuildDebugITimerHeartbeat 
	"convenience method to customize plugins for this build.  default is self  internalPluins"
	^self internalPlugins
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:23'!
internalPluginsBuildITimerHeartbeat 
	"convenience method to customize plugins for this build.  default is self  internalPluins"
	^self internalPlugins
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:24'!
internalPluginsBuildMultiThreaded 
	"convenience method to customize plugins for this build.  default is self  internalPluins"
	^self internalPlugins
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:25'!
internalPluginsBuildMultiThreadedAssert
	"convenience method to customize plugins for this build.  default is self  internalPluins"
	^self internalPlugins
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:25'!
internalPluginsBuildMultiThreadedDebug 
	"convenience method to customize plugins for this build.  default is self  internalPluins"
	^self internalPlugins
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:25'!
internalPluginsBuildNone
	"convenience method to customize plugins for this build.  default is self  internalPluins"
	^self internalPlugins
! !

!TCPlatformConfigForSqueak methodsFor: 'source generation' stamp: 'tty 6/13/2014 12:02'!
interpreterClass
	self required.
	"
	^ CoInterpreter
	^ CoInterpreterMT
	^ StackInterpreter
	^ StackEvtAndroidInterpreter
	??other
	"! !

!TCPlatformConfigForSqueak methodsFor: 'accessing' stamp: 'tty 6/13/2014 12:44'!
linkFlags
	self required

"example:
	^ super linkFlags , ' -m32'
"! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/7/2014 16:08'!
newspeakCogSpur
	^'newspeak.cog.spur'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/7/2014 16:08'!
newspeakCogV3
	^'newspeak.cog.v3'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/7/2014 16:11'!
newspeakSistaSpur
	^'newspeak.sista.Spur'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/7/2014 16:11'!
newspeakSistaV3
	^'newspeak.sista.v3'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/7/2014 16:12'!
newspeakStackSpur
	^'newspeak.stack.spur'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/7/2014 16:12'!
newspeakStackV3
	^'newspeak.stack.v3'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/7/2014 16:38'!
oscogvm
	^'oscogvm'! !

!TCPlatformConfigForSqueak methodsFor: 'squeak compatibility' stamp: 'tty 5/16/2014 17:22'!
outputDir
	self required

! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/14/2014 15:24'!
outputDirName
	^ 'products'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 12:12'!
postBuildActionsBuild: aMaker
	"convenience method for this buildType. default is self postBuildActions"
	^self postBuildActions:aMaker
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 12:13'!
postBuildActionsBuildAssert: aMaker
	"convenience method for this buildType. default is self postBuildActions"
	^self postBuildActions:aMaker
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 12:13'!
postBuildActionsBuildAssertITimerHeartbeat: aMaker
	"convenience method for this buildType. default is self postBuildActions"
	^self postBuildActions:aMaker
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 12:14'!
postBuildActionsBuildDebug: aMaker
	"convenience method for this buildType. default is self postBuildActions: aMaker"
	^self postBuildActions:aMaker
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 12:14'!
postBuildActionsBuildDebugITimerHeartbeat: aMaker
	"convenience method for this buildType. default is self postBuildActions: aMaker"
	^self postBuildActions:aMaker
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 12:15'!
postBuildActionsBuildITimerHeartbeat: aMaker
	"convenience method for this buildType. default is self postBuildActions: aMaker"
	^self postBuildActions:aMaker
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 12:15'!
postBuildActionsBuildMultiThreaded: aMaker
	"convenience method for this buildType. default is self postBuildActions: aMaker"
	^self postBuildActions:aMaker
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 12:15'!
postBuildActionsBuildMultiThreadedAssert: aMaker
	"convenience method for this buildType. default is self postBuildActions: aMaker"
	^self postBuildActions:aMaker
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 12:16'!
postBuildActionsBuildMultiThreadedDebug: aMaker 
	"convenience method for this buildType. default is self postBuildActions: aMaker"
	^self postBuildActions:aMaker
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 12:16'!
postBuildActionsBuildNone: aMaker
	"convenience method for this buildType. default is self postBuildActions: aMaker"
	^self postBuildActions:aMaker
! !

!TCPlatformConfigForSqueak methodsFor: 'source files' stamp: 'tty 6/14/2014 18:20'!
preferredIncludes
	self required

"
	^#()

SystemNavigation default browseMethodsWhoseNamesContain: 'preferredIncludes'"
	! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 17:16'!
preferredIncludesBuild	
	"convencience method to customize for this build. default is self preferredIncludes"
	^self preferredIncludes

! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 17:16'!
preferredIncludesBuildAssert
	"convencience method to customize for this build. default is self preferredIncludes"
	^self preferredIncludes
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 17:16'!
preferredIncludesBuildAssertITimerHeartbeat
	"convencience method to customize for this build. default is self preferredIncludes"
	^self preferredIncludes
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 17:17'!
preferredIncludesBuildDebug
	"convencience method to customize for this build. default is self preferredIncludes"
	^self preferredIncludes
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 17:17'!
preferredIncludesBuildDebugITimerHeartbeat
	"convencience method to customize for this build. default is self preferredIncludes"
	^self preferredIncludes
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 17:17'!
preferredIncludesBuildITimerHeartbeat
	"convencience method to customize for this build. default is self preferredIncludes"
	^self preferredIncludes
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 17:17'!
preferredIncludesBuildMultiThreaded
	"convencience method to customize for this build. default is self preferredIncludes"
	^self preferredIncludes
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 17:17'!
preferredIncludesBuildMultiThreadedAssert
	"convencience method to customize for this build. default is self preferredIncludes"
	^self preferredIncludes
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 17:17'!
preferredIncludesBuildMultiThreadedDebug
	"convencience method to customize for this build. default is self preferredIncludes"
	^self preferredIncludes
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 17:18'!
preferredIncludesBuildNone
	"SHOULD NOT GET HERE"
	self halt
! !

!TCPlatformConfigForSqueak methodsFor: 'source generation' stamp: 'tty 6/13/2014 12:13'!
prepareForGeneration
	self required

	"^self prepareForCogGeneration
	  ^self prepareForStackVMGeneration
		
	  CPlatformConfig browse"
! !

!TCPlatformConfigForSqueak methodsFor: 'utils' stamp: 'tty 6/13/2014 13:10'!
setExtraTargetProperties: maker
	"override me if needed. Super call is to CPlatformConfig which does nothing"
	super setExtraTargetProperties: maker.
"
SystemNavigation default browseMethodsWhoseNamesContain: 'setExtraTargetProperties:' 

"! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:57'!
setExtraTargetPropertiesBuild: aMaker
	"convenience method for this buildType. default is self setExtraTargetProperties"
	^self setExtraTargetProperties
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:58'!
setExtraTargetPropertiesBuildAssert: aMaker 
	"convenience method for this buildType. default is self setExtraTargetProperties"
	^self setExtraTargetProperties
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:58'!
setExtraTargetPropertiesBuildAssertITimerHeartbeat: aMaker
	"convenience method for this buildType. default is self setExtraTargetProperties"
	^self setExtraTargetProperties
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:58'!
setExtraTargetPropertiesBuildDebug: aMaker
	"convenience method for this buildType. default is self setExtraTargetProperties"
	^self setExtraTargetProperties
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:59'!
setExtraTargetPropertiesBuildDebugITimerHeartbeat: aMaker
	"convenience method for this buildType. default is self setExtraTargetProperties"
	^self setExtraTargetProperties
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:59'!
setExtraTargetPropertiesBuildITimerHeartbeat: aMaker
	"convenience method for this buildType. default is self setExtraTargetProperties"
	^self setExtraTargetProperties
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:59'!
setExtraTargetPropertiesBuildMultiThreaded: aMaker
	"convenience method for this buildType. default is self setExtraTargetProperties"
	^self setExtraTargetProperties
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 12:00'!
setExtraTargetPropertiesBuildMultiThreadedAssert: aMaker
	"convenience method for this buildType. default is self setExtraTargetProperties"
	^self setExtraTargetProperties
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 12:00'!
setExtraTargetPropertiesBuildMultiThreadedDebug: aMaker
	"convenience method for this buildType. default is self setExtraTargetProperties"
	^self setExtraTargetProperties
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 12:00'!
setExtraTargetPropertiesBuildNone: aMaker
	"convenience method for this buildType. default is self setExtraTargetProperties"
	^self setExtraTargetProperties
! !

!TCPlatformConfigForSqueak methodsFor: 'utils' stamp: 'tty 6/16/2014 19:04'!
setGlobalOptions: maker
	"SystemNavigation default browseMethodsWhoseNamesContain: 'setGlobalOptions:'
	
	we subclass this in our concrete builder and route it to 
	
	^self setGlobalOptions: aMaker buildType: (self buildType asSymbol)

	"
	self required
	
! !

!TCPlatformConfigForSqueak methodsFor: 'utils' stamp: 'tty 6/16/2014 20:00'!
setGlobalOptions: aMaker buildType: aBuildType
	"invoke correct setGlobalOptions for this buildType to allow per-buildType customization'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self setGlobalOptionsBuild: aMaker];
		at: #buildAssert  put: [self setGlobalOptionsBuildAssert: aMaker];
		at: #buildAssertITimerHeartbeat  put: [self setGlobalOptionsBuildAssertITimerHeartbeat: aMaker];
            at:#buildDebug  put: [self setGlobalOptionsBuildDebug: aMaker];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self setGlobalOptionsBuildDebugITimerHeartbeat: aMaker ];
		at: #buildITimerHeartbeat  put: [self setGlobalOptionsBuildITimerHeartbeat: aMaker];
		at: #buildMultiThreaded  put: [self setGlobalOptionsBuildMultiThreaded: aMaker ];
		at: #buildMultiThreadedAssert  put: [self setGlobalOptionsBuildMultiThreadedAssert: aMaker];
		at: #buildMultiThreadedDebug   put: [self setGlobalOptionsBuildMultiThreadedDebug: aMaker ];
		at: #buildNone put:[self setGlobalOptionsBuildNone: aMaker].

	 ^(d at: ( aBuildType)) value
! !

!TCPlatformConfigForSqueak methodsFor: 'utils' stamp: 'tty 6/16/2014 20:18'!
setGlobalOptionsAfterDetermineSystem: aMaker buildType: aBuildType
	"invoke correct setGlobalOptions for this buildType to allow per-buildType customization'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self setGlobalOptionsAfterDetermineSystemBuild: aMaker];
		at: #buildAssert  put: [self setGlobalOptionsAfterDetermineSystemBuildAssert: aMaker];
		at: #buildAssertITimerHeartbeat  put: [self setGlobalOptionsAfterDetermineSystemBuildAssertITimerHeartbeat: aMaker];
            at:#buildDebug  put: [self setGlobalOptionsAfterDetermineSystemBuildDebug: aMaker];   
		at: #buildITimerHeartbeat  put: [self setGlobalOptionsAfterDetermineSystemBuildITimerHeartbeat: aMaker];
		at: #buildMultiThreaded  put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreaded: aMaker ];
		at: #buildMultiThreadedAssert  put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreadedAssert: aMaker];
		at: #buildMultiThreadedDebug   put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreadedDebug: aMaker ];
		at: #buildNone put:[self setGlobalOptionsBuildNone: aMaker].

	 ^(d at: ( aBuildType)) value
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 19:49'!
setGlobalOptionsAfterDetermineSystemBuild: aMaker
	"convenience method to customize setGlobalOptionsAfterDetermineSystemBuild: aMaker for this build type. 

	Default is in CPlatformConfig>AfterDetermineSystemBuild aMaker setGlobalOptions: aMaker"
	^super setGlobalOptions: aMaker 
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 19:50'!
setGlobalOptionsAfterDetermineSystemBuildAssert: aMaker
	"convenience method to customize setGlobalOptionsAfterDetermineSystemBuild: aMaker for this build type. 

	Default is in CPlatformConfig>AfterDetermineSystemBuild aMaker setGlobalOptions: aMaker"
	^super setGlobalOptions: aMaker 
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 19:50'!
setGlobalOptionsAfterDetermineSystemBuildAssertITimerHeartbeat: aMaker
	"convenience method to customize setGlobalOptionsAfterDetermineSystemBuild: aMaker for this build type. 

	Default is in CPlatformConfig>AfterDetermineSystemBuild aMaker setGlobalOptions: aMaker"
	^super setGlobalOptions: aMaker 
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 19:50'!
setGlobalOptionsAfterDetermineSystemBuildDebug: aMaker
	"convenience method to customize setGlobalOptionsAfterDetermineSystemBuild: aMaker for this build type. 

	Default is in CPlatformConfig>AfterDetermineSystemBuild aMaker setGlobalOptions: aMaker"
	^super setGlobalOptions: aMaker 
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 19:51'!
setGlobalOptionsAfterDetermineSystemBuildDebugITimerHeartbeat: aMaker
	"convenience method to customize setGlobalOptionsAfterDetermineSystemBuild: aMaker for this build type. 

	Default is in CPlatformConfig>AfterDetermineSystemBuild aMaker setGlobalOptions: aMaker"
	^super setGlobalOptions: aMaker 
 
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 19:51'!
setGlobalOptionsAfterDetermineSystemBuildITimerHeartbeat: aMaker
	"convenience method to customize setGlobalOptionsAfterDetermineSystemBuild: aMaker for this build type. 

	Default is in CPlatformConfig>AfterDetermineSystemBuild aMaker setGlobalOptions: aMaker"
	^super setGlobalOptions: aMaker 
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 19:51'!
setGlobalOptionsAfterDetermineSystemBuildMultiThreaded: aMaker
	"convenience method to customize setGlobalOptionsAfterDetermineSystemBuild: aMaker for this build type. 

	Default is in CPlatformConfig>AfterDetermineSystemBuild aMaker setGlobalOptions: aMaker"
	^super setGlobalOptions: aMaker 

! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 19:51'!
setGlobalOptionsAfterDetermineSystemBuildMultiThreadedAssert: aMaker
	"convenience method to customize setGlobalOptionsAfterDetermineSystemBuild: aMaker for this build type. 

	Default is in CPlatformConfig>AfterDetermineSystemBuild aMaker setGlobalOptions: aMaker"
	^super setGlobalOptions: aMaker 

! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 19:52'!
setGlobalOptionsAfterDetermineSystemBuildMultiThreadedDebug: aMaker
	"convenience method to customize setGlobalOptionsAfterDetermineSystemBuild: aMaker for this build type. 

	Default is in CPlatformConfig>AfterDetermineSystemBuild aMaker setGlobalOptions: aMaker"
	^super setGlobalOptions: aMaker 

! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 10:15'!
setGlobalOptionsAfterDetermineSystemBuildNone
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 10:06'!
setGlobalOptionsBuild: aMaker
	self required.! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 10:06'!
setGlobalOptionsBuildAssert: aMaker
	self required.! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 10:07'!
setGlobalOptionsBuildAssertITimerHeartbeat: aMaker
	self required.! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 10:08'!
setGlobalOptionsBuildDebug: aMaker
	self required.! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 10:08'!
setGlobalOptionsBuildDebugITimerHeartbeat: aMaker
	self required.! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 10:08'!
setGlobalOptionsBuildITimerHeartbeat: aMaker
	self required.! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 10:09'!
setGlobalOptionsBuildMultiThreaded: aMaker
	self required.! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 10:09'!
setGlobalOptionsBuildMultiThreadedAssert: aMaker
	self required.! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 10:09'!
setGlobalOptionsBuildMultiThreadedDebug: aMaker
	self required.! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 19:22'!
setGlobalOptionsBuildNone: aMaker
	"SHOULD NOT HAPPEN"
	self halt.! !

!TCPlatformConfigForSqueak methodsFor: 'squeak compatibility' stamp: 'tty 5/16/2014 17:02'!
setupDirectories:gen
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/7/2014 16:12'!
squeakCogSpur
	^'squeak.cog.spur'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/7/2014 16:12'!
squeakCogV3
	^'squeak.cog.v3'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/7/2014 16:12'!
squeakSistaSpur
	^'squeak.sista.Spur'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/7/2014 16:12'!
squeakSistaV3
	^'squeak.sista.v3'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/7/2014 16:13'!
squeakStackSpur
	^'squeak.stack.spur'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake directory ' stamp: 'tty 6/7/2014 16:13'!
squeakStackV3
	^'squeak.stack.v3'! !

!TCPlatformConfigForSqueak methodsFor: 'squeak compatibility' stamp: 'tty 5/16/2014 16:05'!
srcDir
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 17:10'!
standardIncludesBuild
	"convencience method to customize for this build. default is self standardIncludes"
	^self standardIncludes
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 17:12'!
standardIncludesBuildAssert 
	"convencience method to customize for this build. default is self standardIncludes"
	^self standardIncludes
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 17:13'!
standardIncludesBuildAssertITimerHeartbeat 
	"convencience method to customize for this build. default is self standardIncludes"
	^self standardIncludes
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 17:13'!
standardIncludesBuildDebug 
	"convencience method to customize for this build. default is self standardIncludes"
	^self standardIncludes
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 17:13'!
standardIncludesBuildDebugITimerHeartbeat 
	"convencience method to customize for this build. default is self standardIncludes"
	^self standardIncludes
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 17:13'!
standardIncludesBuildITimerHeartbeat 
	"convencience method to customize for this build. default is self standardIncludes"
	^self standardIncludes
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 17:14'!
standardIncludesBuildMultiThreaded 
	"convencience method to customize for this build. default is self standardIncludes"
	^self standardIncludes
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 17:14'!
standardIncludesBuildMultiThreadedAssert
	"convencience method to customize for this build. default is self standardIncludes"
	^self standardIncludes
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 17:14'!
standardIncludesBuildMultiThreadedDebug 
	"convencience method to customize for this build. default is self standardIncludes"
	^self standardIncludes
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 17:14'!
standardIncludesBuildNone
	"SHOULD NOT GET HERE"
	^self halt
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:42'!
thirdpartyLibsBuild 
	"convenience method to customize third party libs for this buildType.  default is self  thirdpartyLibs"
	^self thirdpartyLibs
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:43'!
thirdpartyLibsBuildAssert 
	"convenience method to customize third party libs for this buildType.  default is self  thirdpartyLibs"
	^self thirdpartyLibs
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:43'!
thirdpartyLibsBuildAssertITimerHeartbeat 
	"convenience method to customize third party libs for this buildType.  default is self  thirdpartyLibs"
	^self thirdpartyLibs
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:43'!
thirdpartyLibsBuildDebug 
	"convenience method to customize third party libs for this buildType.  default is self  thirdpartyLibs"
	^self thirdpartyLibs
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:43'!
thirdpartyLibsBuildDebugITimerHeartbeat 
	"convenience method to customize third party libs for this buildType.  default is self  thirdpartyLibs"
	^self thirdpartyLibs
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:44'!
thirdpartyLibsBuildITimerHeartbeat 
	"convenience method to customize third party libs for this buildType.  default is self  thirdpartyLibs"
	^self thirdpartyLibs
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:44'!
thirdpartyLibsBuildMultiThreaded 
	"convenience method to customize third party libs for this buildType.  default is self  thirdpartyLibs"
	^self thirdpartyLibs
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:44'!
thirdpartyLibsBuildMultiThreadedAssert
	"convenience method to customize third party libs for this buildType.  default is self  thirdpartyLibs"
	^self thirdpartyLibs
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:45'!
thirdpartyLibsBuildMultiThreadedDebug 
	"convenience method to customize third party libs for this buildType.  default is self  thirdpartyLibs"
	^self thirdpartyLibs
! !

!TCPlatformConfigForSqueak methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 11:45'!
thirdpartyLibsBuildNone 
	"convenience method to customize third party libs for this buildType.  default is self  thirdpartyLibs"
	^self thirdpartyLibs
! !

!TCPlatformConfigForSqueak methodsFor: 'squeak compatibility' stamp: 'tty 5/16/2014 16:05'!
topDir
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'squeak compatibility' stamp: 'tty 5/16/2014 17:08'!
validateSourcesPresent
	self required! !

!TCPlatformConfigForSqueak methodsFor: 'accessing' stamp: 'tty 6/13/2014 12:44'!
version
	^ ''! !

!TCPlatformConfigForSqueak methodsFor: 'cmake executable names' stamp: 'tty 6/16/2014 07:55'!
vmCogExecutableName
	"the name of the cog vm executable"
	^'cog'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake executable names' stamp: 'tty 6/16/2014 07:55'!
vmSistaExecutableName
	"the name of the sista vm executable"
	^'sista'! !

!TCPlatformConfigForSqueak methodsFor: 'cmake executable names' stamp: 'tty 6/16/2014 07:55'!
vmStackExecutableName
	"the name of the stack vm executable"
	^'squeak'! !

!TCPlatformConfigForSqueak methodsFor: 'squeak compatibility' stamp: 'tty 5/16/2014 16:54'!
write: aContents toFile: aFileName
	self required! !

Object subclass: #CMakeVMakerConfigurationInfo
	instanceVariableNames: 'availableBuildTypes dirBuildPlatform dirSource excludeFromBuild'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Builder'!

!CMakeVMakerConfigurationInfo commentStamp: 'tty 6/8/2014 11:37' prior: 0!
I am a lowly data bucket.

Think of me as a database dataset. 

A CMakeVMMaker-Builder can request information from its configurations passing an instance of me as a storage container. 

They stick their info in me; the builder then extracts it and prints it out for the user.

The Builder then reports the data that I have.

!

!CMakeVMakerConfigurationInfo methodsFor: 'accessing' stamp: 'tty 6/8/2014 18:46'!
availableBuildTypes

	^ availableBuildTypes! !

!CMakeVMakerConfigurationInfo methodsFor: 'accessing' stamp: 'tty 6/8/2014 16:56'!
dirBuildPlatform

	^ dirBuildPlatform! !

!CMakeVMakerConfigurationInfo methodsFor: 'accessing' stamp: 'tty 6/8/2014 18:41'!
dirSource
	^ dirSource! !

!CMakeVMakerConfigurationInfo methodsFor: 'accessing' stamp: 'tty 6/9/2014 17:37'!
excludeFromBuild

	^ excludeFromBuild! !

!CMakeVMakerConfigurationInfo methodsFor: 'visiting' stamp: 'tty 6/9/2014 17:37'!
visit: aVisitor
	|v|
	"I am being visited by a CMakeVMMakerSqueak configuration class. Extract its information and store it in myself"
	self flag:'tty'. "why am I not storing the instances itself?does this visit stuff really make sense? I am thinking its 'lightweight'. hmmm"
	v:= aVisitor new.
	availableBuildTypes := v availableBuilds.
	dirBuildPlatform := v dirBuildPlatform.
	dirSource  := v dirSource.
	excludeFromBuild := v excludeFromBuild.

! !

Object subclass: #SqueakCMakeVMMakerAbstractBuilder
	instanceVariableNames: 'buildTypeAndDirectoryInfo config'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Builder'!

SqueakCMakeVMMakerAbstractBuilder class
	instanceVariableNames: 'default'!

!SqueakCMakeVMMakerAbstractBuilder commentStamp: 'tty 6/15/2014 13:08' prior: 0!
I am an abstract base class for various CMakeVMMakerSqueak builders.

I am a singleton.
I am a facade to the various Squeak[Platform][WordSize][VM][MemoryManager]Config classes
I provide facilities to query my configurations.
I use the Visitor pattern in collecting information about my configurations.

HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp


Usage: 
-------------------------Using CMakeVMMakerSqueak-------------------------
These instructions are duplicated in SqueakCMakeVMMakerAbstractBuilder class comments.


The easiest way to use this tool is to utilize one of the concrete Builders in category CMakeVMMakerSqueak-Builder.

With a builder, you can query it for information and then invoke it to generate configurations and or source.

Printing or inspecting the following lines will give you a flavor of a typical work-flow.


-------------Buildable/non-buildable configurations---------
SqueakCMakeVMMakerAbstractBuilder showExcludeFromBuild:false    "buildable configurations"
SqueakCMakeVMMakerAbstractBuilder showExcludeFromBuild:true.    "edit that configs 'excludeFromBuild' method to change"
SqueakCMakeVMMakerAbstractBuilder availableBuildTypes
-------------------------Querying Builders---------------
SqueakLinux32X86Builder configurationsCategory 
SqueakLinux32X86Builder buildDirectory 
SqueakLinux32X86Builder availableBuilds	 
SqueakLinux32X86Builder availableBuildTypesFor:(SqueakLinux32X86Builder availableBuilds at:1)
SqueakLinux32X86Builder availableBuildTypesFor: #Linux32x86SqueakStackSpurConfig
SqueakLinux32X86Builder availableBuildTypesFor: #Linux32x86SqueakStackV3Config
SqueakLinux32X86Builder sourceDirectoryFor:(SqueakLinux32X86Builder availableBuilds at:1)

-------------------------Invoking Builders-------------------------
"generate only CMake config files"
SqueakLinux32X86Builder 
	configureABuildFor: #Linux32x86SqueakCogV3Config withBuildType: #assertWithHeartbeatTimer;
	generate   

"generate configurations and invoke VMMaker to generate source code"
SqueakLinux32X86Builder 
	configureABuildFor: #Linux32x86SqueakCogV3Config withBuildType: #debug;
	generateSources  

-------------------------Compiling Instructions-------------------------
open a terminal and go to the configurations build directory for that configuration. (SqueakLinux32X86Builder buildDirectory)
change into the build type subdirectory (build, build.assert, build.debug...etc)
source build.sh will run 'cmake. make' 
executable is placed in  /products folder.  (SqueakLinux32X86Builder ouputDirectory)


----------------------Editing/Constructing Configurations--------------

Configurations are organized by category:  OperatingSystem, VM Word Size, Processor . (i.e MacOSX32x86 configurations reside in CMakeVMMakerSqueak-MacOSX32x86a)
For a OperatingSystem,VM Word Size, Processor, configurations are then organized by Language.VM.MemoryManafger (newswpeak.stack.v3, squeak.sista.spur. squeak.cog.spur, etc)

IF an existing configuratin exists, you may edit or subclass it. For a Builder to see it, it must remain in the category.

The flag excludeFromBuild determines wether the builder will build it or not. This flag is set to exclude configurations that are just placeholders.

If you have a special case for an existing [OS][WordSize][Processor].[lang][vm][mm] configuration just subclass it and provide customizations.

TODO: Provide typical customizations and how to implement them

internal/external plugins?
compiler flags?
includes?




----------------------Improvements needed-------------------------

The CMakeVMMakerSqueak package has some design hacks because it extends 
the pharo CMakeVMMaker package without modifying that code base.
Therefore, things that should have been done by introducing squeak sub-classes in the pharo source tree could not be done.

The biggest design 'quirk' is the use of the Trait TCPlatformConfigForSqueak to enforce a pseudo abstract base class mechanism.
The other design 'quirk' are the overrides of methods in CPlatformConfig in pharo's package of incompatible methods. (see protocol squeak-compatibility)
Because of the existing inheritance tree, the overrides could not happen in one squeak compatibility class, but are implemented
in several subclasses of CPlatformConfig.

The Squeak Builders implementation also differs significantly from the pharo implementation.
The pharo code's 'configForDebug/configForReleaase' has been expanded to support the squeak build needs.

!

SqueakCMakeVMMakerAbstractBuilder class
	instanceVariableNames: 'default'!

SqueakCMakeVMMakerAbstractBuilder subclass: #SqueakAndroidBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Builder'!

!SqueakAndroidBuilder commentStamp: 'tty 6/7/2014 11:23' prior: 0!
I am a facade.

I query, and invoke CMakeVMMakerSqueak configurations.



!

!SqueakAndroidBuilder methodsFor: 'queries' stamp: 'tty 6/8/2014 14:28'!
configurationsCategory
	^'CMakeVMMakerSqueak-Android'! !

SqueakCMakeVMMakerAbstractBuilder subclass: #SqueakBSDx86Builder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Builder'!

!SqueakBSDx86Builder commentStamp: 'tty 6/7/2014 11:23' prior: 0!
I am a facade.

I query, and invoke CMakeVMMakerSqueak configurations.

!

!SqueakBSDx86Builder methodsFor: 'queries' stamp: 'tty 6/8/2014 14:29'!
configurationsCategory
	^ 'CMakeVMMakerSqueak-BSD32x86'! !

!SqueakCMakeVMMakerAbstractBuilder class methodsFor: 'queries' stamp: 'tty 6/10/2014 12:37'!
availableBuildTypes
	default ifNil:[default:= self new].
	^default availableBuildTypes.! !

!SqueakCMakeVMMakerAbstractBuilder class methodsFor: 'queries' stamp: 'tty 6/8/2014 17:11'!
availableBuildTypesFor: aSymbol
	default ifNil:[default:= self new].
	^default availableBuildTypesFor: aSymbol! !

!SqueakCMakeVMMakerAbstractBuilder class methodsFor: 'queries' stamp: 'tty 6/8/2014 17:05'!
availableBuilds
	default ifNil:[default:= self new].
	^default availableBuilds! !

!SqueakCMakeVMMakerAbstractBuilder class methodsFor: 'queries' stamp: 'tty 6/8/2014 18:26'!
buildDirectory
	"buildDirectory is user friendly term. dirBuildPlatform is internal naming convention. "
	^self dirBuildPlatform
! !

!SqueakCMakeVMMakerAbstractBuilder class methodsFor: 'queries' stamp: 'tty 6/8/2014 18:04'!
buildTypeDirectoriesFor: aSymbol
	default ifNil:[default:= self new].
	^default buildTypeDirectoriesFor: aSymbol! !

!SqueakCMakeVMMakerAbstractBuilder class methodsFor: 'queries' stamp: 'tty 6/8/2014 16:15'!
configurationsCategory
	default ifNil:[default:= self new].
	^default configurationsCategory
! !

!SqueakCMakeVMMakerAbstractBuilder class methodsFor: 'building' stamp: 'tty 6/16/2014 07:38'!
configureA: aSqueakCMakeConfiguration forBuildType: aSymbol
	"a better end-user facing method name"
	self flag: 'tty'. "refactor this after system is in place and make this facade method the real method"
	default ifNil:[default:= self new].
	^default configureABuildFor: aSqueakCMakeConfiguration withBuildType: aSymbol! !

!SqueakCMakeVMMakerAbstractBuilder class methodsFor: 'building' stamp: 'tty 6/9/2014 10:32'!
configureABuildFor: aSqueakCMakeConfiguration withBuildType: aSymbol
	default ifNil:[default:= self new].
	^default configureABuildFor: aSqueakCMakeConfiguration withBuildType: aSymbol! !

!SqueakCMakeVMMakerAbstractBuilder class methodsFor: 'initialize-release' stamp: 'tty 6/8/2014 15:07'!
default
	^default ifNil:[default:= self new]! !

!SqueakCMakeVMMakerAbstractBuilder class methodsFor: 'queries' stamp: 'tty 6/8/2014 16:58'!
dirBuildPlatform
	default ifNil:[default:= self new].
	^default dirBuildPlatform! !

!SqueakCMakeVMMakerAbstractBuilder class methodsFor: 'building' stamp: 'tty 6/10/2014 16:30'!
generate
	default ifNil:[default:= self new].
	^default  generate! !

!SqueakCMakeVMMakerAbstractBuilder class methodsFor: 'building' stamp: 'tty 6/16/2014 07:38'!
generateCmakeFiles
	"a better end-user facing method name"
	self flag: 'tty'. "refactor this after system is in place and make this facade method the real method"
	default ifNil:[default:= self new].
	^default  generate! !

!SqueakCMakeVMMakerAbstractBuilder class methodsFor: 'building' stamp: 'tty 6/11/2014 10:07'!
generateSources
	default ifNil:[default:= self new].
	^default  generateSources! !

!SqueakCMakeVMMakerAbstractBuilder class methodsFor: 'initialize-release' stamp: 'tty 6/12/2014 16:46'!
reset
	default:=nil.! !

!SqueakCMakeVMMakerAbstractBuilder class methodsFor: 'queries' stamp: 'tty 6/10/2014 09:08'!
showExcludeFromBuild: aBoolean
	default ifNil:[default:= self new].
	^default showExcludeFromBuild: aBoolean! !

!SqueakCMakeVMMakerAbstractBuilder class methodsFor: 'queries' stamp: 'tty 6/8/2014 18:32'!
sourceDirectoryFor: aSymbol
	default ifNil:[default:= self new].
	^default sourceDirectoryFor: aSymbol! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'queries' stamp: 'tty 6/8/2014 14:19'!
allBuildConfigurations
	^buildTypeAndDirectoryInfo keys asOrderedCollection sorted.
! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'queries' stamp: 'tty 6/10/2014 12:38'!
availableBuildTypes
	^self buildTypeAndDirectoryInfo keys asSortedCollection
! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'queries' stamp: 'tty 6/8/2014 18:00'!
availableBuildTypesFor: aSymbol
	"answer a build type. somthing like #assert, #debug, #release. Each configuration is in charge of letting us know what it does"
	[
	((Smalltalk at: aSymbol)  category) =  (self configurationsCategory)  "verify the class is handled by this concrete builder"
		ifTrue:[	^self availableBuildTypesFor: aSymbol inCategory: ((Smalltalk at: aSymbol)  category).]  "if so, go get its info"
		ifFalse:[^self userErrorInvalidTarget: aSymbol]
	] ifError:[^'BuildTypeForTarget: ''', aSymbol , ''' not found' ].
	^nil.! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'queries' stamp: 'tty 6/8/2014 18:46'!
availableBuildTypesFor: aSymbol inCategory: aCategoryName
	|d |
	"extract the CMakeVMakerConfigurationInfo object for a configuration and return the availableBuildTypes ."
	d:=(self configurationDictionary:aCategoryName) at: aSymbol ifAbsent:[^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations].
	^d availableBuildTypes



! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'queries' stamp: 'tty 6/8/2014 17:55'!
availableBuilds
	"abstract class pass through for concrete instance"
	^self availableBuilds: (self configurationsCategory)! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'queries' stamp: 'tty 6/8/2014 17:56'!
availableBuilds: aCategoryName
	"answer the CMakeVMakerSqueak configurations in a Smalltalk category"
	^((self configurationDictionary:aCategoryName) keys asSortedCollection) sort

! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'accessing' stamp: 'tty 6/9/2014 11:18'!
buildTypeAndDirectoryInfo

	^ buildTypeAndDirectoryInfo! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'queries' stamp: 'tty 6/8/2014 18:07'!
buildTypeDirectoriesFor: aSymbol
	"answer a subset of buildTypeAndDirectoryInfo based on the buildTypes the configuration supports   "
	[
	((Smalltalk at: aSymbol)  category) =  (self configurationsCategory)  "verify the class is handled by this concrete builder"
		ifTrue:[	^self buildTypeDirectoriesFor: aSymbol inCategory: ((Smalltalk at: aSymbol)  category).]  "if so, go get its info"
		ifFalse:[^self userErrorInvalidTarget: aSymbol]
	] ifError:[^'BuildTypeDirectoriesFor: ''', aSymbol , ''' not found' ].
	^nil.! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'queries' stamp: 'tty 6/8/2014 18:46'!
buildTypeDirectoriesFor: aSymbol inCategory: aCategoryName
	|d |
	"extract the CMakeVMakerConfigurationInfo object for a configuration and return the availableBuildTypes ."
	d:=(self configurationDictionary:aCategoryName) at: aSymbol ifAbsent:[^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations].
	^d availableBuildTypes



! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'queries' stamp: 'tty 6/8/2014 17:53'!
configurationDictionary: aCategoryName
	| result info|
	self flag:'tty'. "building this on the fly is slow. Should I cache/lazy initialize?"

	"return a Dictionary of CMakeMakerSqueak-XYZ platform configurations and their associated CMakeVMakerConfigurationInfo "

	result := Dictionary new.
	Smalltalk globals 
		allClassesDo:[:c | (c class category asString withoutQuoting = aCategoryName)    "is there a faster lookup method?"
			ifTrue: [ 
				info := CMakeVMakerConfigurationInfo new.
				info visit: c.
				result at: (c name) put:info.]].
	^result

! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'queries' stamp: 'tty 6/8/2014 14:20'!
configurationsCategory
	"Answer the category in which the Builder's configurations reside."
	self subclassResponsibility! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'building' stamp: 'tty 6/16/2014 19:38'!
configureABuildFor: configSymbol withBuildType: typeSymbol
	| i |
	self flag:'tty'. "excludeFromBuild returning True does not exit gracefully"
	"Do some sanity checks, then set the internal state of a Configuration for a particular build type. "
	[
	((Smalltalk at: configSymbol)  category) =  (self configurationsCategory)  "verify the class is handled by this concrete builder"
		ifTrue:[	
				config := (Smalltalk at: configSymbol) new.                              "verify this config can handle this build type."
				config excludeFromBuild                                                         "has a developer excluded this build manually?"
					ifTrue:[^self userErrorConfigMarkedAsExcludeFromBuild: configSymbol].   
				i:=config availableBuilds indexOf:typeSymbol                                    
						ifAbsent:[^self userErrorInvalidBuildType: typeSymbol "this config does not support this build type"
										forConfiguration: configSymbol 
										hasTypes: config availableBuilds].
				(config configureForBuildType: typeSymbol) value.                             "config configure yourself"
				^self]
		ifFalse:[^self userErrorInvalidTarget: configSymbol]
	] ifError:[^'error configureABuildFor: ''', configSymbol].

	^nil.
	

	! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'queries' stamp: 'tty 6/8/2014 17:23'!
dirBuildPlatform
	"Answer the root directory for this configuration's build that contains build, build.assert...etc directories. example:  cmake_build.linux32x86."
	^self dirBuildPlatform:(self configurationsCategory)! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'queries' stamp: 'tty 6/8/2014 17:43'!
dirBuildPlatform: aCategoryName
	|info|
	"All the configurations in a category share the same build platform."
	info:=(self configurationDictionary:aCategoryName) at: ((self configurationDictionary:aCategoryName) keys at:1).  "i.e. aDictionary at:1"
	^info dirBuildPlatform
	
	
! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'building' stamp: 'tty 6/10/2014 16:28'!
generate
	(config isKindOf: CPlatformConfig)
		ifTrue:[config generate]
		! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'building' stamp: 'tty 6/11/2014 10:08'!
generateSources
	(config isKindOf: CPlatformConfig)
		ifTrue:[config generateSources]
		! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'queries' stamp: 'tty 6/10/2014 09:20'!
getInfoForBuild: aSymbol! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'queries' stamp: 'tty 6/10/2014 10:12'!
getInfoForBuilds
	| result|
	"return a Dictionary of CMakeMakerSqueak-XYZ platform configurations and their associated CMakeVMakerConfigurationInfo "
	result := Dictionary new.
	self class allSubclassesDo:[:c | |configurationsCategory |
				configurationsCategory := c default configurationsCategory.
				result at:(configurationsCategory asSymbol)  put: (self configurationDictionary: configurationsCategory).
	].
.	^result

! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'initialization' stamp: 'tty 6/8/2014 14:12'!
initialize
	"a stupid <cough>temporary</cough> hack to workaround initialization problems"
	Cogit allSubclassesDo: [ :each | each initializeWithOptions: (VMMaker new instVarNamed: 'optionsDictionary') ].

	self initializeBuildTypeAndDirectoryInfo.

	! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'initialization' stamp: 'tty 6/16/2014 20:02'!
initializeBuildTypeAndDirectoryInfo
	"A dictionary of build types and the name of the directory they are stored in"
	buildTypeAndDirectoryInfo := Dictionary new.
	buildTypeAndDirectoryInfo 
			at: #build put: 'build';
			at: #buildAssert put:'build.assert';
		      at: #buildAssertITimerHeartbeat put: 'build.assert.itimerheartbeat';
                  at: #buildDebug put: 'build.debug';                                                                     
			at: #buildDebugITimerHeartbeat put: 'build.debug.itimerheartbeat';
			at: #buildITimerHeartbeat put: 'build.itimerheartbeat';
			at: #buildMultiThreaded put: 'build.multithreaded';
			at: #buildMultiThreadedAssert put: 'build.multithreaded.assert';
			at: #buildMultiThreadedDebug put: 'build.multithreaded.debug';
			at: #buildNone put: 'build.should.not.happen'.
! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'queries' stamp: 'tty 6/8/2014 14:21'!
noBuildConfigurations
	^#(#noBuildsImplementedForThisConfiguration)! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'queries' stamp: 'tty 6/10/2014 10:53'!
showExcludeFromBuild: aBoolean
	|dictionary result msg s|
	"return all configurations that where the  excludeFromBuid matches aBoolean. excludeFromBuild is manually set by the developer"	
	aBoolean
		ifTrue:[msg:= 'available configurations are: '. s:='']
		ifFalse:[msg:= 'disabled configurations are: '. s:= ' edit method excludeFromBuild to toggle'].
	result := OrderedCollection new.
	dictionary:=self getInfoForBuilds.
	dictionary do:[:dict | 
			dict keysAndValuesDo: [:config :configinfo | 
				aBoolean == (configinfo excludeFromBuild) 
					ifTrue:[ result add:  config]]].
	^'Configurations where excludeFromBuild ==', aBoolean ,'->',result, s.! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'queries' stamp: 'tty 6/8/2014 18:41'!
sourceDirectoryFor: aSymbol
	"answer a subset of buildTypeAndDirectoryInfo based on the buildTypes the configuration supports   "
	[
	((Smalltalk at: aSymbol)  category) =  (self configurationsCategory)  "verify the class is handled by this concrete builder"
		ifTrue:[	^self sourceDirectoryFor: aSymbol inCategory: ((Smalltalk at: aSymbol)  category).]  "if so, go get its info"
		ifFalse:[^self userErrorInvalidTarget: aSymbol]
	] ifError:[^'sourceDirectoryFor: ''', aSymbol , ''' not found' ].
	^nil.! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'queries' stamp: 'tty 6/8/2014 18:42'!
sourceDirectoryFor: aSymbol inCategory: aCategoryName
	|info |
	"extract the CMakeVMakerConfigurationInfo object for a configuration and return the sourceDirectory ."
	info:=(self configurationDictionary:aCategoryName) at: aSymbol ifAbsent:[^SqueakCMakeVMMakerAbstractBuilder default userErrorNoSource:aSymbol].
	^info dirSource



! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'queries' stamp: 'tty 6/9/2014 18:00'!
userErrorConfigMarkedAsExcludeFromBuild: aSymbol
	^'Class ', aSymbol ,'has been manually excluded from building. edit method ''excludeFromBuild'' to change this' .! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'queries' stamp: 'tty 6/9/2014 10:46'!
userErrorInvalidBuildType: typeSymbol forConfiguration: configSymbol hasTypes: anOrderedCollection
	^'The configuration: ', configSymbol, 'does not support buildType ', typeSymbol, '. supported types are:', anOrderedCollection
! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'queries' stamp: 'tty 6/8/2014 14:21'!
userErrorInvalidTarget: aSymbol
	^'I cannot build for this target', aSymbol asString.! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'queries' stamp: 'tty 6/16/2014 06:27'!
userErrorNoExecutable: aSymbol
	^aSymbol asString, ' is not meant to be an executable. Read my class comment'! !

!SqueakCMakeVMMakerAbstractBuilder methodsFor: 'queries' stamp: 'tty 6/8/2014 18:35'!
userErrorNoSource: aSymbol
	^'I cannot find the source directory for ', aSymbol asString.! !

SqueakCMakeVMMakerAbstractBuilder subclass: #SqueakIA32BochsBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Builder'!

!SqueakIA32BochsBuilder commentStamp: 'tty 6/7/2014 11:23' prior: 0!
I am a facade.

I query, and invoke CMakeVMMakerSqueak configurations.

!

!SqueakIA32BochsBuilder methodsFor: 'queries' stamp: 'tty 6/8/2014 15:23'!
configurationsCategory
	^'CMakeVMMakerSqueak-IA32-Bochs'! !

SqueakCMakeVMMakerAbstractBuilder subclass: #SqueakIOSBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Builder'!

!SqueakIOSBuilder commentStamp: '<historical>' prior: 0!
I am a facade.

I query, and invoke CMakeVMMakerSqueak configurations.

!

!SqueakIOSBuilder methodsFor: 'queries' stamp: 'tty 6/8/2014 15:23'!
configurationsCategory
	^'CMakeVMMakerSqueak-IOS'! !

SqueakCMakeVMMakerAbstractBuilder subclass: #SqueakLinux32ARMv6Builder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Builder'!

!SqueakLinux32ARMv6Builder commentStamp: 'tty 6/7/2014 11:23' prior: 0!
I am a facade.

I query, and invoke CMakeVMMakerSqueak configurations.

!

!SqueakLinux32ARMv6Builder methodsFor: 'queries' stamp: 'tty 6/8/2014 15:41'!
configurationsCategory
	^'CMakeVMMakerSqueak-Linux32ARMv6'! !

SqueakCMakeVMMakerAbstractBuilder subclass: #SqueakLinux32x86Builder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Builder'!

!SqueakLinux32x86Builder commentStamp: 'tty 6/7/2014 11:23' prior: 0!
I am a facade.

I query, and invoke CMakeVMMakerSqueak configurations.

!

!SqueakLinux32x86Builder methodsFor: 'queries' stamp: 'tty 6/8/2014 15:42'!
configurationsCategory
	^'CMakeVMMakerSqueak-Linux32x86'! !

SqueakCMakeVMMakerAbstractBuilder subclass: #SqueakLinux32x86_64Builder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Builder'!

!SqueakLinux32x86_64Builder commentStamp: 'tty 6/7/2014 11:23' prior: 0!
I am a facade.

I query, and invoke CMakeVMMakerSqueak configurations.

!

!SqueakLinux32x86_64Builder methodsFor: 'queries' stamp: 'tty 6/15/2014 11:26'!
configurationsCategory
	^'CMakeVMMakerSqueak-LinuxX86-64'! !

SqueakCMakeVMMakerAbstractBuilder subclass: #SqueakLinux64x86w32CompatBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Builder'!

!SqueakLinux64x86w32CompatBuilder commentStamp: 'tty 6/7/2014 11:23' prior: 0!
I am a facade.

I query, and invoke CMakeVMMakerSqueak configurations.



!

!SqueakLinux64x86w32CompatBuilder methodsFor: 'queries' stamp: 'tty 6/15/2014 11:28'!
configurationsCategory
	^'CMakeVMMakerSqueak-Linux64X86-32BitCompatibility'! !

SqueakCMakeVMMakerAbstractBuilder subclass: #SqueakMacOSBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Builder'!

!SqueakMacOSBuilder commentStamp: 'tty 6/7/2014 11:23' prior: 0!
I am a facade.

I query, and invoke CMakeVMMakerSqueak configurations.!

!SqueakMacOSBuilder methodsFor: 'queries' stamp: 'tty 6/8/2014 15:42'!
configurationsCategory
	^'CMakeVMMakerSqueak-MacOS'! !

SqueakCMakeVMMakerAbstractBuilder subclass: #SqueakMacOSPowerPCBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Builder'!

!SqueakMacOSPowerPCBuilder commentStamp: 'tty 6/7/2014 11:24' prior: 0!
I am a facade.

I query, and invoke CMakeVMMakerSqueak configurations.!

!SqueakMacOSPowerPCBuilder methodsFor: 'queries' stamp: 'tty 6/8/2014 15:42'!
configurationsCategory
	^'CMakeVMMakerSqueak-MacOSPowerPC'! !

SqueakCMakeVMMakerAbstractBuilder subclass: #SqueakMacOSX32x86Builder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Builder'!

!SqueakMacOSX32x86Builder commentStamp: 'tty 6/7/2014 11:24' prior: 0!
I am a facade.

I query, and invoke CMakeVMMakerSqueak configurations.!

!SqueakMacOSX32x86Builder methodsFor: 'queries' stamp: 'tty 6/8/2014 15:42'!
configurationsCategory
	^'CMakeVMMakerSqueak-MacOSX32x86'! !

SqueakCMakeVMMakerAbstractBuilder subclass: #SqueakSunOS32x86Builder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Builder'!

!SqueakSunOS32x86Builder commentStamp: 'tty 6/7/2014 11:24' prior: 0!
I am a facade.

I query, and invoke CMakeVMMakerSqueak configurations.!

!SqueakSunOS32x86Builder methodsFor: 'queries' stamp: 'tty 6/8/2014 15:42'!
configurationsCategory
	^'CMakeVMMakerSqueak-SunOS32x86'! !

SqueakCMakeVMMakerAbstractBuilder subclass: #SqueakWin32x86Builder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Builder'!

!SqueakWin32x86Builder commentStamp: 'tty 6/7/2014 11:23' prior: 0!
I am a facade.

I query, and invoke CMakeVMMakerSqueak configurations.



!

!SqueakWin32x86Builder methodsFor: 'queries' stamp: 'tty 6/8/2014 15:43'!
configurationsCategory
	^ 'CMakeVMMakerSqueak-Win32x86'! !

CogFamilyUnixConfig subclass: #Linux32x86Config
	uses: TCPlatformConfigForSqueak
	instanceVariableNames: 'buildType generateBuild generateBuildAssert generateBuildAssertITimerHeartbeat generateBuildDebug generateBuildDebugITimerHeartbeat generateBuildDebugMultiThreaded generateBuildIHeartbeatTimer generateBuildMultiThreaded generateBuildMultiThreadedAssert generateBuildMultiThreadedDebug'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Linux32x86'!

!Linux32x86Config commentStamp: 'tty 6/15/2014 14:02' prior: 0!
A Linux32x86Config is a Squeak Compatibility Layer between the Pharo code in CMakeVMMaker and CMakeVMakerSqueak.

I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


I am not meant to be built.

SqueakLinux32x86Builder 
	configureABuildFor: #ONE OF MY SUBCLASSES NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp

!

Linux32x86Config class
	uses: TCPlatformConfigForSqueak classTrait
	instanceVariableNames: ''!

Linux32x86Config subclass: #Linux32ARMv6StackV3CrossRaspbianConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Linux32ARMv6'!

!Linux32ARMv6StackV3CrossRaspbianConfig commentStamp: 'tty 6/15/2014 14:04' prior: 0!
This is a concrete class which generates a StackVM for Raspbian (debian on RaspberryPi). But in cross compilation usage.

I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakLinux32ARMv6Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp


!

!Linux32ARMv6StackV3CrossRaspbianConfig methodsFor: 'utils' stamp: 'tty 5/20/2014 14:02'!
addDriver: name sources: aSources generator: cmakeGen

	| cfg srcs |
	
	srcs := aSources inject: '' into: [:res :each | res , ' "', each, '"' ].
	cfg := cmakeGen
		captureOutputDuring: [
			cmakeGen printHeader;
			project: name;
			include: '../directories.cmake';
		
			message: 'Adding module: ', name;
			
			addDefinitions:  self compilerFlags;
			addDefinitions: '-fPIC -DPIC';
			set: #sources to: srcs;
			cmd: 'add_library' params: name, ' SHARED ${sources}';
			linkDirectories: '${CMAKE_FIND_ROOT_PATH}/usr/lib/arm-linux-gnueabihf/';
	 		includeDirectories: '${CMAKE_FIND_ROOT_PATH}/usr/include/';
			includeDirectories: '${crossDir}/plugins/FilePlugin';
			includeDirectories: '${targetPlatform}/plugins/B3DAcceleratorPlugin';
			includeDirectories: '${crossDir}/plugins/B3DAcceleratorPlugin';
			set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir;
			cmd: 'set_target_properties' params: name , ' PROPERTIES PREFIX "" SUFFIX "" 
			LINK_FLAGS "', self linkFlags , '"'
	].
	
		
	self write: cfg toFile: ((self buildDir / name) assureExistence / cmakeGen outputFileName) fullName.
	cmakeGen addSubdirectory:  name.
	! !

!Linux32ARMv6StackV3CrossRaspbianConfig methodsFor: 'squeak compatibility' stamp: 'tty 5/20/2014 14:07'!
addDriver: name sources: aSources generator: cmakeGen externalLibs: extLibs
	super addDriver: name sources: aSources generator: cmakeGen externalLibs: extLibs
! !

!Linux32ARMv6StackV3CrossRaspbianConfig methodsFor: 'cmake' stamp: 'tty 6/8/2014 18:50'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder  default  noBuildConfigurations
! !

!Linux32ARMv6StackV3CrossRaspbianConfig methodsFor: 'compiler flags' stamp: 'tty 5/20/2014 14:02'!
commonCompilerFlags

	"Common compiler flags
	
	
	LSB_FIRST=1 means that target platform is little endian. 
	set it to 0 for big-endian platforms
	
	"
	
	^ {
		'-DLSB_FIRST=1'. 
		'-DUSE_GLOBAL_STRUCT=0'. 
		'-DCOGMTVM=0' } 	
	! !

!Linux32ARMv6StackV3CrossRaspbianConfig methodsFor: 'compiler flags' stamp: 'tty 5/20/2014 14:02'!
compilerFlagsDebug

	^ {
	'-g3'.
	'-O0'. 
	'-D_GNU_SOURCE'. 
	'-DITIMER_HEARTBEAT=1'. 
	'-DNO_VM_PROFILE=1'. 
	'-DDEBUGVM=1' }! !

!Linux32ARMv6StackV3CrossRaspbianConfig methodsFor: 'compiler flags' stamp: 'tty 5/20/2014 14:02'!
compilerFlagsRelease
"
THIS FLAGS ARE CRASHING COMPILER 
-fschedule-insns2 
-fschedule-insns 

THIS FLAGS ARE CRASHING VM
-ftree-pre  
-fcaller-saves 

THIS FLAGS ARE WORKING 
-O1 -fthread-jumps -falign-functions -falign-jumps -falign-loops -falign-labels -fcrossjumping -fcse-follow-jumps -fcse-skip-blocks -fdelete-null-pointer-checks -fdevirtualize -fexpensive-optimizations -fgcse -fgcse-lm -finline-small-functions -findirect-inlining -fipa-sra -foptimize-sibling-calls -fpeephole2 -fregmove -freorder-blocks -frerun-cse-after-loop -freorder-functions  -fsched-interblock -fsched-spec -fstrict-aliasing -fstrict-overflow  -ftree-switch-conversion -ftree-vrp

THIS IS LIKE: -O2 -fno-tree-pre -fno-caller-saves 

"

	^ {
		'-g0'. 
		'-O2'. 
		'-fno-tree-pre'. 
		'-fno-caller-saves'. 
		'-D_GNU_SOURCE'. 
		'-DNDEBUG'. 
		'-DITIMER_HEARTBEAT=1'. 
		'-DNO_VM_PROFILE=1'. 
		'-DDEBUGVM=0' }! !

!Linux32ARMv6StackV3CrossRaspbianConfig methodsFor: 'headers generation' stamp: 'tty 5/20/2014 14:02'!
configH
	" right now its like  that "
	^ '
#ifndef __sq_config_h
#define __sq_config_h

/* explicit image width */

#define	HAVE_INTERP_H 1

/* package options */

#define	USE_X11 1
#define	USE_X11_GLX 1
/* #undef	USE_QUARTZ */
/* #undef	USE_QUARTZ_CGL */
/* #undef	USE_RFB */

/* libraries */

/* #undef	HAVE_LIBX11 */
/* #undef	HAVE_LIBXEXT */
#define	HAVE_LIBDL 1
/* #undef	HAVE_DYLD */
/* #undef	HAVE_LIBFFI */
/* #undef	HAVE_ICONV */

/* #undef	USE_AUDIO_NONE */
/* #undef	USE_AUDIO_SUN */
/* #undef	USE_AUDIO_NAS */
/* #undef	USE_AUDIO_OSS */
/* #undef	USE_AUDIO_MACOSX */
/* #undef	OSS_DEVICE */

/* header files */

#define	HAVE_UNISTD_H 1
/* #undef	NEED_GETHOSTNAME_P */

#define	HAVE_DIRENT_H 1
/* #undef	HAVE_SYS_NDIR_H */
/* #undef	HAVE_SYS_DIR_H */
/* #undef	HAVE_NDIR_H */
#define	HAVE_DLFCN_H 1
#define	HAVE_ICONV_H 1

#define	HAVE_SYS_TIME_H 1
#define	TIME_WITH_SYS_TIME 1

/* #undef	HAVE_SYS_FILIO_H */

/* #undef	HAVE_SYS_AUDIOIO_H */
/* #undef	HAVE_SUN_AUDIOIO_H */

#define	HAVE_PTY_H 1
/* #undef	HAVE_UTIL_H */
/* #undef	HAVE_LIBUTIL_H */
#define	HAVE_STROPTS_H 1

#define	HAVE_GL_GL_H 1
/* #undef	HAVE_OPENGL_GL_H */

/* #undef	NEED_SUNOS_H */

/* system calls/library functions */

#define	AT_EXIT atexit

#define	HAVE_TZSET 1

#define	HAVE_OPENPTY 1
/* #undef	HAVE_UNIX98_PTYS */

#define	HAVE_SNPRINTF 1
/* #undef	HAVE___SNPRINTF */

#define	HAVE_MMAP 1

/* #undef	HAVE_DYLD */

#define	HAVE_LANGINFO_CODESET 1

#define	HAVE_ALLOCA 1
#define	HAVE_ALLOCA_H 1

#define	HAVE_UNSETENV 1

#define	HAVE_NANOSLEEP 1

/* widths of primitive types */

#define	SIZEOF_INT 4
#define	SIZEOF_LONG 4
#define	SIZEOF_LONG_LONG 8
#define	SIZEOF_VOID_P 4

/* structures */

#define	HAVE_TM_GMTOFF 1
#define	HAVE_TIMEZONE 1

/* typedefs */

/* #undef	size_t */
/* #undef	socklen_t */

#define	ENABLE_FAST_BLT 1
#define	squeakInt64 long long

/* architecture */

#define	OS_TYPE "unix"
#define __arm__ 1
#define __ARM_ARCH_6__ 1
#define	VM_HOST "arm-pc-linux-gnu"
#define	VM_HOST_CPU "arm"
/* #undef	VM_HOST_VENDOR */
#define	VM_HOST_OS "linux-gnu"
#define	VM_BUILD_STRING "Unix built on "__DATE__ " "__TIME__" Compiler: "__VERSION__

/* #undef	WORDS_BIGENDIAN */
/* #undef	DOUBLE_WORD_ALIGNMENT */

/* damage containment */

/* #undef	DARWIN */

#ifdef NEED_SUNOS_H
# include "sunos.h"
#endif

/* other configured variables */

#define SQ_VERSION "3.9a-7024"
#define VM_VERSION "3.9-7"
#define VM_MODULE_PREFIX ""
/* #undef VM_DLSYM_PREFIX */
#define VM_X11DIR ""

/* avoid dependencies on glibc2.3 */

#define HAVE_FEATURES_H 1

#if defined(HAVE_FEATURES_H)
# include "glibc.h"
#endif


/* used by UUID plugin: */

#define HAVE_UUID_H 1

#endif /* __sq_config_h */
																																																																					
																																																																				'! !

!Linux32ARMv6StackV3CrossRaspbianConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/20/2014 14:02'!
configureB3DAcceleratorPlugin: maker
	"extra rules for B3DAcceleratorPlugin"
	
	super configureB3DAcceleratorPlugin: maker.
	maker includeDirectories: '${CMAKE_FIND_ROOT_PATH}/usr/include/'.! !

!Linux32ARMv6StackV3CrossRaspbianConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/20/2014 14:02'!
configureBitBltSimulation: maker
	"extra rules for BitBltSimulation"

	maker includeDirectories: '${pluginCross}'.

	maker addCrossSources: #(
		'BitBltGeneric.c'
		'BitBltDispatch.c'
	).
	! !

!Linux32ARMv6StackV3CrossRaspbianConfig methodsFor: 'plugins' stamp: 'tty 5/20/2014 14:09'!
defaultExternalPlugins
	self flag:'tty'. "InternetConfigPlugin is part of pharo build but not squeak. why?"
	^ #(
		B3DAcceleratorPlugin
		JPEGReaderPlugin 
		JPEGReadWriter2Plugin 			
		RePlugin
"		InternetConfigPlugin"
	)! !

!Linux32ARMv6StackV3CrossRaspbianConfig methodsFor: 'plugins' stamp: 'tty 5/20/2014 14:02'!
defaultInternalPlugins
" took from unixbuild/bld/plugins.int"
	^ #(
		ADPCMCodecPlugin 
		AsynchFilePlugin 
		BalloonEnginePlugin "B2DPlugin" 
		BitBltSimulation "BitBltPlugin"
		BMPReadWriterPlugin 
		CroquetPlugin 
		DeflatePlugin  "ZipPlugin"
		DropPlugin 
		DSAPlugin "DSAPrims" 
		FFTPlugin 
		FileCopyPlugin 
		FilePlugin 
		FloatArrayPlugin 
		FloatMathPlugin 
		JoystickTabletPlugin 
		KlattSynthesizerPlugin "Klatt"
		LargeIntegersPlugin "LargeIntegers"
		Matrix2x3Plugin 
		MIDIPlugin 
		MiscPrimitivePlugin 
		Mpeg3Plugin  	
		SecurityPlugin 
		SerialPlugin 
		SocketPlugin 
		SoundCodecPlugin "SoundCodecPrims"
		SoundGenerationPlugin 
		SoundPlugin 
		StarSqueakPlugin 
		SurfacePlugin	
		LocalePlugin
		)! !

!Linux32ARMv6StackV3CrossRaspbianConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:18'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackV3! !

!Linux32ARMv6StackV3CrossRaspbianConfig methodsFor: 'cmake' stamp: 'tty 6/8/2014 15:50'!
dirBuildPlatform
	"the directory for the platform. example: build.linux32x86"
	^self dirARMv6! !

!Linux32ARMv6StackV3CrossRaspbianConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:35'!
excludeFromBuild
	^true
! !

!Linux32ARMv6StackV3CrossRaspbianConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:04'!
executableName
	^ self vmStackExecutableName! !

!Linux32ARMv6StackV3CrossRaspbianConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/20/2014 14:02'!
extraPluginSettings: maker

	maker isExternal ifTrue: [
		"copy lib to results dir "
		maker set: 'LIBRARY_OUTPUT_PATH' to: '${outputDir}' 
	].	
	
	maker set: #linkFlags toString: '${linkFlags}'
! !

!Linux32ARMv6StackV3CrossRaspbianConfig methodsFor: 'accessing' stamp: 'tty 5/20/2014 14:02'!
linkFlags
	 ^ '-lSM -lICE -ldl -lGL -lpthread -lm -lnsl -lX11'! !

!Linux32ARMv6StackV3CrossRaspbianConfig methodsFor: 'source files' stamp: 'tty 5/20/2014 14:02'!
preferredIncludes
	^ #('${CMAKE_FIND_ROOT_PATH}/usr/include/'
	'${targetPlatform}/plugins/B3DAcceleratorPlugin')
	! !

!Linux32ARMv6StackV3CrossRaspbianConfig methodsFor: 'utils' stamp: 'tty 5/20/2014 14:02'!
setExtraTargetProperties: maker

	"maker setTargetProperties: 'LINK_FLAGS ""'."
		
	maker puts: 'set_source_files_properties( ${srcVMDir}/cogit.c PROPERTIES 
		COMPILE_FLAGS "-O1 -fno-omit-frame-pointer -momit-leaf-frame-pointer")'.
		
		
	maker 
		cmd: 'set_source_files_properties'
		params: ' ${targetPlatform}/vm/sqUnixHeartbeat.c PROPERTIES 
		COMPILE_FLAGS "-O1 -fno-omit-frame-pointer"'.
						
	maker linkDirectories: '${CMAKE_FIND_ROOT_PATH}/usr/lib/arm-linux-gnueabihf/'.
	
	maker addExternalLibraries: 
		#(
			'm'  "math lib"
			'dl'  "dynamic loader"
			'pthread' "posix threads" 
		).
		
	maker set: 'EXECUTABLE_OUTPUT_PATH' toString: self outputDir fullName.
	self addVMDrivers: maker.! !

Linux32ARMv6StackV3CrossRaspbianConfig subclass: #Linux32ARMv6StackV3CrossRaspbianFastBltConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Linux32ARMv6'!

!Linux32ARMv6StackV3CrossRaspbianFastBltConfig commentStamp: 'tty 6/15/2014 14:05' prior: 0!
This is a concrete class which generates a StackVM for Raspbian (debian on RaspberryPi). But in cross compilation usage.

I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakLinux32ARMv6Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp

!

!Linux32ARMv6StackV3CrossRaspbianFastBltConfig methodsFor: 'compiler flags' stamp: 'tty 5/20/2014 16:44'!
commonCompilerFlags
	^ super commonCompilerFlags, { '-DENABLE_FAST_BLT' }.! !

!Linux32ARMv6StackV3CrossRaspbianFastBltConfig methodsFor: 'compiler flags' stamp: 'tty 5/20/2014 16:44'!
compilerFlagsDebug

	^ {
		'-g3'. 
		'-D_GNU_SOURCE'. 
		'-DITIMER_HEARTBEAT=1'. 
		'-DNO_VM_PROFILE=1'. 
		'-DDEBUGVM=1' }! !

!Linux32ARMv6StackV3CrossRaspbianFastBltConfig methodsFor: 'compiler flags' stamp: 'tty 5/20/2014 16:44'!
compilerFlagsRelease
"
THIS FLAGS ARE CRASHING COMPILER 
-fschedule-insns2 
-fschedule-insns 

THIS FLAGS ARE CRASHING VM
-ftree-pre  
-fcaller-saves 

THIS FLAGS ARE WORKING 
-O1 -fthread-jumps -falign-functions -falign-jumps -falign-loops -falign-labels -fcrossjumping -fcse-follow-jumps -fcse-skip-blocks -fdelete-null-pointer-checks -fdevirtualize -fexpensive-optimizations -fgcse -fgcse-lm -finline-small-functions -findirect-inlining -fipa-sra -foptimize-sibling-calls -fpeephole2 -fregmove -freorder-blocks -frerun-cse-after-loop -freorder-functions  -fsched-interblock -fsched-spec -fstrict-aliasing -fstrict-overflow  -ftree-switch-conversion -ftree-vrp

THIS IS LIKE: -O2 -fno-tree-pre -fno-caller-saves 

"

	^ {
		'-g0'. 
		'-D_GNU_SOURCE'. 
		'-DNDEBUG'. 
		'-DITIMER_HEARTBEAT=1'. 
		'-DNO_VM_PROFILE=1'. 
		'-DDEBUGVM=0' }! !

!Linux32ARMv6StackV3CrossRaspbianFastBltConfig methodsFor: 'headers generation' stamp: 'tty 5/20/2014 16:44'!
configH
	" right now its like  that "
	^ '
#ifndef __sq_config_h
#define __sq_config_h

/* explicit image width */

#define	HAVE_INTERP_H 1

/* package options */

#define	USE_X11 1
#define	USE_X11_GLX 1
/* #undef	USE_QUARTZ */
/* #undef	USE_QUARTZ_CGL */
/* #undef	USE_RFB */

/* libraries */

/* #undef	HAVE_LIBX11 */
/* #undef	HAVE_LIBXEXT */
#define	HAVE_LIBDL 1
/* #undef	HAVE_DYLD */
/* #undef	HAVE_LIBFFI */
/* #undef	HAVE_ICONV */

/* #undef	USE_AUDIO_NONE */
/* #undef	USE_AUDIO_SUN */
/* #undef	USE_AUDIO_NAS */
/* #undef	USE_AUDIO_OSS */
/* #undef	USE_AUDIO_MACOSX */
/* #undef	OSS_DEVICE */

/* header files */

#define	HAVE_UNISTD_H 1
/* #undef	NEED_GETHOSTNAME_P */

#define	HAVE_DIRENT_H 1
/* #undef	HAVE_SYS_NDIR_H */
/* #undef	HAVE_SYS_DIR_H */
/* #undef	HAVE_NDIR_H */
#define	HAVE_DLFCN_H 1
#define	HAVE_ICONV_H 1

#define	HAVE_SYS_TIME_H 1
#define	TIME_WITH_SYS_TIME 1

/* #undef	HAVE_SYS_FILIO_H */

/* #undef	HAVE_SYS_AUDIOIO_H */
/* #undef	HAVE_SUN_AUDIOIO_H */

#define	HAVE_PTY_H 1
/* #undef	HAVE_UTIL_H */
/* #undef	HAVE_LIBUTIL_H */
#define	HAVE_STROPTS_H 1

#define	HAVE_GL_GL_H 1
/* #undef	HAVE_OPENGL_GL_H */

/* #undef	NEED_SUNOS_H */

/* system calls/library functions */

#define	AT_EXIT atexit

#define	HAVE_TZSET 1

#define	HAVE_OPENPTY 1
/* #undef	HAVE_UNIX98_PTYS */

#define	HAVE_SNPRINTF 1
/* #undef	HAVE___SNPRINTF */

#define	HAVE_MMAP 1

/* #undef	HAVE_DYLD */

#define	HAVE_LANGINFO_CODESET 1

#define	HAVE_ALLOCA 1
#define	HAVE_ALLOCA_H 1

#define	HAVE_UNSETENV 1

#define	HAVE_NANOSLEEP 1

/* widths of primitive types */

#define	SIZEOF_INT 4
#define	SIZEOF_LONG 4
#define	SIZEOF_LONG_LONG 8
#define	SIZEOF_VOID_P 4

/* structures */

#define	HAVE_TM_GMTOFF 1
#define	HAVE_TIMEZONE 1

/* typedefs */

/* #undef	size_t */
/* #undef	socklen_t */

#define	ENABLE_FAST_BLT 1
#define	squeakInt64 long long

/* architecture */

#define	OS_TYPE "unix"

#define	VM_HOST "i686-pc-linux-gnu"
#define	VM_HOST_CPU "i686"
/* #undef	VM_HOST_VENDOR */
#define	VM_HOST_OS "linux-gnu"
#define	VM_BUILD_STRING "Unix built on "__DATE__ " "__TIME__" Compiler: "__VERSION__

/* #undef	WORDS_BIGENDIAN */
/* #undef	DOUBLE_WORD_ALIGNMENT */

/* damage containment */

/* #undef	DARWIN */

#ifdef NEED_SUNOS_H
# include "sunos.h"
#endif

/* other configured variables */

#define SQ_VERSION "3.9a-7024"
#define VM_VERSION "3.9-7"
#define VM_MODULE_PREFIX ""
/* #undef VM_DLSYM_PREFIX */
#define VM_X11DIR ""

/* avoid dependencies on glibc2.3 */

#define HAVE_FEATURES_H 1

#if defined(HAVE_FEATURES_H)
# include "glibc.h"
#endif


/* used by UUID plugin: */

#define HAVE_UUID_H 1

#endif /* __sq_config_h */
																																																																					
																																																																				'! !

!Linux32ARMv6StackV3CrossRaspbianFastBltConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/20/2014 16:44'!
configureBitBltSimulation: maker
	"extra rules for BitBltSimulation"

	maker includeDirectories: '${pluginCross}'.
	maker set: 'can_use_assembler' to: 'TRUE'.
	maker cmd: 'enable_language' params: 'ASM'.
	maker set: 'CMAKE_ASM_COMPILE_OBJECT' to: '"asasm -cpu 6 -I ${pluginCross} -o <OBJECT> <SOURCE>"'.
	
	maker addCrossSources: #(
		'BitBltArm.c'
		'BitBltArmSimd.c'
		'BitBltDispatch.c'
		'BitBltGeneric.c'
		'BitBltArmLinux.c'
		'BitBltArmSimdAlphaBlend.s'
		'BitBltArmSimdBitLogical.s'
		'BitBltArmSimdPixPaint.s'
		'BitBltArmSimdSourceWord.s'
	).
	! !

!Linux32ARMv6StackV3CrossRaspbianFastBltConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:19'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackV3! !

!Linux32ARMv6StackV3CrossRaspbianFastBltConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:35'!
excludeFromBuild
	^true
! !

!Linux32ARMv6StackV3CrossRaspbianFastBltConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:04'!
executableName
	^ self vmStackExecutableName! !

Linux32x86Config subclass: #Linux32ARMv6StackV3RaspbianConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Linux32ARMv6'!

!Linux32ARMv6StackV3RaspbianConfig commentStamp: 'tty 6/15/2014 14:05' prior: 0!
This is a concrete class which generates a StackVM for Raspbian (debian on RaspberryPi).

I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakLinux32ARMv6Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp

!

!Linux32ARMv6StackV3RaspbianConfig methodsFor: 'squeak compatibility' stamp: 'tty 5/20/2014 16:49'!
addDriver: name sources: aSources generator: cmakeGen externalLibs: extLibs
	super addDriver: name sources: aSources generator: cmakeGen externalLibs: extLibs
! !

!Linux32ARMv6StackV3RaspbianConfig methodsFor: 'cmake' stamp: 'tty 6/8/2014 18:50'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder  default  noBuildConfigurations
! !

!Linux32ARMv6StackV3RaspbianConfig methodsFor: 'compiler flags' stamp: 'tty 5/20/2014 16:48'!
commonCompilerFlags

	"Common compiler flags
	
	
	LSB_FIRST=1 means that target platform is little endian. 
	set it to 0 for big-endian platforms
	
	"
	
	^ {
		'-DLSB_FIRST=1'. 
		'-DUSE_GLOBAL_STRUCT=0'. 
		'-DCOGMTVM=0' } ! !

!Linux32ARMv6StackV3RaspbianConfig methodsFor: 'compiler flags' stamp: 'tty 5/20/2014 16:48'!
compilerFlagsDebug

	^ {
		'-g3'. 
		'-O0'. 
		'-D_GNU_SOURCE'. 
		'-DITIMER_HEARTBEAT=1'. 
		'-DNO_VM_PROFILE=1'. 
		'-DDEBUGVM=1' }! !

!Linux32ARMv6StackV3RaspbianConfig methodsFor: 'compiler flags' stamp: 'tty 5/20/2014 16:48'!
compilerFlagsRelease
"
THIS FLAGS ARE CRASHING COMPILER 
-fschedule-insns2 
-fschedule-insns 

THIS FLAGS ARE CRASHING VM
-ftree-pre  
-fcaller-saves 

THIS FLAGS ARE WORKING 
-O1 -fthread-jumps -falign-functions -falign-jumps -falign-loops -falign-labels -fcrossjumping -fcse-follow-jumps -fcse-skip-blocks -fdelete-null-pointer-checks -fdevirtualize -fexpensive-optimizations -fgcse -fgcse-lm -finline-small-functions -findirect-inlining -fipa-sra -foptimize-sibling-calls -fpeephole2 -fregmove -freorder-blocks -frerun-cse-after-loop -freorder-functions  -fsched-interblock -fsched-spec -fstrict-aliasing -fstrict-overflow  -ftree-switch-conversion -ftree-vrp

THIS IS LIKE: -O2 -fno-tree-pre -fno-caller-saves 

"

	^ {
		'-g0'. 
		'-O2'. 
		'-fno-tree-pre'. 
		'-fno-caller-saves'. 
		'-D_GNU_SOURCE'. 
		'-DNDEBUG'. 
		'-DITIMER_HEARTBEAT=1'. 
		'-DNO_VM_PROFILE=1'. 
		'-DDEBUGVM=0' }! !

!Linux32ARMv6StackV3RaspbianConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/20/2014 16:48'!
configureBitBltSimulation: maker
	"extra rules for BitBltSimulation"

	maker includeDirectories: '${pluginCross}'.

	maker addCrossSources: #(
		'BitBltGeneric.c'
		'BitBltDispatch.c'
	).
	! !

!Linux32ARMv6StackV3RaspbianConfig methodsFor: 'plugins' stamp: 'tty 5/20/2014 16:56'!
defaultExternalPlugins
	self flag:'tty'. "InternetConfigPlugin not available default svn co of Cog for unix. "
	^ #(
		B3DAcceleratorPlugin
		JPEGReaderPlugin 
		JPEGReadWriter2Plugin 			
		RePlugin
"		InternetConfigPlugin"
	)! !

!Linux32ARMv6StackV3RaspbianConfig methodsFor: 'plugins' stamp: 'tty 5/20/2014 16:48'!
defaultInternalPlugins
" took from unixbuild/bld/plugins.int"
	^ #(
		ADPCMCodecPlugin 
		AsynchFilePlugin 
		BalloonEnginePlugin "B2DPlugin" 
		BitBltSimulation "BitBltPlugin"
		BMPReadWriterPlugin 
		CroquetPlugin 
		DeflatePlugin  "ZipPlugin"
		DropPlugin 
		DSAPlugin "DSAPrims" 
		FFTPlugin 
		FileCopyPlugin 
		FilePlugin 
		FloatArrayPlugin 
		FloatMathPlugin 
		JoystickTabletPlugin 
		KlattSynthesizerPlugin "Klatt"
		LargeIntegersPlugin "LargeIntegers"
		Matrix2x3Plugin 
		MIDIPlugin 
		MiscPrimitivePlugin 
		Mpeg3Plugin  	
		SecurityPlugin 
		SerialPlugin 
		SocketPlugin 
		SoundCodecPlugin "SoundCodecPrims"
		SoundGenerationPlugin 
		SoundPlugin 
		StarSqueakPlugin 
		SurfacePlugin	
		LocalePlugin
		)! !

!Linux32ARMv6StackV3RaspbianConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:19'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackV3! !

!Linux32ARMv6StackV3RaspbianConfig methodsFor: 'cmake' stamp: 'tty 6/8/2014 15:51'!
dirBuildPlatform
	"the directory for the platform. example: build.linux32x86"
	^self dirARMv6! !

!Linux32ARMv6StackV3RaspbianConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:35'!
excludeFromBuild
	^true
! !

!Linux32ARMv6StackV3RaspbianConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:04'!
executableName
	^ self vmStackExecutableName! !

!Linux32ARMv6StackV3RaspbianConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/20/2014 16:48'!
extraPluginSettings: maker

	maker isExternal ifTrue: [
		"copy lib to results dir "
		maker set: 'LIBRARY_OUTPUT_PATH' to: '${outputDir}' 
	].	
	
	maker set: #linkFlags toString: '${linkFlags}'
! !

!Linux32ARMv6StackV3RaspbianConfig methodsFor: 'accessing' stamp: 'tty 5/20/2014 16:48'!
linkFlags
	 ^ '-lSM -lICE -ldl -lGL -lpthread -lm -lnsl -lX11'! !

!Linux32ARMv6StackV3RaspbianConfig methodsFor: 'utils' stamp: 'tty 5/20/2014 16:48'!
setExtraTargetProperties: maker

	"maker setTargetProperties: 'LINK_FLAGS ""'."
		
	maker puts: 'set_source_files_properties( ${srcVMDir}/cogit.c PROPERTIES 
		COMPILE_FLAGS "-O1 -fno-omit-frame-pointer -momit-leaf-frame-pointer")'.
		
	
	maker 
		cmd: 'set_source_files_properties'
		params: ' ${targetPlatform}/vm/sqUnixHeartbeat.c PROPERTIES 
		COMPILE_FLAGS "-O1 -fno-omit-frame-pointer"'.
						
	
	maker addExternalLibraries: 
		#(
			'm'  "math lib"
			'dl'  "dynamic loader"
			'pthread' "posix threads" 
		).
		
	maker set: 'EXECUTABLE_OUTPUT_PATH' toString: self outputDir fullName.
	self addVMDrivers: maker.! !

Linux32ARMv6StackV3RaspbianConfig subclass: #Linux32ARMv6StackV3RaspbianFastBltConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Linux32ARMv6'!

!Linux32ARMv6StackV3RaspbianFastBltConfig commentStamp: 'tty 6/15/2014 14:05' prior: 0!
http://www.cmake.org/Wiki/CMake/Assembler
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakLinux32ARMv6Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp

!

!Linux32ARMv6StackV3RaspbianFastBltConfig methodsFor: 'compiler flags' stamp: 'tty 5/20/2014 19:31'!
commonCompilerFlags
	^ super commonCompilerFlags, { '-DENABLE_FAST_BLT' }.! !

!Linux32ARMv6StackV3RaspbianFastBltConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/20/2014 19:31'!
configureBitBltSimulation: maker
	"extra rules for BitBltSimulation"

	maker includeDirectories: '${pluginCross}'.
	
	maker set: 'can_use_assembler' to: 'TRUE'.
	
	maker addCrossSources: #(
		'BitBltArm.c'
		'BitBltArmSimd.c'
		'BitBltDispatch.c'
		'BitBltGeneric.c'
		'BitBltArmLinux.c'
		'BitBltArmSimdAlphaBlend.s'
		'BitBltArmSimdBitLogical.s'
		'BitBltArmSimdPixPaint.s'
		'BitBltArmSimdSourceWord.s'
	).
	! !

!Linux32ARMv6StackV3RaspbianFastBltConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:19'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackV3! !

!Linux32ARMv6StackV3RaspbianFastBltConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:35'!
excludeFromBuild
	^true
! !

!Linux32ARMv6StackV3RaspbianFastBltConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:04'!
executableName
	^ self vmStackExecutableName! !

!Linux32x86Config methodsFor: 'squeak compatibility' stamp: 'tty 6/9/2014 18:16'!
addDriver: name sources: aSources generator: cmakeGen externalLibs: extLibs

	| cfg srcs |
	
	srcs := aSources inject: '' into: [:res :each | res , ' "', each, '"' ].
	cfg := cmakeGen
		captureOutputDuring: [
			cmakeGen printHeader;
			project: name;
			include: '../directories.cmake';
		
			message: 'Adding module: ', name;
			
			addDefinitions:  self compilerFlags;
			addDefinitions: '-fPIC -DPIC';
			set: #sources to: srcs;
			cmd: 'add_library' params: name, ' SHARED ${sources}'; 
			includeDirectories: '${crossDir}/plugins/FilePlugin';
			includeDirectories: '${targetPlatform}/plugins/B3DAcceleratorPlugin';
			includeDirectories: '${crossDir}/plugins/B3DAcceleratorPlugin';
			set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir fullName;
			addExternalLibraries: extLibs;
			cmd: 'target_link_libraries' params: name , ' ${LINKLIBS}';
			cmd: 'set_target_properties' params: name , ' PROPERTIES PREFIX "" SUFFIX "" 
			LINK_FLAGS -m32' 
	].
	
	(self buildDir / name) assureExistence.
	self write: cfg toFile: name , '/', cmakeGen outputFileName.
	cmakeGen addSubdirectory:  name.
	! !

!Linux32x86Config methodsFor: 'cmake' stamp: 'tty 6/8/2014 18:57'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default allBuildConfigurations copyWithoutAll:#(#releaseMultiThreadedFFI #debugMultiThreadedFFI)
! !

!Linux32x86Config methodsFor: 'squeak compatibility' stamp: 'tty 6/7/2014 16:50'!
buildDir
	^ buildDir ifNil: [ buildDir := ( self topDir / self buildDirName) assureExistence].! !

!Linux32x86Config methodsFor: 'squeak compatibility' stamp: 'tty 6/12/2014 17:17'!
buildDirName
	buildType isNil
		ifTrue:[^self dirBuildPlatform, FileDirectory slash, self dirBuildLanguageVMMM, FileDirectory slash, 'build']
		ifFalse:[^self dirBuildPlatform, FileDirectory slash, self dirBuildLanguageVMMM, FileDirectory slash, buildType asString]! !

!Linux32x86Config methodsFor: 'squeak compatibility' stamp: 'tty 6/9/2014 18:17'!
buildScript
	"answer the build script for building everything"
	

	^ 
'#!!/usr/bin/env bash

cmake .
make

'! !

!Linux32x86Config methodsFor: 'squeak compatibility' stamp: 'tty 6/12/2014 17:40'!
buildType: aSymbol
	buildType:= aSymbol! !

!Linux32x86Config methodsFor: 'source generation' stamp: 'tty 6/13/2014 12:10'!
cogitClass
	^ StackToRegisterMappingCogit ! !

!Linux32x86Config methodsFor: 'compiler flags' stamp: 'tty 6/13/2014 12:22'!
commonCompilerFlags
	self flag: 'tty'. "pull up common flags from subclasses on a refactoring pass."
	^#()! !

!Linux32x86Config methodsFor: 'compiler flags' stamp: 'tty 6/16/2014 20:04'!
compilerFlags
	|d commonFlags flags|
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self compilerFlagsBuild];
		at: #buildAssert  put: [self compilerFlagsAssert];
		at: #buildAssertITimerHeartbeat  put: [self compilerFlagsAssertITimerHeartbeat];
            at:#buildDebug  put: [self compilerFlagsDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self compilerFlagsDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self compilerFlagsIHeartbeatTimer];
		at: #buildMultiThreaded  put: [self compilerFlagsMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self compilerFlagsMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self compilerFlagsMultiThreadedDebug ];
		at: #buildNone put:[self compilerFlagsNoBuildType].

    flags:= String streamContents: [ :stream |
	 (((d at:  buildType) value)  collect: #withBlanksTrimmed as: Set)
		asStringOn: stream 
		delimiter:' '].

    commonFlags:=String streamContents: [ :stream |
		((self commonCompilerFlags) collect: #withBlanksTrimmed as: Set)
			asStringOn: stream 
			delimiter: ' ' ].
	^ commonFlags, ' ' ,flags.! !

!Linux32x86Config methodsFor: 'compiler flags' stamp: 'tty 6/14/2014 11:44'!
compilerFlagsBuild
	"backwards compatability with pharo. If adding, override compilerFlagsRelease in your configuration."

	^self compilerFlagsRelease.! !

!Linux32x86Config methodsFor: 'cmake' stamp: 'tty 6/13/2014 11:26'!
compilerFlagsDebug

	^ {
		'-g3'. 
		'-O0'. 
		'-msse2'. 
		'-D_GNU_SOURCE'. 
		'-DITIMER_HEARTBEAT=1'. 
		'-DNO_VM_PROFILE=1'. 
		'-DDEBUGVM=1' }! !

!Linux32x86Config methodsFor: 'squeak compatibility' stamp: 'tty 6/10/2014 16:38'!
configH
	" right now its like  that "
	^ '
#ifndef __sq_config_h
#define __sq_config_h

/* explicit image width */

#define HAVE_INTERP_H 1

/* package options */

#define USE_X11 1
#define USE_X11_GLX 1
/* #undef       USE_QUARTZ */
/* #undef       USE_QUARTZ_CGL */
/* #undef       USE_RFB */

/* libraries */

/* #undef       HAVE_LIBX11 */
#define HAVE_LIBXEXT 1
#define HAVE_LIBDL 1
/* #undef       HAVE_DYLD */
/* #undef       HAVE_LIBFFI */
/* #undef       HAVE_ICONV */

/* #undef       USE_AUDIO_NONE */
/* #undef       USE_AUDIO_SUN */
/* #undef       USE_AUDIO_NAS */
/* #undef       USE_AUDIO_OSS */
/* #undef       USE_AUDIO_MACOSX */
/* #undef       OSS_DEVICE */

/* header files */

#define HAVE_UNISTD_H 1
/* #undef       NEED_GETHOSTNAME_P */

#define HAVE_DIRENT_H 1
/* #undef       HAVE_SYS_NDIR_H */
/* #undef       HAVE_SYS_DIR_H */
/* #undef       HAVE_NDIR_H */
#define HAVE_DLFCN_H 1
/* #undef       HAVE_ICONV_H */

#define HAVE_SYS_TIME_H 1
#define TIME_WITH_SYS_TIME 1

#define HAVE_SYS_FILIO_H 1

/* #undef       HAVE_SYS_AUDIOIO_H */
/* #undef       HAVE_SUN_AUDIOIO_H */

/* #undef       HAVE_PTY_H */
/* #undef       HAVE_UTIL_H */
#define HAVE_LIBUTIL_H 1
/* #undef       HAVE_STROPTS_H */

#define HAVE_GL_GL_H 1
/* #undef       HAVE_OPENGL_GL_H */

/* #undef       NEED_SUNOS_H */


#define HAVE_UUID_H
/* system calls/library functions */

#define AT_EXIT atexit

#define HAVE_TZSET 1

#define HAVE_OPENPTY 1
/* #undef       HAVE_UNIX98_PTYS */

#define HAVE_SNPRINTF 1
/* #undef       HAVE___SNPRINTF */

#define HAVE_MMAP 1

/* #undef       HAVE_DYLD */

#define HAVE_LANGINFO_CODESET 1

#define HAVE_ALLOCA 1
/* #undef       HAVE_ALLOCA_H */

#define HAVE_UNSETENV 1

#define HAVE_NANOSLEEP 1

/* widths of primitive types */

#define SIZEOF_INT 4
#define SIZEOF_LONG 4
#define SIZEOF_LONG_LONG 8
#define SIZEOF_VOID_P 4

/* structures */

#define HAVE_TM_GMTOFF 1
#define HAVE_TIMEZONE 1

/* typedefs */

/* #undef       size_t */
/* #undef       socklen_t */

#define squeakInt64 long long

/* architecture */

#define OS_TYPE "unix"

#define VM_HOST "i386-freebsd8.2"
#define VM_HOST_CPU "i386"
/* #undef       VM_HOST_VENDOR */
#define VM_HOST_OS "freebsd8.2"
#define VM_BUILD_STRING "Unix built on "__DATE__ " "__TIME__" Compiler: "__VERSION__

/* #undef       WORDS_BIGENDIAN */
/* #undef       DOUBLE_WORD_ALIGNMENT */

/* damage containment */

/* #undef       DARWIN */

#ifdef NEED_SUNOS_H
# include "sunos.h"
#endif

/* other configured variables */

#define SQ_VERSION "3.9a-7024"
#define VM_VERSION "3.9-7"
#define VM_MODULE_PREFIX ""
/* #undef VM_DLSYM_PREFIX */
#define VM_X11DIR "/usr/X11R6/lib"

/* avoid dependencies on glibc2.3 */

/* #undef HAVE_FEATURES_H */

#if defined(HAVE_FEATURES_H)
# include "glibc.h"
#endif

#endif /* __sq_config_h */
																																																																					
																																																																				'! !

!Linux32x86Config methodsFor: 'cmake' stamp: 'tty 6/12/2014 17:48'!
configureBuildAssertITimerHeartbeat
	generateBuildAssertITimerHeartbeat:=true.! !

!Linux32x86Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 20:05'!
configureForBuildType: aSymbol
	| d |
	"provide a concrete builder with the buildType and configureBuildX method to invoke"
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	self configureNoBuildType.                "reset all internal flags"
	d 
		at: #build 
		put: [self buildType:#build.  self configureBuild];

		at: #buildAssert 
		put: [self buildType: #buildAssert.  	self configureBuildAssert];

		at: #buildAssertITimerHeartbeat 
		put:     [ self buildType: #buildAssertITimerHeartbeat.   self configureBuildAssertITimerHeartbeat];

            at:#buildDebug 
		put: [self buildType: #buildDebug.  self configureBuildDebug];

		at: #buildDebugITimerHeartbeat 
		put:  [self buildType: #buildDebugITimerHeartbeat.   self configureBuildDebugITimerHeartbeat];

		at: #buildITimerHeartbeat 
		put: [self buildType:#buildITimerHeartbeat.    self configureBuildIHeartbeatTimer];

		at: #buildMultiThreaded 
		put:  [self buildType:#buildMultiThreaded . self configureBuildMultiThreaded];

		at: #buildMultiThreadedAssert 
		put: [self buildType: #buildMultiThreadedAssert. self configureBuildMultiThreadedAssert];

		at: #buildMultiThreadedDebug  
		put: [self buildType: #buildMultiThreadedDebug. self configureBuildMultiThreadedDebug].

     ^(d at: aSymbol).! !

!Linux32x86Config methodsFor: 'cmake' stamp: 'tty 6/12/2014 17:08'!
configureNoBuildType
		generateBuild:=generateBuildAssert:=generateBuildAssertITimerHeartbeat:=generateBuildDebug:=generateBuildDebugITimerHeartbeat:= generateBuildDebugMultiThreaded:= generateBuildIHeartbeatTimer:= generateBuildMultiThreaded:= generateBuildMultiThreadedAssert:= generateBuildMultiThreadedDebug:=false.! !

!Linux32x86Config methodsFor: 'sources' stamp: 'tty 6/13/2014 12:25'!
coreSources
	"files to include from src/vm dir"
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!Linux32x86Config methodsFor: 'plugins' stamp: 'tty 6/11/2014 14:20'!
defaultExternalPlugins
" tty 2014.06.10  cut-n-paste from Cog/build.linux32x86/newspeak.cog.spur/build/plugins.ext"
	^ #(B3DAcceleratorPlugin 
		BochsIA32Plugin 
	      ThreadedFFIPlugin    "moduleName->SqueakFFIPrims "
		"FFIPlugin"                   "moduleName->SqueakFFIPrims "
		SqueakSSLPlugin       "moduleName->SqueakSSL" 
		LocalePlugin 
		UnixOSProcessPlugin 
		UUIDPlugin)


"N.B. Regarding ThreadedFFIPlugin and FFIPlugin from eem:

Use  ThreadedFFIPlugin.  The FFIPlugin is obsolete (it requires assembler support files, and is non-reentrant).  This should generate in src/plugins/SqueakFFIPrims/{SqueakFFIPrims.c,ARM32FFIPlugin.c,IA32FFIPlugin.c} and you should compile only src/plugins/SqueakFFIPrims/SqueakFFIPrims.c.  src/plugins/SqueakFFIPrims/SqueakFFIPrims.c is a simple wrapper that includes ARM32FFIPlugin.c or IA32FFIPlugin.c as appropriate (and others can be added as they are developed).


"! !

!Linux32x86Config methodsFor: 'plugins' stamp: 'tty 6/13/2014 11:45'!
defaultInternalPlugins
" tty 2014.06.10  cut-n-paste from Cog/build.linux32x86/newspeak.cog.spur/build/plugins.int
   N.B. moduleName->XYZ means XYZ appears in the GNU-Build's plugins.int/ext. However, Smalltalk requires the class name.
                                 XYZSmalltalkClass  moduleName->XYZ as it appears in plugins.int/ext
"
	^ #(
	    ADPCMCodecPlugin
    AsynchFilePlugin
    BalloonEnginePlugin "moduleName -->B2DPlugin"
    BitBltSimulation        "moduleName->BitBltPlugin"
    BMPReadWriterPlugin
    CroquetPlugin
    DeflatePlugin               "moduleName->ZipPlugin"
    DropPlugin
    DSAPlugin                    "moduleName->DSAPrims"
    FFTPlugin
    FileCopyPlugin
    FilePlugin
    FloatArrayPlugin
    FloatMathPlugin
    IA32ABIPlugin             "moduleName->IA32ABI"
   " InflatePlugin"               "moduleName->ZipPlugin"   "already included with the DeflatePlugin"
    JoystickTabletPlugin
    JPEGReaderPlugin
    JPEGReadWriter2Plugin
    KlattSynthesizerPlugin  "moduleName->Klatt"
    LargeIntegersPlugin      "moduleName->LargeIntegers"
    Matrix2x3Plugin
    MIDIPlugin
    MiscPrimitivePlugin
    Mpeg3Plugin
    RePlugin
    SecurityPlugin
    SerialPlugin
    SocketPlugin
    SoundCodecPlugin        "moduleName->SoundCodecPrims"
    SoundGenerationPlugin
    SoundPlugin
    StarSqueakPlugin
    SurfacePlugin
    VMProfileLinuxSupportPlugin)! !

!Linux32x86Config methodsFor: 'cmake' stamp: 'tty 6/12/2014 13:07'!
dirArmv6
	^'cmake.build.arm.v6'! !

!Linux32x86Config methodsFor: 'cmake' stamp: 'tty 6/7/2014 16:45'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakCogV3! !

!Linux32x86Config methodsFor: 'cmake' stamp: 'tty 6/7/2014 16:44'!
dirBuildPlatform
	"the directory for the platform. example: build.linux32x86"
	^self dirLinux32x86! !

!Linux32x86Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 16:59'!
excludeFromBuild
	"over-ride to exclude yourself from a build"
	^true! !

!Linux32x86Config methodsFor: 'accessing' stamp: 'tty 6/13/2014 12:38'!
executableName
	self required! !

!Linux32x86Config methodsFor: 'accessing' stamp: 'tty 6/13/2014 17:27'!
executableType
	^''

"
SystemNavigation default browseMethodsWhoseNamesContain: ''executableType''
	^ 'MACOSX_BUNDLE'
	^ 'WIN32'\
	^ ''
"! !

!Linux32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 6/13/2014 12:49'!
extraPluginSettings: maker
	super extraPluginSettings: maker.  
	maker set: #linkFlags toString: '${linkFlags} -m32'! !

!Linux32x86Config methodsFor: 'sources' stamp: 'tty 6/13/2014 12:26'!
extraSources
	self flag: 'tty'. "what is this?"
	^ 'version.c'! !

!Linux32x86Config methodsFor: 'settings' stamp: 'tty 6/14/2014 12:19'!
extraVMSettings: maker
	| versionC |
	self generateConfigH.
	
	"add a generated version.c"
	
	versionC := 'version.c'.
	
	maker cmd: 'add_custom_command' params: 'OUTPUT ',
		versionC , '
		COMMAND ${platformsDir}/unix/config/verstamp ',versionC,' gcc
		COMMENT "Generating version.c"
	'.
	
	! !

!Linux32x86Config methodsFor: 'squeak compatibility' stamp: 'tty 6/13/2014 12:40'!
generate
	self generatePluginsList. 
	self generateLicense. 
	^ CMakeVMGeneratorForSqueak generate: self ! !

!Linux32x86Config methodsFor: 'headers generation' stamp: 'tty 6/16/2014 18:01'!
generateConfigH
	"	
	used to be: 	
		self write: self configH toFile: 'config.h'
      but with variable buildTypes we need:
"
	self write: (self generateConfigH: buildType) toFile: 'config.h'   
! !

!Linux32x86Config methodsFor: 'headers generation' stamp: 'tty 6/16/2014 20:06'!
generateConfigH: aBuildType
	"self write: self configH toFile: 'config.h'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self configHBuild];
		at: #buildAssert  put: [self configHBuildAssert];
		at: #buildAssertITimerHeartbeat  put: [self configHBuildAssertITimerHeartbeat];
            at:#buildDebug  put: [self configHBuildDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self configHBuildDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self configHBuildITimerHeartbeat];
		at: #buildMultiThreaded  put: [self configHBuildMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self configHBuildMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self configHBuildMultiThreadedDebug ];
		at: #buildNone put:[self configHNoBuildType].


	 ^(d at: ( aBuildType)) value



! !

!Linux32x86Config methodsFor: 'initialize-release' stamp: 'tty 6/9/2014 12:28'!
initialize
	super initialize.
	"this should be in my superclass, but I do not have permission to modify it. tty"
	 generateForAssert:= generateForAssertHeartbeatTimer:= generateForDebug :=generateForDebugWithHeartbeatTimer:= generateForDebugMultiThreadedFFI:= generateForReleaseHeartbeatTimer:= generateForReleaseMultiThreadedFFI:=false! !

!Linux32x86Config methodsFor: 'accessing' stamp: 'tty 6/13/2014 17:35'!
linkFlags
"	^ super linkFlags , ' -luuid -lSM -lICE -ldl -lGL -lpthread -lm -lnsl -lX11'"
	^ super linkFlags , ' -luuid -lSM -lICE -ldl  -lpthread -lm -lnsl -lX11'

! !

!Linux32x86Config methodsFor: 'cmake' stamp: 'tty 6/7/2014 16:51'!
oscogvm
	^ 'oscogvm'! !

!Linux32x86Config methodsFor: 'squeak compatibility' stamp: 'tty 6/14/2014 15:42'!
outputDir

	"the directory where built binaries will be stored"
	^ outputDir ifNil: [ outputDir := (self topDir / self dirOutput /  self dirInstall) ]	

! !

!Linux32x86Config methodsFor: 'sources' stamp: 'tty 6/13/2014 12:27'!
platformSources
	"files added from platform/unix/vm dir "
	^ #(
	'aio.c'
	'debug.c'
"	'dlfcn-dyld.c'
	'mac-alias.c' "
	'osExports.c'
	'sqUnixCharConv.c'
"	'sqUnixEvent.c' "
	'sqUnixExternalPrims.c'
	'sqUnixHeartbeat.c'
	'sqUnixMain.c'
	'sqUnixMemory.c'
	'sqUnixThreads.c'
	'sqUnixVMProfile.c'
	)! !

!Linux32x86Config methodsFor: 'source files' stamp: 'tty 6/14/2014 21:32'!
preferredIncludes
	self flag:'tty'. "pharo does not support newspeak or sista., yet sets this in CogUnixConfig. Is this appropriate here? Revisit when coding newspeak etc"
	^ #(  '${targetPlatform}/plugins/AioPlugin'
 '${targetPlatform}/plugins/B3DAcceleratorPlugin'
 '${targetPlatform}/plugins/DropPlugin'
 '${targetPlatform}/plugins/FilePlugin'
 '${targetPlatform}/plugins/HostWindowPlugin'
 '${targetPlatform}/plugins/JPEGReadWriter2Plugin'
 '${targetPlatform}/plugins/LocalePlugin'
 '${targetPlatform}/plugins/Mpeg3Plugin'
 '${targetPlatform}/plugins/PseudoTTYPlugin'
 '${targetPlatform}/plugins/SerialPlugin'
 '${targetPlatform}/plugins/SoundPlugin'
 '${crossDir}/plugins/SoundGenerationPlugin'
 '${targetPlatform}/plugins/SqueakSSL'
 '${targetPlatform}/plugins/UnixOSProcessPlugin'
 '${targetPlatform}/plugins/AsynchFilePlugin'
 '${targetPlatform}/plugins/BochsIA32Plugin'
 '${targetPlatform}/plugins/FileCopyPlugin'
 '${targetPlatform}/plugins/FloatMathPlugin'
 '${targetPlatform}/plugins/InternetConfigPlugin'
 '${targetPlatform}/plugins/JoystickTabletPlugin'
 '${targetPlatform}/plugins/MIDIPlugin'
 '${targetPlatform}/plugins/PrintJobPlugin'
 '${targetPlatform}/plugins/SecurityPlugin'
 '${targetPlatform}/plugins/SocketPlugin'
 '${targetPlatform}/plugins/SqueakFFIPrims'
 '${targetPlatform}/plugins/UUIDPlugin'    
 '${targetPlatform}/plugins/XDisplayControlPlugin'

)


	

"SystemNavigation default browseMethodsWhoseNamesContain: 'preferredIncludes'"
	! !

!Linux32x86Config methodsFor: 'squeak compatibility' stamp: 'tty 6/9/2014 18:18'!
prepareVMMaker
	
	| maker allPlugins |
	
	"In CogVMs (in contrast to Interpreter VM) the generated sources are platform independent, therefore Cross is ok"
	maker := VMMaker forPlatform: 'Cross'.
	
	maker sourceDirectoryName: self srcDir pathName.
	maker platformRootDirectoryName: self platformsDir.
	
	
	allPlugins := self internalPlugins , self externalPlugins.
	
	"touch plugins to force their source generation unconditionally"
	allPlugins do: [:name | (Smalltalk globals at: name) touch ].
	
	" Why we put all plugins as external?   Because the generated sources are not different whether the plugins were defined as internal or external. VMMaker used to need this to to generate plugins.int and plugins.ext files. But since this is achieved in another way with CMakeVMMaker, there is no different at all to put all plugins as internal or as external."
	maker externalModules addAll:  allPlugins.
	
	^ maker! !

!Linux32x86Config methodsFor: 'utils' stamp: 'tty 6/14/2014 21:04'!
setExtraTargetProperties: maker
	self flag:'tty'. "I am nervous about this method up here in this class, but pharo has it in CogUnixConfig, so using as is for now"

	maker setTargetProperties: 'LINK_FLAGS "-m32"'.
		
	maker puts: 'set_source_files_properties( ${srcVMDir}/cogit.c PROPERTIES 
		COMPILE_FLAGS "-O1 -fno-omit-frame-pointer -momit-leaf-frame-pointer -mno-rtd -mno-accumulate-outgoing-args")'.
		
	
	maker 
		cmd: 'set_source_files_properties'
		params: ' ${targetPlatform}/vm/sqUnixHeartbeat.c PROPERTIES 
		COMPILE_FLAGS "-O1 -fno-omit-frame-pointer -mno-rtd -mno-accumulate-outgoing-args"'.
	
	maker addExternalLibraries: 
		#(
			'uuid'  ""
			'ssl'  ""
			'crypto' ""
		).
					
	super setExtraTargetProperties: maker.
! !

!Linux32x86Config methodsFor: 'utils' stamp: 'tty 6/14/2014 21:04'!
setGlobalOptions: maker

	maker set: 'CMAKE_C_COMPILER' to: '/usr/bin/gcc'.
	maker set: 'CMAKE_CXX_COMPILER' to: '/usr/bin/g++'.
"	maker set: 'CMAKE_LIBRARY_PATH ${CMAKE_LIBRARY_PATH}' to: ' /usr/lib/gcc/x86_64-slackware-linux/4.8.2/'. 
set any CMake global options, before declaring a project in cmake file
	
	set(CMAKE_LIBRARY_PATH ${CMAKE_LIBRARY_PATH} /opt/local/lib)
	SystemNavigation default browseMethodsWhoseNamesContain: 'setGlobalOptions:'
"! !

!Linux32x86Config methodsFor: 'utils' stamp: 'tty 6/16/2014 20:06'!
setGlobalOptionsAfterDetermineSystem: aMaker buildType: aBuildType
	"invoke correct setGlobalOptions for this buildType to allow per-buildType customization'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self setGlobalOptionsAfterDetermineSystemBuild: aMaker];
		at: #buildAssert  put: [self setGlobalOptionsAfterDetermineSystemBuildAssert: aMaker];
		at: #buildAssertITimerHeartbeat  put: [self setGlobalOptionsAfterDetermineSystemBuildAssertITimerHeartbeat: aMaker];
            at:#buildDebug  put: [self setGlobalOptionsAfterDetermineSystemBuildDebug: aMaker];   
		at: #buildITimerHeartbeat  put: [self setGlobalOptionsAfterDetermineSystemBuildITimerHeartbeat: aMaker];
		at: #buildMultiThreaded  put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreaded: aMaker ];
		at: #buildMultiThreadedAssert  put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreadedAssert: aMaker];
		at: #buildMultiThreadedDebug   put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreadedDebug: aMaker ];
		at: #buildNone put:[self setGlobalOptionsBuildNone: aMaker].

	 ^(d at: ( aBuildType)) value
! !

!Linux32x86Config methodsFor: 'squeak compatibility' stamp: 'tty 6/9/2014 18:19'!
setupDirectories: gen
	| dirsInclude |

	" write the directories in separate include file"
	dirsInclude := gen captureOutputDuring: [
		gen
			set: #topDir toString: (self topDir fullName); 
			set: #buildDir toString: (self buildDir ifNil: ['${topDir}/build'] ifNotNil: [self buildDir fullName] );
			set: #thirdpartyDir toString: '${buildDir}/thirdParty';
			set: #platformsDir toString: self platformsDir;
			set: #srcDir toString: self srcDir pathName;
			set: #srcPluginsDir toString: (pluginsDir ifNil: [ '${srcDir}/plugins' ]);
			set: #srcVMDir toString: '${srcDir}/vm';
			set: #platformName toString: self platformName;
			set: #targetPlatform to: '${platformsDir}/${platformName}';
			set: #crossDir toString: '${platformsDir}/Cross';
			set: #platformVMDir toString: '${targetPlatform}/vm';
			set: #outputDir toString: self outputDir fullName.
	].

	self write: dirsInclude toFile: 'directories.cmake'.
	
	gen include: 'directories.cmake'.
! !

!Linux32x86Config methodsFor: 'squeak compatibility' stamp: 'tty 6/7/2014 18:05'!
srcDir
		^ srcDir ifNil: [ srcDir := (self topDir directoryNamed: 'src' )]! !

!Linux32x86Config methodsFor: 'squeak compatibility' stamp: 'tty 6/7/2014 16:57'!
topDir
	"N.B. this is a clash between Trait usage and Inheritence usage due to restrictions on modifying pharo's source"
	^ topDir ifNil: [ topDir := FileDirectory default directoryNamed: self oscogvm ]
	! !

!Linux32x86Config methodsFor: 'squeak compatibility' stamp: 'tty 6/9/2014 18:20'!
validateSourcesPresent
	| sources |
	sources := Smalltalk sourcesName.
	
	(sources == nil)
		ifTrue: [	self error: 'VM source code cannot be generated without .sources file'.]		! !

!Linux32x86Config methodsFor: 'squeak compatibility' stamp: 'tty 6/9/2014 18:20'!
write: aContents toFile: aFileName
	"write a file to current output directory (buildDir).
	use line end convention appropriate for config platform"

	| bldDir |
	bldDir := self buildDir.
	bldDir isString
		ifTrue: [ bldDir := FileDirectory directoryEntryFor: bldDir ].
	bldDir assureExistence.
	bldDir
		forceNewFileNamed: aFileName
		do: [:s | s
				nextPutAll: (self fixLineEndsOf: aContents)]

! !

Linux32x86Config subclass: #Linux32x86NewspeakCogSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Linux32x86'!

!Linux32x86NewspeakCogSpurConfig commentStamp: 'tty 6/15/2014 14:03' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


I am not meant to be built.

SqueakLinux32x86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!Linux32x86NewspeakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:03'!
dirBuildLanguageVMMM
	^self newspeakCogSpur! !

!Linux32x86NewspeakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:35'!
excludeFromBuild
	^true
! !

!Linux32x86NewspeakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:08'!
executableName
	^ self vmCogExecutableName! !

!Linux32x86NewspeakCogSpurConfig methodsFor: 'source generation' stamp: 'tty 6/13/2014 12:06'!
prepareForGeneration
	^ self prepareForCogGeneration
! !

Linux32x86Config subclass: #Linux32x86NewspeakCogV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Linux32x86'!

!Linux32x86NewspeakCogV3Config commentStamp: 'tty 6/15/2014 14:03' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


I am not meant to be built.

SqueakLinux32x86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!Linux32x86NewspeakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:03'!
dirBuildLanguageVMMM
	^self newspeakCogV3! !

!Linux32x86NewspeakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:35'!
excludeFromBuild
	^true
! !

!Linux32x86NewspeakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:08'!
executableName
	^ self vmCogExecutableName! !

!Linux32x86NewspeakCogV3Config methodsFor: 'source generation' stamp: 'tty 6/13/2014 12:05'!
prepareForGeneration
	^ self prepareForCogGeneration
! !

Linux32x86Config subclass: #Linux32x86NewspeakSistaSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Linux32x86'!

!Linux32x86NewspeakSistaSpurConfig commentStamp: 'tty 6/15/2014 14:03' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


I am not meant to be built.

SqueakLinux32x86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!Linux32x86NewspeakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:03'!
dirBuildLanguageVMMM
	^self newspeakSistaSpur! !

!Linux32x86NewspeakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 12:12'!
excludeFromBuild
	"over-ride to exclude yourself from a build"
	^true "tty 2014.06.10 not implemented on gnu side"! !

!Linux32x86NewspeakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:57'!
executableName
	^ self vmSistaExecutableName! !

Linux32x86Config subclass: #Linux32x86NewspeakSistaV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Linux32x86'!

!Linux32x86NewspeakSistaV3Config commentStamp: 'tty 6/15/2014 14:03' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


I am not meant to be built.

SqueakLinux32x86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!Linux32x86NewspeakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:04'!
dirBuildLanguageVMMM
	^self newspeakSistaV3! !

!Linux32x86NewspeakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 12:14'!
excludeFromBuild
	"over-ride to exclude yourself from a build"
	^true "tty 2014.06.10 not implemented on gnu side"! !

!Linux32x86NewspeakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:57'!
executableName
	^ self vmSistaExecutableName! !

Linux32x86Config subclass: #Linux32x86NewspeakStackSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Linux32x86'!

!Linux32x86NewspeakStackSpurConfig commentStamp: 'tty 6/15/2014 14:03' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


I am not meant to be built.

SqueakLinux32x86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!Linux32x86NewspeakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:04'!
dirBuildLanguageVMMM
	^self newspeakStackSpur! !

!Linux32x86NewspeakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:36'!
excludeFromBuild
	^true
! !

!Linux32x86NewspeakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:04'!
executableName
	^ self vmStackExecutableName! !

Linux32x86Config subclass: #Linux32x86NewspeakStackV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Linux32x86'!

!Linux32x86NewspeakStackV3Config commentStamp: 'tty 6/15/2014 14:03' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


I am not meant to be built.

SqueakLinux32x86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!Linux32x86NewspeakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/7/2014 16:45'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackV3! !

!Linux32x86NewspeakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:36'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Linux32x86NewspeakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:03'!
executableName
	^ self vmStackExecutableName! !

Linux32x86Config subclass: #Linux32x86SqueakCogSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Linux32x86'!

!Linux32x86SqueakCogSpurConfig commentStamp: 'tty 6/15/2014 14:03' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


I am not meant to be built.

SqueakLinux32x86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!Linux32x86SqueakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/7/2014 16:45'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakCogSpur! !

!Linux32x86SqueakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:36'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Linux32x86SqueakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:08'!
executableName
	^ self vmCogExecutableName! !

!Linux32x86SqueakCogSpurConfig methodsFor: 'source generation' stamp: 'tty 6/13/2014 12:05'!
prepareForGeneration
	^ self prepareForCogGeneration
! !

Linux32x86Config subclass: #Linux32x86SqueakCogV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Linux32x86'!

!Linux32x86SqueakCogV3Config commentStamp: 'tty 6/15/2014 14:03' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


I am not meant to be built.

SqueakLinux32x86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!Linux32x86SqueakCogV3Config methodsFor: 'source generation' stamp: 'tty 6/13/2014 12:07'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!Linux32x86SqueakCogV3Config methodsFor: 'compiler flags' stamp: 'tty 6/13/2014 17:25'!
commonCompilerFlags
	^ {
		'-DLSB_FIRST=1'. 
		'-DUSE_GLOBAL_STRUCT=0'. 
		'-DCOGMTVM=0'. 
		'-m32'.
		'-DENABLE_FAST_BLT ' } 	
	! !

!Linux32x86SqueakCogV3Config methodsFor: 'compiler flags' stamp: 'tty 6/13/2014 17:16'!
compilerFlagsDebug
"
SystemNavigation default browseMethodsWhoseNamesContain: ''compilerFlagsRelease''
"
	

	^ {
		'-g3'. 
		'-O0'. 
		'-msse2'. 
		'-D_GNU_SOURCE'. 
		'-DITIMER_HEARTBEAT=1'. 
		'-DNO_VM_PROFILE=1'. 
		'-DDEBUGVM=1' }! !

!Linux32x86SqueakCogV3Config methodsFor: 'compiler flags' stamp: 'tty 6/13/2014 17:15'!
compilerFlagsRelease
"
SystemNavigation default browseMethodsWhoseNamesContain: ''compilerFlagsRelease''
"
	^ {
		'-g0'. 
		'-O2'. 
		'-fno-tree-pre'. 
		'-fno-caller-saves'. 
		'-msse2'. 
		'-D_GNU_SOURCE'. 
		'-DNDEBUG'. 
		'-DITIMER_HEARTBEAT=1'. 
		'-DNO_VM_PROFILE=1'. 
		'-DDEBUGVM=0' }! !

!Linux32x86SqueakCogV3Config methodsFor: 'sources' stamp: 'tty 6/13/2014 17:28'!
coreSources
	"files to include from src/vm dir"
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!Linux32x86SqueakCogV3Config methodsFor: 'plugins' stamp: 'tty 6/13/2014 13:27'!
defaultExternalPlugins
	""
	self flag:'tty'. "UUIDPlugin does not build on my linux system. fix this"
	^ (super defaultExternalPlugins copyWithoutAll: #(#UUIDPlugin #UnixOSProcessPlugin))! !

!Linux32x86SqueakCogV3Config methodsFor: 'plugins' stamp: 'tty 6/13/2014 13:28'!
defaultInternalPlugins
	""
	self flag:'tty'. "UUIDPlugin does not build on my linux system. fix this"
	^ (super defaultInternalPlugins copyWithoutAll: #(#VMProfileLinuxSupportPlugin))! !

!Linux32x86SqueakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:04'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakCogV3! !

!Linux32x86SqueakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:36'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Linux32x86SqueakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:08'!
executableName
	^ self vmCogExecutableName! !

!Linux32x86SqueakCogV3Config methodsFor: 'source generation' stamp: 'tty 6/11/2014 10:57'!
interpreterClass
	^ CoInterpreter! !

!Linux32x86SqueakCogV3Config methodsFor: 'source generation' stamp: 'tty 6/11/2014 10:23'!
prepareForGeneration
	^ self prepareForCogGeneration
! !

!Linux32x86SqueakCogV3Config methodsFor: 'utils' stamp: 'tty 6/13/2014 16:29'!
setExtraTargetProperties: maker

	maker setTargetProperties: 'LIBS "-lptrhead -luuid"'.
	maker setTargetProperties: 'LDFLAGS "-Wl -z now"'.

	super setExtraTargetProperties: maker.
! !

Linux32x86Config subclass: #Linux32x86SqueakCogV3DebugConfigz
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-IslandOfMisfitToys'!

!Linux32x86SqueakCogV3DebugConfigz commentStamp: 'tty 6/7/2014 10:34' prior: 0!
I need to go away. In the meantime....

THis is a concrete class which generates a DEBUG CogVM for Unix systems. This VM is normally known as a debug CogVM. The debug means that it is compiled with all the necessary symbolic symbols for debugging and can be debugged, for example, with GDB.


Fore more information, check the class comments of all the superclasses.
!

!Linux32x86SqueakCogV3DebugConfigz methodsFor: 'squeak compatibility' stamp: 'tty 6/16/2014 20:07'!
compilerFlags
	|d commonFlags flags|
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self compilerFlagsBuild];
		at: #buildAssert  put: [self compilerFlagsAssert];
		at: #buildAssertITimerHeartbeat  put: [self compilerFlagsAssertITimerHeartbeat];
            at:#buildDebug  put: [self compilerFlagsDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self compilerFlagsDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self compilerFlagsIHeartbeatTimer];
		at: #buildMultiThreaded  put: [self compilerFlagsMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self compilerFlagsMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self compilerFlagsMultiThreadedDebug ];
		at: #buildNone put:[self compilerFlagsNoBuildType].

    flags:= String streamContents: [ :stream |
	 (((d at:  buildType) value)  collect: #withBlanksTrimmed as: Set)
		asStringOn: stream 
		delimiter:' '].

    commonFlags:=String streamContents: [ :stream |
		((self commonCompilerFlags) collect: #withBlanksTrimmed as: Set)
			asStringOn: stream 
			delimiter: ' ' ].
	^ commonFlags, ' ' ,flags.! !

!Linux32x86SqueakCogV3DebugConfigz methodsFor: 'plugins' stamp: 'tty 5/23/2014 19:41'!
defaultExternalPlugins
	^ (super defaultExternalPlugins copyWithoutAll: #(#ThreadedIA32FFIPlugin #InternetConfigPlugin))

! !

!Linux32x86SqueakCogV3DebugConfigz methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:36'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

Linux32x86Config subclass: #Linux32x86SqueakCogV3MultiThreadedConfigz
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-IslandOfMisfitToys'!

!Linux32x86SqueakCogV3MultiThreadedConfigz commentStamp: 'tty 6/7/2014 10:34' prior: 0!
This is a concrete class which generates a thread-aware VM and threaded FFI CogVM for Unix. This VM is normally known as CogMTVM.

For more information, check the class comments of all the superclasses.

Linux32x86SqueakCogV3MultiThreadedConfig generateWithSources.
Linux32x86SqueakCogV3MultiThreadedConfig generate.
!

!Linux32x86SqueakCogV3MultiThreadedConfigz methodsFor: 'squeak compatibility' stamp: 'tty 5/23/2014 19:23'!
buildDirName
	^ 'cmake_unixbuild/mtbld'! !

!Linux32x86SqueakCogV3MultiThreadedConfigz methodsFor: 'compiler flags' stamp: 'tty 5/23/2014 18:09'!
commonCompilerFlags

	"Common compiler flags
	
	
	LSB_FIRST=1 means that target platform is little endian. 
	set it to 0 for big-endian platforms
	
	"
	
	^ {
		'-DLSB_FIRST=1'. 
		'-DUSE_GLOBAL_STRUCT=0'. 
		'-DCOGMTVM=1'. 
		'-m32' }! !

!Linux32x86SqueakCogV3MultiThreadedConfigz methodsFor: 'plugin extra rules' stamp: 'tty 5/23/2014 18:09'!
configureReentrantIA32FFIPlugin: maker
	self error: 'use ThreadedIA32FFIPlugin instead'
! !

!Linux32x86SqueakCogV3MultiThreadedConfigz methodsFor: 'sources' stamp: 'tty 5/23/2014 18:09'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerpmt.c'
		)! !

!Linux32x86SqueakCogV3MultiThreadedConfigz methodsFor: 'plugins' stamp: 'tty 5/23/2014 19:03'!
defaultExternalPlugins
	^ (super defaultExternalPlugins copyWithoutAll: #(#ThreadedIA32FFIPlugin #InternetConfigPlugin))

! !

!Linux32x86SqueakCogV3MultiThreadedConfigz methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:36'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Linux32x86SqueakCogV3MultiThreadedConfigz methodsFor: 'accessing' stamp: 'tty 5/23/2014 18:09'!
executableName
	^ 'CogMTVM'! !

!Linux32x86SqueakCogV3MultiThreadedConfigz methodsFor: 'source generation' stamp: 'tty 5/23/2014 18:09'!
interpreterClass
	^ CoInterpreterMT! !

Linux32x86Config subclass: #Linux32x86SqueakSistaSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Linux32x86'!

!Linux32x86SqueakSistaSpurConfig commentStamp: 'tty 6/15/2014 14:03' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


I am not meant to be built.

SqueakLinux32x86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!Linux32x86SqueakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:04'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakSistaSpur! !

!Linux32x86SqueakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:36'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Linux32x86SqueakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:57'!
executableName
	^ self vmSistaExecutableName! !

Linux32x86Config subclass: #Linux32x86SqueakSistaV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Linux32x86'!

!Linux32x86SqueakSistaV3Config commentStamp: 'tty 6/15/2014 14:03' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


I am not meant to be built.

SqueakLinux32x86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!Linux32x86SqueakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:04'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakSistaV3! !

!Linux32x86SqueakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:36'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Linux32x86SqueakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:57'!
executableName
	^ self vmSistaExecutableName! !

Linux32x86Config subclass: #Linux32x86SqueakStackSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Linux32x86'!

!Linux32x86SqueakStackSpurConfig commentStamp: 'tty 6/15/2014 14:03' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


I am not meant to be built.

SqueakLinux32x86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!Linux32x86SqueakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:04'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackSpur! !

!Linux32x86SqueakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:36'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Linux32x86SqueakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:03'!
executableName
	^ self vmStackExecutableName! !

Linux32x86Config subclass: #Linux32x86SqueakStackV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Linux32x86'!

!Linux32x86SqueakStackV3Config commentStamp: 'tty 6/15/2014 14:03' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


I am not meant to be built.

SqueakLinux32x86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!Linux32x86SqueakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:04'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackV3! !

!Linux32x86SqueakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:37'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Linux32x86SqueakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:03'!
executableName
	^ self vmStackExecutableName! !

CogFamilyUnixConfig subclass: #Linux32x86SqueakCogV3Configz
	uses: TCPlatformConfigForSqueak
	instanceVariableNames: 'buildType generateForAssert generateForDebug generateForDebugWithHeartbeatTimer generateForDebugMultiThreadedFFI generateForReleaseHeartbeatTimer generateForReleaseMultiThreadedFFI generateForAssertHeartbeatTimer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-IslandOfMisfitToys'!

!Linux32x86SqueakCogV3Configz commentStamp: 'tty 6/7/2014 10:35' prior: 0!
Base and concrete configuration for building a CogVM on Unix platform(s).

Usage: 
Linux32x86SqueakCogV3Config generateWithSources
or
Linux32x86SqueakCogV3Config generate   "if VMMaker sources already there"

Or:
find my Builder in CMakeVMMakerSqueak-Builder category and use that to query me or invoke me
!

Linux32x86SqueakCogV3Configz class
	uses: TCPlatformConfigForSqueak classTrait
	instanceVariableNames: ''!

!Linux32x86SqueakCogV3Configz class methodsFor: 'as yet unclassified' stamp: 'tty 6/8/2014 14:23'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default allBuildConfigurations
! !

!Linux32x86SqueakCogV3Configz class methodsFor: 'as yet unclassified' stamp: 'tty 5/23/2014 19:28'!
licenseTemplate
	^'Squeak  {1} license information
==============================

About Squeak
-----------


Squeak is a modern, open source, full-featured implementation of the powerful Smalltalk programming language and environment. Squeak is highly-portable, running on almost any platform you could name and you can really truly write once run anywhere.  Squeak is the vehicle for a wide range of projects from multimedia applications and educational platforms to commercial web application development. Read on and join in!!

http://www.squeak.org


LIcense

Note: The current release of Squeak is a combination of source code originating from it''s origins at Apple which Apple agreed to license under the Apache license and more recent contributions licensed under the MIT license. The vast majority of the code is under the MIT license.
MIT License

Copyright (c) The individual, corporate, and institutional contributors who have collectively contributed elements to this software ("The Squeak Community"), 1996-2010 All rights reserved.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
Portions of Squeak are covered by the following license:
Apache License, Version 2.0

Copyright (c) Xerox Corp. 1981, 1982 All rights reserved. Copyright (c) Apple Computer, Inc. 1985-1996 All rights reserved.

Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.


About Cog
---------

Cog is a virtual machine designed for Smalltalk and other similar dynamic languages.  Cog builds on the
Squeak virtual machine adding a stack-to-register-mapping just-in-time compiler, aggressive in-line message
cacheing and effective optimization of Smalltalk’s first-class activation records.  Cog is the virtual machine
underlying Teleplace''s Croquet-based enterprise virtual collaboration spaces software, the fastest virtual
machine for Squeak, and for Gilad Bracha''s Newspeak modular language inspired by Beta and Smalltalk.  
Like the original Squeak VM, Cog is implemented and developed in Smalltalk, and translated into a lower-level
language to produce the production VM.  Being a Smalltalk program it is a delight to develop.  Cog is
available under the MIT open source license and is unencumbered for commercial deployment.

Cog''s performance relative to the existing Squeak interpreter varies, depending on the benchmark chosen.
As of early-2011, the Cog JIT uses strong inline cacheing techniques and stack-to-register mapping that
results in a register-based calling convention for low-arity methods.  Due to the complexity of the Squeak
object representation it has a limited set of primitives implemented in machine code that, for example,
exclude object allocation.  Performance of the early-2011 JIT for the nbody, binarytrees and chameneos
redux benchmarks from the computer language shootout is in the range of 4 to 6 times faster than the
interpreter.
'! !

!Linux32x86SqueakCogV3Configz class methodsFor: 'as yet unclassified' stamp: 'tty 5/23/2014 19:28'!
pluginsTemplate
	^'Squeak {1} ships with the following plugins already built:
		
Internal: 
=========
{2}

External: 
=========
{3}

'! !

!Linux32x86SqueakCogV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 5/23/2014 19:13'!
addDriver: name sources: aSources generator: cmakeGen externalLibs: extLibs

	| cfg srcs |
	
	srcs := aSources inject: '' into: [:res :each | res , ' "', each, '"' ].
	cfg := cmakeGen
		captureOutputDuring: [
			cmakeGen printHeader;
			project: name;
			include: '../directories.cmake';
		
			message: 'Adding module: ', name;
			
			addDefinitions:  self compilerFlags;
			addDefinitions: '-fPIC -DPIC';
			set: #sources to: srcs;
			cmd: 'add_library' params: name, ' SHARED ${sources}'; 
			includeDirectories: '${crossDir}/plugins/FilePlugin';
			includeDirectories: '${targetPlatform}/plugins/B3DAcceleratorPlugin';
			includeDirectories: '${crossDir}/plugins/B3DAcceleratorPlugin';
			set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir fullName;
			addExternalLibraries: extLibs;
			cmd: 'target_link_libraries' params: name , ' ${LINKLIBS}';
			cmd: 'set_target_properties' params: name , ' PROPERTIES PREFIX "" SUFFIX "" 
			LINK_FLAGS -m32' 
	].
	
	(self buildDir / name) assureExistence.
	self write: cfg toFile: name , '/', cmakeGen outputFileName.
	cmakeGen addSubdirectory:  name.
	! !

!Linux32x86SqueakCogV3Configz methodsFor: 'cmake' stamp: 'tty 6/8/2014 19:00'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default allBuildConfigurations copyWithoutAll:#(#assert #assertWithHeartbeatTimer #releaseHeartbeatTimer #debugMultiThreadedFFI #debugWithHeartbeatTimer )


! !

!Linux32x86SqueakCogV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 5/23/2014 19:13'!
buildDir
	^ buildDir ifNil: [ buildDir := ( self topDir / self buildDirName) assureExistence].! !

!Linux32x86SqueakCogV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 6/7/2014 14:56'!
buildDirName
	^ 'cmake_build.linux32x86'! !

!Linux32x86SqueakCogV3Configz methodsFor: 'build script' stamp: 'tty 5/25/2014 19:52'!
buildScript
	"answer the build script for building everything"
	

	^ 
'#!!/usr/bin/env bash

cmake .
make

'! !

!Linux32x86SqueakCogV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 6/7/2014 15:14'!
buildType: aSymbol
	buildType:= aSymbol! !

!Linux32x86SqueakCogV3Configz methodsFor: 'source generation' stamp: 'tty 5/23/2014 19:11'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!Linux32x86SqueakCogV3Configz methodsFor: 'compiler flags' stamp: 'tty 5/23/2014 19:11'!
commonCompilerFlags

	"Common compiler flags
	
	
	LSB_FIRST=1 means that target platform is little endian. 
	set it to 0 for big-endian platforms
	
	"
	
	^ {
		'-DLSB_FIRST=1'. 
		'-DUSE_GLOBAL_STRUCT=0'. 
		'-DCOGMTVM=0'. 
		'-m32'.
		'-DENABLE_FAST_BLT ' } 	
	! !

!Linux32x86SqueakCogV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 6/16/2014 20:06'!
compilerFlags
	|d commonFlags flags|
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self compilerFlagsBuild];
		at: #buildAssert  put: [self compilerFlagsAssert];
		at: #buildAssertITimerHeartbeat  put: [self compilerFlagsAssertITimerHeartbeat];
            at:#buildDebug  put: [self compilerFlagsDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self compilerFlagsDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self compilerFlagsIHeartbeatTimer];
		at: #buildMultiThreaded  put: [self compilerFlagsMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self compilerFlagsMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self compilerFlagsMultiThreadedDebug ];
		at: #buildNone put:[self compilerFlagsNoBuildType].

    flags:= String streamContents: [ :stream |
	 (((d at:  buildType) value)  collect: #withBlanksTrimmed as: Set)
		asStringOn: stream 
		delimiter:' '].

    commonFlags:=String streamContents: [ :stream |
		((self commonCompilerFlags) collect: #withBlanksTrimmed as: Set)
			asStringOn: stream 
			delimiter: ' ' ].
	^ commonFlags, ' ' ,flags.! !

!Linux32x86SqueakCogV3Configz methodsFor: 'compiler flags' stamp: 'tty 5/23/2014 19:11'!
compilerFlagsDebug

	^ {
		'-g3'. 
		'-O0'. 
		'-msse2'. 
		'-D_GNU_SOURCE'. 
		'-DITIMER_HEARTBEAT=1'. 
		'-DNO_VM_PROFILE=1'. 
		'-DDEBUGVM=1' }! !

!Linux32x86SqueakCogV3Configz methodsFor: 'compiler flags' stamp: 'tty 5/23/2014 19:11'!
compilerFlagsRelease
"
THIS FLAGS ARE CRASHING COMPILER 
-fschedule-insns2 
-fschedule-insns 

THIS FLAGS ARE CRASHING VM
-ftree-pre  
-fcaller-saves 

THIS FLAGS ARE WORKING 
-O1 -fthread-jumps -falign-functions -falign-jumps -falign-loops -falign-labels -fcrossjumping -fcse-follow-jumps -fcse-skip-blocks -fdelete-null-pointer-checks -fdevirtualize -fexpensive-optimizations -fgcse -fgcse-lm -finline-small-functions -findirect-inlining -fipa-sra -foptimize-sibling-calls -fpeephole2 -fregmove -freorder-blocks -frerun-cse-after-loop -freorder-functions  -fsched-interblock -fsched-spec -fstrict-aliasing -fstrict-overflow  -ftree-switch-conversion -ftree-vrp

THIS IS LIKE: -O2 -fno-tree-pre -fno-caller-saves 

"

	^ {
		'-g0'. 
		'-O2'. 
		'-fno-tree-pre'. 
		'-fno-caller-saves'. 
		'-msse2'. 
		'-D_GNU_SOURCE'. 
		'-DNDEBUG'. 
		'-DITIMER_HEARTBEAT=1'. 
		'-DNO_VM_PROFILE=1'. 
		'-DDEBUGVM=0' }! !

!Linux32x86SqueakCogV3Configz methodsFor: 'headers generation' stamp: 'tty 5/23/2014 19:11'!
configH
	" right now its like  that "
	^ '
#ifndef __sq_config_h
#define __sq_config_h

/* explicit image width */

#define	HAVE_INTERP_H 1

/* package options */

#define	USE_X11 1
#define	USE_X11_GLX 1
/* #undef	USE_QUARTZ */
/* #undef	USE_QUARTZ_CGL */
/* #undef	USE_RFB */

/* libraries */

/* #undef	HAVE_LIBX11 */
/* #undef	HAVE_LIBXEXT */
#define	HAVE_LIBDL 1
/* #undef	HAVE_DYLD */
/* #undef	HAVE_LIBFFI */
/* #undef	HAVE_ICONV */

/* #undef	USE_AUDIO_NONE */
/* #undef	USE_AUDIO_SUN */
/* #undef	USE_AUDIO_NAS */
/* #undef	USE_AUDIO_OSS */
/* #undef	USE_AUDIO_MACOSX */
/* #undef	OSS_DEVICE */

/* header files */

#define	HAVE_UNISTD_H 1
/* #undef	NEED_GETHOSTNAME_P */

#define	HAVE_DIRENT_H 1
/* #undef	HAVE_SYS_NDIR_H */
/* #undef	HAVE_SYS_DIR_H */
/* #undef	HAVE_NDIR_H */
#define	HAVE_DLFCN_H 1
#define	HAVE_ICONV_H 1

#define	HAVE_SYS_TIME_H 1
#define	TIME_WITH_SYS_TIME 1

/* #undef	HAVE_SYS_FILIO_H */

/* #undef	HAVE_SYS_AUDIOIO_H */
/* #undef	HAVE_SUN_AUDIOIO_H */

#define	HAVE_PTY_H 1
/* #undef	HAVE_UTIL_H */
/* #undef	HAVE_LIBUTIL_H */
#define	HAVE_STROPTS_H 1

#define	HAVE_GL_GL_H 1
/* #undef	HAVE_OPENGL_GL_H */

/* #undef	NEED_SUNOS_H */

/* system calls/library functions */

#define	AT_EXIT atexit

#define	HAVE_TZSET 1

#define	HAVE_OPENPTY 1
/* #undef	HAVE_UNIX98_PTYS */

#define	HAVE_SNPRINTF 1
/* #undef	HAVE___SNPRINTF */

#define	HAVE_MMAP 1

/* #undef	HAVE_DYLD */

#define	HAVE_LANGINFO_CODESET 1

#define	HAVE_ALLOCA 1
#define	HAVE_ALLOCA_H 1

#define	HAVE_UNSETENV 1

#define	HAVE_NANOSLEEP 1

/* widths of primitive types */

#define	SIZEOF_INT 4
#define	SIZEOF_LONG 4
#define	SIZEOF_LONG_LONG 8
#define	SIZEOF_VOID_P 4

/* structures */

#define	HAVE_TM_GMTOFF 1
#define	HAVE_TIMEZONE 1

/* typedefs */

/* #undef	size_t */
/* #undef	socklen_t */

#define	squeakInt64 long long

/* architecture */

#define	OS_TYPE "unix"

#define	VM_HOST "i686-pc-linux-gnu"
#define	VM_HOST_CPU "i686"
/* #undef	VM_HOST_VENDOR */
#define	VM_HOST_OS "linux-gnu"
#define	VM_BUILD_STRING "Unix built on "__DATE__ " "__TIME__" Compiler: "__VERSION__

/* #undef	WORDS_BIGENDIAN */
/* #undef	DOUBLE_WORD_ALIGNMENT */

/* damage containment */

/* #undef	DARWIN */

#ifdef NEED_SUNOS_H
# include "sunos.h"
#endif

/* other configured variables */

#define SQ_VERSION "3.9a-7024"
#define VM_VERSION "3.9-7"
#define VM_MODULE_PREFIX ""
/* #undef VM_DLSYM_PREFIX */
#define VM_X11DIR ""

/* avoid dependencies on glibc2.3 */

#define HAVE_FEATURES_H 1

#if defined(HAVE_FEATURES_H)
# include "glibc.h"
#endif


/* used by UUID plugin: */

#define HAVE_UUID_H 1

#endif /* __sq_config_h */
																																																																					
																																																																				'! !

!Linux32x86SqueakCogV3Configz methodsFor: 'cmake configuration' stamp: 'tty 6/16/2014 20:06'!
configureForBuildType: aSymbol
	| d |
	"provide a concrete builder with the buildType and configureBuildX method to invoke"
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	self configureNoBuildType.                "reset all internal flags"
	d 
		at: #build 
		put: [self buildType:#build.  self configureBuild];

		at: #buildAssert 
		put: [self buildType: #buildAssert.  	self configureBuildAssert];

		at: #buildAssertITimerHeartbeat 
		put:     [ self buildType: #buildAssertITimerHeartbeat.   self configureBuildAssertITimerHeartbeat];

            at:#buildDebug 
		put: [self buildType: #buildDebug.  self configureBuildDebug];

		at: #buildDebugITimerHeartbeat 
		put:  [self buildType: #buildDebugITimerHeartbeat.   self configureBuildDebugITimerHeartbeat];

		at: #buildITimerHeartbeat 
		put: [self buildType:#buildITimerHeartbeat.    self configureBuildIHeartbeatTimer];

		at: #buildMultiThreaded 
		put:  [self buildType:#buildMultiThreaded . self configureBuildMultiThreaded];

		at: #buildMultiThreadedAssert 
		put: [self buildType: #buildMultiThreadedAssert. self configureBuildMultiThreadedAssert];

		at: #buildMultiThreadedDebug  
		put: [self buildType: #buildMultiThreadedDebug. self configureBuildMultiThreadedDebug].

     ^(d at: aSymbol).! !

!Linux32x86SqueakCogV3Configz methodsFor: 'sources' stamp: 'tty 5/23/2014 19:11'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!Linux32x86SqueakCogV3Configz methodsFor: 'plugins' stamp: 'tty 5/23/2014 19:11'!
defaultExternalPlugins
	^ #(
		B3DAcceleratorPlugin
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
		"UUIDPlugin"
		"UnixOSProcessPlugin ?? "	
		JPEGReaderPlugin 
		JPEGReadWriter2Plugin 			
		RePlugin
		InternetConfigPlugin
	)! !

!Linux32x86SqueakCogV3Configz methodsFor: 'plugins' stamp: 'tty 6/2/2014 17:41'!
defaultInternalPlugins
" took from unixbuild/bld/plugins.int"
	^ #(
		ADPCMCodecPlugin 
		AsynchFilePlugin 
		BalloonEnginePlugin "B2DPlugin" 
		BitBltSimulation "BitBltPlugin"
		BMPReadWriterPlugin 
		CroquetPlugin 
		DeflatePlugin  "ZipPlugin"
		DropPlugin 
		DSAPlugin "DSAPrims" 
		FFTPlugin 
		FileCopyPlugin 
		FilePlugin 
		FloatArrayPlugin 
		FloatMathPlugin 
		IA32ABIPlugin "IA32ABI"
		JoystickTabletPlugin 
		KlattSynthesizerPlugin "Klatt"
		LargeIntegersPlugin "LargeIntegers"
		Matrix2x3Plugin 
		MIDIPlugin 
		MiscPrimitivePlugin 
		Mpeg3Plugin  	
		SecurityPlugin 
		SerialPlugin 
		SocketPlugin 
		SoundCodecPlugin "SoundCodecPrims"
		SoundGenerationPlugin 
		SoundPlugin 
		StarSqueakPlugin 
		SurfacePlugin	
		LocalePlugin
		VMProfileLinuxSupportPlugin
		)! !

!Linux32x86SqueakCogV3Configz methodsFor: 'cmake' stamp: 'tty 6/7/2014 16:45'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakCogV3! !

!Linux32x86SqueakCogV3Configz methodsFor: 'cmake' stamp: 'tty 6/8/2014 15:53'!
dirBuildPlatform
	"the directory for the platform. example: build.linux32x86"
	^self dirLinux32x86! !

!Linux32x86SqueakCogV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 5/23/2014 19:14'!
dirFrom: t1 
	^ t1 isString
		ifTrue: [FileDirectory forFileName: t1]
		ifFalse: [t1]! !

!Linux32x86SqueakCogV3Configz methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:36'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Linux32x86SqueakCogV3Configz methodsFor: 'accessing' stamp: 'tty 5/23/2014 19:11'!
executableName
	^ 'CogVM'! !

!Linux32x86SqueakCogV3Configz methodsFor: 'plugin extra rules' stamp: 'tty 5/23/2014 19:11'!
extraPluginSettings: maker
	super extraPluginSettings: maker.  
	maker set: #linkFlags toString: '${linkFlags} -m32'
! !

!Linux32x86SqueakCogV3Configz methodsFor: 'sources' stamp: 'tty 5/23/2014 19:11'!
extraSources
	" mac VM using some unix sources"
	
	^ 
	'version.c'! !

!Linux32x86SqueakCogV3Configz methodsFor: 'accessing' stamp: 'tty 5/23/2014 19:26'!
generate 
	self generatePluginsList. 
	self generateLicense. 
	"^super generate"
	^CMakeVMGeneratorForSqueak generate:self    "Bypass CPlatformConfig generate to invoke our compatibility class"! !

!Linux32x86SqueakCogV3Configz methodsFor: 'headers generation' stamp: 'tty 5/23/2014 19:11'!
generateConfigH
	"will fix that later"
	self write: self configH toFile: 'config.h'! !

!Linux32x86SqueakCogV3Configz methodsFor: 'headers generation' stamp: 'tty 6/16/2014 20:07'!
generateConfigH: aBuildType
	"self write: self configH toFile: 'config.h'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self configHBuild];
		at: #buildAssert  put: [self configHBuildAssert];
		at: #buildAssertITimerHeartbeat  put: [self configHBuildAssertITimerHeartbeat];
            at:#buildDebug  put: [self configHBuildDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self configHBuildDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self configHBuildITimerHeartbeat];
		at: #buildMultiThreaded  put: [self configHBuildMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self configHBuildMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self configHBuildMultiThreadedDebug ];
		at: #buildNone put:[self configHNoBuildType].


	 ^(d at: ( aBuildType)) value



! !

!Linux32x86SqueakCogV3Configz methodsFor: 'accessing' stamp: 'tty 5/23/2014 19:26'!
generateLicense 
	self 
		write:  (self class licenseTemplate 
			format: { self version })
		toFile: 'LICENSE.txt'
	! !

!Linux32x86SqueakCogV3Configz methodsFor: 'accessing' stamp: 'tty 5/23/2014 19:27'!
generatePluginsList 
	self 
		write:  (self class pluginsTemplate 
			format: {
				self version. 
				String streamContents: [ :stream | self internalPlugins asStringOn: stream delimiter: String cr ].
				String streamContents: [ :stream | self externalPlugins asStringOn: stream delimiter: String cr ].
				self executableName })
		toFile: 'PLUGINS.txt'
	! !

!Linux32x86SqueakCogV3Configz methodsFor: 'initialize-release' stamp: 'tty 6/9/2014 12:26'!
initialize
	super initialize.
	"this should be in my superclass, but I do not have permission to modify it. tty"
	 generateForAssert:= generateForAssertHeartbeatTimer:= generateForDebug :=generateForDebugWithHeartbeatTimer:= generateForDebugMultiThreadedFFI:= generateForReleaseHeartbeatTimer:= generateForReleaseMultiThreadedFFI:=false! !

!Linux32x86SqueakCogV3Configz methodsFor: 'source generation' stamp: 'tty 5/23/2014 19:11'!
interpreterClass
	^ CoInterpreter! !

!Linux32x86SqueakCogV3Configz methodsFor: 'accessing' stamp: 'tty 5/23/2014 19:11'!
linkFlags 
	^ super linkFlags , ' -m32'! !

!Linux32x86SqueakCogV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 5/23/2014 19:15'!
outputDir

	"the directory where built binaries will be stored"
	^ outputDir ifNil: [ outputDir := (self topDir / self outputDirName) ]	

! !

!Linux32x86SqueakCogV3Configz methodsFor: 'sources' stamp: 'tty 5/23/2014 19:11'!
platformSources
	"files added from platform/unix/vm dir "
	^ #(
	'aio.c'
	'debug.c'
"	'dlfcn-dyld.c'
	'mac-alias.c' "
	'osExports.c'
	'sqUnixCharConv.c'
"	'sqUnixEvent.c' "
	'sqUnixExternalPrims.c'
	'sqUnixHeartbeat.c'
	'sqUnixMain.c'
	'sqUnixMemory.c'
	'sqUnixThreads.c'
	'sqUnixVMProfile.c'
	)! !

!Linux32x86SqueakCogV3Configz methodsFor: 'source files' stamp: 'tty 5/23/2014 19:11'!
preferredIncludes
	^ #( '${targetPlatform}/plugins/B3DAcceleratorPlugin')
	! !

!Linux32x86SqueakCogV3Configz methodsFor: 'source generation' stamp: 'tty 5/23/2014 19:11'!
prepareForGeneration
	^ self prepareForCogGeneration
! !

!Linux32x86SqueakCogV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 5/23/2014 19:15'!
prepareVMMaker
	
	| maker allPlugins |
	
	"In CogVMs (in contrast to Interpreter VM) the generated sources are platform independent, therefore Cross is ok"
	maker := VMMaker forPlatform: 'Cross'.
	
	maker sourceDirectoryName: self srcDir pathName.
	maker platformRootDirectoryName: self platformsDir.
	
	
	allPlugins := self internalPlugins , self externalPlugins.
	
	"touch plugins to force their source generation unconditionally"
	allPlugins do: [:name | (Smalltalk globals at: name) touch ].
	
	" Why we put all plugins as external?   Because the generated sources are not different whether the plugins were defined as internal or external. VMMaker used to need this to to generate plugins.int and plugins.ext files. But since this is achieved in another way with CMakeVMMaker, there is no different at all to put all plugins as internal or as external."
	maker externalModules addAll:  allPlugins.
	
	^ maker! !

!Linux32x86SqueakCogV3Configz methodsFor: 'utils' stamp: 'tty 5/23/2014 19:11'!
setExtraTargetProperties: maker

	maker setTargetProperties: 'LINK_FLAGS "-m32"'.
		
	maker puts: 'set_source_files_properties( ${srcVMDir}/cogit.c PROPERTIES 
		COMPILE_FLAGS "-O1 -fno-omit-frame-pointer -momit-leaf-frame-pointer -mno-rtd -mno-accumulate-outgoing-args")'.
		
	
	maker 
		cmd: 'set_source_files_properties'
		params: ' ${targetPlatform}/vm/sqUnixHeartbeat.c PROPERTIES 
		COMPILE_FLAGS "-O1 -fno-omit-frame-pointer -mno-rtd -mno-accumulate-outgoing-args"'.
						
	super setExtraTargetProperties: maker.
! !

!Linux32x86SqueakCogV3Configz methodsFor: 'utils' stamp: 'tty 6/16/2014 20:07'!
setGlobalOptionsAfterDetermineSystem: aMaker buildType: aBuildType
	"invoke correct setGlobalOptions for this buildType to allow per-buildType customization'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self setGlobalOptionsAfterDetermineSystemBuild: aMaker];
		at: #buildAssert  put: [self setGlobalOptionsAfterDetermineSystemBuildAssert: aMaker];
		at: #buildAssertITimerHeartbeat  put: [self setGlobalOptionsAfterDetermineSystemBuildAssertITimerHeartbeat: aMaker];
            at:#buildDebug  put: [self setGlobalOptionsAfterDetermineSystemBuildDebug: aMaker];   
		at: #buildITimerHeartbeat  put: [self setGlobalOptionsAfterDetermineSystemBuildITimerHeartbeat: aMaker];
		at: #buildMultiThreaded  put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreaded: aMaker ];
		at: #buildMultiThreadedAssert  put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreadedAssert: aMaker];
		at: #buildMultiThreadedDebug   put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreadedDebug: aMaker ];
		at: #buildNone put:[self setGlobalOptionsBuildNone: aMaker].

	 ^(d at: ( aBuildType)) value
! !

!Linux32x86SqueakCogV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 5/23/2014 19:15'!
setupDirectories: gen
	| dirsInclude |

	" write the directories in separate include file"
	dirsInclude := gen captureOutputDuring: [
		gen
			set: #topDir toString: (self topDir fullName); 
			set: #buildDir toString: (self buildDir ifNil: ['${topDir}/build'] ifNotNil: [self buildDir fullName] );
			set: #thirdpartyDir toString: '${buildDir}/thirdParty';
			set: #platformsDir toString: self platformsDir;
			set: #srcDir toString: self srcDir pathName;
			set: #srcPluginsDir toString: (pluginsDir ifNil: [ '${srcDir}/plugins' ]);
			set: #srcVMDir toString: '${srcDir}/vm';
			set: #platformName toString: self platformName;
			set: #targetPlatform to: '${platformsDir}/${platformName}';
			set: #crossDir toString: '${platformsDir}/Cross';
			set: #platformVMDir toString: '${targetPlatform}/vm';
			set: #outputDir toString: self outputDir fullName.
	].

	self write: dirsInclude toFile: 'directories.cmake'.
	
	gen include: 'directories.cmake'.
! !

!Linux32x86SqueakCogV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 5/23/2014 19:16'!
srcDir
		^ srcDir ifNil: [ srcDir := (self topDir directoryNamed: 'src' )]! !

!Linux32x86SqueakCogV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 6/7/2014 16:57'!
topDir
	^ topDir ifNil: [ topDir := FileDirectory default directoryNamed: self oscogvm ]! !

!Linux32x86SqueakCogV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 5/23/2014 19:16'!
validateSourcesPresent
	| sources |
	sources := Smalltalk sourcesName.
	
	(sources == nil)
		ifTrue: [	self error: 'VM source code cannot be generated without .sources file'.]		! !

!Linux32x86SqueakCogV3Configz methodsFor: 'accessing' stamp: 'tty 5/23/2014 19:27'!
version
	^ ''! !

!Linux32x86SqueakCogV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 5/23/2014 19:17'!
write: aContents toFile: aFileName
	"write a file to current output directory (buildDir).
	use line end convention appropriate for config platform"

	| bldDir |
	bldDir := self buildDir.
	bldDir isString
		ifTrue: [ bldDir := FileDirectory directoryEntryFor: bldDir ].
	bldDir assureExistence.
	bldDir
		forceNewFileNamed: aFileName
		do: [:s | s
				nextPutAll: (self fixLineEndsOf: aContents)]

! !

CogFamilyUnixConfig subclass: #Linux64Config
	uses: TCPlatformConfigForSqueak
	instanceVariableNames: 'buildType generateBuild generateBuildAssert generateBuildAssertITimerHeartbeat generateBuildDebug generateBuildDebugITimerHeartbeat generateBuildDebugMultiThreaded generateBuildIHeartbeatTimer generateBuildMultiThreaded generateBuildMultiThreadedAssert generateBuildMultiThreadedDebug'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-LinuxX86-64'!

!Linux64Config commentStamp: 'tty 6/15/2014 14:01' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


I am not meant to be built.

SqueakLinux32x86_64Builder 
	configureABuildFor: #ONE OF MY SUBCLASSES NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

Linux64Config class
	uses: TCPlatformConfigForSqueak classTrait
	instanceVariableNames: ''!

!Linux64Config class methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:22'!
licenseTemplate
	^'Squeak {1} license information
==============================

About Squeak
-----------
Squeak is a modern, open source, full-featured implementation of the powerful Smalltalk programming language and environment. Squeak is highly-portable, running on almost any platform you could name and you can really truly write once run anywhere.  Squeak is the vehicle for a wide range of projects from multimedia applications and educational platforms to commercial web application development.

LIcense
Note: The current release of Squeak is a combination of source code originating from it''s origins at Apple which Apple agreed to license under the Apache license and more recent contributions licensed under the MIT license. The vast majority of the code is under the MIT license.
MIT License

Copyright (c) The individual, corporate, and institutional contributors who have collectively contributed elements to this software ("The Squeak Community"), 1996-2010 All rights reserved.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
Portions of Squeak are covered by the following license:
Apache License, Version 2.0

Copyright (c) Xerox Corp. 1981, 1982 All rights reserved. Copyright (c) Apple Computer, Inc. 1985-1996 All rights reserved.

Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.


About Cog
---------

Cog is a virtual machine designed for Smalltalk and other similar dynamic languages.  Cog builds on the
Squeak virtual machine adding a stack-to-register-mapping just-in-time compiler, aggressive in-line message
cacheing and effective optimization of Smalltalk?s first-class activation records.  Cog is the virtual machine
underlying Teleplace''s Croquet-based enterprise virtual collaboration spaces software, the fastest virtual
machine for Squeak, and for Gilad Bracha''s Newspeak modular language inspired by Beta and Smalltalk.  
Like the original Squeak VM, Cog is implemented and developed in Smalltalk, and translated into a lower-level
language to produce the production VM.  Being a Smalltalk program it is a delight to develop.  Cog is
available under the MIT open source license and is unencumbered for commercial deployment.

Cog''s performance relative to the existing Squeak interpreter varies, depending on the benchmark chosen.
As of early-2011, the Cog JIT uses strong inline cacheing techniques and stack-to-register mapping that
results in a register-based calling convention for low-arity methods.  Due to the complexity of the Squeak
object representation it has a limited set of primitives implemented in machine code that, for example,
exclude object allocation.  Performance of the early-2011 JIT for the nbody, binarytrees and chameneos
redux benchmarks from the computer language shootout is in the range of 4 to 6 times faster than the
interpreter.
'! !

!Linux64Config class methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:22'!
pluginsTemplate
	^'{4} {1} ships with this plugins already built:
		
Internal: 
=========
{2}

External: 
=========
{3}

'! !

!Linux64Config methodsFor: 'squeak compatibility' stamp: 'tty 6/9/2014 18:22'!
addDriver: name sources: aSources generator: cmakeGen externalLibs: extLibs

	| cfg srcs |
	
	srcs := aSources inject: '' into: [:res :each | res , ' "', each, '"' ].
	cfg := cmakeGen
		captureOutputDuring: [
			cmakeGen printHeader;
			project: name;
			include: '../directories.cmake';
		
			message: 'Adding module: ', name;
			
			addDefinitions:  self compilerFlags;
			addDefinitions: '-fPIC -DPIC';
			set: #sources to: srcs;
			cmd: 'add_library' params: name, ' SHARED ${sources}'; 
			includeDirectories: '${crossDir}/plugins/FilePlugin';
			includeDirectories: '${targetPlatform}/plugins/B3DAcceleratorPlugin';
			includeDirectories: '${crossDir}/plugins/B3DAcceleratorPlugin';
			set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir fullName;
			addExternalLibraries: extLibs;
			cmd: 'target_link_libraries' params: name , ' ${LINKLIBS}';
			cmd: 'set_target_properties' params: name , ' PROPERTIES PREFIX "" SUFFIX "" 
			LINK_FLAGS -m32' 
	].
	
	(self buildDir / name) assureExistence.
	self write: cfg toFile: name , '/', cmakeGen outputFileName.
	cmakeGen addSubdirectory:  name.
	! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default allBuildConfigurations copyWithoutAll:#(#releaseMultiThreadedFFI #debugMultiThreadedFFI)
! !

!Linux64Config methodsFor: 'squeak compatibility' stamp: 'tty 6/9/2014 18:22'!
buildDir
	^ buildDir ifNil: [ buildDir := ( self topDir / self buildDirName) assureExistence].! !

!Linux64Config methodsFor: 'squeak compatibility' stamp: 'tty 6/12/2014 12:05'!
buildDirName
	buildType isNil
		ifTrue:[^self dirBuildPlatform, FileDirectory slash, self dirBuildLanguageVMMM, FileDirectory slash, 'build']
		ifFalse:[^self dirBuildPlatform, FileDirectory slash, self dirBuildLanguageVMMM, FileDirectory slash, buildType asString]! !

!Linux64Config methodsFor: 'squeak compatibility' stamp: 'tty 6/9/2014 18:22'!
buildScript
	"answer the build script for building everything"
	

	^ 
'#!!/usr/bin/env bash

cmake .
make

'! !

!Linux64Config methodsFor: 'squeak compatibility' stamp: 'tty 6/9/2014 18:22'!
buildType: aSymbol
	buildType:= aSymbol! !

!Linux64Config methodsFor: 'squeak compatibility' stamp: 'tty 6/9/2014 18:22'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!Linux64Config methodsFor: 'squeak compatibility' stamp: 'tty 6/9/2014 18:22'!
commonCompilerFlags

	"Common compiler flags
	
	
	LSB_FIRST=1 means that target platform is little endian. 
	set it to 0 for big-endian platforms
	
	"
	
	^ {
		'-DLSB_FIRST=1'. 
		'-DUSE_GLOBAL_STRUCT=0'. 
		'-DCOGMTVM=0'. 
		'-m32'.
		'-DENABLE_FAST_BLT ' } 	
	! !

!Linux64Config methodsFor: 'squeak compatibility' stamp: 'tty 6/16/2014 20:10'!
compilerFlags
	|d commonFlags flags|
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self compilerFlagsBuild];
		at: #buildAssert  put: [self compilerFlagsAssert];
		at: #buildAssertITimerHeartbeat  put: [self compilerFlagsAssertITimerHeartbeat];
            at:#buildDebug  put: [self compilerFlagsDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self compilerFlagsDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self compilerFlagsIHeartbeatTimer];
		at: #buildMultiThreaded  put: [self compilerFlagsMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self compilerFlagsMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self compilerFlagsMultiThreadedDebug ];
		at: #buildNone put:[self compilerFlagsNoBuildType].

    flags:= String streamContents: [ :stream |
	 (((d at:  buildType) value)  collect: #withBlanksTrimmed as: Set)
		asStringOn: stream 
		delimiter:' '].

    commonFlags:=String streamContents: [ :stream |
		((self commonCompilerFlags) collect: #withBlanksTrimmed as: Set)
			asStringOn: stream 
			delimiter: ' ' ].
	^ commonFlags, ' ' ,flags.! !

!Linux64Config methodsFor: 'cmake configuration' stamp: 'tty 6/16/2014 20:10'!
configureForBuildType: aSymbol
	| d |
	"provide a concrete builder with the buildType and configureBuildX method to invoke"
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	self configureNoBuildType.                "reset all internal flags"
	d 
		at: #build 
		put: [self buildType:#build.  self configureBuild];

		at: #buildAssert 
		put: [self buildType: #buildAssert.  	self configureBuildAssert];

		at: #buildAssertITimerHeartbeat 
		put:     [ self buildType: #buildAssertITimerHeartbeat.   self configureBuildAssertITimerHeartbeat];

            at:#buildDebug 
		put: [self buildType: #buildDebug.  self configureBuildDebug];

		at: #buildDebugITimerHeartbeat 
		put:  [self buildType: #buildDebugITimerHeartbeat.   self configureBuildDebugITimerHeartbeat];

		at: #buildITimerHeartbeat 
		put: [self buildType:#buildITimerHeartbeat.    self configureBuildIHeartbeatTimer];

		at: #buildMultiThreaded 
		put:  [self buildType:#buildMultiThreaded . self configureBuildMultiThreaded];

		at: #buildMultiThreadedAssert 
		put: [self buildType: #buildMultiThreadedAssert. self configureBuildMultiThreadedAssert];

		at: #buildMultiThreadedDebug  
		put: [self buildType: #buildMultiThreadedDebug. self configureBuildMultiThreadedDebug].

     ^(d at: aSymbol).! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/12/2014 17:09'!
configureNoBuildType
		generateBuild:=generateBuildAssert:=generateBuildAssertITimerHeartbeat:=generateBuildDebug:=generateBuildDebugITimerHeartbeat:= generateBuildDebugMultiThreaded:= generateBuildIHeartbeatTimer:= generateBuildMultiThreaded:= generateBuildMultiThreadedAssert:= generateBuildMultiThreadedDebug:=false.! !

!Linux64Config methodsFor: 'plugins' stamp: 'tty 6/9/2014 18:22'!
defaultExternalPlugins
	^ #(SqueakSSL	)! !

!Linux64Config methodsFor: 'plugins' stamp: 'tty 6/9/2014 18:22'!
defaultInternalPlugins
" cut-n-paste from Cog/build.linux32x86/newspeak.cog.v3/build"
	^ #(
		AsynchFilePlugin 
		BMPReadWriterPlugin 
		B2DPlugin 
		BitBltPlugin 
		DSAPrims 
		DropPlugin 
		FileCopyPlugin 
		FilePlugin 
		FloatArrayPlugin 
		FloatMathPlugin 
		ZipPlugin 
		JPEGReadWriter2Plugin 
		JPEGReaderPlugin 
		LargeIntegers 
		Matrix2x3Plugin 
		MiscPrimitivePlugin 
		IA32ABI 
		RePlugin 
		SecurityPlugin 
		SocketPlugin 
		SurfacePlugin 
		UUIDPlugin 
		UnixOSProcessPlugin 
		VMProfileLinuxSupportPlugin)! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
dirAndroid
	^'Do Not Build. See Class Comment'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
dirBSD32x86
	^'cmake_build.bsd32x86'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
dirBuild
	^'build'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
dirBuildAssert
	^'build.assert'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
dirBuildDebug
	^'build.debug'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
dirBuildDebugITimerHeartbeat
	^'build.debug.itimerheartbeat'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
dirBuildITimerHeartbeat
	^'build.itimerheartbeat'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:19'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self required! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
dirBuildPlatform
	"the directory for the platform. example: build.linux32x86"
	^self dirLinux32x86! !

!Linux64Config methodsFor: 'squeak compatibility' stamp: 'tty 6/9/2014 18:22'!
dirFrom: aStringOrDir
	^ aStringOrDir isString
		ifTrue: [ FileDirectory forFileName: aStringOrDir  ]
		ifFalse: [ aStringOrDir ]! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
dirIA32Bochs
	^'cmake_build.ia32bochs'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
dirIOS
	^'cmake_build.ios'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
dirLinux32Armv6
	^'cmake_build.linux32armv6'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
dirLinux32x86
	^'cmake_build.linux32x86'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
dirLinux32x8664
	^'cmake_build.linux32x86_64'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
dirMacOS
	^'cmake_build.macos'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
dirMacOSPowerPC
	^'cmake_build.macospowerpc'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
dirMacOSX32x86
	^'cmake_build.macosx32x86'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
dirOutput
	^'cmake_products'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
dirSource
	^'src'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
dirSunOS32x86
	^'cmake_build.sunos32x86'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
dirSunOS32x8664
	^'cmake_build.sunos32x86_64'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
dirWin32x86
	^'cmake_build.win32x86'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
excludeFromBuild
	"over-ride to exclude yourself from a build"
	^true! !

!Linux64Config methodsFor: 'headers generation' stamp: 'tty 6/16/2014 18:02'!
generateConfigH
	"	
	used to be: 	
		self write: self configH toFile: 'config.h'
      but with variable buildTypes we need:
"
	self write: (self generateConfigH: buildType) toFile: 'config.h'   
! !

!Linux64Config methodsFor: 'headers generation' stamp: 'tty 6/16/2014 20:10'!
generateConfigH: aBuildType
	"self write: self configH toFile: 'config.h'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self configHBuild];
		at: #buildAssert  put: [self configHBuildAssert];
		at: #buildAssertITimerHeartbeat  put: [self configHBuildAssertITimerHeartbeat];
            at:#buildDebug  put: [self configHBuildDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self configHBuildDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self configHBuildITimerHeartbeat];
		at: #buildMultiThreaded  put: [self configHBuildMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self configHBuildMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self configHBuildMultiThreadedDebug ];
		at: #buildNone put:[self configHNoBuildType].


	 ^(d at: ( aBuildType)) value



! !

!Linux64Config methodsFor: 'initialize-release' stamp: 'tty 6/9/2014 18:22'!
initialize
	super initialize.
	"this should be in my superclass, but I do not have permission to modify it. tty"
	 generateForAssert:= generateForAssertHeartbeatTimer:= generateForDebug :=generateForDebugWithHeartbeatTimer:= generateForDebugMultiThreadedFFI:= generateForReleaseHeartbeatTimer:= generateForReleaseMultiThreadedFFI:=false! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
newspeakCogSpur
	^'newspeak.cog.spur'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
newspeakCogV3
	^'newspeak.cog.v3'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
newspeakSistaSpur
	^'newspeak.sista.Spur'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
newspeakSistaV3
	^'newspeak.sista.v3'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
newspeakStackSpur
	^'newspeak.stack.spur'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
newspeakStackV3
	^'newspeak.stack.v3'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
oscogvm
	^ 'oscogvm'! !

!Linux64Config methodsFor: 'squeak compatibility' stamp: 'tty 6/14/2014 15:42'!
outputDir

	"the directory where built binaries will be stored"
	^ outputDir ifNil: [ outputDir := (self topDir / self dirOutput / self dirInstall) ]	

! !

!Linux64Config methodsFor: 'squeak compatibility' stamp: 'tty 6/9/2014 18:22'!
prepareVMMaker
	
	| maker allPlugins |
	
	"In CogVMs (in contrast to Interpreter VM) the generated sources are platform independent, therefore Cross is ok"
	maker := VMMaker forPlatform: 'Cross'.
	
	maker sourceDirectoryName: self srcDir pathName.
	maker platformRootDirectoryName: self platformsDir.
	
	
	allPlugins := self internalPlugins , self externalPlugins.
	
	"touch plugins to force their source generation unconditionally"
	allPlugins do: [:name | (Smalltalk globals at: name) touch ].
	
	" Why we put all plugins as external?   Because the generated sources are not different whether the plugins were defined as internal or external. VMMaker used to need this to to generate plugins.int and plugins.ext files. But since this is achieved in another way with CMakeVMMaker, there is no different at all to put all plugins as internal or as external."
	maker externalModules addAll:  allPlugins.
	
	^ maker! !

!Linux64Config methodsFor: 'utils' stamp: 'tty 6/16/2014 20:10'!
setGlobalOptionsAfterDetermineSystem: aMaker buildType: aBuildType
	"invoke correct setGlobalOptions for this buildType to allow per-buildType customization'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self setGlobalOptionsAfterDetermineSystemBuild: aMaker];
		at: #buildAssert  put: [self setGlobalOptionsAfterDetermineSystemBuildAssert: aMaker];
		at: #buildAssertITimerHeartbeat  put: [self setGlobalOptionsAfterDetermineSystemBuildAssertITimerHeartbeat: aMaker];
            at:#buildDebug  put: [self setGlobalOptionsAfterDetermineSystemBuildDebug: aMaker];   
		at: #buildITimerHeartbeat  put: [self setGlobalOptionsAfterDetermineSystemBuildITimerHeartbeat: aMaker];
		at: #buildMultiThreaded  put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreaded: aMaker ];
		at: #buildMultiThreadedAssert  put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreadedAssert: aMaker];
		at: #buildMultiThreadedDebug   put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreadedDebug: aMaker ];
		at: #buildNone put:[self setGlobalOptionsBuildNone: aMaker].

	 ^(d at: ( aBuildType)) value
! !

!Linux64Config methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 20:32'!
setupDirectories: aMaker 
	"SystemNavigation default browseMethodsWhoseNamesContain: 'setupDirectories:'
	
	we subclass this in our concrete builder and route it to 
	
	^self setupDirectories: aMaker buildType: (self buildType asSymbol)

	"
	self required
	
! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
squeakCogSpur
	^'squeak.cog.spur'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
squeakCogV3
	^'squeak.cog.v3'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
squeakSistaSpur
	^'squeak.sista.Spur'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
squeakSistaV3
	^'squeak.sista.v3'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
squeakStackSpur
	^'squeak.stack.spur'! !

!Linux64Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:22'!
squeakStackV3
	^'squeak.stack.v3'! !

!Linux64Config methodsFor: 'squeak compatibility' stamp: 'tty 6/9/2014 18:22'!
srcDir
		^ srcDir ifNil: [ srcDir := (self topDir directoryNamed: 'src' )]! !

!Linux64Config methodsFor: 'squeak compatibility' stamp: 'tty 6/9/2014 18:22'!
topDir
	"N.B. this is a clash between Trait usage and Inheritence usage due to restrictions on modifying pharo's source"
	^ topDir ifNil: [ topDir := FileDirectory default directoryNamed: self oscogvm ]
	! !

!Linux64Config methodsFor: 'squeak compatibility' stamp: 'tty 6/9/2014 18:22'!
validateSourcesPresent
	| sources |
	sources := Smalltalk sourcesName.
	
	(sources == nil)
		ifTrue: [	self error: 'VM source code cannot be generated without .sources file'.]		! !

!Linux64Config methodsFor: 'squeak compatibility' stamp: 'tty 6/9/2014 18:22'!
write: aContents toFile: aFileName
	"write a file to current output directory (buildDir).
	use line end convention appropriate for config platform"

	| bldDir |
	bldDir := self buildDir.
	bldDir isString
		ifTrue: [ bldDir := FileDirectory directoryEntryFor: bldDir ].
	bldDir assureExistence.
	bldDir
		forceNewFileNamed: aFileName
		do: [:s | s
				nextPutAll: (self fixLineEndsOf: aContents)]

! !

Linux64Config subclass: #Linux64NewspeakCogSpur
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-LinuxX86-64'!

!Linux64NewspeakCogSpur commentStamp: 'tty 6/15/2014 14:01' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


SqueakLinux32x86_64Builder 
	configureABuildFor: #MY  NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!Linux64NewspeakCogSpur methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:25'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!Linux64NewspeakCogSpur methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:19'!
dirBuildLanguageVMMM
	^self newspeakCogSpur! !

!Linux64NewspeakCogSpur methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:25'!
dirBuildPlatform
	"the directory for the platform. example: build.linux32x86"
	^self dirLinux32x8664! !

!Linux64NewspeakCogSpur methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:37'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Linux64NewspeakCogSpur methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:08'!
executableName
	^ self vmCogExecutableName! !

Linux64Config subclass: #Linux64NewspeakCogV3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-LinuxX86-64'!

!Linux64NewspeakCogV3 commentStamp: 'tty 6/15/2014 14:01' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


SqueakLinux32x86_64Builder 
	configureABuildFor: #MY  NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!Linux64NewspeakCogV3 methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:25'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!Linux64NewspeakCogV3 methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:20'!
dirBuildLanguageVMMM
	^self newspeakCogV3! !

!Linux64NewspeakCogV3 methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:25'!
dirBuildPlatform
	"the directory for the platform. example: build.linux32x86"
	^self dirLinux32x8664! !

!Linux64NewspeakCogV3 methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:37'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Linux64NewspeakCogV3 methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:09'!
executableName
	^ self vmCogExecutableName! !

Linux64Config subclass: #Linux64NewspeakSistaSpur
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-LinuxX86-64'!

!Linux64NewspeakSistaSpur commentStamp: 'tty 6/15/2014 14:01' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


SqueakLinux32x86_64Builder 
	configureABuildFor: #MY  NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!Linux64NewspeakSistaSpur methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:31'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!Linux64NewspeakSistaSpur methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:20'!
dirBuildLanguageVMMM
	^self newspeakSistaSpur! !

!Linux64NewspeakSistaSpur methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:31'!
dirBuildPlatform
	"the directory for the platform. example: build.linux32x86"
	^self dirLinux32x8664! !

!Linux64NewspeakSistaSpur methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:37'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Linux64NewspeakSistaSpur methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:57'!
executableName
	^ self vmSistaExecutableName! !

Linux64Config subclass: #Linux64NewspeakSistaV3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-LinuxX86-64'!

!Linux64NewspeakSistaV3 commentStamp: 'tty 6/15/2014 14:02' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


SqueakLinux32x86_64Builder 
	configureABuildFor: #MY  NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!Linux64NewspeakSistaV3 methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:31'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!Linux64NewspeakSistaV3 methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:20'!
dirBuildLanguageVMMM
	^self newspeakSistaV3! !

!Linux64NewspeakSistaV3 methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:31'!
dirBuildPlatform
	"the directory for the platform. example: build.linux32x86"
	^self dirLinux32x8664! !

!Linux64NewspeakSistaV3 methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:37'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Linux64NewspeakSistaV3 methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:57'!
executableName
	^ self vmSistaExecutableName! !

Linux64Config subclass: #Linux64NewspeakStackSpur
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-LinuxX86-64'!

!Linux64NewspeakStackSpur commentStamp: 'tty 6/15/2014 14:02' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


SqueakLinux32x86_64Builder 
	configureABuildFor: #MY  NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!Linux64NewspeakStackSpur methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:31'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!Linux64NewspeakStackSpur methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:20'!
dirBuildLanguageVMMM
	^self newspeakStackSpur! !

!Linux64NewspeakStackSpur methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:31'!
dirBuildPlatform
	"the directory for the platform. example: build.linux32x86"
	^self dirLinux32x8664! !

!Linux64NewspeakStackSpur methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:37'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Linux64NewspeakStackSpur methodsFor: 'accessing' stamp: 'tty 6/16/2014 08:03'!
executableName
	^ self vmStackExecutableName! !

Linux64Config subclass: #Linux64NewspeakStackV3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-LinuxX86-64'!

!Linux64NewspeakStackV3 commentStamp: 'tty 6/15/2014 14:02' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


SqueakLinux32x86_64Builder 
	configureABuildFor: #MY  NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!Linux64NewspeakStackV3 methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:31'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!Linux64NewspeakStackV3 methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:20'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackV3! !

!Linux64NewspeakStackV3 methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:31'!
dirBuildPlatform
	"the directory for the platform. example: build.linux32x86"
	^self dirLinux32x8664! !

!Linux64NewspeakStackV3 methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:37'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Linux64NewspeakStackV3 methodsFor: 'accessing' stamp: 'tty 6/16/2014 08:03'!
executableName
	^ self vmStackExecutableName! !

Linux64Config subclass: #Linux64SqueakCogSpur
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-LinuxX86-64'!

!Linux64SqueakCogSpur commentStamp: 'tty 6/15/2014 14:02' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


SqueakLinux32x86_64Builder 
	configureABuildFor: #MY  NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!Linux64SqueakCogSpur methodsFor: 'cmake' stamp: 'tty 6/8/2014 19:09'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!Linux64SqueakCogSpur methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:20'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakCogSpur! !

!Linux64SqueakCogSpur methodsFor: 'cmake' stamp: 'tty 6/8/2014 17:45'!
dirBuildPlatform
	"the directory for the platform. example: build.linux32x86"
	^self dirLinux32x8664! !

!Linux64SqueakCogSpur methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:38'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Linux64SqueakCogSpur methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:09'!
executableName
	^ self vmCogExecutableName! !

Linux64Config subclass: #Linux64SqueakCogV3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-LinuxX86-64'!

!Linux64SqueakCogV3 commentStamp: 'tty 6/15/2014 14:02' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


SqueakLinux32x86_64Builder 
	configureABuildFor: #MY  NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!Linux64SqueakCogV3 methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:32'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!Linux64SqueakCogV3 methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:21'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakCogV3! !

!Linux64SqueakCogV3 methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:32'!
dirBuildPlatform
	"the directory for the platform. example: build.linux32x86"
	^self dirLinux32x8664! !

!Linux64SqueakCogV3 methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:38'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Linux64SqueakCogV3 methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:09'!
executableName
	^ self vmCogExecutableName! !

Linux64Config subclass: #Linux64SqueakSistaSpur
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-LinuxX86-64'!

!Linux64SqueakSistaSpur commentStamp: 'tty 6/15/2014 14:02' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


SqueakLinux32x86_64Builder 
	configureABuildFor: #MY  NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!Linux64SqueakSistaSpur methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:32'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!Linux64SqueakSistaSpur methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:21'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakSistaSpur! !

!Linux64SqueakSistaSpur methodsFor: 'as yet unclassified' stamp: 'tty 6/9/2014 18:32'!
dirBuildPlatform
	"the directory for the platform. example: build.linux32x86"
	^self dirLinux32x8664! !

!Linux64SqueakSistaSpur methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:38'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Linux64SqueakSistaSpur methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:57'!
executableName
	^ self vmSistaExecutableName! !

Linux64Config subclass: #Linux64SqueakSistaV3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-LinuxX86-64'!

!Linux64SqueakSistaV3 commentStamp: 'tty 6/15/2014 14:02' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


SqueakLinux32x86_64Builder 
	configureABuildFor: #MY  NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!Linux64SqueakSistaV3 methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:32'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!Linux64SqueakSistaV3 methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:21'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakSistaV3! !

!Linux64SqueakSistaV3 methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:32'!
dirBuildPlatform
	"the directory for the platform. example: build.linux32x86"
	^self dirLinux32x8664! !

!Linux64SqueakSistaV3 methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:38'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Linux64SqueakSistaV3 methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:57'!
executableName
	^ self vmSistaExecutableName! !

Linux64Config subclass: #Linux64SqueakStackSpur
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-LinuxX86-64'!

!Linux64SqueakStackSpur commentStamp: 'tty 6/15/2014 14:02' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


SqueakLinux32x86_64Builder 
	configureABuildFor: #MY  NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!Linux64SqueakStackSpur methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:32'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!Linux64SqueakStackSpur methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:21'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackSpur! !

!Linux64SqueakStackSpur methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:32'!
dirBuildPlatform
	"the directory for the platform. example: build.linux32x86"
	^self dirLinux32x8664! !

!Linux64SqueakStackSpur methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:38'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Linux64SqueakStackSpur methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:03'!
executableName
	^ self vmStackExecutableName! !

Linux64Config subclass: #Linux64SqueakStackV3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-LinuxX86-64'!

!Linux64SqueakStackV3 commentStamp: 'tty 6/15/2014 14:02' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


SqueakLinux32x86_64Builder 
	configureABuildFor: #MY  NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!Linux64SqueakStackV3 methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:33'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!Linux64SqueakStackV3 methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:21'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackV3! !

!Linux64SqueakStackV3 methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:33'!
dirBuildPlatform
	"the directory for the platform. example: build.linux32x86"
	^self dirLinux32x8664! !

!Linux64SqueakStackV3 methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:45'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Linux64SqueakStackV3 methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:03'!
executableName
	^ self vmStackExecutableName! !

CogFamilyUnixConfig subclass: #Linux64x86w32BitConfig
	uses: TCPlatformConfigForSqueak
	instanceVariableNames: 'buildType generateBuild generateBuildAssert generateBuildAssertITimerHeartbeat generateBuildDebug generateBuildDebugITimerHeartbeat generateBuildDebugMultiThreaded generateBuildIHeartbeatTimer generateBuildMultiThreaded generateBuildMultiThreadedAssert generateBuildMultiThreadedDebug'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Linux64X86-32BitCompatibility'!

!Linux64x86w32BitConfig commentStamp: 'tty 6/15/2014 13:49' prior: 0!
I provide base class functionality.

I am not meant to be built.

SqueakLinux64x86w32CompatBuilder 
	configureABuildFor: #ONE OF MY SUBCLASSES NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp


!

Linux64x86w32BitConfig class
	uses: TCPlatformConfigForSqueak classTrait
	instanceVariableNames: ''!

!Linux64x86w32BitConfig class methodsFor: 'accessing' stamp: 'tty 6/15/2014 11:23'!
licenseTemplate
	^'Squeak {1} license information
==============================

About Squeak
-----------
Squeak is a modern, open source, full-featured implementation of the powerful Smalltalk programming language and environment. Squeak is highly-portable, running on almost any platform you could name and you can really truly write once run anywhere.  Squeak is the vehicle for a wide range of projects from multimedia applications and educational platforms to commercial web application development.

LIcense
Note: The current release of Squeak is a combination of source code originating from it''s origins at Apple which Apple agreed to license under the Apache license and more recent contributions licensed under the MIT license. The vast majority of the code is under the MIT license.
MIT License

Copyright (c) The individual, corporate, and institutional contributors who have collectively contributed elements to this software ("The Squeak Community"), 1996-2010 All rights reserved.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
Portions of Squeak are covered by the following license:
Apache License, Version 2.0

Copyright (c) Xerox Corp. 1981, 1982 All rights reserved. Copyright (c) Apple Computer, Inc. 1985-1996 All rights reserved.

Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.


About Cog
---------

Cog is a virtual machine designed for Smalltalk and other similar dynamic languages.  Cog builds on the
Squeak virtual machine adding a stack-to-register-mapping just-in-time compiler, aggressive in-line message
cacheing and effective optimization of Smalltalk?s first-class activation records.  Cog is the virtual machine
underlying Teleplace''s Croquet-based enterprise virtual collaboration spaces software, the fastest virtual
machine for Squeak, and for Gilad Bracha''s Newspeak modular language inspired by Beta and Smalltalk.  
Like the original Squeak VM, Cog is implemented and developed in Smalltalk, and translated into a lower-level
language to produce the production VM.  Being a Smalltalk program it is a delight to develop.  Cog is
available under the MIT open source license and is unencumbered for commercial deployment.

Cog''s performance relative to the existing Squeak interpreter varies, depending on the benchmark chosen.
As of early-2011, the Cog JIT uses strong inline cacheing techniques and stack-to-register mapping that
results in a register-based calling convention for low-arity methods.  Due to the complexity of the Squeak
object representation it has a limited set of primitives implemented in machine code that, for example,
exclude object allocation.  Performance of the early-2011 JIT for the nbody, binarytrees and chameneos
redux benchmarks from the computer language shootout is in the range of 4 to 6 times faster than the
interpreter.
'! !

!Linux64x86w32BitConfig class methodsFor: 'accessing' stamp: 'tty 6/15/2014 11:23'!
pluginsTemplate
	^'{4} {1} ships with this plugins already built:
		
Internal: 
=========
{2}

External: 
=========
{3}

'! !

!Linux64x86w32BitConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/15/2014 11:22'!
addDriver: name sources: aSources generator: cmakeGen externalLibs: extLibs

	| cfg srcs |
	
	srcs := aSources inject: '' into: [:res :each | res , ' "', each, '"' ].
	cfg := cmakeGen
		captureOutputDuring: [
			cmakeGen printHeader;
			project: name;
			include: '../directories.cmake';
		
			message: 'Adding module: ', name;
			
			addDefinitions:  self compilerFlags;
			addDefinitions: '-fPIC -DPIC';
			set: #sources to: srcs;
			cmd: 'add_library' params: name, ' SHARED ${sources}'; 
			includeDirectories: '${crossDir}/plugins/FilePlugin';
			includeDirectories: '${targetPlatform}/plugins/B3DAcceleratorPlugin';
			includeDirectories: '${crossDir}/plugins/B3DAcceleratorPlugin';
			set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir fullName;
			addExternalLibraries: extLibs;
			cmd: 'target_link_libraries' params: name , ' ${LINKLIBS}';
			cmd: 'set_target_properties' params: name , ' PROPERTIES PREFIX "" SUFFIX "" 
			LINK_FLAGS -m32' 
	].
	
	(self buildDir / name) assureExistence.
	self write: cfg toFile: name , '/', cmakeGen outputFileName.
	cmakeGen addSubdirectory:  name.
	! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default allBuildConfigurations copyWithoutAll:#(#releaseMultiThreadedFFI #debugMultiThreadedFFI)
! !

!Linux64x86w32BitConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/15/2014 11:22'!
buildDir
	^ buildDir ifNil: [ buildDir := ( self topDir / self buildDirName) assureExistence].! !

!Linux64x86w32BitConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/15/2014 11:22'!
buildDirName
	buildType isNil
		ifTrue:[^self dirBuildPlatform, FileDirectory slash, self dirBuildLanguageVMMM, FileDirectory slash, 'build']
		ifFalse:[^self dirBuildPlatform, FileDirectory slash, self dirBuildLanguageVMMM, FileDirectory slash, buildType asString]! !

!Linux64x86w32BitConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/15/2014 11:22'!
buildScript
	"answer the build script for building everything"
	

	^ 
'#!!/usr/bin/env bash

cmake .
make

'! !

!Linux64x86w32BitConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/15/2014 11:22'!
buildType: aSymbol
	buildType:= aSymbol! !

!Linux64x86w32BitConfig methodsFor: 'source generation' stamp: 'tty 6/15/2014 11:22'!
cogitClass
	^ StackToRegisterMappingCogit ! !

!Linux64x86w32BitConfig methodsFor: 'compiler flags' stamp: 'tty 6/15/2014 11:22'!
commonCompilerFlags
	self flag: 'tty'. "pull up common flags from subclasses on a refactoring pass."
	^#()! !

!Linux64x86w32BitConfig methodsFor: 'compiler flags' stamp: 'tty 6/16/2014 20:11'!
compilerFlags
	|d commonFlags flags|
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self compilerFlagsBuild];
		at: #buildAssert  put: [self compilerFlagsAssert];
		at: #buildAssertITimerHeartbeat  put: [self compilerFlagsAssertITimerHeartbeat];
            at:#buildDebug  put: [self compilerFlagsDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self compilerFlagsDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self compilerFlagsIHeartbeatTimer];
		at: #buildMultiThreaded  put: [self compilerFlagsMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self compilerFlagsMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self compilerFlagsMultiThreadedDebug ];
		at: #buildNone put:[self compilerFlagsNoBuildType].

    flags:= String streamContents: [ :stream |
	 (((d at:  buildType) value)  collect: #withBlanksTrimmed as: Set)
		asStringOn: stream 
		delimiter:' '].

    commonFlags:=String streamContents: [ :stream |
		((self commonCompilerFlags) collect: #withBlanksTrimmed as: Set)
			asStringOn: stream 
			delimiter: ' ' ].
	^ commonFlags, ' ' ,flags.! !

!Linux64x86w32BitConfig methodsFor: 'compiler flags' stamp: 'tty 6/15/2014 11:22'!
compilerFlagsAssert
	self required! !

!Linux64x86w32BitConfig methodsFor: 'compiler flags' stamp: 'tty 6/15/2014 11:22'!
compilerFlagsAssertITimerHeartbeat
	self required! !

!Linux64x86w32BitConfig methodsFor: 'compiler flags' stamp: 'tty 6/15/2014 11:22'!
compilerFlagsBuild
	"backwards compatability with pharo. If adding, override compilerFlagsRelease in your configuration."

	^self compilerFlagsRelease.! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
compilerFlagsDebug

	^ {
		'-g3'. 
		'-O0'. 
		'-msse2'. 
		'-D_GNU_SOURCE'. 
		'-DITIMER_HEARTBEAT=1'. 
		'-DNO_VM_PROFILE=1'. 
		'-DDEBUGVM=1' }! !

!Linux64x86w32BitConfig methodsFor: 'compiler flags' stamp: 'tty 6/15/2014 11:22'!
compilerFlagsDebugITimerHeartbeat
	self required! !

!Linux64x86w32BitConfig methodsFor: 'compiler flags' stamp: 'tty 6/15/2014 11:22'!
compilerFlagsDebugMultiThreaded
	self required! !

!Linux64x86w32BitConfig methodsFor: 'compiler flags' stamp: 'tty 6/15/2014 11:22'!
compilerFlagsIHeartbeatTimer
	self required! !

!Linux64x86w32BitConfig methodsFor: 'compiler flags' stamp: 'tty 6/15/2014 11:22'!
compilerFlagsMultiThreaded
	self required! !

!Linux64x86w32BitConfig methodsFor: 'compiler flags' stamp: 'tty 6/15/2014 11:22'!
compilerFlagsMultiThreadedAssert
	self required! !

!Linux64x86w32BitConfig methodsFor: 'compiler flags' stamp: 'tty 6/15/2014 11:22'!
compilerFlagsMultiThreadedDebug
	self required! !

!Linux64x86w32BitConfig methodsFor: 'compiler flags' stamp: 'tty 6/15/2014 11:22'!
compilerFlagsNoBuildType
	self shouldNotImplement.! !

!Linux64x86w32BitConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/15/2014 11:22'!
configH
	" right now its like  that "
	^ '
#ifndef __sq_config_h
#define __sq_config_h

/* explicit image width */

#define HAVE_INTERP_H 1

/* package options */

#define USE_X11 1
#define USE_X11_GLX 1
/* #undef       USE_QUARTZ */
/* #undef       USE_QUARTZ_CGL */
/* #undef       USE_RFB */

/* libraries */

/* #undef       HAVE_LIBX11 */
#define HAVE_LIBXEXT 1
#define HAVE_LIBDL 1
/* #undef       HAVE_DYLD */
/* #undef       HAVE_LIBFFI */
/* #undef       HAVE_ICONV */

/* #undef       USE_AUDIO_NONE */
/* #undef       USE_AUDIO_SUN */
/* #undef       USE_AUDIO_NAS */
/* #undef       USE_AUDIO_OSS */
/* #undef       USE_AUDIO_MACOSX */
/* #undef       OSS_DEVICE */

/* header files */

#define HAVE_UNISTD_H 1
/* #undef       NEED_GETHOSTNAME_P */

#define HAVE_DIRENT_H 1
/* #undef       HAVE_SYS_NDIR_H */
/* #undef       HAVE_SYS_DIR_H */
/* #undef       HAVE_NDIR_H */
#define HAVE_DLFCN_H 1
/* #undef       HAVE_ICONV_H */

#define HAVE_SYS_TIME_H 1
#define TIME_WITH_SYS_TIME 1

#define HAVE_SYS_FILIO_H 1

/* #undef       HAVE_SYS_AUDIOIO_H */
/* #undef       HAVE_SUN_AUDIOIO_H */

/* #undef       HAVE_PTY_H */
/* #undef       HAVE_UTIL_H */
#define HAVE_LIBUTIL_H 1
/* #undef       HAVE_STROPTS_H */

#define HAVE_GL_GL_H 1
/* #undef       HAVE_OPENGL_GL_H */

/* #undef       NEED_SUNOS_H */


#define HAVE_UUID_H
/* system calls/library functions */

#define AT_EXIT atexit

#define HAVE_TZSET 1

#define HAVE_OPENPTY 1
/* #undef       HAVE_UNIX98_PTYS */

#define HAVE_SNPRINTF 1
/* #undef       HAVE___SNPRINTF */

#define HAVE_MMAP 1

/* #undef       HAVE_DYLD */

#define HAVE_LANGINFO_CODESET 1

#define HAVE_ALLOCA 1
/* #undef       HAVE_ALLOCA_H */

#define HAVE_UNSETENV 1

#define HAVE_NANOSLEEP 1

/* widths of primitive types */

#define SIZEOF_INT 4
#define SIZEOF_LONG 4
#define SIZEOF_LONG_LONG 8
#define SIZEOF_VOID_P 4

/* structures */

#define HAVE_TM_GMTOFF 1
#define HAVE_TIMEZONE 1

/* typedefs */

/* #undef       size_t */
/* #undef       socklen_t */

#define squeakInt64 long long

/* architecture */

#define OS_TYPE "unix"

#define VM_HOST "i386-freebsd8.2"
#define VM_HOST_CPU "i386"
/* #undef       VM_HOST_VENDOR */
#define VM_HOST_OS "freebsd8.2"
#define VM_BUILD_STRING "Unix built on "__DATE__ " "__TIME__" Compiler: "__VERSION__

/* #undef       WORDS_BIGENDIAN */
/* #undef       DOUBLE_WORD_ALIGNMENT */

/* damage containment */

/* #undef       DARWIN */

#ifdef NEED_SUNOS_H
# include "sunos.h"
#endif

/* other configured variables */

#define SQ_VERSION "3.9a-7024"
#define VM_VERSION "3.9-7"
#define VM_MODULE_PREFIX ""
/* #undef VM_DLSYM_PREFIX */
#define VM_X11DIR "/usr/X11R6/lib"

/* avoid dependencies on glibc2.3 */

/* #undef HAVE_FEATURES_H */

#if defined(HAVE_FEATURES_H)
# include "glibc.h"
#endif

#endif /* __sq_config_h */
																																																																					
																																																																				'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 20:54'!
configureBuild
	"configure this Configuration for a buildType #build"
	self 
		preferredIncludesBuild;
		standardIncludesBuild;
		compilerFlagsBuild;
		internalPluginsBuild;
		externalPluginsBuild;
		thirdpartyLibsBuild.
! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
configureBuildAssert
	self required! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
configureBuildAssertITimerHeartbeat
	generateBuildAssertITimerHeartbeat:=true.! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
configureBuildDebug
	self required! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
configureBuildDebugITimerHeartbeat
	self required! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
configureBuildDebugMultiThreaded
	self required! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
configureBuildIHeartbeatTimer
	self required! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
configureBuildMultiThreaded
	self required! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
configureBuildMultiThreadedAssert
	self required! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
configureBuildMultiThreadedDebug
	self required! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 20:11'!
configureForBuildType: aSymbol
	| d |
	"provide a concrete builder with the buildType and configureBuildX method to invoke"
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	self configureNoBuildType.                "reset all internal flags"
	d 
		at: #build 
		put: [self buildType:#build.  self configureBuild];

		at: #buildAssert 
		put: [self buildType: #buildAssert.  	self configureBuildAssert];

		at: #buildAssertITimerHeartbeat 
		put:     [ self buildType: #buildAssertITimerHeartbeat.   self configureBuildAssertITimerHeartbeat];

            at:#buildDebug 
		put: [self buildType: #buildDebug.  self configureBuildDebug];

		at: #buildDebugITimerHeartbeat 
		put:  [self buildType: #buildDebugITimerHeartbeat.   self configureBuildDebugITimerHeartbeat];

		at: #buildITimerHeartbeat 
		put: [self buildType:#buildITimerHeartbeat.    self configureBuildIHeartbeatTimer];

		at: #buildMultiThreaded 
		put:  [self buildType:#buildMultiThreaded . self configureBuildMultiThreaded];

		at: #buildMultiThreadedAssert 
		put: [self buildType: #buildMultiThreadedAssert. self configureBuildMultiThreadedAssert];

		at: #buildMultiThreadedDebug  
		put: [self buildType: #buildMultiThreadedDebug. self configureBuildMultiThreadedDebug].

     ^(d at: aSymbol).! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
configureNoBuildType
		generateBuild:=generateBuildAssert:=generateBuildAssertITimerHeartbeat:=generateBuildDebug:=generateBuildDebugITimerHeartbeat:= generateBuildDebugMultiThreaded:= generateBuildIHeartbeatTimer:= generateBuildMultiThreaded:= generateBuildMultiThreadedAssert:= generateBuildMultiThreadedDebug:=false.! !

!Linux64x86w32BitConfig methodsFor: 'sources' stamp: 'tty 6/15/2014 11:22'!
coreSources
	"files to include from src/vm dir"
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!Linux64x86w32BitConfig methodsFor: 'plugins' stamp: 'tty 6/16/2014 15:41'!
defaultExternalPlugins
" tty 2014.06.10  cut-n-paste from Cog/build.linux32x86/newspeak.cog.spur/build/plugins.ext"
	^ #(B3DAcceleratorPlugin 
		BochsIA32Plugin 
	      ThreadedFFIPlugin    "moduleName->SqueakFFIPrims "
		"FFIPlugin"                   "moduleName->SqueakFFIPrims "
		SqueakSSLPlugin       "moduleName->SqueakSSL" 
		LocalePlugin 
		UnixOSProcessPlugin 
		UUIDPlugin)


"N.B. Regarding ThreadedFFIPlugin and FFIPlugin from eem:

Use  ThreadedFFIPlugin.  The FFIPlugin is obsolete (it requires assembler support files, and is non-reentrant).  
This should generate in src/plugins/SqueakFFIPrims/{SqueakFFIPrims.c,ARM32FFIPlugin.c,IA32FFIPlugin.c} and 
you should compile only src/plugins/SqueakFFIPrims/SqueakFFIPrims.c.  
src/plugins/SqueakFFIPrims/SqueakFFIPrims.c is a simple wrapper that includes 
ARM32FFIPlugin.c or IA32FFIPlugin.c as appropriate 
(and others can be added as they are developed).


"! !

!Linux64x86w32BitConfig methodsFor: 'plugins' stamp: 'tty 6/15/2014 11:22'!
defaultInternalPlugins
" tty 2014.06.10  cut-n-paste from Cog/build.linux32x86/newspeak.cog.spur/build/plugins.int
   N.B. moduleName->XYZ means XYZ appears in the GNU-Build's plugins.int/ext. However, Smalltalk requires the class name.
                                 XYZSmalltalkClass  moduleName->XYZ as it appears in plugins.int/ext
"
	^ #(
	    ADPCMCodecPlugin
    AsynchFilePlugin
    BalloonEnginePlugin "moduleName -->B2DPlugin"
    BitBltSimulation        "moduleName->BitBltPlugin"
    BMPReadWriterPlugin
    CroquetPlugin
    DeflatePlugin               "moduleName->ZipPlugin"
    DropPlugin
    DSAPlugin                    "moduleName->DSAPrims"
    FFTPlugin
    FileCopyPlugin
    FilePlugin
    FloatArrayPlugin
    FloatMathPlugin
    IA32ABIPlugin             "moduleName->IA32ABI"
   " InflatePlugin"               "moduleName->ZipPlugin"   "already included with the DeflatePlugin"
    JoystickTabletPlugin
    JPEGReaderPlugin
    JPEGReadWriter2Plugin
    KlattSynthesizerPlugin  "moduleName->Klatt"
    LargeIntegersPlugin      "moduleName->LargeIntegers"
    Matrix2x3Plugin
    MIDIPlugin
    MiscPrimitivePlugin
    Mpeg3Plugin
    RePlugin
    SecurityPlugin
    SerialPlugin
    SocketPlugin
    SoundCodecPlugin        "moduleName->SoundCodecPrims"
    SoundGenerationPlugin
    SoundPlugin
    StarSqueakPlugin
    SurfacePlugin
    VMProfileLinuxSupportPlugin)! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirARMv6
	^'cmake.build.arm.v6'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirAndroid
	^'Do Not Build. See Class Comment'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirArmv6
	^'cmake.build.arm.v6'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirBSD32x86
	^'cmake.build.bsd32x86'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirBuild
	^SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo at: #build! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirBuildAssert
	^SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo at: #buildAssert! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirBuildAssertITimerHeartbeat
	^SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo at: #buildAssertITimerHeartbeat! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirBuildDebug
	^SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo at: #debug! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirBuildDebugITimerHeartbeat
	^SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo at: #debugITimerHeartbeat! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirBuildDebugMultiThreaded
	^SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo at: #debugMultiThreaded! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirBuildITimerHeartbeat
	^SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo at: #buildITimerHeartbeat! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakCogV3! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirBuildMultiThreaded
	^SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo at: #buildMultiThreaded! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirBuildMultiThreadedAssert
	^SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo at: #buildMultiThreadedAssert! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirBuildMultiThreadedDebug
	^SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo at: #buildMultiThreadedDebug! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirBuildPlatform
	"the directory for the platform. example: build.linux32x86"
	^self dirLinux32x86! !

!Linux64x86w32BitConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/15/2014 11:22'!
dirFrom: aStringOrDir
	^ aStringOrDir isString
		ifTrue: [ FileDirectory forFileName: aStringOrDir  ]
		ifFalse: [ aStringOrDir ]! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirIA32Bochs
	^'cmake.build.ia32bochs'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirIOS
	^'cmake.build.ios'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirInstall
	"the directory of the finished product.. the place where 'make install' puts stuff.
	SystemNavigation default browseMethodsWhoseNamesContain: 'outputDir'
      "
self required.
! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirLinux32Armv6
	^'cmake.build.linux32armv6'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirLinux32x86
	^'cmake.build.linux32x86'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirLinux32x8664
	^'cmake.build.linux32_64x86'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirMacOS
	^'cmake.build.macos'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirMacOSPowerPC
	^'cmake.build.macospowerpc'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirMacOSX32x86
	^'cmake.build.macosx32x86'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirOutput
	^'cmake.products'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirSource
	^'src'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirSunOS32x86
	^'cmake.build.sunos32x86'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
dirWin32x86
	^'cmake.build.win32x86'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
eventStackV3
	"needed by Android config to pass internal tests. Android config is not built"
	^'do not build'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:45'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Linux64x86w32BitConfig methodsFor: 'accessing' stamp: 'tty 6/15/2014 11:22'!
executableName
	self required! !

!Linux64x86w32BitConfig methodsFor: 'accessing' stamp: 'tty 6/15/2014 11:22'!
executableType
	^''

"
SystemNavigation default browseMethodsWhoseNamesContain: ''executableType''
	^ 'MACOSX_BUNDLE'
	^ 'WIN32'\
	^ ''
"! !

!Linux64x86w32BitConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/15/2014 11:22'!
extraPluginSettings: maker
	super extraPluginSettings: maker.  
	maker set: #linkFlags toString: '${linkFlags} -m32'! !

!Linux64x86w32BitConfig methodsFor: 'sources' stamp: 'tty 6/15/2014 11:22'!
extraSources
	self flag: 'tty'. "what is this?"
	^ 'version.c'! !

!Linux64x86w32BitConfig methodsFor: 'settings' stamp: 'tty 6/15/2014 11:22'!
extraVMSettings: maker
	| versionC |
	self generateConfigH.
	
	"add a generated version.c"
	
	versionC := 'version.c'.
	
	maker cmd: 'add_custom_command' params: 'OUTPUT ',
		versionC , '
		COMMAND ${platformsDir}/unix/config/verstamp ',versionC,' gcc
		COMMENT "Generating version.c"
	'.
	
	! !

!Linux64x86w32BitConfig methodsFor: 'accessing' stamp: 'tty 6/15/2014 11:22'!
frameworks
	"leave empty for all platforms but Mac OS"
	^ #()! !

!Linux64x86w32BitConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/15/2014 11:22'!
generate
	self generatePluginsList. 
	self generateLicense. 
	^ CMakeVMGeneratorForSqueak generate: self ! !

!Linux64x86w32BitConfig methodsFor: 'headers generation' stamp: 'tty 6/16/2014 18:31'!
generateConfigH
	"	
	used to be: 	
		self write: self configH toFile: 'config.h'
      but with variable buildTypes we need:
"
	self write: (self generateConfigH: buildType asSymbol) toFile: 'config.h'   
! !

!Linux64x86w32BitConfig methodsFor: 'headers generation' stamp: 'tty 6/16/2014 20:11'!
generateConfigH: aBuildType
	"self write: self configH toFile: 'config.h'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self configHBuild];
		at: #buildAssert  put: [self configHBuildAssert];
		at: #buildAssertITimerHeartbeat  put: [self configHBuildAssertITimerHeartbeat];
            at:#buildDebug  put: [self configHBuildDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self configHBuildDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self configHBuildITimerHeartbeat];
		at: #buildMultiThreaded  put: [self configHBuildMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self configHBuildMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self configHBuildMultiThreadedDebug ];
		at: #buildNone put:[self configHNoBuildType].


	 ^(d at: ( aBuildType)) value



! !

!Linux64x86w32BitConfig methodsFor: 'accessing' stamp: 'tty 6/15/2014 11:22'!
generateLicense 
	self 
		write:  (self class licenseTemplate 
			format: { self version })
		toFile: 'LICENSE.txt'
	! !

!Linux64x86w32BitConfig methodsFor: 'accessing' stamp: 'tty 6/15/2014 11:22'!
generatePluginsList 
	self 
		write:  (self class pluginsTemplate 
			format: {
				self version. 
				String streamContents: [ :stream | self internalPlugins asStringOn: stream delimiter: String cr ].
				String streamContents: [ :stream | self externalPlugins asStringOn: stream delimiter: String cr ].
				self executableName })
		toFile: 'PLUGINS.txt'
	! !

!Linux64x86w32BitConfig methodsFor: 'initialize-release' stamp: 'tty 6/15/2014 11:22'!
initialize
	super initialize.
	"this should be in my superclass, but I do not have permission to modify it. tty"
	 generateForAssert:= generateForAssertHeartbeatTimer:= generateForDebug :=generateForDebugWithHeartbeatTimer:= generateForDebugMultiThreadedFFI:= generateForReleaseHeartbeatTimer:= generateForReleaseMultiThreadedFFI:=false! !

!Linux64x86w32BitConfig methodsFor: 'source generation' stamp: 'tty 6/15/2014 11:22'!
interpreterClass
	self required.
	"
	^ CoInterpreter
	^ CoInterpreterMT
	^ StackInterpreter
	^ StackEvtAndroidInterpreter
	??other
	"! !

!Linux64x86w32BitConfig methodsFor: 'accessing' stamp: 'tty 6/15/2014 11:22'!
linkFlags
"	^ super linkFlags , ' -luuid -lSM -lICE -ldl -lGL -lpthread -lm -lnsl -lX11'"
	^ super linkFlags , ' -luuid -lSM -lICE -ldl  -lpthread -lm -lnsl -lX11'

! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
newspeakCogSpur
	^'newspeak.cog.spur'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
newspeakCogV3
	^'newspeak.cog.v3'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
newspeakSistaSpur
	^'newspeak.sista.Spur'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
newspeakSistaV3
	^'newspeak.sista.v3'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
newspeakStackSpur
	^'newspeak.stack.spur'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
newspeakStackV3
	^'newspeak.stack.v3'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
oscogvm
	^ 'oscogvm'! !

!Linux64x86w32BitConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/15/2014 11:22'!
outputDir

	"the directory where built binaries will be stored"
	^ outputDir ifNil: [ outputDir := (self topDir / self dirOutput /  self dirInstall) ]	

! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
outputDirName
	^ 'products'! !

!Linux64x86w32BitConfig methodsFor: 'sources' stamp: 'tty 6/15/2014 11:22'!
platformSources
	"files added from platform/unix/vm dir "
	^ #(
	'aio.c'
	'debug.c'
"	'dlfcn-dyld.c'
	'mac-alias.c' "
	'osExports.c'
	'sqUnixCharConv.c'
"	'sqUnixEvent.c' "
	'sqUnixExternalPrims.c'
	'sqUnixHeartbeat.c'
	'sqUnixMain.c'
	'sqUnixMemory.c'
	'sqUnixThreads.c'
	'sqUnixVMProfile.c'
	)! !

!Linux64x86w32BitConfig methodsFor: 'source files' stamp: 'tty 6/15/2014 11:22'!
preferredIncludes
	self flag:'tty'. "pharo does not support newspeak or sista., yet sets this in CogUnixConfig. Is this appropriate here? Revisit when coding newspeak etc"
	^ #(  '${targetPlatform}/plugins/AioPlugin'
 '${targetPlatform}/plugins/B3DAcceleratorPlugin'
 '${targetPlatform}/plugins/DropPlugin'
 '${targetPlatform}/plugins/FilePlugin'
 '${targetPlatform}/plugins/HostWindowPlugin'
 '${targetPlatform}/plugins/JPEGReadWriter2Plugin'
 '${targetPlatform}/plugins/LocalePlugin'
 '${targetPlatform}/plugins/Mpeg3Plugin'
 '${targetPlatform}/plugins/PseudoTTYPlugin'
 '${targetPlatform}/plugins/SerialPlugin'
 '${targetPlatform}/plugins/SoundPlugin'
 '${crossDir}/plugins/SoundGenerationPlugin'
 '${targetPlatform}/plugins/SqueakSSL'
 '${targetPlatform}/plugins/UnixOSProcessPlugin'
 '${targetPlatform}/plugins/AsynchFilePlugin'
 '${targetPlatform}/plugins/BochsIA32Plugin'
 '${targetPlatform}/plugins/FileCopyPlugin'
 '${targetPlatform}/plugins/FloatMathPlugin'
 '${targetPlatform}/plugins/InternetConfigPlugin'
 '${targetPlatform}/plugins/JoystickTabletPlugin'
 '${targetPlatform}/plugins/MIDIPlugin'
 '${targetPlatform}/plugins/PrintJobPlugin'
 '${targetPlatform}/plugins/SecurityPlugin'
 '${targetPlatform}/plugins/SocketPlugin'
 '${targetPlatform}/plugins/SqueakFFIPrims'
 '${targetPlatform}/plugins/UUIDPlugin'    
 '${targetPlatform}/plugins/XDisplayControlPlugin'

)


	

"SystemNavigation default browseMethodsWhoseNamesContain: 'preferredIncludes'"
	! !

!Linux64x86w32BitConfig methodsFor: 'source generation' stamp: 'tty 6/15/2014 11:22'!
prepareForGeneration
	self required

	"^self prepareForCogGeneration
	  ^self prepareForStackVMGeneration
		
	  CPlatformConfig browse"
! !

!Linux64x86w32BitConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/15/2014 11:22'!
prepareVMMaker
	
	| maker allPlugins |
	
	"In CogVMs (in contrast to Interpreter VM) the generated sources are platform independent, therefore Cross is ok"
	maker := VMMaker forPlatform: 'Cross'.
	
	maker sourceDirectoryName: self srcDir pathName.
	maker platformRootDirectoryName: self platformsDir.
	
	
	allPlugins := self internalPlugins , self externalPlugins.
	
	"touch plugins to force their source generation unconditionally"
	allPlugins do: [:name | (Smalltalk globals at: name) touch ].
	
	" Why we put all plugins as external?   Because the generated sources are not different whether the plugins were defined as internal or external. VMMaker used to need this to to generate plugins.int and plugins.ext files. But since this is achieved in another way with CMakeVMMaker, there is no different at all to put all plugins as internal or as external."
	maker externalModules addAll:  allPlugins.
	
	^ maker! !

!Linux64x86w32BitConfig methodsFor: 'utils' stamp: 'tty 6/15/2014 11:23'!
setExtraTargetProperties: maker
	self flag:'tty'. "I am nervous about this method up here in this class, but pharo has it in CogUnixConfig, so using as is for now"

	maker setTargetProperties: 'LINK_FLAGS "-m32"'.
		
	maker puts: 'set_source_files_properties( ${srcVMDir}/cogit.c PROPERTIES 
		COMPILE_FLAGS "-O1 -fno-omit-frame-pointer -momit-leaf-frame-pointer -mno-rtd -mno-accumulate-outgoing-args")'.
		
	
	maker 
		cmd: 'set_source_files_properties'
		params: ' ${targetPlatform}/vm/sqUnixHeartbeat.c PROPERTIES 
		COMPILE_FLAGS "-O1 -fno-omit-frame-pointer -mno-rtd -mno-accumulate-outgoing-args"'.
	
	maker addExternalLibraries: 
		#(
			'uuid'  ""
			'ssl'  ""
			'crypto' ""
		).
					
	super setExtraTargetProperties: maker.
! !

!Linux64x86w32BitConfig methodsFor: 'utils' stamp: 'tty 6/16/2014 19:20'!
setGlobalOptions: aMaker
	"SystemNavigation default browseMethodsWhoseNamesContain: 'setGlobalOptions:'
	
	we subclass this in our concrete builder and route it to "

	^self setGlobalOptions: aMaker buildType: (buildType asSymbol)
! !

!Linux64x86w32BitConfig methodsFor: 'utils' stamp: 'tty 6/16/2014 20:11'!
setGlobalOptions: aMaker buildType: aBuildType
	"invoke correct setGlobalOptions for this buildType to allow per-buildType customization'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self setGlobalOptionsBuild: aMaker];
		at: #buildAssert  put: [self setGlobalOptionsBuildAssert: aMaker];
		at: #buildAssertITimerHeartbeat  put: [self setGlobalOptionsBuildAssertITimerHeartbeat: aMaker];
            at:#buildDebug  put: [self setGlobalOptionsBuildDebug: aMaker];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self setGlobalOptionsBuildDebugITimerHeartbeat: aMaker ];
		at: #buildITimerHeartbeat  put: [self setGlobalOptionsBuildITimerHeartbeat: aMaker];
		at: #buildMultiThreaded  put: [self setGlobalOptionsBuildMultiThreaded: aMaker ];
		at: #buildMultiThreadedAssert  put: [self setGlobalOptionsBuildMultiThreadedAssert: aMaker];
		at: #buildMultiThreadedDebug   put: [self setGlobalOptionsBuildMultiThreadedDebug: aMaker ];
		at: #buildNone put:[self setGlobalOptionsBuildNone: aMaker].

	 ^((d at: ( aBuildType)) value)
! !

!Linux64x86w32BitConfig methodsFor: 'utils' stamp: 'tty 6/16/2014 20:12'!
setGlobalOptionsAfterDetermineSystem: aMaker buildType: aBuildType
	"invoke correct setGlobalOptions for this buildType to allow per-buildType customization'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self setGlobalOptionsAfterDetermineSystemBuild: aMaker];
		at: #buildAssert  put: [self setGlobalOptionsAfterDetermineSystemBuildAssert: aMaker];
		at: #buildAssertITimerHeartbeat  put: [self setGlobalOptionsAfterDetermineSystemBuildAssertITimerHeartbeat: aMaker];
            at:#buildDebug  put: [self setGlobalOptionsAfterDetermineSystemBuildDebug: aMaker];   
		at: #buildITimerHeartbeat  put: [self setGlobalOptionsAfterDetermineSystemBuildITimerHeartbeat: aMaker];
		at: #buildMultiThreaded  put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreaded: aMaker ];
		at: #buildMultiThreadedAssert  put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreadedAssert: aMaker];
		at: #buildMultiThreadedDebug   put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreadedDebug: aMaker ];
		at: #buildNone put:[self setGlobalOptionsBuildNone: aMaker].

	 ^(d at: ( aBuildType)) value
! !

!Linux64x86w32BitConfig methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 19:46'!
setGlobalOptionsAfterDetermineSystemBuild: aMaker 
	self required! !

!Linux64x86w32BitConfig methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 19:21'!
setGlobalOptionsBuild: aMaker
	"convenience method to customize setGlobalOptions: aMaker for this build type. 
	Default is in CPlatformConfig>setGlobalOptions: aMaker setGlobalOptions: aMaker"
	^super setGlobalOptions: aMaker! !

!Linux64x86w32BitConfig methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 19:23'!
setGlobalOptionsBuildAssert: aMaker
	"convenience method to customize setGlobalOptions: aMaker for this build type. 
	Default is in CPlatformConfig>setGlobalOptions: aMaker setGlobalOptions: aMaker"
	^super setGlobalOptions: aMaker! !

!Linux64x86w32BitConfig methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 19:24'!
setGlobalOptionsBuildAssertITimerHeartbeat: aMaker
	"convenience method to customize setGlobalOptions: aMaker for this build type. 
	Default is in CPlatformConfig>setGlobalOptions: aMaker setGlobalOptions: aMaker"
	^super setGlobalOptions: aMaker! !

!Linux64x86w32BitConfig methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 19:23'!
setGlobalOptionsBuildDebug: aMaker
	"convenience method to customize setGlobalOptions: aMaker for this build type. 
	Default is in CPlatformConfig>setGlobalOptions: aMaker setGlobalOptions: aMaker"
	^super setGlobalOptions: aMaker! !

!Linux64x86w32BitConfig methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 19:23'!
setGlobalOptionsBuildDebugITimerHeartbeat: aMaker
	"convenience method to customize setGlobalOptions: aMaker for this build type. 
	Default is in CPlatformConfig>setGlobalOptions: aMaker setGlobalOptions: aMaker"
	^super setGlobalOptions: aMaker! !

!Linux64x86w32BitConfig methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 19:24'!
setGlobalOptionsBuildITimerHeartbeat: aMaker
	"convenience method to customize setGlobalOptions: aMaker for this build type. 
	Default is in CPlatformConfig>setGlobalOptions: aMaker setGlobalOptions: aMaker"
	self break.
	^super setGlobalOptions: aMaker! !

!Linux64x86w32BitConfig methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 19:24'!
setGlobalOptionsBuildMultiThreaded: aMaker
	"convenience method to customize setGlobalOptions: aMaker for this build type. 
	Default is in CPlatformConfig>setGlobalOptions: aMaker setGlobalOptions: aMaker"
	^super setGlobalOptions: aMaker! !

!Linux64x86w32BitConfig methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 19:24'!
setGlobalOptionsBuildMultiThreadedAssert: aMaker
	"convenience method to customize setGlobalOptions: aMaker for this build type. 
	Default is in CPlatformConfig>setGlobalOptions: aMaker setGlobalOptions: aMaker"
	^super setGlobalOptions: aMaker! !

!Linux64x86w32BitConfig methodsFor: 'cmake config build type ' stamp: 'tty 6/16/2014 19:24'!
setGlobalOptionsBuildMultiThreadedDebug: aMaker
	"convenience method to customize setGlobalOptions: aMaker for this build type. 
	Default is in CPlatformConfig>setGlobalOptions: aMaker setGlobalOptions: aMaker"
	^super setGlobalOptions: aMaker! !

!Linux64x86w32BitConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/16/2014 20:41'!
setupDirectories: aMaker
	| dirsInclude |

	" write the directories in separate include file"
	dirsInclude := aMaker captureOutputDuring: [
		aMaker
			set: #topDir toString: (self topDir fullName); 
			set: #buildDir toString: (self buildDir ifNil: ['${topDir}/build'] ifNotNil: [self buildDir fullName] );
			set: #thirdpartyDir toString: '${buildDir}/thirdParty';
			set: #platformsDir toString: self platformsDir;
			set: #srcDir toString: self srcDir pathName;
			set: #srcPluginsDir toString: (pluginsDir ifNil: [ '${srcDir}/plugins' ]);
			set: #srcVMDir toString: '${srcDir}/vm';
			set: #platformName toString: self platformName;
			set: #targetPlatform to: '${platformsDir}/${platformName}';
			set: #crossDir toString: '${platformsDir}/Cross';
			set: #platformVMDir toString: '${targetPlatform}/vm';
			set: #outputDir toString: self outputDir fullName.
	].

	self write: dirsInclude toFile: 'directories.cmake'.
	
	aMaker include: 'directories.cmake'.
! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
squeakCogSpur
	^'squeak.cog.spur'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
squeakCogV3
	^'squeak.cog.v3'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
squeakSistaSpur
	^'squeak.sista.Spur'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
squeakSistaV3
	^'squeak.sista.v3'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
squeakStackSpur
	^'squeak.stack.spur'! !

!Linux64x86w32BitConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:22'!
squeakStackV3
	^'squeak.stack.v3'! !

!Linux64x86w32BitConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/15/2014 11:22'!
srcDir
		^ srcDir ifNil: [ srcDir := (self topDir directoryNamed: 'src' )]! !

!Linux64x86w32BitConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/15/2014 11:23'!
topDir
	"N.B. this is a clash between Trait usage and Inheritence usage due to restrictions on modifying pharo's source"
	^ topDir ifNil: [ topDir := FileDirectory default directoryNamed: self oscogvm ]
	! !

!Linux64x86w32BitConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/15/2014 11:23'!
validateSourcesPresent
	| sources |
	sources := Smalltalk sourcesName.
	
	(sources == nil)
		ifTrue: [	self error: 'VM source code cannot be generated without .sources file'.]		! !

!Linux64x86w32BitConfig methodsFor: 'accessing' stamp: 'tty 6/15/2014 11:22'!
version
	^ ''! !

!Linux64x86w32BitConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/15/2014 11:23'!
write: aContents toFile: aFileName
	"write a file to current output directory (buildDir).
	use line end convention appropriate for config platform"

	| bldDir |
	bldDir := self buildDir.
	bldDir isString
		ifTrue: [ bldDir := FileDirectory directoryEntryFor: bldDir ].
	bldDir assureExistence.
	bldDir
		forceNewFileNamed: aFileName
		do: [:s | s
				nextPutAll: (self fixLineEndsOf: aContents)]

! !

Linux64x86w32BitConfig subclass: #Linux64x86w32BitSqueakCogV3SlackwareNoGLConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Linux64X86-32BitCompatibility'!

!Linux64x86w32BitSqueakCogV3SlackwareNoGLConfig commentStamp: 'tty 6/15/2014 18:26' prior: 0!
A slightly modified configuration, which avoids linking with openGL libraries.

SqueakLinux64x86w32CompatBuilder 
	configureABuildFor: #Linux32x86SqueakCogV3NoGLConfig withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp


Getting the UUIDPlugin to compile (not work, unfortunately, but compile) required modifying oscogvm/platforms/unix/plugins/acinclude.m4.
to read: (my Slackware system has <uuid> and uuidgen. then setting the 

# -*- sh -*-

AC_MSG_CHECKING([for UUID support])
AC_TRY_COMPILE([#include <sys/uuid.h>],[uuid_generatorxyz;],[
  AC_MSG_RESULT(yes)
  AC_CHECK_LIB(uuid, uuid_generator_xyz,LIB_UUID="-luuid" )
],[
  AC_MSG_RESULT(no)
  AC_MSG_CHECKING([for UUID support uuid/uuid.h] and uuid_generate)
  AC_TRY_COMPILE([#include <uuid/uuid.h>],[uuid_generate;],[
    AC_MSG_RESULT(yes)
    AC_CHECK_LIB(uuid, uuid_generate, LIB_UUID="-luuid")],[
    AC_MSG_RESULT(no)
      AC_MSG_CHECKING([for UUID support uuid and uuidgen] )
      AC_TRY_COMPILE([#include <uuid.h>],[uuidgen;],[
      AC_MSG_RESULT(yes)
       AC_CHECK_LIB(uuid, uuidgen, LIB_UUID="-luuid" )],[
       AC_MSG_RESULT(no)
        AC_PLUGIN_DISABLE
   ])
 ])
])




#define HAVE_UUID_H 1 
#define HAVE_UUIDGEN 1

fl;ags in my configH method

!

!Linux64x86w32BitSqueakCogV3SlackwareNoGLConfig methodsFor: 'utils' stamp: 'tty 5/23/2014 19:43'!
addDriver: name sources: aSources generator: cmakeGen

	| cfg srcs |
	
	srcs := aSources inject: '' into: [:res :each | res , ' "', each, '"' ].
	cfg := cmakeGen
		captureOutputDuring: [
			cmakeGen printHeader;
			project: name;
			include: '../directories.cmake';
		
			message: 'Adding module: ', name;
			
			addDefinitions:  self compilerFlags;
			addDefinitions: '-fPIC -DPIC';
			set: #sources to: srcs;
			cmd: 'add_library' params: name, ' SHARED ${sources}'; 
			includeDirectories: '${crossDir}/plugins/FilePlugin';
			set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir;
			cmd: 'set_target_properties' params: name , ' PROPERTIES PREFIX "" SUFFIX "" 
			LINK_FLAGS "-lSM -lICE -ldl -lpthread -lm -lnsl -lX11"'
	].
	
		
	self write: cfg toFile: ((self buildDir / name) assureExistence / cmakeGen outputFileName) fullName.
	cmakeGen addSubdirectory:  name.
	! !

!Linux64x86w32BitSqueakCogV3SlackwareNoGLConfig methodsFor: 'compiler flags' stamp: 'tty 6/14/2014 11:51'!
commonCompilerFlags
"	LSB_FIRST=1 means that target platform is little endian. 	set it to 0 for big-endian platforms"
	^ {
		'-DLSB_FIRST=1'. 
		'-DUSE_GLOBAL_STRUCT=0'. 
		'-DCOGMTVM=0'. 
		'-m32'.
		'-DENABLE_FAST_BLT ' } 	
	! !

!Linux64x86w32BitSqueakCogV3SlackwareNoGLConfig methodsFor: 'compiler flags' stamp: 'tty 6/14/2014 11:49'!
compilerFlagsRelease

	^ {
		'-g0'. 
		'-O2'. 
		'-fno-tree-pre'. 
		'-fno-caller-saves'. 
		'-msse2'. 
		'-D_GNU_SOURCE'. 
		'-DNDEBUG'. 
		'-DITIMER_HEARTBEAT=1'. 
		'-DNO_VM_PROFILE=1'. 
		'-DDEBUGVM=0' }! !

!Linux64x86w32BitSqueakCogV3SlackwareNoGLConfig methodsFor: 'headers generation' stamp: 'tty 6/16/2014 18:32'!
configHBuild
	^ '

#define HAVE_UUID_H 1 
#define HAVE_UUIDGEN 1

#ifndef __sq_config_h
#define __sq_config_h

/* explicit image width */

#define	HAVE_INTERP_H 1

/* package options */

#define	USE_X11 1

#undef	USE_X11_GLX 
/* #undef	USE_QUARTZ */
/* #undef	USE_QUARTZ_CGL */
/* #undef	USE_RFB */

/* libraries */

/* #undef	HAVE_LIBX11 */
/* #undef	HAVE_LIBXEXT */
#define	HAVE_LIBDL 1
/* #undef	HAVE_DYLD */
/* #undef	HAVE_LIBFFI */
/* #undef	HAVE_ICONV */

/* #undef	USE_AUDIO_NONE */
/* #undef	USE_AUDIO_SUN */
/* #undef	USE_AUDIO_NAS */
/* #undef	USE_AUDIO_OSS */
/* #undef	USE_AUDIO_MACOSX */
/* #undef	OSS_DEVICE */

/* header files */
	
#define	HAVE_UNISTD_H 1
/* #undef	NEED_GETHOSTNAME_P */

#define	HAVE_DIRENT_H 1
/* #undef	HAVE_SYS_NDIR_H */
/* #undef	HAVE_SYS_DIR_H */
/* #undef	HAVE_NDIR_H */
#define	HAVE_DLFCN_H 1
#define	HAVE_ICONV_H 1

#define	HAVE_SYS_TIME_H 1
#define	TIME_WITH_SYS_TIME 1

/* #undef	HAVE_SYS_FILIO_H */

/* #undef	HAVE_SYS_AUDIOIO_H */
/* #undef	HAVE_SUN_AUDIOIO_H */

#define	HAVE_PTY_H 1
/* #undef	HAVE_UTIL_H */
/* #undef	HAVE_LIBUTIL_H */
#define	HAVE_STROPTS_H 1

#undef	HAVE_GL_GL_H
#undef	HAVE_OPENGL_GL_H 

/* #undef	NEED_SUNOS_H */

/* system calls/library functions */

#define	AT_EXIT atexit

#define	HAVE_TZSET 1

#define	HAVE_OPENPTY 1
/* #undef	HAVE_UNIX98_PTYS */

#define	HAVE_SNPRINTF 1
/* #undef	HAVE___SNPRINTF */

#define	HAVE_MMAP 1

/* #undef	HAVE_DYLD */

#define	HAVE_LANGINFO_CODESET 1

#define	HAVE_ALLOCA 1
#define	HAVE_ALLOCA_H 1

#define	HAVE_UNSETENV 1

#define	HAVE_NANOSLEEP 1

/* widths of primitive types */

#define	SIZEOF_INT 4
#define	SIZEOF_LONG 4
#define	SIZEOF_LONG_LONG 8
#define	SIZEOF_VOID_P 4

/* structures */

#define	HAVE_TM_GMTOFF 1
#define	HAVE_TIMEZONE 1

/* typedefs */

/* #undef	size_t */
/* #undef	socklen_t */

#define	squeakInt64 long long

/* architecture */

#define	OS_TYPE "unix"

#define	VM_HOST "i686-pc-linux-gnu"
#define	VM_HOST_CPU "i686"
/* #undef	VM_HOST_VENDOR */
#define	VM_HOST_OS "linux-gnu"
#define	VM_BUILD_STRING "Unix built on "__DATE__ " "__TIME__" Compiler: "__VERSION__

/* #undef	WORDS_BIGENDIAN */
/* #undef	DOUBLE_WORD_ALIGNMENT */

/* damage containment */

/* #undef	DARWIN */

#ifdef NEED_SUNOS_H
# include "sunos.h"
#endif

/* other configured variables */

#define SQ_VERSION "3.9a-7024"
#define VM_VERSION "3.9-7"
#define VM_MODULE_PREFIX ""
/* #undef VM_DLSYM_PREFIX */
#define VM_X11DIR ""

/* avoid dependencies on glibc2.3 */

#define HAVE_FEATURES_H 1

#if defined(HAVE_FEATURES_H)
# include "glibc.h"
#endif

#endif /* __sq_config_h */
																																																																					
																																																																				'! !

!Linux64x86w32BitSqueakCogV3SlackwareNoGLConfig methodsFor: 'plugins' stamp: 'tty 6/16/2014 15:35'!
defaultExternalPlugins
	^ super defaultExternalPlugins copyWithoutAll: #(#B3DAcceleratorPlugin #BochsIA32Plugin)
! !

!Linux64x86w32BitSqueakCogV3SlackwareNoGLConfig methodsFor: 'cmake' stamp: 'tty 6/14/2014 15:45'!
dirInstall
	"the directory of the finished product.. the place where 'make install' puts stuff.
	SystemNavigation default browseMethodsWhoseNamesContain: 'outputDir'
      "
	^self squeakCogV3 , '.noGL'! !

!Linux64x86w32BitSqueakCogV3SlackwareNoGLConfig methodsFor: 'cmake' stamp: 'tty 6/14/2014 11:24'!
excludeFromBuild
	^false   "build this configuration"
"	^true"

! !

!Linux64x86w32BitSqueakCogV3SlackwareNoGLConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:09'!
executableName
	^ self vmCogExecutableName! !

!Linux64x86w32BitSqueakCogV3SlackwareNoGLConfig methodsFor: 'source generation' stamp: 'tty 6/14/2014 16:03'!
interpreterClass
	^ CoInterpreter! !

!Linux64x86w32BitSqueakCogV3SlackwareNoGLConfig methodsFor: 'source generation' stamp: 'tty 6/14/2014 16:02'!
prepareForGeneration
	^self prepareForCogGeneration
! !

!Linux64x86w32BitSqueakCogV3SlackwareNoGLConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/16/2014 20:52'!
setupDirectories: gen
	super setupDirectories: gen.
	gen set: #externalModulesDir toString: self externalModulesDir.! !

CogFamilyUnixConfig subclass: #SqueakBSDConfig
	uses: TCPlatformConfigForSqueak
	instanceVariableNames: 'buildType generateBuild generateBuildAssert generateBuildAssertITimerHeartbeat generateBuildDebug generateBuildDebugITimerHeartbeat generateBuildDebugMultiThreaded generateBuildIHeartbeatTimer generateBuildMultiThreaded generateBuildMultiThreadedAssert generateBuildMultiThreadedDebug'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-BSD32x86'!

!SqueakBSDConfig commentStamp: 'tty 6/15/2014 14:12' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

I am not meant to be built.

SqueakBSDx86Builder 
	configureABuildFor: #MY SUBCLASS NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp

!

SqueakBSDConfig class
	uses: TCPlatformConfigForSqueak classTrait
	instanceVariableNames: ''!

!SqueakBSDConfig class methodsFor: 'as yet unclassified' stamp: 'tty 6/7/2014 09:00'!
availableBuilds
	"SqueakCMakeVMMakerAbstractBuilder  allBuildConfigurations"
	^#(#assert #debug  #release )! !

!SqueakBSDConfig methodsFor: 'accessing' stamp: 'tty 6/6/2014 18:17'!
addDriver: name sources: aSources generator: cmakeGen externalLibs: extLibs

	| cfg srcs |
	
	srcs := aSources inject: '' into: [:res :each | res , ' "', each, '"' ].
	cfg := cmakeGen
		captureOutputDuring: [
			cmakeGen printHeader;
			project: name;
			include: '../directories.cmake';
		
			message: 'Adding module: ', name;
			
			addDefinitions:  self compilerFlags;
			addDefinitions: '-fPIC -DPIC';
			set: #sources to: srcs;
			cmd: 'add_library' params: name, ' SHARED ${sources}'; 
			includeDirectories: '${crossDir}/plugins/FilePlugin';
			includeDirectories: '${targetPlatform}/plugins/B3DAcceleratorPlugin';
			includeDirectories: '${crossDir}/plugins/B3DAcceleratorPlugin';
			set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir fullName;
			addExternalLibraries: extLibs;
			cmd: 'target_link_libraries' params: name , ' ${LINKLIBS}';
			cmd: 'set_target_properties' params: name , ' PROPERTIES PREFIX "" SUFFIX "" 
			LINK_FLAGS -m32' 
	].
	
	(self buildDir / name) assureExistence.
	self write: cfg toFile: name , '/', cmakeGen outputFileName.
	cmakeGen addSubdirectory:  name.
	! !

!SqueakBSDConfig methodsFor: 'cmake' stamp: 'tty 6/8/2014 18:49'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder  default  noBuildConfigurations
! !

!SqueakBSDConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/6/2014 18:17'!
buildDir
	^ buildDir ifNil: [ buildDir := ( self topDir / self buildDirName) assureExistence].! !

!SqueakBSDConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/12/2014 12:05'!
buildDirName
	buildType isNil
		ifTrue:[^self dirBuildPlatform, FileDirectory slash, self dirBuildLanguageVMMM, FileDirectory slash, 'build']
		ifFalse:[^self dirBuildPlatform, FileDirectory slash, self dirBuildLanguageVMMM, FileDirectory slash, buildType asString]! !

!SqueakBSDConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/16/2014 20:13'!
compilerFlags
	|d commonFlags flags|
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self compilerFlagsBuild];
		at: #buildAssert  put: [self compilerFlagsAssert];
		at: #buildAssertITimerHeartbeat  put: [self compilerFlagsAssertITimerHeartbeat];
            at:#buildDebug  put: [self compilerFlagsDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self compilerFlagsDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self compilerFlagsIHeartbeatTimer];
		at: #buildMultiThreaded  put: [self compilerFlagsMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self compilerFlagsMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self compilerFlagsMultiThreadedDebug ];
		at: #buildNone put:[self compilerFlagsNoBuildType].

    flags:= String streamContents: [ :stream |
	 (((d at:  buildType) value)  collect: #withBlanksTrimmed as: Set)
		asStringOn: stream 
		delimiter:' '].

    commonFlags:=String streamContents: [ :stream |
		((self commonCompilerFlags) collect: #withBlanksTrimmed as: Set)
			asStringOn: stream 
			delimiter: ' ' ].
	^ commonFlags, ' ' ,flags.! !

!SqueakBSDConfig methodsFor: 'cmake configuration' stamp: 'tty 6/16/2014 20:54'!
configureBuild
	"configure this Configuration for a buildType #build"
	self 
		preferredIncludesBuild;
		standardIncludesBuild;
		compilerFlagsBuild;
		internalPluginsBuild;
		externalPluginsBuild;
		thirdpartyLibsBuild
		


		
		
		! !

!SqueakBSDConfig methodsFor: 'cmake configuration' stamp: 'tty 6/16/2014 20:13'!
configureForBuildType: aSymbol
	| d |
	"provide a concrete builder with the buildType and configureBuildX method to invoke"
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	self configureNoBuildType.                "reset all internal flags"
	d 
		at: #build 
		put: [self buildType:#build.  self configureBuild];

		at: #buildAssert 
		put: [self buildType: #buildAssert.  	self configureBuildAssert];

		at: #buildAssertITimerHeartbeat 
		put:     [ self buildType: #buildAssertITimerHeartbeat.   self configureBuildAssertITimerHeartbeat];

            at:#buildDebug 
		put: [self buildType: #buildDebug.  self configureBuildDebug];

		at: #buildDebugITimerHeartbeat 
		put:  [self buildType: #buildDebugITimerHeartbeat.   self configureBuildDebugITimerHeartbeat];

		at: #buildITimerHeartbeat 
		put: [self buildType:#buildITimerHeartbeat.    self configureBuildIHeartbeatTimer];

		at: #buildMultiThreaded 
		put:  [self buildType:#buildMultiThreaded . self configureBuildMultiThreaded];

		at: #buildMultiThreadedAssert 
		put: [self buildType: #buildMultiThreadedAssert. self configureBuildMultiThreadedAssert];

		at: #buildMultiThreadedDebug  
		put: [self buildType: #buildMultiThreadedDebug. self configureBuildMultiThreadedDebug].

     ^(d at: aSymbol).! !

!SqueakBSDConfig methodsFor: 'cmake' stamp: 'tty 6/12/2014 17:10'!
configureNoBuildType
		generateBuild:=generateBuildAssert:=generateBuildAssertITimerHeartbeat:=generateBuildDebug:=generateBuildDebugITimerHeartbeat:= generateBuildDebugMultiThreaded:= generateBuildIHeartbeatTimer:= generateBuildMultiThreaded:= generateBuildMultiThreadedAssert:= generateBuildMultiThreadedDebug:=false.! !

!SqueakBSDConfig methodsFor: 'plugins' stamp: 'tty 6/12/2014 13:43'!
defaultExternalPlugins
" tty 2014.06.10  cut-n-paste from Cog/build.linux32x86/newspeak.cog.spur/build/plugins.ext"
	^ #(B3DAcceleratorPlugin 
		BochsIA32Plugin 
	      ThreadedFFIPlugin    "moduleName->SqueakFFIPrims "
		"FFIPlugin"                   "moduleName->SqueakFFIPrims "
		SqueakSSLPlugin       "moduleName->SqueakSSL" 
		LocalePlugin 
		UnixOSProcessPlugin 
		UUIDPlugin)


"N.B. Regarding ThreadedFFIPlugin and FFIPlugin from eem:

Use  ThreadedFFIPlugin.  The FFIPlugin is obsolete (it requires assembler support files, and is non-reentrant).  This should generate in src/plugins/SqueakFFIPrims/{SqueakFFIPrims.c,ARM32FFIPlugin.c,IA32FFIPlugin.c} and you should compile only src/plugins/SqueakFFIPrims/SqueakFFIPrims.c.  src/plugins/SqueakFFIPrims/SqueakFFIPrims.c is a simple wrapper that includes ARM32FFIPlugin.c or IA32FFIPlugin.c as appropriate (and others can be added as they are developed).


"! !

!SqueakBSDConfig methodsFor: 'plugins' stamp: 'tty 6/12/2014 13:43'!
defaultInternalPlugins
" N.B. THESE MAY BE WILDLY INAPPROPRIATE FOR BSD. cut-n-pasted from Linux32x86Config.
   N.B. moduleName->XYZ means XYZ appears in the GNU-Build's plugins.int/ext. However, Smalltalk requires the class name.
                                 XYZSmalltalkClass  moduleName->XYZ as it appears in plugins.int/ext
"
	^ #(
	    ADPCMCodecPlugin
    AsynchFilePlugin
    BalloonEnginePlugin "moduleName -->B2DPlugin"
    BitBltSimulation        "moduleName->BitBltPlugin"
    BMPReadWriterPlugin
    CroquetPlugin
    DeflatePlugin               "moduleName->ZipPlugin"
    DropPlugin
    DSAPlugin                    "moduleName->DSAPrims"
    FFTPlugin
    FileCopyPlugin
    FilePlugin
    FloatArrayPlugin
    FloatMathPlugin
    IA32ABIPlugin             "moduleName->IA32ABI"
    InflatePlugin               "moduleName->ZipPlugin"
    JoystickTabletPlugin
    JPEGReaderPlugin
    JPEGReadWriter2Plugin
    KlattSynthesizerPlugin  "moduleName->Klatt"
    LargeIntegersPlugin      "moduleName->LargeIntegers"
    Matrix2x3Plugin
    MIDIPlugin
    MiscPrimitivePlugin
    Mpeg3Plugin
    RePlugin
    SecurityPlugin
    SerialPlugin
    SocketPlugin
    SoundCodecPlugin        "moduleName->SoundCodecPrims"
    SoundGenerationPlugin
    SoundPlugin
    StarSqueakPlugin
    SurfacePlugin
    VMProfileLinuxSupportPlugin)! !

!SqueakBSDConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:30'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	self required! !

!SqueakBSDConfig methodsFor: 'cmake' stamp: 'tty 6/7/2014 16:35'!
dirBuildPlatform
	"the directory for the platform. example: build.linux32x86"
	^self dirBSD32x86! !

!SqueakBSDConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/6/2014 18:18'!
dirFrom: aStringOrDir
	^ aStringOrDir isString
		ifTrue: [ FileDirectory forFileName: aStringOrDir  ]
		ifFalse: [ aStringOrDir ]! !

!SqueakBSDConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:46'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakBSDConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/6/2014 18:18'!
executableName
	^ 'cogvm'! !

!SqueakBSDConfig methodsFor: 'headers generation' stamp: 'tty 6/16/2014 18:00'!
generateConfigH
	"	
	used to be: 	
		self write: self configH toFile: 'config.h'
      but with variable buildTypes we need:
"
	self write: (self generateConfigH: buildType) toFile: 'config.h'   
! !

!SqueakBSDConfig methodsFor: 'headers generation' stamp: 'tty 6/16/2014 20:13'!
generateConfigH: aBuildType
	"self write: self configH toFile: 'config.h'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self configHBuild];
		at: #buildAssert  put: [self configHBuildAssert];
		at: #buildAssertITimerHeartbeat  put: [self configHBuildAssertITimerHeartbeat];
            at:#buildDebug  put: [self configHBuildDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self configHBuildDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self configHBuildITimerHeartbeat];
		at: #buildMultiThreaded  put: [self configHBuildMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self configHBuildMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self configHBuildMultiThreadedDebug ];
		at: #buildNone put:[self configHNoBuildType].


	 ^(d at: ( aBuildType)) value



! !

!SqueakBSDConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/14/2014 15:42'!
outputDir

	"the directory where built binaries will be stored"
	^ outputDir ifNil: [ outputDir := (self topDir / self dirOutput/ self dirInstall) ]	

! !

!SqueakBSDConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/6/2014 18:18'!
prepareVMMaker
	
	| maker allPlugins |
	
	"In CogVMs (in contrast to Interpreter VM) the generated sources are platform independent, therefore Cross is ok"
	maker := VMMaker forPlatform: 'Cross'.
	
	maker sourceDirectoryName: self srcDir pathName.
	maker platformRootDirectoryName: self platformsDir.
	
	
	allPlugins := self internalPlugins , self externalPlugins.
	
	"touch plugins to force their source generation unconditionally"
	allPlugins do: [:name | (Smalltalk globals at: name) touch ].
	
	" Why we put all plugins as external?   Because the generated sources are not different whether the plugins were defined as internal or external. VMMaker used to need this to to generate plugins.int and plugins.ext files. But since this is achieved in another way with CMakeVMMaker, there is no different at all to put all plugins as internal or as external."
	maker externalModules addAll:  allPlugins.
	
	^ maker! !

!SqueakBSDConfig methodsFor: 'utils' stamp: 'tty 6/16/2014 20:13'!
setGlobalOptionsAfterDetermineSystem: aMaker buildType: aBuildType
	"invoke correct setGlobalOptions for this buildType to allow per-buildType customization'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self setGlobalOptionsAfterDetermineSystemBuild: aMaker];
		at: #buildAssert  put: [self setGlobalOptionsAfterDetermineSystemBuildAssert: aMaker];
		at: #buildAssertITimerHeartbeat  put: [self setGlobalOptionsAfterDetermineSystemBuildAssertITimerHeartbeat: aMaker];
            at:#buildDebug  put: [self setGlobalOptionsAfterDetermineSystemBuildDebug: aMaker];   
		at: #buildITimerHeartbeat  put: [self setGlobalOptionsAfterDetermineSystemBuildITimerHeartbeat: aMaker];
		at: #buildMultiThreaded  put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreaded: aMaker ];
		at: #buildMultiThreadedAssert  put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreadedAssert: aMaker];
		at: #buildMultiThreadedDebug   put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreadedDebug: aMaker ];
		at: #buildNone put:[self setGlobalOptionsBuildNone: aMaker].

	 ^(d at: ( aBuildType)) value
! !

!SqueakBSDConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/6/2014 18:18'!
setupDirectories: gen
	| dirsInclude |

	" write the directories in separate include file"
	dirsInclude := gen captureOutputDuring: [
		gen
			set: #topDir toString: (self topDir fullName); 
			set: #buildDir toString: (self buildDir ifNil: ['${topDir}/build'] ifNotNil: [self buildDir fullName] );
			set: #thirdpartyDir toString: '${buildDir}/thirdParty';
			set: #platformsDir toString: self platformsDir;
			set: #srcDir toString: self srcDir pathName;
			set: #srcPluginsDir toString: (pluginsDir ifNil: [ '${srcDir}/plugins' ]);
			set: #srcVMDir toString: '${srcDir}/vm';
			set: #platformName toString: self platformName;
			set: #targetPlatform to: '${platformsDir}/${platformName}';
			set: #crossDir toString: '${platformsDir}/Cross';
			set: #platformVMDir toString: '${targetPlatform}/vm';
			set: #outputDir toString: self outputDir fullName.
	].

	self write: dirsInclude toFile: 'directories.cmake'.
	
	gen include: 'directories.cmake'.
! !

!SqueakBSDConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/6/2014 18:19'!
srcDir
		^ srcDir ifNil: [ srcDir := (self topDir directoryNamed: 'src' )]! !

!SqueakBSDConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/7/2014 16:58'!
topDir
		^ topDir ifNil: [ topDir := FileDirectory default directoryNamed: self oscogvm ]! !

!SqueakBSDConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/6/2014 18:19'!
validateSourcesPresent
	| sources |
	sources := Smalltalk sourcesName.
	
	(sources == nil)
		ifTrue: [	self error: 'VM source code cannot be generated without .sources file'.]		! !

!SqueakBSDConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/6/2014 18:19'!
write: aContents toFile: aFileName
	"write a file to current output directory (buildDir).
	use line end convention appropriate for config platform"

	| bldDir |
	bldDir := self buildDir.
	bldDir isString
		ifTrue: [ bldDir := FileDirectory directoryEntryFor: bldDir ].
	bldDir assureExistence.
	bldDir
		forceNewFileNamed: aFileName
		do: [:s | s
				nextPutAll: (self fixLineEndsOf: aContents)]

! !

SqueakBSDConfig subclass: #SqueakFreeBSDNewspeakCogSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-BSD32x86'!

!SqueakFreeBSDNewspeakCogSpurConfig commentStamp: 'tty 6/15/2014 14:12' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakBSDx86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp

!

!SqueakFreeBSDNewspeakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:12'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. default is squeak.cog.v3"
	^self newspeakCogSpur! !

!SqueakFreeBSDNewspeakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:46'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakFreeBSDNewspeakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:07'!
executableName
	^ self vmCogExecutableName! !

SqueakBSDConfig subclass: #SqueakFreeBSDNewspeakCogV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-BSD32x86'!

!SqueakFreeBSDNewspeakCogV3Config commentStamp: 'tty 6/15/2014 14:12' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakBSDx86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp

!

!SqueakFreeBSDNewspeakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:13'!
dirBuildLanguageVMMM
	^self newspeakCogV3! !

!SqueakFreeBSDNewspeakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:47'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakFreeBSDNewspeakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:07'!
executableName
	^ self vmCogExecutableName! !

SqueakBSDConfig subclass: #SqueakFreeBSDNewspeakSistaSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-BSD32x86'!

!SqueakFreeBSDNewspeakSistaSpurConfig commentStamp: 'tty 6/15/2014 14:12' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakBSDx86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp

!

!SqueakFreeBSDNewspeakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:13'!
dirBuildLanguageVMMM
	^self newspeakSistaSpur! !

!SqueakFreeBSDNewspeakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:47'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakFreeBSDNewspeakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:56'!
executableName
	^ self vmSistaExecutableName! !

SqueakBSDConfig subclass: #SqueakFreeBSDNewspeakSistaV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-BSD32x86'!

!SqueakFreeBSDNewspeakSistaV3Config commentStamp: 'tty 6/15/2014 14:12' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakBSDx86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp

!

!SqueakFreeBSDNewspeakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:13'!
dirBuildLanguageVMMM
	^self newspeakSistaV3! !

!SqueakFreeBSDNewspeakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:47'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakFreeBSDNewspeakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:56'!
executableName
	^ self vmSistaExecutableName! !

SqueakBSDConfig subclass: #SqueakFreeBSDNewspeakStackSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-BSD32x86'!

!SqueakFreeBSDNewspeakStackSpurConfig commentStamp: 'tty 6/15/2014 14:12' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakBSDx86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp

!

!SqueakFreeBSDNewspeakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:13'!
dirBuildLanguageVMMM
	^self newspeakStackSpur! !

!SqueakFreeBSDNewspeakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:47'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakFreeBSDNewspeakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:06'!
executableName
	^ self vmStackExecutableName! !

SqueakBSDConfig subclass: #SqueakFreeBSDNewspeakStackV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-BSD32x86'!

!SqueakFreeBSDNewspeakStackV3Config commentStamp: 'tty 6/15/2014 14:12' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakBSDx86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp

!

!SqueakFreeBSDNewspeakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:13'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackV3! !

!SqueakFreeBSDNewspeakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:47'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakFreeBSDNewspeakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:06'!
executableName
	^ self vmStackExecutableName! !

SqueakBSDConfig subclass: #SqueakFreeBSDSqueakCogSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-BSD32x86'!

!SqueakFreeBSDSqueakCogSpurConfig commentStamp: 'tty 6/15/2014 14:12' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakBSDx86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp

!

!SqueakFreeBSDSqueakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:13'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakCogSpur! !

!SqueakFreeBSDSqueakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:47'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakFreeBSDSqueakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:07'!
executableName
	^ self vmCogExecutableName! !

SqueakBSDConfig subclass: #SqueakFreeBSDSqueakCogV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-BSD32x86'!

!SqueakFreeBSDSqueakCogV3Config commentStamp: 'tty 6/15/2014 14:12' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakBSDx86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp

!

!SqueakFreeBSDSqueakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:13'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakCogV3! !

!SqueakFreeBSDSqueakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:47'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakFreeBSDSqueakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:07'!
executableName
	^ self vmCogExecutableName! !

SqueakBSDConfig subclass: #SqueakFreeBSDSqueakSistaSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-BSD32x86'!

!SqueakFreeBSDSqueakSistaSpurConfig commentStamp: 'tty 6/15/2014 14:12' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakBSDx86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp

!

!SqueakFreeBSDSqueakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:13'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakSistaSpur! !

!SqueakFreeBSDSqueakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:47'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakFreeBSDSqueakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:56'!
executableName
	^ self vmSistaExecutableName! !

SqueakBSDConfig subclass: #SqueakFreeBSDSqueakSistaV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-BSD32x86'!

!SqueakFreeBSDSqueakSistaV3Config commentStamp: 'tty 6/15/2014 14:12' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakBSDx86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp

!

!SqueakFreeBSDSqueakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:14'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakSistaV3! !

!SqueakFreeBSDSqueakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:47'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakFreeBSDSqueakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:56'!
executableName
	^ self vmSistaExecutableName! !

SqueakBSDConfig subclass: #SqueakFreeBSDSqueakStackSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-BSD32x86'!

!SqueakFreeBSDSqueakStackSpurConfig commentStamp: 'tty 6/15/2014 14:12' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakBSDx86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp

!

!SqueakFreeBSDSqueakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:14'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackSpur! !

!SqueakFreeBSDSqueakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:47'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakFreeBSDSqueakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:06'!
executableName
	^ self vmStackExecutableName! !

SqueakBSDConfig subclass: #SqueakFreeBSDSqueakStackV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-BSD32x86'!

!SqueakFreeBSDSqueakStackV3Config commentStamp: 'tty 6/15/2014 14:12' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakBSDx86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp

!

!SqueakFreeBSDSqueakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:14'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackV3! !

!SqueakFreeBSDSqueakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:47'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakFreeBSDSqueakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:06'!
executableName
	^ self vmStackExecutableName! !

CustomHelp subclass: #CMakeVMMakerSqueakHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Help'!

!CMakeVMMakerSqueakHelp commentStamp: 'tty 6/12/2014 20:13' prior: 0!
A CMakeVMMakerSqueakHelp provides an overview and use help on CMakeVMMakerSqueak!

CMakeVMMakerSqueakHelp subclass: #CMakeVMMakerSqueakDeveloperHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Help'!

!CMakeVMMakerSqueakDeveloperHelp class methodsFor: 'pages' stamp: 'tty 6/13/2014 08:36'!
availableBuilds
	^HelpTopic
		title:'configuring available build types'
		contents:
'The purpose of this method is to present the end user with the avaiable buildTypes for a configuration category. when they invoke a Builder like so:

	SqueakLinux32X86Builder availableBuildTypesFor: #Linux32x86SqueakStackV3Config

Since builds are sometimes not available and/or under development  a developer may wish to restrict what build types are avaiable for a configurations Builder by modifying the configuration''s "availableBuilds" method.

The default is all buildTypes: 
	^SqueakCMakeVMMakerAbstractBuilder  default  allBuildConfigurations

You can display no buildTypes with:
	^SqueakCMakeVMMakerAbstractBuilder  default  noBuildConfigurations.

or you can customize it like so:
	^(SqueakCMakeVMMakerAbstractBuilder  default  allBuildConfigurations 
			copyWithoutAll: #( #assertWithHeartbeatTimer #debugWithHeartbeatTimer debugMultiThreadedFFI.....etc))  


'! !

!CMakeVMMakerSqueakDeveloperHelp class methodsFor: 'accessing' stamp: 'tty 6/16/2014 12:28'!
bookName 
	^'Developer Guide'! !

!CMakeVMMakerSqueakDeveloperHelp class methodsFor: 'pages' stamp: 'tty 6/13/2014 17:06'!
cMakeMacros
	^HelpTopic
		title:'configuring cmake macros'
		contents:
'
SystemNavigation default browseMethodsWhoseNamesContain: ''cMakeMacros''
'! !

!CMakeVMMakerSqueakDeveloperHelp class methodsFor: 'pages' stamp: 'tty 6/15/2014 18:21'!
configH
	^HelpTopic
		title:'configuring configH'
		contents:
'
Use AConcreteBuilder>>configH to tell your plugins where to find its libraries etc.

The version of this is platform dependent.

You may also need to edit your oscogvm/platforms/YOUR PLATFORM/plugins/ThePLuginDirectory/acinclude.m4 file so that it conforms to your system.

 

based on my work getting the oscogvm/platforms/unix/plugins/UUIDPlugin/sqUnixUUID.c... to compile.
Working from the C source up to configuration then to Squeak....we start with the source code for sqUnixUUID.c

#include "config.h"

#if defined(HAVE_SYS_UUID_H)
# include <sys/types.h>
# include <sys/uuid.h>
#elif defined(HAVE_UUID_UUID_H)
# include <uuid/uuid.h>
#elif defined(HAVE_UUID_H)
# include <uuid.h>
#else
# error cannot find a uuid.h to include
#endif

On my platform, I needed that HAVE_UUID_H define set. 
To do that, I modified the acinclude.m4 file to check for the <uuid.h> (my changes in Bold--I emailed you this previously)


AC_MSG_CHECKING([for UUID support uuid/uuid.h] and uuid_generate)
AC_TRY_COMPILE([#include <uuid/uuid.h>],[uuid_generate;],[
 AC_MSG_RESULT(yes)
 AC_CHECK_LIB(uuid, uuid_generate, LIB_UUID="-luuid")],[
 AC_MSG_RESULT(no)
AC_MSG_CHECKING([for UUID support uuid and uuidgen] )
 AC_TRY_COMPILE([#include <uuid.h>],[uuidgen;],[
 AC_MSG_RESULT(yes)
 AC_CHECK_LIB(uuid, uuidgen, LIB_UUID="-luuid" )],[
 AC_MSG_RESULT(no)
AC_PLUGIN_DISABLE
 ])
])

AC_SUBST(LIB_UUID)

 


For the source code to see it, the config.h file needs to be in place with that HAVE_UUID_H  flag*, so in Squeak, I over-ride the configH method to include that define flag:


configH


#define HAVE_UUID_H 1 
#define HAVE_UUIDGEN 1

#ifndef __sq_config_h

The CMakeVMMakerSqueak ''generate'' message to a builder dumps that config.h to the build directory.
running the build.sh generated script invokes
cmake .

 command which looks in the specified source/config directory to configure the GNU-Makefile to look for that source code and pairs it with the generated config.h

The CMake generate GNU-Make system then uses those source/build artifacts to put the output in the oscogvm/products directory.


So, let me summarize.

1. We know that the plugins depend on config.h
2. Ideally, that config.h should be incrementally build by the Squeak plugins themselves or the CMakeVMMaker configurations. How? I don''t know yet. Looking at it, the UUIDPlugin class would have to contribute its configuration information.
    this is non-trivial.
3. So, in the meantime, CMakeVMMakerSqueak configurations are classes that encapsulate a <drum roll please> Configuration.
4. It seems reasonable to make this part of the configuration setup process.
5. I will/have documented in in the HelpBrowser HelpTopic for the system.

My apologies for the long-winded explanation. 


'! !

!CMakeVMMakerSqueakDeveloperHelp class methodsFor: 'pages' stamp: 'tty 6/13/2014 11:33'!
excludeFromBuild
	^HelpTopic
		title:'Excluding a Configuration From Builds'
		contents:
' The "excludeFromBuild" method in a concrete configuration can be manually toggled to exclude or include a configuration from being built by a builder.

	excludeFromBuild
		"over-ride to exclude yourself from a build"
		^false


  Be careful witht he logic. True excludes the configuration. False includes the configuration
'! !

!CMakeVMMakerSqueakDeveloperHelp class methodsFor: 'pages' stamp: 'tty 6/13/2014 13:03'!
executableName
	^HelpTopic
		title:'set executable name'
		contents:
'
In your concrete configuration, set the exectuable name in method "executableName"

SystemNavigation default browseMethodsWhoseNamesContain: ''executableName''


'! !

!CMakeVMMakerSqueakDeveloperHelp class methodsFor: 'pages' stamp: 'tty 6/13/2014 13:02'!
extraPluginSettings
	^HelpTopic
		title:'set extra plugin settings'
		contents:
'In your concrete configuration configure "extraPluginSettings"

SystemNavigation default browseMethodsWhoseNamesContain: ''extraPluginSettings''


look at the differences in the concrete implementations, especially by platform type.	

'! !

!CMakeVMMakerSqueakDeveloperHelp class methodsFor: 'pages' stamp: 'tty 6/12/2014 20:58'!
igorStasenkoDesign
	^HelpTopic
		title:'Igor Stasenko''s CMakeVMMaker Design for pharo'
		contents:
'CMakeVMMakerSqueak extends Igor Stasenko''s pharo work in CMMakeVMMaker. 

For this reason, a discussion of the Pharo design is apropos as it will support later discussion about CMakeVMMakerSqueak

TODO: finish me


'! !

!CMakeVMMakerSqueakDeveloperHelp class methodsFor: 'pages' stamp: 'tty 6/15/2014 12:32'!
organizationOfBuildersConfigs
	^HelpTopic
		title:'Organization Of Builder and Configuration Classes'
		contents:
'
The CMakeVMMakerSqueak Builders and Configurations are organized to mirror  Eliot''s GNU build system organization.

The intent is to reduce brain cycles translating from the computer''s directory layout to what you see in CMakeVMMakerSqueak by providing a (nearly) one-to-one correspondence.

Eliot has named build directories in Cog/ svn (oscogvm directory in this system) by the convention
build.[OperatingSystem].[VMWordSize].[Processor Architecture]. For  example: build.macosx32x86 

Under each build.[OperatingSystem].[VMWordSize].[Processor Architecture]  directory are subdirectories for each
[Language][VM][MemoryManager]. example newspeak.sista.spur.

The permutations of [Language][VM][MemoryManager] currently are: 

[newspeak | squeak]. [cog | sista | stack]. [spur | v3] or 2!! x 3!! x 2!!  which is  between 12 and eleventy billion permutations 

Similarly, in CMakeVMMakerSqueak,  Categories containing Configurations are organized by CMakeVMMakerSqueak-[OperatingSystem][VMWordSize][Processor][etc]

Configuration classes within a CMakeVMMakerSqueak-[OperatingSystem][VMWordSize][Processor][etc] are Named:
[[Squeak] | [] ][Language][VM][MemoryManager][etc]Config and correspond with the 12 permutations

When CMakeVMMakerSqueak generates build or products , it prefaces Eliot''s naming convention with a ''cmake.''

for example builds take place in:  cmake.build.linux.32.x66/squeak.cog.spur
and output is placed in cmake.products. for example: oscogvm/cmake.products/squeak.cog.v3.noGL/

Builders manage Configurations and Builds for a particular [Language][VM][MemoryManager]  category.
THERE IS A ONE-TO-ONE CORRESPONEDENCE between aConcreteBuilder>configurationsCategory and the Smalltalk Category name. 
If you change one, you must change the other in order for the Builder to manage that configuration.

example: SqueakMacOSBuilder configurationsCategory



Semi-Kludgey--yes, but an acceptable kludge in my estimation.

'! !

!CMakeVMMakerSqueakDeveloperHelp class methodsFor: 'pages' stamp: 'tty 6/12/2014 20:54'!
overview
	^HelpTopic
		title:'CMakeVMMaker in a couple of sentences.'
		contents:
'The heart of the package is CMakeGenerator and its two subclasses CMakeVMGenerator and CMakePluginGenerator.

CMakeGenerator collects information from CPlatformConf, CMThirdpartyLibrary and InterpreterPlugins and writes it out to CMake files and associated directories. 

From there, the user invokes cmake and make using a generated build.sh script.

The programmer directs the flow of the generator by coding a subclass of CPlatformConf, setting it up correctly and asking it to generate itself. 

The configuration then invokes the CMakeVMGenerator passing itself as an argument. 

The VMGeneratator extracts the information and utilizes VMPluginGenerator to generate plugin stuff, the CPlatformConf to generate other stuff and CMThirdPartyLibrary''s to generate other stuff. 

The end result is a CMake evironment that is set up to correctly build a VM
'! !

!CMakeVMMakerSqueakDeveloperHelp class methodsFor: 'pages' stamp: 'tty 6/15/2014 18:19'!
pages
	^#(overview prerequisites igorStasenkoDesign plugins organizationOfBuildersConfigs availableBuilds excludeFromBuild executableName extraPluginSettings preferredIncludes setExtraTargetProperties cMakeMacros configH scratch)! !

!CMakeVMMakerSqueakDeveloperHelp class methodsFor: 'pages' stamp: 'tty 6/12/2014 21:08'!
plugins
	^HelpTopic
		title:'setting up defaultInternalPlugins and defaultExternalPlugins'
		contents:
'
bad mojo with plugins.int plugins.ext in GNU and plugin names in CMakeVMMaker(Squeak)

|s|
Transcript clear.
s:=SortedCollection new.
InterpreterPlugin allSubclassesDo:[:p|
	p moduleName = ''SqueakSSL''                    "<-------Text from plugins.int or plugins.ext"
		ifTrue:[Transcript show:p name;cr].
	s add: (p moduleName)].


'

! !

!CMakeVMMakerSqueakDeveloperHelp class methodsFor: 'pages' stamp: 'tty 6/13/2014 13:04'!
preferredIncludes
	^HelpTopic
		title:'configuring preferred includes'
		contents:
'
SystemNavigation default browseMethodsWhoseNamesContain: ''preferredIncludes'' 
'! !

!CMakeVMMakerSqueakDeveloperHelp class methodsFor: 'pages' stamp: 'tty 6/12/2014 20:55'!
prerequisites
	^HelpTopic
		title:'Pre-requisits'
		contents:
'TODO: write me


'! !

!CMakeVMMakerSqueakDeveloperHelp class methodsFor: 'pages' stamp: 'tty 6/16/2014 14:36'!
protocols
	^HelpTopic
		title:'An Explanation of Protocols in TCPaltformConfigForSqueak'
		contents:
'TCPlatformConfigForSqueak browse

The purpose of the Trait is to force Abstract Base Class like behavior for pharo''s CMakeVMMaker CPlatformConfig base class. 

Since I do not have access to modify the base class, I used the Trait TCPlatformConfigForSqueak to squeeze in that behavior ''from the side'' if you will.

The following protocols conform to those in the CPlatformConfig:

accessing
compiler flags
headers generation
plugin extra rules
settings
source files
source generation
utils


For methods in the CMakeVMaker CPlatformConfig that where not portable to Squeak, I overrode those.
They reside in the protocol:

squeak compatability


The pharo CMakeVMMaker does not have the functionality to support the naming conventions and buildTypes that CMakeVMMakerSqueak requires. To that end, extra ''cmake-ish'' behavior is placed that is unique to CMakeVMMakerSqueak is placed in the following protocols:

cmake configuration
cmake config buid type
cmake directory
cmake executable names




'! !

!CMakeVMMakerSqueakDeveloperHelp class methodsFor: 'pages' stamp: 'tty 6/12/2014 21:26'!
scratch
	^HelpTopic
		title:'Program Flow'
		contents:
'
Create a new configuration
add external/internal plugins
generateSources
	verifies Sources file in place
	prepares CogRTLOpcodes/CogIA32Compiler/StackInterpreter depending on configuration used
	initializes/prepares VMMaker
	asks VMMaker to generateEntire while intercepting notifications and deprecation warnings.

generate 
	a Configuration passes itself to a CMakeVMGeneratorForSqueak
	an output  writeStream is opened
	ask the config to set global options on the Generator. Stuff like (maker set: ''CMAKE_C_COMPILER'' to: ''/usr/bin/gcc'')
	"We are setting up a file here"
	print the header
	set project name
	set system specific global options after system is known (all existing implementations are XCode CMAKE_OSX_SYSROOT etc)
        set up  directories.cmake  content with all the topDir,srcDir etc in the Generator
	9. is troubling. set''s CMAKECONFIGURATIONTYPES to Release
	set up preferedIncludes. This one is important as it is config specific
	set up standardIncludes. This one is important as it is config specific
	add CompilerFlag Definitions. This is where customization among release, debug, assert flags are set.
	extraVMSettings             . more custom stuff for the VM. The generateConfigH issue resides here
        put this string  ''add_executable(Squeak  ${coreSources} ${crossVMSources} ${platformVMSources} ${extraSources})''
	generate and store internally  the internal/external plugin CMakePluginGeneratorForSqueak . Each of these has its own Stream etc.for CMake
        processThirdPartyLibraries This loops through the CMakeVMMaker-Libs that are associated with this config. these libs generate their own spiel
	                           libraries can be downloaded here?
	processPlugins   pretty complicated as well.
	setExtraTargetProperties   <---this is important. It is used by "most" configs and sets compile flags, etc. This will be messed up for cut-n-paste I did .
	self cmd: ''target_link_libraries'' params: self moduleName , '' ${LINKLIBS}''.  just puts in doc
        postBuildActions  <--used by Mac configs need to clean this up.
	saveFile  "Writes CMakeLists.txt"
	generateBuildScript "this is config specific"
	

----------------------------------------------------------------------------------
SqeuakCogMTBuilder buildUnix32
		self new buildUnix32
>>>		     SqueakCogMTUnixConfig new.   (CPlatformConfig initialize
		     			   	  		   super initialize
								   generateForRelease = true.
				addExternalPlugins#();
				addInternalPlugins#();
1.				generateSources;
2. 				generate.







1 SqueakCogMTUnixConfig generateSources
 CPlatformConfig generateSources
	"Generate whole VM + plugins sources"
	| maker |

	self validateSourcesPresent.  
	self prepareForGeneration.
	
	"suppress questions and deprecation warnings during generation "
	[[
		
		maker := self prepareVMMaker.
	
		maker interpreterClass: self interpreterClass.
		self cogitClass ifNotNil: [:cg | 
			maker cogitClass: cg.
			cg initializeWithOptions: (maker instVarNamed: ''optionsDictionary'')
		].
		
		maker generateEntire

	] on: ProvideAnswerNotification do: [:ex | ex resume: true ]]
	on: Deprecation do: [:ex | ex resume ].
	
	

2. generate 
	self generatePluginsList. writes PLUGINS.txt file from pluginsTemplate
	self generateLicense.     writes LICENSE.txt file from licenseTemplate
3.->	^CMakeVMGeneratorForSqueak generate:self    pass myself (a config) to a VMGenerator

CMakeVMGenerator generate
3. generate
	| intPlugins extPlugins |
			
	output := String new writeStream.
	
4.	config setGlobalOptions: self.
	
	self 
5		printHeader;
6		project: config executableName.

7.	config setGlobalOptionsAfterDetermineSystem: self.

8.	config setupDirectories: self.
	
9.	self message: ''${CMAKE_MODULE_PATH}''.
	self set: ''CMAKE_CONFIGURATION_TYPES'' to: ''Release''.

10.	config preferredIncludes 
		do: [ :each | self includeDirectories: each ].
	self includeDirectories: self includeDirs.	
11	config standardIncludes 
		do: [:each | self includeDirectories: each ].

12	self addDefinitions: config compilerFlags.

13.	config extraVMSettings: self.
	
14	self puts: ''add_executable('' , config executableName, '' '', config executableType, '' '' , self sources , '')''.
	
15	intPlugins := self generatePluginConfigs: config internalPlugins internal: true.  <---this area is complicated, but it generates Plugin files
	extPlugins := self generatePluginConfigs: config externalPlugins internal: false.

16	self processThirdpartyLibraries.
	
17	self processPlugins:  intPlugins, extPlugins.

18.	config setExtraTargetProperties: self.    <---this is very important
	
	self cmd: ''target_link_libraries''
		params: self moduleName , '' ${LINKLIBS}''.

19.	config postBuildActions: self.
	
20	self saveFile.
	self generateBuildScript. build.sh




4. setGlobalOptions: maker

	"set any CMake global options, before declaring a project in cmake file"
	
	maker set: ''CMAKE_C_COMPILER'' to: ''/usr/bin/gcc''.
	maker set: ''CMAKE_CXX_COMPILER'' to: ''/usr/bin/g++''.

5. printHeader
	
	self puts: ''# This is automatically generated file using '', self configurationName, '' on '',
		Date current asString, '' '' , Time current asString;
		puts: ''cmake_minimum_required(VERSION 2.6.2)''



6 project: aProjectName
	self cmd: ''project'' qparams: aProjectName{

	     cmd: cmdName qparams: aString
	     	"quoted params"
		output nextPutAll: cmdName;
		nextPutAll: ''("'';
		nextPutAll: aString;
		nextPutAll: ''")'';
		cr
        }

7.SqueakIPhoneSqueakStackV3Config setGlobalOptionsAfterDetermineSystem: maker   <---here is a representative example
	self setGlobalOptions: maker.	
	maker 
		set: ''CMAKE_OSX_SYSROOT'' 
		to: (''/Applications/Xcode.app/Contents/Developer/Platforms/{1}.platform/Developer/SDKs/{1}{2}.sdk''
			format: { self targetDevice. self sdkVersion })

8. config setupDirectories:self
   this creates directories.cmake with all the top/build/etc directories

9. this is troubling, sets CMAKE_CONFIGURATION_TYPES to ''Release''.



10. preferredIncludes
	^ #(
	''${buildDir}/''
	''${platformsDir}/iOS/vm/iPhone'' "config.h is here. Why???"
	)

	this gets put int CMakeGenerator{

	     includeDirectories: aString
	     	 ^self cmd: ''include_directories'' params: aString


11. standardIncludes <---this one is important


12. addDefinitions:config compilerFlags
    compilerFlags 
	| releaseFlags |
	
	releaseFlags := self isGenerateForRelease 
		ifTrue: [ self compilerFlagsRelease ]
		ifFalse: [ self compilerFlagsDebug ].
		
	^ String streamContents: [ :stream |
		((self commonCompilerFlags, releaseFlags)
			asStringOn: stream 
			delimiter: '' '' )]


13. extraVMSettings: maker    very customizable method. 
	| versionC |
	self generateConfigH.  <---the issue Eliot raised. 
	
	
	"output a fake version.c file"
	
	self write:
''int vm_serial= 1;
char *vm_date= "<HERE IS SUPPOSED TO BE THE DATE>";
char *cc_version= "<HERE IS SUPPOSED TO BE gcc VERSION>";
char *ux_version= "<FAKE FROZEN VERSION FOR DEBUGGING PURPOSES>";
''
	toFile: ''version.c''.


14.  ''add_executable(Squeak  ${coreSources} ${crossVMSources} ${platformVMSources} ${extraSources})''



15. generatePluginConfigs: plugins internal: bool
	"Answers a collection of CMakePluginGenerator instances"
	
	^ plugins collect: [:each | | plugin |
		plugin := Smalltalk at: each.
		plugin generateFor: self internal: bool.   <---InterpreterPlugin method added by CMakeVMMaker 
	].

	generateFor: aCMakeVMGenerator internal: aBoolean 
		^ aCMakeVMGenerator 
			generatePlugin: self 
			internal: aBoolean
			extraRules: nil
	
	so, for each plugin in the generator, invoke my generator method generatePlugin: internal:extraRules:
	    THIS invokes CMakePluginGeneratorForSqueak new
	     	    generate: aPlugin for: aCMakeVMGenerator internal: aBoolean extraRules: aBlock
		    	    doNotGenerate := false.
			    internal := aBoolean.
			    plugin := aPlugin.
			    vmGen := aCMakeVMGenerator.
			    extraRules := aBlock.
		            ^ self generate{

						| name |
						output := String new writeStream.

						name := plugin moduleName.
					#(	vmGen config setGlobalOptions: self.

						self 
							printHeader;
							project: name;
							"include directories generated for build"
							include: ''../directories.cmake''.

						self set: ''CMAKE_CONFIGURATION_TYPES'' to: ''Release''.
					).

						self message: (internal ifTrue: [ ''Adding internal plugin: ''] ifFalse: [''Adding external plugin: ''])  , name.

						self 
							set: #pluginName toString: name;
							set: #pluginSrc toString: ''${srcPluginsDir}/'', name;
							set: #pluginCross toString: ''${crossDir}/plugins/'', name;
							set: #pluginPlatform toString: ''${targetPlatform}/plugins/'', name.

						"clear LINKLIBS variable"
						self set: #LINKLIBS to: ''.		

						internal 
							ifTrue: [ self puts: ''add_definitions(-DSQUEAK_BUILTIN_PLUGIN)''].

						self addSources: { name , ''.c'' } prefixed: ''${pluginSrc}/''.

						" default include directories for plugin "
						self includeDirectories: ''${pluginSrc} ${pluginCross} ${targetPlatform}/plugins/${pluginName}''.

						"Not needed because there are already there (inherited from main configuration)"
						"self addDefinitions: vmGen config compilerFlags."

						" perform config''s configureXYZ: message to apply per-plugin custom rules, if any "

						vmGen config configurePlugin: plugin with: self.

						extraRules ifNotNil: [ extraRules value: self ].

						" generate a static lib for internal plugin, or shared for external"
						internal ifTrue: [
							self cmd: ''add_library'' params:  name , '' STATIC ${sources}''.
						] ifFalse: [
							self cmd: ''add_library'' params: name , '' SHARED ${sources}''.

						"	self cmd: ''set_property'' params: ''TARGET '' , name , ''PROPERTY LINK_FLAGS -bundle''"
						].

						vmGen config extraPluginSettings: self.

						self isExternal ifTrue: [
							self cmd: ''target_link_libraries''
								params: self moduleName , ''${LINKLIBS}''.
							].

						" see senders of #linkFlags "
						self 
							cmd: ''set_property'' 
							params: ''TARGET'', name, ''PROPERTY LINK_FLAGS "${linkFlags}''.

						"set dependencies"
						self puts: ''IF ('',self moduleName , ''_dependencies)''.

						self cmd: ''add_dependencies''
							params: name , ''${'', self moduleName , ''_dependencies}''.

						self puts: ''ENDIF ('',self moduleName , ''_dependencies)''.
						self saveFile.


}
		 	    





16. processThirdpartyLibraries

	config thirdpartyLibs do: [:each |
		each generateFor: self ]{
			      generateFor: aVMGenerator

				      | libDir stream contents |

				      vmGen := aVMGenerator.

				      gen := CMakeGenerator new
					      output: (String new writeStream).

				      libDir := (aVMGenerator thirdpartyDir / self canonicalName) ensureDirectory.

				      stream := String new writeStream.

				      self generate.

				      stream nextPutAll: (vmGen config fixLineEndsOf: gen output contents).

				      contents := stream contents. 

				      (self isFile: (libDir asFileReference / gen outputFileName) fullName hasContents: contents) ifFalse: [
					      "contents changed, update the file. Because fucking cmake will force rebuild everything if we change its modification date
					      without changing its contents"
					      (FileStream forceNewFileNamed: (libDir asFileReference / gen outputFileName)) nextPutAll: contents; close.
					      ].


				      vmGen addSubdirectory:  vmGen thirdpartyDirName , ''/'' , self canonicalName.
				      self defineGlobalTargets.


			      }



17 processPlugins: pluginGenerators
	| libs libDeps |

	libs := OrderedCollection new.
	libDeps := Dictionary new.
	pluginGenerators do: [:gen |
		gen doNotGenerate ifFalse: [
			gen isInternal 
				ifTrue: [
					libs add: gen plugin moduleName ]
				ifFalse: [
					"make main module to depend on external plugin, just to make sure it is built 
					 before main module built"
					self 
						cmd: ''add_dependencies'' 
						params: config executableName, '' '' , gen plugin moduleName ].
				gen externalDependencies 
					ifNotEmpty: [ :deps |
						libDeps 
							at: gen plugin moduleName
							put: (deps fold: [ :a :b | a, '' '', b ]) ].
			self addSubdirectory: gen plugin moduleName ] ].

	self cmd: ''target_link_libraries'' params:  config executableName , '' '' ,
		(libs inject: '' into: [:res :ea | res, '' '' , ea ]).

	libDeps keysAndValuesDo: [ :moduleName :dependencies |
		self 
			cmd: ''add_dependencies'' 
			params: moduleName, '' '', dependencies ].  

	self generateExportsH: libs.


18 setExtraTargetProperties: maker

	"maker setTargetProperties: ''LINK_FLAGS ""''."
		
	maker puts: ''set_source_files_properties( ${srcVMDir}/cogit.c PROPERTIES 
		COMPILE_FLAGS "-O1 -fno-omit-frame-pointer -momit-leaf-frame-pointer")''.
		
		
	maker 
		cmd: ''set_source_files_properties''
		params: ''${targetPlatform}/vm/sqUnixHeartbeat.c PROPERTIES 
		COMPILE_FLAGS "-O1 -fno-omit-frame-pointer"''.
						
	maker linkDirectories: ''${CMAKE_FIND_ROOT_PATH}/usr/lib/arm-linux-gnueabihf/''.
	
	maker addExternalLibraries: 
		#(
			''m''  "math lib"
			''dl''  "dynamic loader"
			''pthread'' "posix threads" 
		).
		
	maker set: ''EXECUTABLE_OUTPUT_PATH'' toString: self outputDir fullName.
	self addVMDrivers: maker.


19. postBuildActions: gen

	" override to add custom rules after all targets is defined "
	
	self write: self fixLibsTemplate toFile: ''fix_libs.cmake''.
	
	
	gen
		set: #bundlePath toString: ''${outputDir}/'', self executableName, ''.app'';
		set: #pluginsRelPath toString: ''@executable_path/Plugins''.

	gen
		puts: ''
		INSTALL(CODE "
			set(externalModulesDir \"${externalModulesDir}\")
			set(bundlePath \"${bundlePath}\")
			set(pluginsRelPath \"${pluginsRelPath}\")
			
			include(fix_libs.cmake)
		")''
			
"					FILE(GLOB_RECURSE bLibs /${externalModulesDir}/*.*)
"




'! !

!CMakeVMMakerSqueakDeveloperHelp class methodsFor: 'pages' stamp: 'tty 6/13/2014 13:05'!
setExtraTargetProperties
	^HelpTopic
		title:'set extra target properties'
		contents:
'
SystemNavigation default browseMethodsWhoseNamesContain: ''setExtraTargetProperties'' 
'! !

!CMakeVMMakerSqueakDeveloperHelp class methodsFor: 'pages' stamp: 'tty 6/13/2014 09:18'!
settingCompilerFlags
	^HelpTopic
		title:'Setting Compiler Flags for a build'
		contents:
'Each buildType (SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo) may require custom compiler flags.

Trait TCPlatformConfigForSqueak compilerFlags method provides a method lookup that is invoked for a specific buildType.
These methods are named compilerFlagsXYZ corresponding to the buildTypes displayed above.

In the compilerFlagsXYZ method for your concrete configuration, you set the internal state of your configuration.

Note: there are two legacy internal states from CPlatformConfig in CMakeVMMaker for pharo "compilerFlagsDebug" and "compilerFlagsRelease" that are invoked
for backwards compatibility.

'! !

CMakeVMMakerSqueakHelp subclass: #CMakeVMMakerSqueakEndUserHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Help'!

!CMakeVMMakerSqueakEndUserHelp class methodsFor: 'as yet unclassified' stamp: 'tty 6/16/2014 12:28'!
bookName 
	^'End User Guide'! !

!CMakeVMMakerSqueakEndUserHelp class methodsFor: 'as yet unclassified' stamp: 'tty 6/15/2014 13:02'!
builders
	^HelpTopic
		title: 'Builders'
		contents:
'
CMakeVMakerSqueak Builders provide a facade to CMakeVMmakerSqueak Configurations.

A Builder is both a ''query'' tool and a ''build'' tool.

With a  Builder, you can 
	query its configurationsCategory''s Configurations
	invoke a Configuration to generate CMake files or 
	invoke a Configuration to generateSources which
			invokes VMMaker.oscog to generate source

Builders are concrete instances of the Abstract Base Class:SqueakCMakeVMMakerAbstractBuilder
View SqueakCMakeVMMakerAbstractBuilder''s class comments for an overview of this tool.

SqueakCMakeVMMakerAbstractBuilder  browseHierarchy.

Information on creating your own is available via HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp

'! !

!CMakeVMMakerSqueakEndUserHelp class methodsFor: 'as yet unclassified' stamp: 'tty 6/15/2014 12:51'!
pages
	^#(builders queryingBuilders scratch)! !

!CMakeVMMakerSqueakEndUserHelp class methodsFor: 'as yet unclassified' stamp: 'tty 6/15/2014 12:52'!
queryingBuilders
	^HelpTopic
		title: 'Querying Builders'
		contents:
'

Below are some queries avaiable via various Builders in the CMakeVMMakerSqueak package:
SqueakCMakeVMMakerAbstractBuilder  reset                                     "reset internal state of the Abstract Builder"
SqueakCMakeVMMakerAbstractBuilder showExcludeFromBuild:false    "buildable configurations"
SqueakCMakeVMMakerAbstractBuilder showExcludeFromBuild:true.    "edit that configs ''excludeFromBuild'' method to change"
SqueakCMakeVMMakerAbstractBuilder availableBuildTypes
SqueakCMakeVMMakerAbstractBuilder  reset                                     "reset internal state of the Abstract Builder"


SqueakAndroidBuilder configurationsCategory
SqueakAndroidBuilder  buildDirectory
SqueakAndroidBuilder  availableBuilds
SqueakAndroidBuilder  availableBuildTypesFor:(SqueakAndroidBuilder availableBuilds at:1)
SqueakAndroidBuilder  sourceDirectoryFor:(SqueakAndroidBuilder availableBuilds at:1)

SqueakBSDx86Builder configurationsCategory
SqueakBSDx86Builder buildDirectory
SqueakBSDx86Builder availableBuilds
SqueakBSDx86Builder availableBuildTypesFor:(SqueakBSDx86Builder availableBuilds at:1)
SqueakBSDx86Builder sourceDirectoryFor:(SqueakBSDx86Builder availableBuilds at:1)

SqueakIA32BochsBuilder configurationsCategory
SqueakIA32BochsBuilder buildDirectory
SqueakIA32BochsBuilder availableBuilds
SqueakIA32BochsBuilder availableBuildTypesFor:(SqueakIA32BochsBuilder availableBuilds at:1)
SqueakIA32BochsBuilder sourceDirectoryFor:(SqueakIA32BochsBuilder availableBuilds at:1)

SqueakIOSBuilder configurationsCategory
SqueakIOSBuilder buildDirectory
SqueakIOSBuilder availableBuilds
SqueakIOSBuilder availableBuildTypesFor:(SqueakIOSBuilder availableBuilds at:1)
SqueakIOSBuilder sourceDirectoryFor:(SqueakIOSBuilder availableBuilds at:1)

SqueakLinux32ARMv6Builder configurationsCategory
SqueakLinux32ARMv6Builder buildDirectory
SqueakLinux32ARMv6Builder availableBuilds
SqueakLinux32ARMv6Builder availableBuildTypesFor:(SqueakLinux32ARMv6Builder availableBuilds at:1)
SqueakLinux32ARMv6Builder sourceDirectoryFor:(SqueakLinux32ARMv6Builder availableBuilds at:1)


SqueakLinux32x86Builder configurationsCategory
SqueakLinux32x86Builder buildDirectory
SqueakLinux32x86Builder availableBuilds
SqueakLinux32x86Builder availableBuildTypesFor:(SqueakLinux32x86Builder availableBuilds at:1)
SqueakLinux32x86Builder sourceDirectoryFor:(SqueakLinux32x86Builder availableBuilds at:1)

SqueakLinux32x86_64Builder configurationsCategory
SqueakLinux32x86_64Builder SqueakLinux32x86_64Builder
SqueakLinux32x86_64Builder SqueakLinux32x86_64Builder
SqueakLinux32x86_64Builder availableBuildTypesFor:(SqueakLinux32x86_64Builder availableBuilds at:1)
SqueakLinux32x86_64Builder sourceDirectoryFor:(SqueakLinux32x86_64Builder availableBuilds at:1)

SqueakLinux64x86w32CompatBuilder configurationsCategory
SqueakLinux64x86w32CompatBuilder buildDirectory
SqueakLinux64x86w32CompatBuilder availableBuilds
SqueakLinux64x86w32CompatBuilder availableBuildTypesFor:(SqueakLinux64x86w32CompatBuilder availableBuilds at:1)
SqueakLinux64x86w32CompatBuilder sourceDirectoryFor:(SqueakLinux64x86w32CompatBuilder availableBuilds at:1)

SqueakMacOSBuilder configurationsCategory
SqueakMacOSBuilder buildDirectory
SqueakMacOSBuilder availableBuilds
SqueakMacOSBuilder availableBuildTypesFor:(SqueakMacOSBuilder availableBuilds at:1)
SqueakMacOSBuilder sourceDirectoryFor:(SqueakMacOSBuilder availableBuilds at:1)

SqueakMacOSPowerPCBuilder configurationsCategory
SqueakMacOSPowerPCBuilder buildDirectory
SqueakMacOSPowerPCBuilder availableBuilds
SqueakMacOSPowerPCBuilder availableBuildTypesFor:(SqueakMacOSPowerPCBuilder availableBuilds at:1)
SqueakMacOSPowerPCBuilder sourceDirectoryFor:(SqueakMacOSPowerPCBuilder availableBuilds at:1)

SqueakMacOSX32x86Builder configurationsCategory
SqueakMacOSX32x86Builder buildDirectory
SqueakMacOSX32x86Builder availableBuilds
SqueakMacOSX32x86Builder availableBuildTypesFor:(SqueakMacOSX32x86Builder availableBuilds at:1)
SqueakMacOSX32x86Builder sourceDirectoryFor:(SqueakMacOSX32x86Builder availableBuilds at:1)

SqueakSunOS32x86Builder configurationsCategory
SqueakSunOS32x86Builder buildDirectory
SqueakSunOS32x86Builder availableBuilds
SqueakSunOS32x86Builder availableBuildTypesFor:(SqueakSunOS32x86Builder availableBuilds at:1)
SqueakSunOS32x86Builder sourceDirectoryFor:(SqueakSunOS32x86Builder availableBuilds at:1)

SqueakWin32x86Builder configurationsCategory
SqueakWin32x86Builder buildDirectory
SqueakWin32x86Builder availableBuilds
SqueakWin32x86Builder availableBuildTypesFor:(SqueakWin32x86Builder availableBuilds at:1)
SqueakWin32x86Builder sourceDirectoryFor:(SqueakWin32x86Builder availableBuilds at:1)


'! !

!CMakeVMMakerSqueakEndUserHelp class methodsFor: 'as yet unclassified' stamp: 'tty 6/12/2014 21:02'!
scratch
	^HelpTopic
		title: 'Scratch Notes To Be Organized'
		contents:
'
HEADS UP!! You can ''print it'' in the examples below
-------------------------Using CMakeVMMakerSqueak-------------------------
These instructions are duplicated in SqueakCMakeVMMakerAbstractBuilder class comments.


The easiest way to use this tool is to utilize one of the concrete Builders in category CMakeVMMakerSqueak-Builder.

With a builder, you can query it for information and then invoke it to generate configurations and or source.

Printing or inspecting the following lines will give you a flavor of a typical work-flow.


-------------Buildable/non-buildable configurations---------
SqueakCMakeVMMakerAbstractBuilder showExcludeFromBuild:false    "buildable configurations"
SqueakCMakeVMMakerAbstractBuilder showExcludeFromBuild:true.    "edit that configs ''excludeFromBuild'' method to change"
SqueakCMakeVMMakerAbstractBuilder availableBuildTypes

-------------------------Querying Builders---------------
SqueakLinux32X86Builder configurationsCategory 
SqueakLinux32X86Builder buildDirectory 
SqueakLinux32X86Builder availableBuilds	 
SqueakLinux32X86Builder availableBuildTypesFor:(SqueakLinux32X86Builder availableBuilds at:1)
SqueakLinux32X86Builder availableBuildTypesFor: #Linux32x86SqueakStackSpurConfig
SqueakLinux32X86Builder availableBuildTypesFor: #Linux32x86SqueakStackV3Config
SqueakLinux32X86Builder sourceDirectoryFor:(SqueakLinux32X86Builder availableBuilds at:1)

-------------------------Invoking Builders-------------------------
SqueakCMakeVMMakerAbstractBuilder reset
SqueakCMakeVMMakerAbstractBuilder availableBuildTypes a SortedCollection(#build #buildAssert #buildAssertITimerHeartbeat #buildDebug #buildDebugITimerHeartbeat #buildDebugMultiThreaded #buildITimerHeartbeat #buildMultiThreaded #buildMultiThreadedAssert #buildMultiThreadedDebug)

[SqueakCMakeVMMakerAbstractBuilder availableBuildTypes do: [:type | 
	SqueakLinux32X86Builder
		configureABuildFor: #Linux32x86SqueakCogV3Config withBuildType: type;	
		generate   ]] on: ProvideAnswerNotification do: [:ex | ex resume:true]


"generate only CMake config files"
SqueakLinux32X86Builder 
	configureABuildFor: #Linux32x86SqueakCogV3Config withBuildType: #buildAssertITimerHeartbeat;
	generate   

"generate configurations and invoke VMMaker to generate source code"
SqueakLinux32X86Builder 
	configureABuildFor: #Linux32x86SqueakCogV3Config withBuildType: #buildAssertITimerHeartbeat;
	generateSources  ;
	generate.

-------------------------Compiling Instructions-------------------------
open a terminal and go to the configurations build directory for that configuration. (SqueakLinux32X86Builder buildDirectory)
change into the build type subdirectory (build, build.assert, build.debug...etc)
source build.sh will run ''cmake. make'' 
executable is placed in  /products folder.  (SqueakLinux32X86Builder ouputDirectory)


----------------------Editing/Constructing Configurations--------------

Configurations are organized by category:  OperatingSystem, VM Word Size, Processor . (i.e MacOSX32x86 configurations reside in CMakeVMMakerSqueak-MacOSX32x86a)
For a OperatingSystem,VM Word Size, Processor, configurations are then organized by Language.VM.MemoryManafger (newswpeak.stack.v3, squeak.sista.spur. squeak.cog.spur, etc)

IF an existing configuratin exists, you may edit or subclass it. For a Builder to see it, it must remain in the category.

The flag excludeFromBuild determines wether the builder will build it or not. This flag is set to exclude configurations that are just placeholders.

If you have a special case for an existing [OS][WordSize][Processor].[lang][vm][mm] configuration just subclass it and provide customizations.

TODO: Provide typical customizations and how to implement them

internal/external plugins?
compiler flags?
includes?




----------------------Improvements needed-------------------------

The CMakeVMMakerSqueak package has some design hacks because it extends 
the pharo CMakeVMMaker package without modifying that code base.
Therefore, things that should have been done by introducing squeak sub-classes in the pharo source tree could not be done.

The biggest design ''quirk'' is the use of the Trait TCPlatformConfigForSqueak to enforce a pseudo abstract base class mechanism.
The other design ''quirk'' are the overrides of methods in CPlatformConfig in pharo''s package of incompatible methods. (see protocol squeak-compatibility)
Because of the existing inheritance tree, the overrides could not happen in one squeak compatibility class, but are implemented
in several subclasses of CPlatformConfig.

The Squeak Builders implementation also differs significantly from the pharo implementation.
The pharo code''s ''configForDebug/configForReleaase'' has been expanded to support the squeak build needs.


'! !

!CMakeVMMakerSqueakHelp class methodsFor: 'accessing' stamp: 'tty 6/16/2014 12:24'!
bookName
	^'CMakeVMMaker on Squeak'! !

!CMakeVMMakerSqueakHelp class methodsFor: 'accessing' stamp: 'tty 6/16/2014 12:27'!
pages
	^#(CMakeVMMakerSqueakDeveloperHelp CMakeVMMakerSqueakEndUserHelp CMakeVMMakerSqueakHowToCreateNewConfiguration)! !

CMakeVMMakerSqueakHelp subclass: #CMakeVMMakerSqueakHowToCreateNewConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Help'!

!CMakeVMMakerSqueakHowToCreateNewConfiguration commentStamp: 'tty 6/16/2014 12:19' prior: 0!
A CMakeVMMakerSqueakNewConfigurationStepByStepHelp itemizes the steps needed to create a new build configuration.

HelpBrowser openOn: CMakeVMMakerSqueakNewConfigurationStepByStepHelp!

!CMakeVMMakerSqueakHowToCreateNewConfiguration class methodsFor: 'accessing' stamp: 'tty 6/16/2014 13:25'!
bookName 
	^'Setting up a Configuration. Step By Step.'! !

!CMakeVMMakerSqueakHowToCreateNewConfiguration class methodsFor: 'accessing' stamp: 'tty 6/16/2014 16:00'!
pages
	^#(step1 
		step2 
		step3 
		step4 
		step4a 
		step4b 
		step4c 
		step4d 
		step4e 
		step4f 
		step4g 
		step4h 
		step4i 
		step4j 
		step4k 
		step4l 
		step4m
		step5 
)! !

!CMakeVMMakerSqueakHowToCreateNewConfiguration class methodsFor: 'pages' stamp: 'tty 6/16/2014 15:12'!
step1
	^HelpTopic
		title:'Step 1. Choose Your Category'
		contents:
' CMakeVMMakerSqueak configurations are placed in a Smalltalk category with the naming convention [OS][VMWordSize][Processor]

You start by choosing the correct Smalltalk Category in which to place your new Configuration.

Example; If you need a new configuration for Linux for a 32 bit VM on the x86 platform--[Linux][32][x86]--Choose the CMakeVMMakerSqueak-Linux32x86 category.

A Reminder: Consistent Naming Conventions Are Our Friends!!

'! !

!CMakeVMMakerSqueakHowToCreateNewConfiguration class methodsFor: 'pages' stamp: 'tty 6/16/2014 15:12'!
step2
	^HelpTopic
		title:'Step 2. Copy Existing Concrete Configuration'
		contents:
'Now that you have selected your category to place your new Configuration, you need to create your configuration.

Like Categories, Configurations adhere to a naming convention. It is [language][VM][MemoryManager][etc]Config
example: squeak.cog.v3.tty  is a configuration for compiling Squeak with a Cog VM with the old V3 memory manager and this is a special configuration for tty.

The easiest way to create the config is to subclass an existing configuration. In this case I would subclass squeak.cog.v3.

IMPORTANT: Do not copy a configuration (usually the top one in a category) that has the "	uses: TCPlatformConfigForSqueak"
line in its definition. While there are technical reasons for this warning, the important one is that it makes coding a pain-in-the-butt.


A Reminder: Consistent Naming Conventions Are Our Friends!!
'! !

!CMakeVMMakerSqueakHowToCreateNewConfiguration class methodsFor: 'pages' stamp: 'tty 6/16/2014 15:15'!
step3
	^HelpTopic
		title:'Step 4. Customize the "cmake" protocol'
		contents:
'TODO
dirInstall
	"the directory of the finished product.. the place where ''make install'' puts stuff.
	SystemNavigation default browseMethodsWhoseNamesContain: ''dirInstall''
      "
	^self squeakCogV3 , ''.noGL''


excludeFromBuild
	^false   "build this configuration"
"	^true"

executableName
	^ self vmCogExecutableName
A Reminder: Consistent Naming Conventions Are Our Friends!!
'! !

!CMakeVMMakerSqueakHowToCreateNewConfiguration class methodsFor: 'pages' stamp: 'tty 6/16/2014 17:30'!
step4
	^HelpTopic
		title:'Step 4. Customize the "cmake build type config" protocol'
		contents:
'When we invoke a Builder with a command like:

SqueakLinux64x86w32CompatBuilder
	configureA: #Linux64x86w32BitSqueakCogV3SlackwareNoGLConfig forBuildType: #buildDebugITimerHeartbeat;
	generateSources;
	generate.  

We are telling the Builder to select a Configuration and have that Configuration configure itself to produce CMake output for the buildType: #buildDebugITimerHeartbeat;

On your configuration the entry point for your configuration is one of:

configureBuild
configureBuildAssert
configureBuildAssertITimerHeartbeat
configureBuildDebug
configureBuildDebugITimerHeartbeat                        <----this one is selected by buildType: #buildDebugITimerHeartbeat;
configureBuildITimerHeartbeat
configureBuildMultiThreaded
configureBuildMultiThreadedAssert
configureBuildMultiThreadedDebug

Within this method, system state is set up and customizable for many methods in CMakeVMaker CPlatformConfig.

"setGlobalOptions: aMaker"
"setGlobalOptionsAfterDetermineSystem: aMaker"
setupDirectories
preferredIncludes
standardIncludes
compilerFlags
"extraVMSettings: aMaker"
internalPlugins
externalPlugins
thirdpartyLibs
"setExtraTargetProperties: aMaker"
"postBuildActions: aMaker"
configH

The methods above that take the : aMaker argument are handled on-the-fly later in the process and are only presented here for informational purposes.



A Reminder: Consistent Naming Conventions Are Our Friends!!

'! !

!CMakeVMMakerSqueakHowToCreateNewConfiguration class methodsFor: 'pages' stamp: 'tty 6/16/2014 15:16'!
step4a
	^HelpTopic
		title:'Step 4a. setGlobalOptions'
		contents:
'TODO: summarize this



A Reminder: Consistent Naming Conventions Are Our Friends!!

'! !

!CMakeVMMakerSqueakHowToCreateNewConfiguration class methodsFor: 'pages' stamp: 'tty 6/16/2014 15:17'!
step4b
	^HelpTopic
		title:'Step 4b. setGlobalOptionsAfterDetermineSystem'
		contents:
'TODO: summarize this




A Reminder: Consistent Naming Conventions Are Our Friends!!

'! !

!CMakeVMMakerSqueakHowToCreateNewConfiguration class methodsFor: 'pages' stamp: 'tty 6/16/2014 15:17'!
step4c
	^HelpTopic
		title:'Step 4c. setupDirectories'
		contents:
'TODO: summarize this



A Reminder: Consistent Naming Conventions Are Our Friends!!

'! !

!CMakeVMMakerSqueakHowToCreateNewConfiguration class methodsFor: 'pages' stamp: 'tty 6/16/2014 15:18'!
step4d
	^HelpTopic
		title:'Step 4d. preferredIncludes'
		contents:
'TODO: summarize this


A Reminder: Consistent Naming Conventions Are Our Friends!!

'! !

!CMakeVMMakerSqueakHowToCreateNewConfiguration class methodsFor: 'pages' stamp: 'tty 6/16/2014 15:18'!
step4e
	^HelpTopic
		title:'Step 4e. standardIncludes'
		contents:
'TODO: summarize this



A Reminder: Consistent Naming Conventions Are Our Friends!!

'! !

!CMakeVMMakerSqueakHowToCreateNewConfiguration class methodsFor: 'pages' stamp: 'tty 6/16/2014 15:18'!
step4f
	^HelpTopic
		title:'Step 4f. compilerFlags'
		contents:
'TODO: summarize this



A Reminder: Consistent Naming Conventions Are Our Friends!!

'! !

!CMakeVMMakerSqueakHowToCreateNewConfiguration class methodsFor: 'pages' stamp: 'tty 6/16/2014 15:18'!
step4g
	^HelpTopic
		title:'Step 4g. extraVMSettings'
		contents:
'TODO: summarize this



A Reminder: Consistent Naming Conventions Are Our Friends!!

'! !

!CMakeVMMakerSqueakHowToCreateNewConfiguration class methodsFor: 'pages' stamp: 'tty 6/16/2014 15:18'!
step4h
	^HelpTopic
		title:'Step4h internalPlugins'
		contents:
'TODO: summarize this



A Reminder: Consistent Naming Conventions Are Our Friends!!
'! !

!CMakeVMMakerSqueakHowToCreateNewConfiguration class methodsFor: 'pages' stamp: 'tty 6/16/2014 15:19'!
step4i
	^HelpTopic
		title:'Step4i externalPlugins'
		contents:
'TODO: summarize this




A Reminder: Consistent Naming Conventions Are Our Friends!!

'! !

!CMakeVMMakerSqueakHowToCreateNewConfiguration class methodsFor: 'pages' stamp: 'tty 6/16/2014 15:19'!
step4j
	^HelpTopic
		title:'Step4j thirdpartyLibs'
		contents:
'TODO: summarize this


A Reminder: Consistent Naming Conventions Are Our Friends!!


'! !

!CMakeVMMakerSqueakHowToCreateNewConfiguration class methodsFor: 'pages' stamp: 'tty 6/16/2014 15:19'!
step4k
	^HelpTopic
		title:'Step4k setExtraTargetProperties:aMaker'
		contents:
'TODO: summarize this



A Reminder: Consistent Naming Conventions Are Our Friends!!

'! !

!CMakeVMMakerSqueakHowToCreateNewConfiguration class methodsFor: 'pages' stamp: 'tty 6/16/2014 15:20'!
step4l
	^HelpTopic
		title:'Step4k postBuildActions: aMaker'
		contents:
'TODO: summarize this



A Reminder: Consistent Naming Conventions Are Our Friends!!

'! !

!CMakeVMMakerSqueakHowToCreateNewConfiguration class methodsFor: 'pages' stamp: 'tty 6/16/2014 18:18'!
step4m
	^HelpTopic
		title:'Step4m configH'
		contents:
' This is the contents of a config.h file in the build directory.
It is used only in Unix builds in CMakeVMMaker.


It is called from the method ''extraVMSettings'' of  CogUnixConfig in CMakeVMMaker when CogUnixConfig sends the message:		self generateConfigH.

To provide a custom config.h CMakeVMakerSqueak subclasses that message ''self generateConfigH'' and routes the call
to ''generateConfigH: aBuildType''

From there, a block is evaluated appropriate for the build type that invokes a ''configHBuildXYZ'' method which can be overridden by you to 
return a custom config.h. The default is to return the base configH.


A Reminder: Consistent Naming Conventions Are Our Friends!!

'! !

!CMakeVMMakerSqueakHowToCreateNewConfiguration class methodsFor: 'pages' stamp: 'tty 6/16/2014 15:12'!
step5
	^HelpTopic
		title:'Step5 set up ''cmake directory'' protocol'
		contents:
'The cmake directories protocol contains directory names for your platform, build directory 

See the chapter titled: ''An Explanation of Protocols in TCPaltformConfigForSqueak'' in 
HelpBrowser openOn:CMakeVMMakerSqueakDeveloperHelp  

The ones that your Configuration must implement are:

dirBuildPlatform
dirBuildLanguageVMMM


Basically, we are building a directory like this:
oscogvm/cmake.build.linux32.x86/squeak.cog.v3/build.assert 

which, when expressed as message names reduces to:

topDir/dirLinux32x86/squeakCogV3/dirBuildAssert

which are further reduced to 

topDir/dirBuildPlatform/dirBuildLanguageVMMM/dirBuildAssert

It is the two in the middle that you must customize. (dirBuildAssert is dynamically set by a Builder in a script, to be covered later)
To see how, take a look at the implementors of the two. its quite intuitive once you see it as it is based off our standard naming conventions.

SystemNavigation default browseMethodsWhoseNamesContain: ''dirBuildPlatform''
SystemNavigation default browseMethodsWhoseNamesContain: ''dirBuildLanguageVMMM''

For our purposes in this example, we want:


dirBuildPlatform
	^self dirLinux32x86
and

dirBuildLanguageVMMM
	^self squeakCogV3


A Reminder: Consistent Naming Conventions Are Our Friends!!

'! !

StackUnixConfig subclass: #Linux32x86SqueakStackV3Configz
	uses: TCPlatformConfigForSqueak
	instanceVariableNames: 'buildType generateForAssert generateForDebug generateForDebugWithHeartbeatTimer generateForDebugMultiThreadedFFI generateForReleaseHeartbeatTimer generateForReleaseMultiThreadedFFI generateForAssertHeartbeatTimer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-IslandOfMisfitToys'!

!Linux32x86SqueakStackV3Configz commentStamp: 'tty 6/7/2014 10:33' prior: 0!
A Linux32x86SqueakStackV3Config  configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

Usage: 
Linux32x86SqueakStackV3Config generate
Or: 
Linux32x86SqueakStackV3Config generateWithSources
Or: 
find my Builder in CMakeVMMakerSqueak-Builder category and use that to query me or invoke me
!

Linux32x86SqueakStackV3Configz class
	uses: TCPlatformConfigForSqueak classTrait
	instanceVariableNames: ''!

!Linux32x86SqueakStackV3Configz class methodsFor: 'as yet unclassified' stamp: 'tty 6/7/2014 09:30'!
availableBuilds
	"SqueakCMakeVMMakerAbstractBuilder  allBuildConfigurations
	^SqueakCMakeVMMakerAbstractBuilder noBuildConfigurations"
	^#(#assert  #release )
! !

!Linux32x86SqueakStackV3Configz class methodsFor: 'accessing' stamp: 'tty 5/22/2014 13:54'!
licenseTemplate
	^'Squeak  {1} license information
==============================

About Squeak
-----------


Squeak is a modern, open source, full-featured implementation of the powerful Smalltalk programming language and environment. Squeak is highly-portable, running on almost any platform you could name and you can really truly write once run anywhere.  Squeak is the vehicle for a wide range of projects from multimedia applications and educational platforms to commercial web application development. Read on and join in!!

http://www.squeak.org


LIcense

Note: The current release of Squeak is a combination of source code originating from it''s origins at Apple which Apple agreed to license under the Apache license and more recent contributions licensed under the MIT license. The vast majority of the code is under the MIT license.
MIT License

Copyright (c) The individual, corporate, and institutional contributors who have collectively contributed elements to this software ("The Squeak Community"), 1996-2010 All rights reserved.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
Portions of Squeak are covered by the following license:
Apache License, Version 2.0

Copyright (c) Xerox Corp. 1981, 1982 All rights reserved. Copyright (c) Apple Computer, Inc. 1985-1996 All rights reserved.

Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.


About Cog
---------

Cog is a virtual machine designed for Smalltalk and other similar dynamic languages.  Cog builds on the
Squeak virtual machine adding a stack-to-register-mapping just-in-time compiler, aggressive in-line message
cacheing and effective optimization of Smalltalk’s first-class activation records.  Cog is the virtual machine
underlying Teleplace''s Croquet-based enterprise virtual collaboration spaces software, the fastest virtual
machine for Squeak, and for Gilad Bracha''s Newspeak modular language inspired by Beta and Smalltalk.  
Like the original Squeak VM, Cog is implemented and developed in Smalltalk, and translated into a lower-level
language to produce the production VM.  Being a Smalltalk program it is a delight to develop.  Cog is
available under the MIT open source license and is unencumbered for commercial deployment.

Cog''s performance relative to the existing Squeak interpreter varies, depending on the benchmark chosen.
As of early-2011, the Cog JIT uses strong inline cacheing techniques and stack-to-register mapping that
results in a register-based calling convention for low-arity methods.  Due to the complexity of the Squeak
object representation it has a limited set of primitives implemented in machine code that, for example,
exclude object allocation.  Performance of the early-2011 JIT for the nbody, binarytrees and chameneos
redux benchmarks from the computer language shootout is in the range of 4 to 6 times faster than the
interpreter.
'! !

!Linux32x86SqueakStackV3Configz class methodsFor: 'accessing' stamp: 'tty 5/22/2014 13:55'!
pluginsTemplate
	^'Squeak {1} ships with the following plugins already built:
		
Internal: 
=========
{2}

External: 
=========
{3}

'! !

!Linux32x86SqueakStackV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 5/16/2014 17:33'!
addDriver: name sources: aSources generator: cmakeGen externalLibs: extLibs

	| cfg srcs |
	
	srcs := aSources inject: '' into: [:res :each | res , ' "', each, '"' ].
	cfg := cmakeGen
		captureOutputDuring: [
			cmakeGen printHeader;
			project: name;
			include: '../directories.cmake';
		
			message: 'Adding module: ', name;
			
			addDefinitions:  self compilerFlags;
			addDefinitions: '-fPIC -DPIC';
			set: #sources to: srcs;
			cmd: 'add_library' params: name, ' SHARED ${sources}'; 
			includeDirectories: '${crossDir}/plugins/FilePlugin';
			includeDirectories: '${targetPlatform}/plugins/B3DAcceleratorPlugin';
			includeDirectories: '${crossDir}/plugins/B3DAcceleratorPlugin';
			set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir fullName;
			addExternalLibraries: extLibs;
			cmd: 'target_link_libraries' params: name , ' ${LINKLIBS}';
			cmd: 'set_target_properties' params: name , ' PROPERTIES PREFIX "" SUFFIX "" 
			LINK_FLAGS -m32' 
	].
	
	(self buildDir / name) assureExistence.
	self write: cfg toFile: name , '/', cmakeGen outputFileName.
	cmakeGen addSubdirectory:  name.
	! !

!Linux32x86SqueakStackV3Configz methodsFor: 'cmake' stamp: 'tty 6/8/2014 19:05'!
availableBuilds
	"SqueakCMakeVMMakerAbstractBuilder  default allBuildConfigurations"
	^SqueakCMakeVMMakerAbstractBuilder default allBuildConfigurations copyWithoutAll:#(#assert #assertWithHeartbeatTimer #debugMultiThreadedFFI  #debugWithHeartbeatTimer  #releaseHeartbeatTimer #releaseMultiThreadedFFI )

! !

!Linux32x86SqueakStackV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 5/16/2014 16:44'!
buildDir
	^ buildDir ifNil: [ buildDir := ( self topDir / self buildDirName) assureExistence].! !

!Linux32x86SqueakStackV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 5/20/2014 13:53'!
buildDirName
	^ 'cmake_stackbuild/unixbuild/bld'! !

!Linux32x86SqueakStackV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 6/7/2014 16:13'!
buildLanguageVMMMDir
	"the directory under buildPlatformDir  example: newspeak.cog.spur"
	^self squeakStackV3! !

!Linux32x86SqueakStackV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 6/7/2014 15:55'!
buildPlatformDir
	"the directory for the platform. example: build.linux32x86"
	^self dirLinux32x86! !

!Linux32x86SqueakStackV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 6/7/2014 15:15'!
buildType: aSymbol
	buildType:= aSymbol! !

!Linux32x86SqueakStackV3Configz methodsFor: 'compiler flags' stamp: 'tty 5/15/2014 19:46'!
commonCompilerFlags 
	^super commonCompilerFlags, {  
		'-DIMAGE_DIALECT_NAME="', self executableName, '" '.
		'-DIMAGE_ENV_NAME="SQUEAK_IMAGE"'.
		'-DDEFAULT_IMAGE_NAME="', self executableName, '.image"' }! !

!Linux32x86SqueakStackV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 6/16/2014 20:09'!
compilerFlags
	|d commonFlags flags|
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self compilerFlagsBuild];
		at: #buildAssert  put: [self compilerFlagsAssert];
		at: #buildAssertITimerHeartbeat  put: [self compilerFlagsAssertITimerHeartbeat];
            at:#buildDebug  put: [self compilerFlagsDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self compilerFlagsDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self compilerFlagsIHeartbeatTimer];
		at: #buildMultiThreaded  put: [self compilerFlagsMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self compilerFlagsMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self compilerFlagsMultiThreadedDebug ];
		at: #buildNone put:[self compilerFlagsNoBuildType].

    flags:= String streamContents: [ :stream |
	 (((d at:  buildType) value)  collect: #withBlanksTrimmed as: Set)
		asStringOn: stream 
		delimiter:' '].

    commonFlags:=String streamContents: [ :stream |
		((self commonCompilerFlags) collect: #withBlanksTrimmed as: Set)
			asStringOn: stream 
			delimiter: ' ' ].
	^ commonFlags, ' ' ,flags.! !

!Linux32x86SqueakStackV3Configz methodsFor: 'cmake configuration' stamp: 'tty 6/16/2014 20:09'!
configureForBuildType: aSymbol
	| d |
	"provide a concrete builder with the buildType and configureBuildX method to invoke"
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	self configureNoBuildType.                "reset all internal flags"
	d 
		at: #build 
		put: [self buildType:#build.  self configureBuild];

		at: #buildAssert 
		put: [self buildType: #buildAssert.  	self configureBuildAssert];

		at: #buildAssertITimerHeartbeat 
		put:     [ self buildType: #buildAssertITimerHeartbeat.   self configureBuildAssertITimerHeartbeat];

            at:#buildDebug 
		put: [self buildType: #buildDebug.  self configureBuildDebug];

		at: #buildDebugITimerHeartbeat 
		put:  [self buildType: #buildDebugITimerHeartbeat.   self configureBuildDebugITimerHeartbeat];

		at: #buildITimerHeartbeat 
		put: [self buildType:#buildITimerHeartbeat.    self configureBuildIHeartbeatTimer];

		at: #buildMultiThreaded 
		put:  [self buildType:#buildMultiThreaded . self configureBuildMultiThreaded];

		at: #buildMultiThreadedAssert 
		put: [self buildType: #buildMultiThreadedAssert. self configureBuildMultiThreadedAssert];

		at: #buildMultiThreadedDebug  
		put: [self buildType: #buildMultiThreadedDebug. self configureBuildMultiThreadedDebug].

     ^(d at: aSymbol).! !

!Linux32x86SqueakStackV3Configz methodsFor: 'cmake' stamp: 'tty 6/8/2014 15:50'!
dirARMv6
	^'cmake_build.armv6'! !

!Linux32x86SqueakStackV3Configz methodsFor: 'cmake' stamp: 'tty 6/7/2014 16:46'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackV3! !

!Linux32x86SqueakStackV3Configz methodsFor: 'cmake' stamp: 'tty 6/8/2014 15:53'!
dirBuildPlatform
	"the directory for the platform. example: build.linux32x86"
	^self dirLinux32x86! !

!Linux32x86SqueakStackV3Configz methodsFor: 'cmake' stamp: 'tty 6/9/2014 17:07'!
excludeFromBuild
"	^false"   "build this configuration"
	^true

! !

!Linux32x86SqueakStackV3Configz methodsFor: 'accessing' stamp: 'tty 5/15/2014 18:21'!
executableName
	^ 'StackVM'! !

!Linux32x86SqueakStackV3Configz methodsFor: 'public' stamp: 'tty 5/16/2014 17:59'!
generate 
	self generatePluginsList. 
	self generateLicense. 
	"^super generate"
	^CMakeVMGeneratorForSqueak generate:self    "Bypass CPlatformConfig generate to invoke our compatibility class"! !

!Linux32x86SqueakStackV3Configz methodsFor: 'headers generation' stamp: 'tty 6/16/2014 20:09'!
generateConfigH: aBuildType
	"self write: self configH toFile: 'config.h'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self configHBuild];
		at: #buildAssert  put: [self configHBuildAssert];
		at: #buildAssertITimerHeartbeat  put: [self configHBuildAssertITimerHeartbeat];
            at:#buildDebug  put: [self configHBuildDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self configHBuildDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self configHBuildITimerHeartbeat];
		at: #buildMultiThreaded  put: [self configHBuildMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self configHBuildMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self configHBuildMultiThreadedDebug ];
		at: #buildNone put:[self configHNoBuildType].


	 ^(d at: ( aBuildType)) value



! !

!Linux32x86SqueakStackV3Configz methodsFor: 'public' stamp: ''!
generateLicense 
	self 
		write:  (self class licenseTemplate 
			format: { self version })
		toFile: 'LICENSE.txt'
	! !

!Linux32x86SqueakStackV3Configz methodsFor: 'public' stamp: ''!
generatePluginsList 
	self 
		write:  (self class pluginsTemplate 
			format: {
				self version. 
				String streamContents: [ :stream | self internalPlugins asStringOn: stream delimiter: String cr ].
				String streamContents: [ :stream | self externalPlugins asStringOn: stream delimiter: String cr ].
				self executableName })
		toFile: 'PLUGINS.txt'
	! !

!Linux32x86SqueakStackV3Configz methodsFor: 'initialize-release' stamp: 'tty 6/9/2014 12:27'!
initialize
	super initialize.
	"this should be in my superclass, but I do not have permission to modify it. tty"
	 generateForAssert:= generateForAssertHeartbeatTimer:= generateForDebug :=generateForDebugWithHeartbeatTimer:= generateForDebugMultiThreadedFFI:= generateForReleaseHeartbeatTimer:= generateForReleaseMultiThreadedFFI:=false! !

!Linux32x86SqueakStackV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 5/16/2014 17:23'!
outputDir

	"the directory where built binaries will be stored"
	^ outputDir ifNil: [ outputDir := (self topDir / self outputDirName) ]	

! !

!Linux32x86SqueakStackV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 5/16/2014 17:15'!
prepareVMMaker
	
	| maker allPlugins |
	
	"In CogVMs (in contrast to Interpreter VM) the generated sources are platform independent, therefore Cross is ok"
	maker := VMMaker forPlatform: 'Cross'.
	
	maker sourceDirectoryName: self srcDir pathName.
	maker platformRootDirectoryName: self platformsDir.
	
	
	allPlugins := self internalPlugins , self externalPlugins.
	
	"touch plugins to force their source generation unconditionally"
	allPlugins do: [:name | (Smalltalk globals at: name) touch ].
	
	" Why we put all plugins as external?   Because the generated sources are not different whether the plugins were defined as internal or external. VMMaker used to need this to to generate plugins.int and plugins.ext files. But since this is achieved in another way with CMakeVMMaker, there is no different at all to put all plugins as internal or as external."
	maker externalModules addAll:  allPlugins.
	
	^ maker! !

!Linux32x86SqueakStackV3Configz methodsFor: 'utils' stamp: 'tty 6/16/2014 20:10'!
setGlobalOptionsAfterDetermineSystem: aMaker buildType: aBuildType
	"invoke correct setGlobalOptions for this buildType to allow per-buildType customization'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self setGlobalOptionsAfterDetermineSystemBuild: aMaker];
		at: #buildAssert  put: [self setGlobalOptionsAfterDetermineSystemBuildAssert: aMaker];
		at: #buildAssertITimerHeartbeat  put: [self setGlobalOptionsAfterDetermineSystemBuildAssertITimerHeartbeat: aMaker];
            at:#buildDebug  put: [self setGlobalOptionsAfterDetermineSystemBuildDebug: aMaker];   
		at: #buildITimerHeartbeat  put: [self setGlobalOptionsAfterDetermineSystemBuildITimerHeartbeat: aMaker];
		at: #buildMultiThreaded  put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreaded: aMaker ];
		at: #buildMultiThreadedAssert  put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreadedAssert: aMaker];
		at: #buildMultiThreadedDebug   put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreadedDebug: aMaker ];
		at: #buildNone put:[self setGlobalOptionsBuildNone: aMaker].

	 ^(d at: ( aBuildType)) value
! !

!Linux32x86SqueakStackV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 5/16/2014 17:02'!
setupDirectories: gen
	| dirsInclude |

	" write the directories in separate include file"
	dirsInclude := gen captureOutputDuring: [
		gen
			set: #topDir toString: (self topDir fullName); 
			set: #buildDir toString: (self buildDir ifNil: ['${topDir}/build'] ifNotNil: [self buildDir fullName] );
			set: #thirdpartyDir toString: '${buildDir}/thirdParty';
			set: #platformsDir toString: self platformsDir;
			set: #srcDir toString: self srcDir pathName;
			set: #srcPluginsDir toString: (pluginsDir ifNil: [ '${srcDir}/plugins' ]);
			set: #srcVMDir toString: '${srcDir}/vm';
			set: #platformName toString: self platformName;
			set: #targetPlatform to: '${platformsDir}/${platformName}';
			set: #crossDir toString: '${platformsDir}/Cross';
			set: #platformVMDir toString: '${targetPlatform}/vm';
			set: #outputDir toString: self outputDir fullName.
	].

	self write: dirsInclude toFile: 'directories.cmake'.
	
	gen include: 'directories.cmake'.
! !

!Linux32x86SqueakStackV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 5/16/2014 16:42'!
srcDir
		^ srcDir ifNil: [ srcDir := (self topDir directoryNamed: 'stacksrc' )]! !

!Linux32x86SqueakStackV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 6/7/2014 16:57'!
topDir
	^ topDir ifNil: [ topDir := FileDirectory default directoryNamed: self oscogvm ]! !

!Linux32x86SqueakStackV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 5/16/2014 17:08'!
validateSourcesPresent
	| sources |
	sources := Smalltalk sourcesName.
	
	(sources == nil)
		ifTrue: [	self error: 'VM source code cannot be generated without .sources file'.]		! !

!Linux32x86SqueakStackV3Configz methodsFor: 'accessing' stamp: ''!
version
	^ ''! !

!Linux32x86SqueakStackV3Configz methodsFor: 'squeak compatibility' stamp: 'tty 5/16/2014 16:56'!
write: aContents toFile: aFileName
	"write a file to current output directory (buildDir).
	use line end convention appropriate for config platform"

	| bldDir |
	bldDir := self buildDir.
	bldDir isString
		ifTrue: [ bldDir := FileDirectory directoryEntryFor: bldDir ].
	bldDir assureExistence.
	bldDir
		forceNewFileNamed: aFileName
		do: [:s | s
				nextPutAll: (self fixLineEndsOf: aContents)]

! !

Linux32x86SqueakStackV3Configz subclass: #Linux32x86SqueakStackV3DebugConfigz
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-IslandOfMisfitToys'!

!Linux32x86SqueakStackV3DebugConfigz commentStamp: 'tty 6/7/2014 10:31' prior: 0!
I need to go away. In the meantime....

This is a concrete class which generates a DEBUG StackVM for Unix systems. This VM is normally known as a debug StackVM. The debug means that it is compiled with all the necessary symbolic symbols for debugging and can be debugged, for example, with GDB.

Usage:
Linux32x86SqueakStackV3DebugConfig generateWithSources
Or:
Linux32x86SqueakStackV3DebugConfig generate

Or:
find my Builder in CMakeVMMakerSqueak-Builder category and use that to query me or invoke me
!

!Linux32x86SqueakStackV3DebugConfigz class methodsFor: 'as yet unclassified' stamp: 'tty 6/7/2014 09:32'!
availableBuilds
	self flag:'tty'. "having debug sublclasses makes no sense with the generateForRelease, generateForDebug ,generateForFOO idiom going forward. I need to go away"
	^#(  #debug )
! !

!Linux32x86SqueakStackV3DebugConfigz methodsFor: 'plugins' stamp: 'tty 5/21/2014 14:10'!
defaultExternalPlugins
	"Removed the B3DAcceleratorPlugin since we don't have OpenGL bindings here"
	^ (super defaultExternalPlugins copyWithoutAll: #(#ThreadedIA32FFIPlugin #InternetConfigPlugin #FT2Plugin))! !

!Linux32x86SqueakStackV3DebugConfigz methodsFor: 'plugins' stamp: 'tty 5/21/2014 11:48'!
defaultInternalPlugins
	"Removed the B3DAcceleratorPlugin since we don't have OpenGL bindings here"
	^ (super defaultInternalPlugins copyWithoutAll: #(#IA32ABIPlugin #JoystickTabletPlugin #StarSqueakPlugin #SurfacePlugin #SqueakFFIPrims #ThreadedIA32FFIPlugin))! !

!Linux32x86SqueakStackV3DebugConfigz methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:37'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

Linux32x86SqueakStackV3DebugConfigz subclass: #Linux32x86SqueakStackV3FixedVerSIConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-IslandOfMisfitToys'!

!Linux32x86SqueakStackV3FixedVerSIConfig commentStamp: 'tty 6/7/2014 10:31' prior: 0!
This is done specifically to track down the instability issues of Cog VM on UNIX


Usage:
Linux32x86SqueakStackV3FixedVerSIConfig generateWithSources
or:
Linux32x86SqueakStackV3FixedVerSIConfig generate
Or:
find my Builder in CMakeVMMakerSqueak-Builder category and use that to query me or invoke me
!

!Linux32x86SqueakStackV3FixedVerSIConfig methodsFor: 'compiler flags' stamp: 'tty 5/21/2014 12:02'!
compilerFlagsDebug

	^ {
		'-g3'. 
		'-O0'. 
		'-msse2'. 
		'-save-temps'. 
		'-D_GNU_SOURCE'. 
		'-DITIMER_HEARTBEAT=1'. 
		'-DNO_VM_PROFILE=1'. 
		'-DCOGMTVM=0'. 
		'-DDEBUGVM=1' }! !

!Linux32x86SqueakStackV3FixedVerSIConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:37'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Linux32x86SqueakStackV3FixedVerSIConfig methodsFor: 'settings' stamp: 'tty 5/21/2014 12:02'!
extraVMSettings: maker
	| versionC |
	self generateConfigH.
	
	
	"output a fake version.c file"
	
	self write:
'int vm_serial= 1;
char *vm_date= "<HERE IS SUPPOSED TO BE THE DATE>";
char *cc_version= "<HERE IS SUPPOSED TO BE gcc VERSION>";
char *ux_version= "<FAKE FROZEN VERSION FOR DEBUGGING PURPOSES>";
'
	toFile: 'version.c'.
! !

CMakePluginGenerator subclass: #CMakePluginGeneratorForSqueak
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak'!

!CMakePluginGeneratorForSqueak commentStamp: 'tty 5/16/2014 15:52' prior: 0!
A CMakePluginGeneratorForSqueak overides some CMakeVMPluginGenerator methods for squeak compatibility. 

Instance Variables
!

!CMakePluginGeneratorForSqueak methodsFor: 'squeak compatibility' stamp: 'tty 5/16/2014 16:58'!
saveFile
	
	| reference |
	reference := ((vmGen config dirFrom: vmGen buildDir) / plugin moduleName).
	reference assureExistence.
	reference 
		forceNewFileNamed: (self outputFileName)
		do:[:s | s nextPutAll:(self config fixLineEndsOf: output contents)]
! !

TestCase subclass: #CMakeVMMakerSqueakBuildersTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Tests'!

!CMakeVMMakerSqueakBuildersTest commentStamp: 'tty 6/7/2014 11:39' prior: 0!
I test CMakeVMMakerSqueak Builder classes.!

!CMakeVMMakerSqueakBuildersTest methodsFor: 'as yet unclassified' stamp: 'tty 6/8/2014 17:06'!
testAvailableBuilds
	SqueakCMakeVMMakerAbstractBuilder 
		subclassesDo:[:c | 
			self assert: (c default availableBuilds size > 0).]	! !

!CMakeVMMakerSqueakBuildersTest methodsFor: 'as yet unclassified' stamp: 'tty 6/8/2014 14:22'!
testBuildConfigurations
	self assert: (SqueakCMakeVMMakerAbstractBuilder default allBuildConfigurations size > 0).
	self assert: (SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations size > 0).
	! !

!CMakeVMMakerSqueakBuildersTest methodsFor: 'as yet unclassified' stamp: 'tty 6/8/2014 15:45'!
testConfigurationsCategory
	|oc|
	"ensure builders have a category with configs in it and make sure it is unique. This does not guarantee it is correct, but it helps"
	oc:= OrderedCollection new.
	SqueakCMakeVMMakerAbstractBuilder 
		subclassesDo:[:c | 
			self assert: (c default configurationsCategory isString).
			oc addLast: c.
			self assert: ( (oc occurrencesOf: c) = 1)]	! !

TestCase subclass: #CMakeVMMakerSqueakConfigurationsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Tests'!

!CMakeVMMakerSqueakConfigurationsTest methodsFor: 'as yet unclassified' stamp: 'tty 6/10/2014 11:38'!
testBuildDirName
	"for each builder, make sure all its configurations provide a build directory name "
	SqueakCMakeVMMakerAbstractBuilder 
		subclassesDo:[:builder | | o |
			Smalltalk globals 
				allClassesDo:[:configuration | (configuration class category asString withoutQuoting startsWith: (builder configurationsCategory))
					ifTrue:[ 
							o:= configuration new.
							o excludeFromBuild not                                                     
								ifTrue:[self assert:(o  buildDirName isString)]]]]







! !

!CMakeVMMakerSqueakConfigurationsTest methodsFor: 'as yet unclassified' stamp: 'tty 6/10/2014 11:39'!
testBuildDirs
	"for each builder, make sure all its configurations provides availbale build directories "
	SqueakCMakeVMMakerAbstractBuilder 
		subclassesDo:[:builder | | o |
			Smalltalk globals 
				allClassesDo:[:configuration | (configuration class category asString withoutQuoting startsWith: (builder configurationsCategory))
					ifTrue:[ 
							o:= configuration new.
							o excludeFromBuild not
								ifTrue:[self assert:(o  buildDir isKindOf: FileDirectory)]]]]







! !

!CMakeVMMakerSqueakConfigurationsTest methodsFor: 'as yet unclassified' stamp: 'tty 6/10/2014 11:38'!
testDefaultExternalPlugins
	"for each builder, make sure all its configurations provides defaultExternalPlugins"
	SqueakCMakeVMMakerAbstractBuilder 
		subclassesDo:[:builder | | o |
			Smalltalk globals 
				allClassesDo:[:configuration | (configuration class category asString withoutQuoting startsWith: (builder configurationsCategory))
					ifTrue:[ 
							o:= configuration new.
							self assert:(o  defaultExternalPlugins isArray)]]]







! !

!CMakeVMMakerSqueakConfigurationsTest methodsFor: 'as yet unclassified' stamp: 'tty 6/10/2014 11:38'!
testDefaultInternalPlugins
	"for each builder, make sure all its configurations provides defaultInternalPlugins"
	SqueakCMakeVMMakerAbstractBuilder 
		subclassesDo:[:builder | | o |
			Smalltalk globals 
				allClassesDo:[:configuration | (configuration class category asString withoutQuoting startsWith: (builder configurationsCategory))
					ifTrue:[ 
							o:= configuration new.
							self assert:(o  defaultInternalPlugins isArray)]]]







! !

!CMakeVMMakerSqueakConfigurationsTest methodsFor: 'as yet unclassified' stamp: 'tty 6/10/2014 11:37'!
testDirSource
	"for each builder, make sure all its configurations provide a dirSource "
	SqueakCMakeVMMakerAbstractBuilder 
		subclassesDo:[:builder | | o |
			Smalltalk globals 
				allClassesDo:[:configuration | (configuration class category asString withoutQuoting startsWith: (builder configurationsCategory))
					ifTrue:[ 
							o:= configuration new.
							self assert:(o  dirSource isString)]]]







! !

!CMakeVMMakerSqueakConfigurationsTest methodsFor: 'as yet unclassified' stamp: 'tty 6/10/2014 11:37'!
testExcludeFromBuild
	"for each builder, make sure all its includes or excludes itself from a build "
	SqueakCMakeVMMakerAbstractBuilder 
		subclassesDo:[:builder | | o |
			Smalltalk globals 
				allClassesDo:[:configuration | (configuration class category asString withoutQuoting startsWith: (builder configurationsCategory))
					ifTrue:[ 
							o:= configuration new.
							self assert:(((o  excludeFromBuild) == true) | ((o  excludeFromBuild) == false))]]]







! !

!CMakeVMMakerSqueakConfigurationsTest methodsFor: 'as yet unclassified' stamp: 'tty 6/16/2014 07:46'!
testExectuableName
	"for each builder, make sure all its configurations provide an executableName "
	SqueakCMakeVMMakerAbstractBuilder 
		subclassesDo:[:builder | | o |
			Smalltalk globals 
				allClassesDo:[:configuration | (configuration class category asString withoutQuoting startsWith: (builder configurationsCategory))
					ifTrue:[ 
							o:= configuration new.
							(o excludeFromBuild not)
								ifTrue:[self assert:(o  executableName isString)]]]]







! !

!CMakeVMMakerSqueakConfigurationsTest methodsFor: 'as yet unclassified' stamp: 'tty 6/10/2014 11:37'!
testExternalPlugins
	"for each builder, make sure all its configurations provides externalePlugins "
	SqueakCMakeVMMakerAbstractBuilder 
		subclassesDo:[:builder | | o |
			Smalltalk globals 
				allClassesDo:[:configuration | (configuration class category asString withoutQuoting startsWith: (builder configurationsCategory))
					ifTrue:[ 
							o:= configuration new.
							self assert:(o  externalPlugins isArray)]]]







! !

!CMakeVMMakerSqueakConfigurationsTest methodsFor: 'as yet unclassified' stamp: 'tty 6/10/2014 11:36'!
testInternalPlugins
	"for each builder, make sure all its configurations provides internalPlutgins "
	SqueakCMakeVMMakerAbstractBuilder 
		subclassesDo:[:builder | | o |
			Smalltalk globals 
				allClassesDo:[:configuration | (configuration class category asString withoutQuoting startsWith: (builder configurationsCategory))
					ifTrue:[ 
							o:= configuration new.
							self assert:(o  internalPlugins isArray)]]]







! !

!CMakeVMMakerSqueakConfigurationsTest methodsFor: 'as yet unclassified' stamp: 'tty 6/14/2014 15:57'!
testOutputDir
	"for each builder, make sure all its configurations provide an outputDir "
	SqueakCMakeVMMakerAbstractBuilder 
		subclassesDo:[:builder | | o |
			Smalltalk globals 
				allClassesDo:[:configuration | (configuration class category asString withoutQuoting startsWith: (builder configurationsCategory))
					ifTrue:[ 
							o:= configuration new.
							(o excludeFromBuild not)
								ifTrue:[self assert:(o  outputDir isKindOf: FileDirectory)]]]]







! !

!CMakeVMMakerSqueakConfigurationsTest methodsFor: 'as yet unclassified' stamp: 'tty 6/10/2014 11:36'!
testSrcDirs
	"for each builder, make sure all its configurations provide a srcDir "
	SqueakCMakeVMMakerAbstractBuilder 
		subclassesDo:[:builder | | o |
			Smalltalk globals 
				allClassesDo:[:configuration | (configuration class category asString withoutQuoting startsWith: (builder configurationsCategory))
					ifTrue:[ 
							o:= configuration new.
							self assert:(o  srcDir isKindOf: FileDirectory)]]]







! !

!CMakeVMMakerSqueakConfigurationsTest methodsFor: 'as yet unclassified' stamp: 'tty 6/10/2014 11:36'!
testTopDirs
	"for each builder, make sure all its configurations provide a topDir "
	SqueakCMakeVMMakerAbstractBuilder 
		subclassesDo:[:builder | | o |
			Smalltalk globals 
				allClassesDo:[:configuration | (configuration class category asString withoutQuoting startsWith: (builder configurationsCategory))
					ifTrue:[ 
							o:= configuration new.
							self assert:(o  topDir isKindOf: FileDirectory)]]]







! !

!CMakeVMMakerSqueakConfigurationsTest methodsFor: 'as yet unclassified' stamp: 'tty 6/10/2014 11:36'!
testdirBuildLanguageVMMM
	"for each builder that does not exclude itself from builds, make sure it returns dirBUildLanguageVMMM "
	SqueakCMakeVMMakerAbstractBuilder 
		subclassesDo:[:builder | | o |
			Smalltalk globals 
				allClassesDo:[:configuration | (configuration class category asString withoutQuoting startsWith: (builder configurationsCategory))
					ifTrue:[ 
							o:= configuration new.
							o excludeFromBuild not                                                     
							 	ifTrue:[self assert:(o  dirBuildLanguageVMMM isString)]]]]







! !

CMakeVMGenerator subclass: #CMakeVMGeneratorForSqueak
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak'!

!CMakeVMGeneratorForSqueak commentStamp: 'tty 5/16/2014 15:52' prior: 0!
A CMakeVMGeneratorForSqueak overides some CMakeVMGenerator methos for squeak compatibility. 

!

!CMakeVMGeneratorForSqueak class methodsFor: 'as yet unclassified' stamp: 'tty 5/16/2014 17:18'!
generate: aConfigOrClass  
	^self new 
		generate: aConfigOrClass;
		yourself  ! !

!CMakeVMGeneratorForSqueak methodsFor: 'as yet unclassified' stamp: 'tty 5/16/2014 17:06'!
generatePlugin: aPlugin internal: aBoolean extraRules: aBlock
	" this method called back from plugin"
	^ CMakePluginGeneratorForSqueak new
		generate: aPlugin for: self internal: aBoolean extraRules: aBlock! !

CPlatformConfig subclass: #Linux32x86SqueakStackSpurConfigz
	uses: TCPlatformConfigForSqueak
	instanceVariableNames: 'buildType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-IslandOfMisfitToys'!

Linux32x86SqueakStackSpurConfigz class
	uses: TCPlatformConfigForSqueak classTrait
	instanceVariableNames: ''!

!Linux32x86SqueakStackSpurConfigz methodsFor: 'compiler flags' stamp: 'tty 6/16/2014 20:07'!
compilerFlags
	|d commonFlags flags|
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self compilerFlagsBuild];
		at: #buildAssert  put: [self compilerFlagsAssert];
		at: #buildAssertITimerHeartbeat  put: [self compilerFlagsAssertITimerHeartbeat];
            at:#buildDebug  put: [self compilerFlagsDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self compilerFlagsDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self compilerFlagsIHeartbeatTimer];
		at: #buildMultiThreaded  put: [self compilerFlagsMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self compilerFlagsMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self compilerFlagsMultiThreadedDebug ];
		at: #buildNone put:[self compilerFlagsNoBuildType].

    flags:= String streamContents: [ :stream |
	 (((d at:  buildType) value)  collect: #withBlanksTrimmed as: Set)
		asStringOn: stream 
		delimiter:' '].

    commonFlags:=String streamContents: [ :stream |
		((self commonCompilerFlags) collect: #withBlanksTrimmed as: Set)
			asStringOn: stream 
			delimiter: ' ' ].
	^ commonFlags, ' ' ,flags.! !

!Linux32x86SqueakStackSpurConfigz methodsFor: 'cmake configuration' stamp: 'tty 6/16/2014 20:08'!
configureForBuildType: aSymbol
	| d |
	"provide a concrete builder with the buildType and configureBuildX method to invoke"
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	self configureNoBuildType.                "reset all internal flags"
	d 
		at: #build 
		put: [self buildType:#build.  self configureBuild];

		at: #buildAssert 
		put: [self buildType: #buildAssert.  	self configureBuildAssert];

		at: #buildAssertITimerHeartbeat 
		put:     [ self buildType: #buildAssertITimerHeartbeat.   self configureBuildAssertITimerHeartbeat];

            at:#buildDebug 
		put: [self buildType: #buildDebug.  self configureBuildDebug];

		at: #buildDebugITimerHeartbeat 
		put:  [self buildType: #buildDebugITimerHeartbeat.   self configureBuildDebugITimerHeartbeat];

		at: #buildITimerHeartbeat 
		put: [self buildType:#buildITimerHeartbeat.    self configureBuildIHeartbeatTimer];

		at: #buildMultiThreaded 
		put:  [self buildType:#buildMultiThreaded . self configureBuildMultiThreaded];

		at: #buildMultiThreadedAssert 
		put: [self buildType: #buildMultiThreadedAssert. self configureBuildMultiThreadedAssert];

		at: #buildMultiThreadedDebug  
		put: [self buildType: #buildMultiThreadedDebug. self configureBuildMultiThreadedDebug].

     ^(d at: aSymbol).! !

!Linux32x86SqueakStackSpurConfigz methodsFor: 'plugins' stamp: 'tty 6/9/2014 16:50'!
defaultExternalPlugins
	^ #(SqueakSSL	)! !

!Linux32x86SqueakStackSpurConfigz methodsFor: 'plugins' stamp: 'tty 6/9/2014 16:50'!
defaultInternalPlugins
" cut-n-paste from Cog/build.linux32x86/squeak.stack.spur/build"
	^ #(
		AsynchFilePlugin 
		BMPReadWriterPlugin 
		B2DPlugin 
		BitBltPlugin 
		DSAPrims 
		DropPlugin 
		FileCopyPlugin 
		FilePlugin 
		FloatArrayPlugin 
		FloatMathPlugin 
		ZipPlugin 
		JPEGReadWriter2Plugin 
		JPEGReaderPlugin 
		LargeIntegers 
		Matrix2x3Plugin 
		MiscPrimitivePlugin 
		IA32ABI 
		RePlugin 
		SecurityPlugin 
		SocketPlugin 
		SurfacePlugin 
		UUIDPlugin 
		UnixOSProcessPlugin 
		VMProfileLinuxSupportPlugin
		)! !

!Linux32x86SqueakStackSpurConfigz methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:36'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Linux32x86SqueakStackSpurConfigz methodsFor: 'headers generation' stamp: 'tty 6/16/2014 20:08'!
generateConfigH: aBuildType
	"self write: self configH toFile: 'config.h'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self configHBuild];
		at: #buildAssert  put: [self configHBuildAssert];
		at: #buildAssertITimerHeartbeat  put: [self configHBuildAssertITimerHeartbeat];
            at:#buildDebug  put: [self configHBuildDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self configHBuildDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self configHBuildITimerHeartbeat];
		at: #buildMultiThreaded  put: [self configHBuildMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self configHBuildMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self configHBuildMultiThreadedDebug ];
		at: #buildNone put:[self configHNoBuildType].


	 ^(d at: ( aBuildType)) value



! !

!Linux32x86SqueakStackSpurConfigz methodsFor: 'utils' stamp: 'tty 6/16/2014 20:08'!
setGlobalOptionsAfterDetermineSystem: aMaker buildType: aBuildType
	"invoke correct setGlobalOptions for this buildType to allow per-buildType customization'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self setGlobalOptionsAfterDetermineSystemBuild: aMaker];
		at: #buildAssert  put: [self setGlobalOptionsAfterDetermineSystemBuildAssert: aMaker];
		at: #buildAssertITimerHeartbeat  put: [self setGlobalOptionsAfterDetermineSystemBuildAssertITimerHeartbeat: aMaker];
            at:#buildDebug  put: [self setGlobalOptionsAfterDetermineSystemBuildDebug: aMaker];   
		at: #buildITimerHeartbeat  put: [self setGlobalOptionsAfterDetermineSystemBuildITimerHeartbeat: aMaker];
		at: #buildMultiThreaded  put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreaded: aMaker ];
		at: #buildMultiThreadedAssert  put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreadedAssert: aMaker];
		at: #buildMultiThreadedDebug   put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreadedDebug: aMaker ];
		at: #buildNone put:[self setGlobalOptionsBuildNone: aMaker].

	 ^(d at: ( aBuildType)) value
! !

CPlatformConfig subclass: #SqueakAndroidStackEvtConfig
	uses: TCPlatformConfigForSqueak
	instanceVariableNames: 'buildType generateBuild generateBuildAssert generateBuildAssertITimerHeartbeat generateBuildDebug generateBuildDebugITimerHeartbeat generateBuildDebugMultiThreaded generateBuildIHeartbeatTimer generateBuildMultiThreaded generateBuildMultiThreadedAssert generateBuildMultiThreadedDebug'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Android'!

!SqueakAndroidStackEvtConfig commentStamp: 'tty 5/21/2014 12:18' prior: 0!
A class to configure the Event-driven Stack Cog for Android. This configuration does not lead to building an executable; rather it prepares the source tree to be plugged into the jni subdirectory of an Android project.

Requires AndroidPlugin

Ported from pharo to squeak. !

SqueakAndroidStackEvtConfig class
	uses: TCPlatformConfigForSqueak classTrait
	instanceVariableNames: ''!

!SqueakAndroidStackEvtConfig class methodsFor: 'as yet unclassified' stamp: 'tty 6/8/2014 14:49'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!SqueakAndroidStackEvtConfig methodsFor: 'cmake' stamp: 'tty 6/8/2014 18:48'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder  default  noBuildConfigurations
! !

!SqueakAndroidStackEvtConfig methodsFor: 'directories' stamp: 'tty 5/21/2014 12:15'!
buildDir
	^ buildDir ifNil: [ buildDir := ( self topDir / self buildDirName) assureExistence].! !

!SqueakAndroidStackEvtConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/6/2014 16:04'!
buildDirName
	^'do not build. see class comment'! !

!SqueakAndroidStackEvtConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/7/2014 15:23'!
buildType: aSymbol
	buildType:= aSymbol! !

!SqueakAndroidStackEvtConfig methodsFor: 'source generation' stamp: 'tty 5/21/2014 12:11'!
compilerFlags
	"Compiler flags for Android. Leave empty for now"
	^  ' -DDEBUG=22 '! !

!SqueakAndroidStackEvtConfig methodsFor: 'source files' stamp: 'tty 5/21/2014 12:11'!
configH
	" right now its borrowed directly from unix, but likely will change"
	^ '
#ifndef __sq_config_h
#define __sq_config_h

/* explicit image width */

#define	HAVE_INTERP_H 1

/* package options */

#define	USE_X11 1
#define	USE_X11_GLX 1
/* #undef	USE_QUARTZ */
/* #undef	USE_QUARTZ_CGL */
/* #undef	USE_RFB */

/* libraries */

/* #undef	HAVE_LIBX11 */
/* #undef	HAVE_LIBXEXT */
#define	HAVE_LIBDL 1
/* #undef	HAVE_DYLD */
/* #undef	HAVE_LIBFFI */
/* #undef	HAVE_ICONV */

/* #undef	USE_AUDIO_NONE */
/* #undef	USE_AUDIO_SUN */
/* #undef	USE_AUDIO_NAS */
/* #undef	USE_AUDIO_OSS */
/* #undef	USE_AUDIO_MACOSX */
/* #undef	OSS_DEVICE */

/* header files */

#define	HAVE_UNISTD_H 1
/* #undef	NEED_GETHOSTNAME_P */

#define	HAVE_DIRENT_H 1
/* #undef	HAVE_SYS_NDIR_H */
/* #undef	HAVE_SYS_DIR_H */
/* #undef	HAVE_NDIR_H */

#define	HAVE_SYS_TIME_H 1
#define	TIME_WITH_SYS_TIME 1

/* #undef	HAVE_SYS_FILIO_H */

/* #undef	HAVE_SYS_AUDIOIO_H */
/* #undef	HAVE_SUN_AUDIOIO_H */

#define	HAVE_PTY_H 1
/* #undef	HAVE_UTIL_H */
/* #undef	HAVE_LIBUTIL_H */
#define	HAVE_STROPTS_H 1

#define	HAVE_GL_GL_H 1
/* #undef	HAVE_OPENGL_GL_H */

/* #undef	NEED_SUNOS_H */

/* system calls/library functions */

#define	AT_EXIT atexit

#define	HAVE_TZSET 1

#define	HAVE_OPENPTY 1
/* #undef	HAVE_UNIX98_PTYS */

#define	HAVE_SNPRINTF 1
/* #undef	HAVE___SNPRINTF */

#define	HAVE_MMAP 1

/* #undef	HAVE_DYLD */

#define	HAVE_LANGINFO_CODESET 1

#define	HAVE_ALLOCA 1
#define	HAVE_ALLOCA_H 1

#define	HAVE_UNSETENV 1

#define	HAVE_NANOSLEEP 1

/* widths of primitive types */

#define	SIZEOF_INT 4
#define	SIZEOF_LONG 4
#define	SIZEOF_LONG_LONG 8
#define	SIZEOF_VOID_P 4

/* structures */

#define	HAVE_TM_GMTOFF 1
#define	HAVE_TIMEZONE 1

/* typedefs */

/* #undef	size_t */
/* #undef	socklen_t */

#define	squeakInt64 long long

/* architecture */

#define	OS_TYPE "unix"

#define	VM_HOST "i686-pc-linux-gnu"
#define	VM_HOST_CPU "i686"
/* #undef	VM_HOST_VENDOR */
#define	VM_HOST_OS "linux-gnu"
#define	VM_BUILD_STRING "Unix built on "__DATE__ " "__TIME__" Compiler: "__VERSION__

/* #undef	WORDS_BIGENDIAN */
/* #undef	DOUBLE_WORD_ALIGNMENT */

/* damage containment */

/* #undef	DARWIN */

#ifdef NEED_SUNOS_H
# include "sunos.h"
#endif

/* other configured variables */

#define SQ_VERSION "3.9a-7024"
#define VM_VERSION "3.9-7"
#define VM_MODULE_PREFIX ""
/* #undef VM_DLSYM_PREFIX */
#define VM_X11DIR ""

/* avoid dependencies on glibc2.3 */

#define HAVE_FEATURES_H 1

#if defined(HAVE_FEATURES_H)
# include "glibc.h"
#endif


/* used by UUID plugin: */

#define HAVE_UUID_H 1

#endif /* __sq_config_h */
																																																																					
																																																																				'! !

!SqueakAndroidStackEvtConfig methodsFor: 'cmake configuration' stamp: 'tty 6/16/2014 20:54'!
configureBuild
	"configure this Configuration for a buildType #build"
	self 
		preferredIncludesBuild;
		standardIncludesBuild;
		compilerFlagsBuild;
		internalPluginsBuild;
		externalPluginsBuild;
		thirdpartyLibsBuild
		


		
		
		! !

!SqueakAndroidStackEvtConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/21/2014 12:11'!
configureFileCopyPlugin: maker
	"extra rules for DropPlugin"

	maker addPlatformSources: #( 'sqAndroidFileCopyPlugin.c')
! !

!SqueakAndroidStackEvtConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/21/2014 12:11'!
configureFilePlugin: maker
	"extra rules for FilePlugin"

	super configureFilePlugin: maker.  
	
	maker addPlatformSources: #( 'sqAndroidFile.c')! !

!SqueakAndroidStackEvtConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/21/2014 12:11'!
configureFloatMathPlugin: maker
	"extra rules for FloatMathPlugin"

	maker addCrossSources: #(
		'acos.c' 'acosh.c' 'asin.c' 'asinh.c' 'atan.c' 'atan2.c' 'atanh.c'
		'copysign.c' 'cos.c' 'cosh.c' 'exp.c' 'expm1.c' 'finite.c' 'fmod.c'
		'hypot.c' 'isnan.c' 'k_cos.c' 'k_rem_pio2.c' 'k_sin.c' 'k_tan.c' 'ldexp.c'
		'log.c' 'log10.c' 'log1p.c' 'modf.c' 'pow.c' 'rem_pio2.c' 'rint.c'
		'scalb.c' 'scalbn.c' 'sin.c' 'sinh.c' 'sqrt.c' 'tan.c' 'tanh.c' ).

	
	"according to http://www.netlib.org/fdlibm/readme
	it should be compiled with no optimizations"
	maker addDefinitions: '-O0'.
	
	" compile with -D__LITTLE_ENDIAN
		This macro is set automatically in fdlibm.h when compiled ith -m32 but
		not when compiled with -m64 (Nicolas Cellier)
	"
	self isLittleEndian ifTrue: [
		maker addDefinitions: '-D__LITTLE_ENDIAN=1' ].

	maker addDefinitions: '-DNO_ISNAN'.
	

! !

!SqueakAndroidStackEvtConfig methodsFor: 'cmake configuration' stamp: 'tty 6/16/2014 20:12'!
configureForBuildType: aSymbol
	| d |
	"provide a concrete builder with the buildType and configureBuildX method to invoke"
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	self configureNoBuildType.                "reset all internal flags"
	d 
		at: #build 
		put: [self buildType:#build.  self configureBuild];

		at: #buildAssert 
		put: [self buildType: #buildAssert.  	self configureBuildAssert];

		at: #buildAssertITimerHeartbeat 
		put:     [ self buildType: #buildAssertITimerHeartbeat.   self configureBuildAssertITimerHeartbeat];

            at:#buildDebug 
		put: [self buildType: #buildDebug.  self configureBuildDebug];

		at: #buildDebugITimerHeartbeat 
		put:  [self buildType: #buildDebugITimerHeartbeat.   self configureBuildDebugITimerHeartbeat];

		at: #buildITimerHeartbeat 
		put: [self buildType:#buildITimerHeartbeat.    self configureBuildIHeartbeatTimer];

		at: #buildMultiThreaded 
		put:  [self buildType:#buildMultiThreaded . self configureBuildMultiThreaded];

		at: #buildMultiThreadedAssert 
		put: [self buildType: #buildMultiThreadedAssert. self configureBuildMultiThreadedAssert];

		at: #buildMultiThreadedDebug  
		put: [self buildType: #buildMultiThreadedDebug. self configureBuildMultiThreadedDebug].

     ^(d at: aSymbol).! !

!SqueakAndroidStackEvtConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/21/2014 12:11'!
configureJoystickTabletPlugin: maker 
	"extra rules for JoystickTabletPlugin"
	
	super configureJoystickTabletPlugin: maker.  
	maker addPlatformSources:
		#( 'sqAndroidJoystickTablet.c' )
! !

!SqueakAndroidStackEvtConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/21/2014 12:11'!
configureLocalePlugin: maker
	"extra rules for LocalePlugin"

	super configureLocalePlugin: maker.  
	
	maker addPlatformSources: #( 'sqAndroidLocale.c')! !

!SqueakAndroidStackEvtConfig methodsFor: 'cmake' stamp: 'tty 6/12/2014 17:11'!
configureNoBuildType
		generateBuild:=generateBuildAssert:=generateBuildAssertITimerHeartbeat:=generateBuildDebug:=generateBuildDebugITimerHeartbeat:= generateBuildDebugMultiThreaded:= generateBuildIHeartbeatTimer:= generateBuildMultiThreaded:= generateBuildMultiThreadedAssert:= generateBuildMultiThreadedDebug:=false.! !

!SqueakAndroidStackEvtConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/21/2014 12:11'!
configureSecurityPlugin: maker 
	"extra rules for MIDIPlugin"

	super configureSecurityPlugin: maker.
	
	maker addPlatformSources: #( 'sqAndroidSecurity.c')! !

!SqueakAndroidStackEvtConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/21/2014 12:11'!
configureSocketPlugin: maker 
	"extra rules for SocketPlugin"
	
	maker addPlatformSources: #( 'sqAndroidSocket.c')! !

!SqueakAndroidStackEvtConfig methodsFor: 'source files' stamp: 'tty 5/21/2014 12:11'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!SqueakAndroidStackEvtConfig methodsFor: 'source files' stamp: 'tty 5/21/2014 12:11'!
crossSources 
	^#(
			'sqHeapMap.c'
			'sqNamedPrims.c'
			'sqVirtualMachine.c'
		)! !

!SqueakAndroidStackEvtConfig methodsFor: 'plugins' stamp: 'tty 5/21/2014 12:11'!
defaultExternalPlugins
	^ #(
	)! !

!SqueakAndroidStackEvtConfig methodsFor: 'plugins' stamp: 'tty 5/21/2014 12:11'!
defaultInternalPlugins
" took from unixbuild/bld/plugins.int"
	^ #(
		AndroidPlugin
		BitBltSimulation "BitBltPlugin"
		BalloonEnginePlugin "B2DPlugin" 
		BMPReadWriterPlugin 
		CroquetPlugin 
		DSAPlugin "DSAPrims" 
		FFTPlugin 
		FileCopyPlugin 
		FilePlugin 
		FloatArrayPlugin 
		FloatMathPlugin 
		JoystickTabletPlugin 
		JPEGReaderPlugin 
		LargeIntegersPlugin "LargeIntegers"
		Matrix2x3Plugin 
		LocalePlugin
		RePlugin 	
		SecurityPlugin 
		JPEGReadWriter2Plugin 
		SocketPlugin 
		MiscPrimitivePlugin 
		DeflatePlugin  "ZipPlugin"
		)! !

!SqueakAndroidStackEvtConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 10:59'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self eventStackV3! !

!SqueakAndroidStackEvtConfig methodsFor: 'cmake' stamp: 'tty 6/8/2014 12:28'!
dirBuildPlatform
	"the directory for the platform. example: build.linux32x86"
	^self dirAndroid! !

!SqueakAndroidStackEvtConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:46'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakAndroidStackEvtConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:07'!
executableName
	^ self vmStackExecutableName! !

!SqueakAndroidStackEvtConfig methodsFor: 'source generation' stamp: 'tty 5/21/2014 12:11'!
extraVMSettings: maker
	| versionC |
	self generateConfigH.
	
	"add a generated version.c"
	
	versionC := 'version.c'.

	maker 
		puts: '$(buildDir)/',versionC, ':' ;
		puts: ({Character tab}, '$(platformsDir)/android/config/verstamp ', '$(buildDir)/', versionC,' gcc');
		puts: {Character cr};
		puts: ('LOCAL_SRC_FILES += $(buildDir)/', versionC);
		puts: {Character cr}.
	.
	! !

!SqueakAndroidStackEvtConfig methodsFor: 'utils' stamp: 'tty 5/21/2014 12:11'!
fixLineEndsOf: string
	^ string copyReplaceAll: String cr with: String lf! !

!SqueakAndroidStackEvtConfig methodsFor: 'source generation' stamp: 'tty 5/21/2014 12:11'!
generate
	^ CMakeAndroidGenerator generate: self 	

! !

!SqueakAndroidStackEvtConfig methodsFor: 'headers generation' stamp: 'tty 6/16/2014 18:00'!
generateConfigH
	"	
	used to be: 	
		self write: self configH toFile: 'config.h'
      but with variable buildTypes we need:
"
	self write: (self generateConfigH: buildType) toFile: 'config.h'   
! !

!SqueakAndroidStackEvtConfig methodsFor: 'headers generation' stamp: 'tty 6/16/2014 20:12'!
generateConfigH: aBuildType
	"self write: self configH toFile: 'config.h'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self configHBuild];
		at: #buildAssert  put: [self configHBuildAssert];
		at: #buildAssertITimerHeartbeat  put: [self configHBuildAssertITimerHeartbeat];
            at:#buildDebug  put: [self configHBuildDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self configHBuildDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self configHBuildITimerHeartbeat];
		at: #buildMultiThreaded  put: [self configHBuildMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self configHBuildMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self configHBuildMultiThreadedDebug ];
		at: #buildNone put:[self configHNoBuildType].


	 ^(d at: ( aBuildType)) value



! !

!SqueakAndroidStackEvtConfig methodsFor: 'initialize-release' stamp: 'tty 6/9/2014 12:26'!
initialize
	super initialize.
	"this should be in my superclass, but I do not have permission to modify it. tty"
	 generateForAssert:= generateForAssertHeartbeatTimer:= generateForDebug :=generateForDebugWithHeartbeatTimer:= generateForDebugMultiThreadedFFI:= generateForReleaseHeartbeatTimer:= generateForReleaseMultiThreadedFFI:=false! !

!SqueakAndroidStackEvtConfig methodsFor: 'source generation' stamp: 'tty 5/21/2014 12:11'!
interpreterClass
	^ StackEvtAndroidInterpreter! !

!SqueakAndroidStackEvtConfig methodsFor: 'utils' stamp: 'tty 5/21/2014 12:11'!
mkFileList: anArray baseDir: aDir
	"answer the concatenated contents of the array interspersed with backslash-newline sequences"
	^ (anArray collect: [ :s | aDir, s]) inject: '' into: [ :s :n | s , #($\), {Character cr}, n ].! !

!SqueakAndroidStackEvtConfig methodsFor: 'directories' stamp: 'tty 6/14/2014 15:42'!
outputDir

	"the directory where built binaries will be stored"
	^ outputDir ifNil: [ outputDir := (self topDir / self dirOutput/ self dirInstall) ]	

! !

!SqueakAndroidStackEvtConfig methodsFor: 'source generation' stamp: 'tty 5/21/2014 12:11'!
platformName
	^ 'android'! !

!SqueakAndroidStackEvtConfig methodsFor: 'source files' stamp: 'tty 5/21/2014 12:11'!
platformSources
	"files added from platform/android/vm dir "
	^ #(
	'aio.c'
	'debug.c'
	'osExports.c'
	'sqAndroidCharConv.c'
	'sqAndroidExternalPrims.c'
	'sqAndroidEvtBeat.c'
	'sqAndroidEvtMain.c'
	'sqAndroidMemory.c'
	'sqAndroidVMProfile.c'
	'sqAndroidSemaphores.c'
	'sqAndroidSoundNull.c'
	'sqAndroidDisplay.c'
	)! !

!SqueakAndroidStackEvtConfig methodsFor: 'source generation' stamp: 'tty 5/21/2014 12:11'!
prepareForGeneration

	"force using LF on Macs"
	CrLfFileStream defaultToLF.

	^ self prepareForStackVMGeneration
! !

!SqueakAndroidStackEvtConfig methodsFor: 'utils' stamp: 'tty 6/16/2014 20:12'!
setGlobalOptionsAfterDetermineSystem: aMaker buildType: aBuildType
	"invoke correct setGlobalOptions for this buildType to allow per-buildType customization'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self setGlobalOptionsAfterDetermineSystemBuild: aMaker];
		at: #buildAssert  put: [self setGlobalOptionsAfterDetermineSystemBuildAssert: aMaker];
		at: #buildAssertITimerHeartbeat  put: [self setGlobalOptionsAfterDetermineSystemBuildAssertITimerHeartbeat: aMaker];
            at:#buildDebug  put: [self setGlobalOptionsAfterDetermineSystemBuildDebug: aMaker];   
		at: #buildITimerHeartbeat  put: [self setGlobalOptionsAfterDetermineSystemBuildITimerHeartbeat: aMaker];
		at: #buildMultiThreaded  put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreaded: aMaker ];
		at: #buildMultiThreadedAssert  put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreadedAssert: aMaker];
		at: #buildMultiThreadedDebug   put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreadedDebug: aMaker ];
		at: #buildNone put:[self setGlobalOptionsBuildNone: aMaker].

	 ^(d at: ( aBuildType)) value
! !

!SqueakAndroidStackEvtConfig methodsFor: 'directories' stamp: 'tty 5/21/2014 12:11'!
setupDirectories: gen
	"same logic as the super has, but use gmake syntax instead of cmake"
	| dirsInclude |

	" write the directories in separate include file"
	dirsInclude := gen captureOutputDuring: [
		gen
			set: #topDir to: ('$(ROOT)/', self topDir fullName); 
			set: #buildDir to: (self buildDir ifNil: ['$(topDir)/build'] ifNotNil: ['$(ROOT)/', self buildDir fullName] );
			set: #platformsDir to: ('$(ROOT)/', self platformsDir);
			set: #srcDir to: ('$(ROOT)/', self srcDir);
			set: #srcPluginsDir to: (pluginsDir ifNil: [ '$(srcDir)/plugins' ]);
			set: #srcVMDir to: '$(srcDir)/vm';
			set: #platformName to: self platformName;
			set: #targetPlatform to: '$(platformsDir)/$(platformName)';
			set: #crossDir to: '$(platformsDir)/Cross';
			set: #platformVMDir to: '$(targetPlatform)/vm'.
	].

	self write: dirsInclude toFile: 'cogdirs.mk'
! !

!SqueakAndroidStackEvtConfig methodsFor: 'directories' stamp: 'tty 5/21/2014 12:13'!
srcDir
		^ srcDir ifNil: [ srcDir := (self topDir directoryNamed: 'stacksrc' )]! !

!SqueakAndroidStackEvtConfig methodsFor: 'directories' stamp: 'tty 6/7/2014 16:58'!
topDir
		^ topDir ifNil: [ topDir := FileDirectory default directoryNamed: self oscogvm ]! !

CPlatformConfig subclass: #SqueakIA32BochsConfig
	uses: TCPlatformConfigForSqueak
	instanceVariableNames: 'buildType generateBuild generateBuildAssert generateBuildAssertITimerHeartbeat generateBuildDebug generateBuildDebugITimerHeartbeat generateBuildDebugMultiThreaded generateBuildIHeartbeatTimer generateBuildMultiThreaded generateBuildMultiThreadedAssert generateBuildMultiThreadedDebug'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-IA32-Bochs'!

!SqueakIA32BochsConfig commentStamp: 'tty 6/15/2014 14:08' prior: 0!
N.B. I honestly have no idea how to use this. tty (:

I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


I am not meant to be built.

SqueakIA32BochsBuilder 
	configureABuildFor: #ONE OF MY SUBCLASSES NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp

!

SqueakIA32BochsConfig class
	uses: TCPlatformConfigForSqueak classTrait
	instanceVariableNames: ''!

!SqueakIA32BochsConfig class methodsFor: 'accessing' stamp: 'tty 6/7/2014 09:26'!
availableBuilds
	"SqueakCMakeVMMakerAbstractBuilder  allBuildConfigurations
	^#(#assert #debug  #release )"
	^SqueakCMakeVMMakerAbstractBuilder noBuildConfigurations! !

!SqueakIA32BochsConfig methodsFor: 'cmake' stamp: 'tty 6/8/2014 18:50'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder  default  noBuildConfigurations
! !

!SqueakIA32BochsConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/7/2014 17:00'!
buildDir
	^ buildDir ifNil: [ buildDir := ( self topDir / self buildDirName) assureExistence].! !

!SqueakIA32BochsConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/12/2014 12:08'!
buildDirName
	buildType isNil
		ifTrue:[^self dirBuildPlatform, FileDirectory slash, self dirBuildLanguageVMMM, FileDirectory slash, 'build']
		ifFalse:[^self dirBuildPlatform, FileDirectory slash, self dirBuildLanguageVMMM, FileDirectory slash, buildType asString]! !

!SqueakIA32BochsConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/7/2014 15:22'!
buildType: aSymbol
	buildType:= aSymbol! !

!SqueakIA32BochsConfig methodsFor: 'compiler flags' stamp: 'tty 6/16/2014 20:13'!
compilerFlags
	|d commonFlags flags|
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self compilerFlagsBuild];
		at: #buildAssert  put: [self compilerFlagsAssert];
		at: #buildAssertITimerHeartbeat  put: [self compilerFlagsAssertITimerHeartbeat];
            at:#buildDebug  put: [self compilerFlagsDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self compilerFlagsDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self compilerFlagsIHeartbeatTimer];
		at: #buildMultiThreaded  put: [self compilerFlagsMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self compilerFlagsMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self compilerFlagsMultiThreadedDebug ];
		at: #buildNone put:[self compilerFlagsNoBuildType].

    flags:= String streamContents: [ :stream |
	 (((d at:  buildType) value)  collect: #withBlanksTrimmed as: Set)
		asStringOn: stream 
		delimiter:' '].

    commonFlags:=String streamContents: [ :stream |
		((self commonCompilerFlags) collect: #withBlanksTrimmed as: Set)
			asStringOn: stream 
			delimiter: ' ' ].
	^ commonFlags, ' ' ,flags.! !

!SqueakIA32BochsConfig methodsFor: 'cmake configuration' stamp: 'tty 6/16/2014 20:55'!
configureBuild
	"configure this Configuration for a buildType #build"
	self 
		preferredIncludesBuild;
		standardIncludesBuild;
		compilerFlagsBuild;
		internalPluginsBuild;
		externalPluginsBuild;
		thirdpartyLibsBuild


		
		
		! !

!SqueakIA32BochsConfig methodsFor: 'cmake configuration' stamp: 'tty 6/16/2014 20:14'!
configureForBuildType: aSymbol
	| d |
	"provide a concrete builder with the buildType and configureBuildX method to invoke"
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	self configureNoBuildType.                "reset all internal flags"
	d 
		at: #build 
		put: [self buildType:#build.  self configureBuild];

		at: #buildAssert 
		put: [self buildType: #buildAssert.  	self configureBuildAssert];

		at: #buildAssertITimerHeartbeat 
		put:     [ self buildType: #buildAssertITimerHeartbeat.   self configureBuildAssertITimerHeartbeat];

            at:#buildDebug 
		put: [self buildType: #buildDebug.  self configureBuildDebug];

		at: #buildDebugITimerHeartbeat 
		put:  [self buildType: #buildDebugITimerHeartbeat.   self configureBuildDebugITimerHeartbeat];

		at: #buildITimerHeartbeat 
		put: [self buildType:#buildITimerHeartbeat.    self configureBuildIHeartbeatTimer];

		at: #buildMultiThreaded 
		put:  [self buildType:#buildMultiThreaded . self configureBuildMultiThreaded];

		at: #buildMultiThreadedAssert 
		put: [self buildType: #buildMultiThreadedAssert. self configureBuildMultiThreadedAssert];

		at: #buildMultiThreadedDebug  
		put: [self buildType: #buildMultiThreadedDebug. self configureBuildMultiThreadedDebug].

     ^(d at: aSymbol).! !

!SqueakIA32BochsConfig methodsFor: 'cmake' stamp: 'tty 6/12/2014 17:10'!
configureNoBuildType
		generateBuild:=generateBuildAssert:=generateBuildAssertITimerHeartbeat:=generateBuildDebug:=generateBuildDebugITimerHeartbeat:= generateBuildDebugMultiThreaded:= generateBuildIHeartbeatTimer:= generateBuildMultiThreaded:= generateBuildMultiThreadedAssert:= generateBuildMultiThreadedDebug:=false.! !

!SqueakIA32BochsConfig methodsFor: 'plugins' stamp: 'tty 6/7/2014 17:28'!
defaultExternalPlugins
	^ #()! !

!SqueakIA32BochsConfig methodsFor: 'plugins' stamp: 'tty 6/7/2014 17:27'!
defaultInternalPlugins
	^ #()! !

!SqueakIA32BochsConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:14'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur the default is squeak.cog.v3"
	^self required! !

!SqueakIA32BochsConfig methodsFor: 'cmake' stamp: 'tty 6/7/2014 16:04'!
dirBuildPlatform
	^self dirIA32Bochs! !

!SqueakIA32BochsConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:47'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakIA32BochsConfig methodsFor: 'headers generation' stamp: 'tty 6/16/2014 18:01'!
generateConfigH
	"	
	used to be: 	
		self write: self configH toFile: 'config.h'
      but with variable buildTypes we need:
"
	self write: (self generateConfigH: buildType) toFile: 'config.h'   
! !

!SqueakIA32BochsConfig methodsFor: 'headers generation' stamp: 'tty 6/16/2014 20:14'!
generateConfigH: aBuildType
	"self write: self configH toFile: 'config.h'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self configHBuild];
		at: #buildAssert  put: [self configHBuildAssert];
		at: #buildAssertITimerHeartbeat  put: [self configHBuildAssertITimerHeartbeat];
            at:#buildDebug  put: [self configHBuildDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self configHBuildDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self configHBuildITimerHeartbeat];
		at: #buildMultiThreaded  put: [self configHBuildMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self configHBuildMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self configHBuildMultiThreadedDebug ];
		at: #buildNone put:[self configHNoBuildType].
	 ^(d at: ( aBuildType)) value



! !

!SqueakIA32BochsConfig methodsFor: 'initialize-release' stamp: 'tty 6/9/2014 12:27'!
initialize
	super initialize.
	"this should be in my superclass, but I do not have permission to modify it. tty"
	 generateForAssert:= generateForAssertHeartbeatTimer:= generateForDebug :=generateForDebugWithHeartbeatTimer:= generateForDebugMultiThreadedFFI:= generateForReleaseHeartbeatTimer:= generateForReleaseMultiThreadedFFI:=false! !

!SqueakIA32BochsConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/14/2014 15:42'!
outputDir

	"the directory where built binaries will be stored"
	^ outputDir ifNil: [ outputDir := (self topDir / self dirOutput/ self dirInstall) ]	

! !

!SqueakIA32BochsConfig methodsFor: 'utils' stamp: 'tty 6/16/2014 20:14'!
setGlobalOptionsAfterDetermineSystem: aMaker buildType: aBuildType
	"invoke correct setGlobalOptions for this buildType to allow per-buildType customization'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self setGlobalOptionsAfterDetermineSystemBuild: aMaker];
		at: #buildAssert  put: [self setGlobalOptionsAfterDetermineSystemBuildAssert: aMaker];
		at: #buildAssertITimerHeartbeat  put: [self setGlobalOptionsAfterDetermineSystemBuildAssertITimerHeartbeat: aMaker];
            at:#buildDebug  put: [self setGlobalOptionsAfterDetermineSystemBuildDebug: aMaker];   
		at: #buildITimerHeartbeat  put: [self setGlobalOptionsAfterDetermineSystemBuildITimerHeartbeat: aMaker];
		at: #buildMultiThreaded  put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreaded: aMaker ];
		at: #buildMultiThreadedAssert  put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreadedAssert: aMaker];
		at: #buildMultiThreadedDebug   put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreadedDebug: aMaker ];
		at: #buildNone put:[self setGlobalOptionsBuildNone: aMaker].

	 ^(d at: ( aBuildType)) value
! !

!SqueakIA32BochsConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/7/2014 18:04'!
srcDir
		^ srcDir ifNil: [ srcDir := (self topDir directoryNamed: 'src' )]! !

!SqueakIA32BochsConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/7/2014 16:58'!
topDir
		^ topDir ifNil: [ topDir := FileDirectory default directoryNamed: self oscogvm ]! !

SqueakIA32BochsConfig subclass: #SqueakIA32BochsLinuxConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-IA32-Bochs'!

!SqueakIA32BochsLinuxConfig commentStamp: 'tty 6/15/2014 14:09' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakIA32BochsBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp

!

!SqueakIA32BochsLinuxConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:16'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakCogSpur! !

SqueakIA32BochsConfig subclass: #SqueakIA32BochsMacOSConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-IA32-Bochs'!

!SqueakIA32BochsMacOSConfig commentStamp: 'tty 6/15/2014 14:09' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakIA32BochsBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp

!

!SqueakIA32BochsMacOSConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:16'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakCogSpur! !

SqueakIA32BochsConfig subclass: #SqueakIA32BochsMacOSXConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-IA32-Bochs'!

!SqueakIA32BochsMacOSXConfig commentStamp: 'tty 6/15/2014 14:09' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakIA32BochsBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp

!

!SqueakIA32BochsMacOSXConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:16'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakCogSpur! !

SqueakIA32BochsConfig subclass: #SqueakIA32BochsWin32Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-IA32-Bochs'!

!SqueakIA32BochsWin32Config commentStamp: 'tty 6/15/2014 14:09' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakIA32BochsBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp

!

!SqueakIA32BochsWin32Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:17'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakCogSpur! !

CPlatformConfig subclass: #SqueakMacOSConfig
	uses: TCPlatformConfigForSqueak
	instanceVariableNames: 'buildType generateBuild generateBuildAssert generateBuildAssertITimerHeartbeat generateBuildDebug generateBuildDebugITimerHeartbeat generateBuildDebugMultiThreaded generateBuildIHeartbeatTimer generateBuildMultiThreaded generateBuildMultiThreadedAssert generateBuildMultiThreadedDebug'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOS'!

!SqueakMacOSConfig commentStamp: 'tty 6/15/2014 13:46' prior: 0!
A SqueakMacOSConfig  configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


I am not meant to be built.

SqueakMacOSBuilder 
	configureABuildFor: #ONE OF MY SUBCLASSES NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

SqueakMacOSConfig class
	uses: TCPlatformConfigForSqueak classTrait
	instanceVariableNames: ''!

!SqueakMacOSConfig class methodsFor: 'as yet unclassified' stamp: 'tty 6/8/2014 14:25'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder  default  allBuildConfigurations! !

!SqueakMacOSConfig methodsFor: 'cmake' stamp: 'tty 6/8/2014 19:15'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default allBuildConfigurations copyWithoutAll:#(#assert #assertWithHeartbeatTimer #debugMultiThreadedFFI #debugWithHeartbeatTimer #releaseHeartbeatTimer )
! !

!SqueakMacOSConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/7/2014 17:00'!
buildDir
	^ buildDir ifNil: [ buildDir := ( self topDir / self buildDirName) assureExistence].! !

!SqueakMacOSConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/12/2014 12:08'!
buildDirName
	buildType isNil
		ifTrue:[^self dirBuildPlatform, FileDirectory slash, self dirBuildLanguageVMMM, FileDirectory slash, 'build']
		ifFalse:[^self dirBuildPlatform, FileDirectory slash, self dirBuildLanguageVMMM, FileDirectory slash, buildType asString]! !

!SqueakMacOSConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/7/2014 15:18'!
buildType: aSymbol
	buildType:= aSymbol! !

!SqueakMacOSConfig methodsFor: 'compiler flags' stamp: 'tty 6/16/2014 20:15'!
compilerFlags
	|d commonFlags flags|
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self compilerFlagsBuild];
		at: #buildAssert  put: [self compilerFlagsAssert];
		at: #buildAssertITimerHeartbeat  put: [self compilerFlagsAssertITimerHeartbeat];
            at:#buildDebug  put: [self compilerFlagsDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self compilerFlagsDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self compilerFlagsIHeartbeatTimer];
		at: #buildMultiThreaded  put: [self compilerFlagsMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self compilerFlagsMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self compilerFlagsMultiThreadedDebug ];
		at: #buildNone put:[self compilerFlagsNoBuildType].

    flags:= String streamContents: [ :stream |
	 (((d at:  buildType) value)  collect: #withBlanksTrimmed as: Set)
		asStringOn: stream 
		delimiter:' '].

    commonFlags:=String streamContents: [ :stream |
		((self commonCompilerFlags) collect: #withBlanksTrimmed as: Set)
			asStringOn: stream 
			delimiter: ' ' ].
	^ commonFlags, ' ' ,flags.! !

!SqueakMacOSConfig methodsFor: 'cmake configuration' stamp: 'tty 6/16/2014 20:55'!
configureBuild
	"configure this Configuration for a buildType #build"
	self 
		preferredIncludesBuild;
		standardIncludesBuild;
		compilerFlagsBuild;
		internalPluginsBuild;
		externalPluginsBuild;
		thirdpartyLibsBuild
		


		
		
		! !

!SqueakMacOSConfig methodsFor: 'cmake configuration' stamp: 'tty 6/16/2014 20:15'!
configureForBuildType: aSymbol
	| d |
	"provide a concrete builder with the buildType and configureBuildX method to invoke"
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	self configureNoBuildType.                "reset all internal flags"
	d 
		at: #build 
		put: [self buildType:#build.  self configureBuild];

		at: #buildAssert 
		put: [self buildType: #buildAssert.  	self configureBuildAssert];

		at: #buildAssertITimerHeartbeat 
		put:     [ self buildType: #buildAssertITimerHeartbeat.   self configureBuildAssertITimerHeartbeat];

            at:#buildDebug 
		put: [self buildType: #buildDebug.  self configureBuildDebug];

		at: #buildDebugITimerHeartbeat 
		put:  [self buildType: #buildDebugITimerHeartbeat.   self configureBuildDebugITimerHeartbeat];

		at: #buildITimerHeartbeat 
		put: [self buildType:#buildITimerHeartbeat.    self configureBuildIHeartbeatTimer];

		at: #buildMultiThreaded 
		put:  [self buildType:#buildMultiThreaded . self configureBuildMultiThreaded];

		at: #buildMultiThreadedAssert 
		put: [self buildType: #buildMultiThreadedAssert. self configureBuildMultiThreadedAssert];

		at: #buildMultiThreadedDebug  
		put: [self buildType: #buildMultiThreadedDebug. self configureBuildMultiThreadedDebug].

     ^(d at: aSymbol).! !

!SqueakMacOSConfig methodsFor: 'cmake' stamp: 'tty 6/12/2014 17:10'!
configureNoBuildType
		generateBuild:=generateBuildAssert:=generateBuildAssertITimerHeartbeat:=generateBuildDebug:=generateBuildDebugITimerHeartbeat:= generateBuildDebugMultiThreaded:= generateBuildIHeartbeatTimer:= generateBuildMultiThreaded:= generateBuildMultiThreadedAssert:= generateBuildMultiThreadedDebug:=false.! !

!SqueakMacOSConfig methodsFor: 'plugins' stamp: 'tty 6/7/2014 17:34'!
defaultExternalPlugins
	"cut-n-pasted with exquisite expertise from Cog/macbuild/plugin.ext"
	^#(BochsIA32Plugin 
		CroquetPlugin 
		SqueakFFIPrims 
		SqueakSSL 
		FloatArrayPlugin 
		FloatMathPlugin 
		Mpeg3Plugin 
		UnixOSProcessPlugin
		)! !

!SqueakMacOSConfig methodsFor: 'plugins' stamp: 'tty 6/7/2014 17:32'!
defaultInternalPlugins
	"cut-n-past from Cog/macbuild/plugin.int"
	^#(ADPCMCodecPlugin 
		AioPlugin 
		AsynchFilePlugin 
		B3DAcceleratorPlugin 
		B2DPlugin 
		BitBltPlugin 
		BMPReadWriterPlugin 
		ZipPlugin 
		DropPlugin 
		DSAPrims 
		FFTPlugin 
		FilePlugin 
		HostWindowPlugin 
		IA32ABI 
		InternetConfigPlugin 
		JoystickTabletPlugin 
		JPEGReaderPlugin 
		JPEGReadWriter2Plugin 
		Klatt 
		LargeIntegers 
		LocalePlugin 
		MacMenubarPlugin 
		Matrix2x3Plugin 
		MIDIPlugin 
		MiscPrimitivePlugin 
		RePlugin 
		SecurityPlugin 
		SerialPlugin 
		SocketPlugin 
		SoundCodecPrims 
		SoundGenerationPlugin 
		SoundPlugin 
		StarSqueakPlugin 
		SurfacePlugin 
		UUIDPlugin 
		VMProfileMacSupportPlugin 
		)! !

!SqueakMacOSConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:09'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. default is squeak.cog.v3"
	^self required! !

!SqueakMacOSConfig methodsFor: 'cmake' stamp: 'tty 6/7/2014 16:21'!
dirBuildPlatform
	"the directory for the platform. example: build.linux32x86"
	^self dirMacOS! !

!SqueakMacOSConfig methodsFor: 'cmake' stamp: 'tty 6/9/2014 17:25'!
excludeFromBuild
	^true
! !

!SqueakMacOSConfig methodsFor: 'headers generation' stamp: 'tty 6/16/2014 18:01'!
generateConfigH
	"	
	used to be: 	
		self write: self configH toFile: 'config.h'
      but with variable buildTypes we need:
"
	self write: (self generateConfigH: buildType) toFile: 'config.h'   
! !

!SqueakMacOSConfig methodsFor: 'headers generation' stamp: 'tty 6/16/2014 20:15'!
generateConfigH: aBuildType
	"self write: self configH toFile: 'config.h'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self configHBuild];
		at: #buildAssert  put: [self configHBuildAssert];
		at: #buildAssertITimerHeartbeat  put: [self configHBuildAssertITimerHeartbeat];
            at:#buildDebug  put: [self configHBuildDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self configHBuildDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self configHBuildITimerHeartbeat];
		at: #buildMultiThreaded  put: [self configHBuildMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self configHBuildMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self configHBuildMultiThreadedDebug ];
		at: #buildNone put:[self configHNoBuildType].


	 ^(d at: ( aBuildType)) value



! !

!SqueakMacOSConfig methodsFor: 'initialize-release' stamp: 'tty 6/9/2014 12:27'!
initialize
	super initialize.
	"this should be in my superclass, but I do not have permission to modify it. tty"
	 generateForAssert:= generateForAssertHeartbeatTimer:= generateForDebug :=generateForDebugWithHeartbeatTimer:= generateForDebugMultiThreadedFFI:= generateForReleaseHeartbeatTimer:= generateForReleaseMultiThreadedFFI:=false! !

!SqueakMacOSConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/14/2014 15:42'!
outputDir

	"the directory where built binaries will be stored"
	^ outputDir ifNil: [ outputDir := (self topDir / self dirOutput/ self dirInstall) ]	

! !

!SqueakMacOSConfig methodsFor: 'utils' stamp: 'tty 6/16/2014 20:15'!
setGlobalOptionsAfterDetermineSystem: aMaker buildType: aBuildType
	"invoke correct setGlobalOptions for this buildType to allow per-buildType customization'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self setGlobalOptionsAfterDetermineSystemBuild: aMaker];
		at: #buildAssert  put: [self setGlobalOptionsAfterDetermineSystemBuildAssert: aMaker];
		at: #buildAssertITimerHeartbeat  put: [self setGlobalOptionsAfterDetermineSystemBuildAssertITimerHeartbeat: aMaker];
            at:#buildDebug  put: [self setGlobalOptionsAfterDetermineSystemBuildDebug: aMaker];   
		at: #buildITimerHeartbeat  put: [self setGlobalOptionsAfterDetermineSystemBuildITimerHeartbeat: aMaker];
		at: #buildMultiThreaded  put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreaded: aMaker ];
		at: #buildMultiThreadedAssert  put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreadedAssert: aMaker];
		at: #buildMultiThreadedDebug   put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreadedDebug: aMaker ];
		at: #buildNone put:[self setGlobalOptionsBuildNone: aMaker].

	 ^(d at: ( aBuildType)) value
! !

!SqueakMacOSConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/7/2014 18:04'!
srcDir
		^ srcDir ifNil: [ srcDir := (self topDir directoryNamed: 'src' )]! !

!SqueakMacOSConfig methodsFor: 'squeak compatibility' stamp: 'tty 6/7/2014 16:58'!
topDir
		^ topDir ifNil: [ topDir := FileDirectory default directoryNamed: self oscogvm ]! !

SqueakMacOSConfig subclass: #SqueakMacOSV3Config
	instanceVariableNames: 'resourcesDir'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOS'!

!SqueakMacOSV3Config commentStamp: 'tty 6/15/2014 13:46' prior: 0!
tty. This layer is should be merged with it's parent.

This is an abstract class for all Mac Carbon configurations. It is intended to share code between different concrete implementations. 

It is using a Carbon framework , which eventually will be replaced by Cocoa. (see CocoaIOSConfig and its subclasses).


I am not meant to be built.

SqueakMacOSBuilder 
	configureABuildFor: #ONE OF MY SUBCLASSES NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

SqueakMacOSV3Config subclass: #SqueakCocoaIOSConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-IOS'!

!SqueakCocoaIOSConfig commentStamp: 'tty 6/15/2014 14:06' prior: 0!
This is an abstract class for all Mac Cocoa configurations. It is intended to share code between different concrete implementations. 


I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


I am not meant to be built.

SqueakIOSBuilder 
	configureABuildFor: #ONE OF MY SUBCLASSES NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp

!

SqueakCocoaIOSConfig subclass: #SqueakCocoaIOSCogV3FamilyConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-IOS'!

!SqueakCocoaIOSCogV3FamilyConfig commentStamp: 'tty 6/15/2014 14:07' prior: 0!
This is an abstract class for all Mac Cocoa Cog VMs family. That is, for all CogVMS (StackVM, CogVM, CogMTVM, etc). 

I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


I am not meant to be built.

SqueakIOSBuilder 
	configureABuildFor: #ONE OF MY SUBCLASSES NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp






!

!SqueakCocoaIOSCogV3FamilyConfig methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 14:56'!
CFBundleIconFile

	"An application icon"
	^ 'Cog.icns'! !

!SqueakCocoaIOSCogV3FamilyConfig methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 14:56'!
CFBundleVersion
	"An application version"
	^ '6.0-pre'! !

!SqueakCocoaIOSCogV3FamilyConfig methodsFor: 'settings' stamp: 'tty 5/22/2014 14:56'!
commonCompilerFlags
	^super commonCompilerFlags,  #(
	"CLANG >>"
	'-fwrapv' "Non optimization of stackoverflow (to allow number conversions)"
	'-Wno-return-type' "to avoid clang to complain about plugins that do not return properly."	
	'-Qunused-arguments'
	"CLANG <<"
	'-funroll-loops' 
	'-fasm-blocks' 
	'-fno-inline-functions' 
	'-mfpmath=sse' 
	'-march=pentium-m' 
	'-mtune=prescott' 
	'-falign-functions=16' 
	'-fno-gcse' 
	'-std=gnu99'
	'-fmessage-length=0' 
	'-fpascal-strings' 
	'-DBUILD_FOR_OSX' 
	"'-DUSE_INLINE_MEMORY_ACCESSORS=1' "
	'-DLSB_FIRST' 
	'-DHAVE_SYS_TIME_H' 
	'-DHAVE_NANOSLEEP' 
	'-DCOGMTVM=0' 
	'-DUSE_GLOBAL_STRUCT=0' 
	'-DBASE_HEADER_SIZE=4'
	'-DENABLE_FAST_BLT')! !

!SqueakCocoaIOSCogV3FamilyConfig methodsFor: 'settings' stamp: 'tty 5/22/2014 14:56'!
compilerFlagsDebug
	^#('-g3' '-O0' '-DDEBUGVM=1')! !

!SqueakCocoaIOSCogV3FamilyConfig methodsFor: 'settings' stamp: 'tty 5/22/2014 14:56'!
compilerFlagsRelease 
	^#('-g0' '-O3' '-fomit-frame-pointer' '-DNDEBUG' '-DDEBUGVM=0')! !

!SqueakCocoaIOSCogV3FamilyConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 14:56'!
configureFFIPlugin: maker
	"extra rules for FFIPlugin"

	
	"Never generate this plugin. Because it is a legacy code.
	For Cog FFI, use ReentrantFFIPlugin  (ReentrantIA32FFIPlugin for x86) "
	
	maker doNotGenerate: true.! !

!SqueakCocoaIOSCogV3FamilyConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 14:56'!
configureHostWindowPlugin: maker
	super configureHostWindowPlugin: maker.
	maker includeDirectories: '${platformsDir}/Cross/plugins/HostWindowPlugin'.! !

!SqueakCocoaIOSCogV3FamilyConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 14:56'!
configureQuicktimePlugin: maker
	"extra rules for QuicktimePlugin"
	
	maker includeDirectories: '${platformsDir}/Cross/plugins/QuicktimePlugin'.! !

!SqueakCocoaIOSCogV3FamilyConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 14:56'!
configureSqueakSSLPlugin: maker
	maker addPlatformSources: #('sqMacSSL.c').! !

!SqueakCocoaIOSCogV3FamilyConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 14:56'!
configureSystemInfoPlugin: maker
	maker includeDirectories: '${platformsDir}/Cross/plugins/SystemInfoPlugin'.
	maker addPlatformSources: #('sqSystemInfo.m' ).! !

!SqueakCocoaIOSCogV3FamilyConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 14:56'!
configureUnixAioPlugin: maker
	maker includeDirectories: '${crossDir}/plugins/FilePlugin'.
	maker includeDirectories: '${platformsDir}/Cross/plugins/SocketPlugin'.! !

!SqueakCocoaIOSCogV3FamilyConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 14:56'!
configureUnixOSProcessPlugin: maker
	super configureHostWindowPlugin: maker.
	maker includeDirectories: '${platformsDir}/Cross/plugins/SocketPlugin'.! !

!SqueakCocoaIOSCogV3FamilyConfig methodsFor: 'source files' stamp: 'tty 5/22/2014 14:56'!
crossSources 
	^super crossSources, #(
	'sqExternalSemaphores.c'
	'sqHeapMap.c'
	'sqTicker.c')! !

!SqueakCocoaIOSCogV3FamilyConfig methodsFor: 'plugins' stamp: 'tty 6/2/2014 16:34'!
defaultExternalPlugins 
	^(self versionExternalPlugins),
		#(
		UUIDPlugin
		FloatMathPlugin
		AsynchFilePlugin
		Mpeg3Plugin
		CroquetPlugin
		JoystickTabletPlugin
		B3DAcceleratorPlugin
		JPEGReadWriter2Plugin 
		JPEGReaderPlugin
		RePlugin
		LocalePlugin
		ObjectiveCPlugin
		QuicktimePlugin
	"	TestOSAPlugin  Broken?"
		SqueakSSLPlugin
		SerialPlugin
		MIDIPlugin
	)! !

!SqueakCocoaIOSCogV3FamilyConfig methodsFor: 'plugins' stamp: 'tty 5/22/2014 15:40'!
defaultInternalPlugins
	^ #(
		ADPCMCodecPlugin
		BMPReadWriterPlugin 
		BalloonEnginePlugin 
		BitBltSimulation 
		ClipboardExtendedPlugin
		DSAPlugin 
		DeflatePlugin 
		DropPlugin 
		FFTPlugin 
		FilePlugin 
		FloatArrayPlugin 
		GeniePlugin 
		HostWindowPlugin 
		"JPEGReadWriter2Plugin 
		JPEGReaderPlugin" 
		KlattSynthesizerPlugin
		LargeIntegersPlugin 
		Matrix2x3Plugin 
		MiscPrimitivePlugin 
		"RePlugin" 
		SecurityPlugin 
		SocketPlugin 
		SoundCodecPlugin 
		SoundGenerationPlugin 
		SoundPlugin
		StarSqueakPlugin 
		SurfacePlugin 
		UnixAioPlugin
		UnixOSProcessPlugin
		)! !

!SqueakCocoaIOSCogV3FamilyConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:46'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakCocoaIOSCogV3FamilyConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:05'!
executableName
	^ self vmCogExecutableName! !

!SqueakCocoaIOSCogV3FamilyConfig methodsFor: 'source files' stamp: 'tty 5/22/2014 14:56'!
extraSources
	" mac VM using some unix sources "
	
	^super extraSources,'
	${platformsDir}/unix/vm/aio.c 
	${platformsDir}/unix/vm/sqUnixHeartbeat.c 
	${platformsDir}/unix/vm/sqUnixVMProfile.c 
	${platformsDir}/unix/vm/sqUnixThreads.c '! !

!SqueakCocoaIOSCogV3FamilyConfig methodsFor: 'source files' stamp: 'tty 5/22/2014 14:56'!
platformSources
	"files added from platform/iOS/vm dir "
	^ #(
		'Common/main.m'
		"'Common/aio.c'"
		'Common/Classes/Queue.m'
		'Common/Classes/sqMacV2Time.c'
		'Common/Classes/sqSqueakAppDelegate.m'
		'Common/Classes/sqSqueakFileDirectoryAPI.m'
		'Common/Classes/sqSqueakFileDirectoryInterface.m'
		'Common/Classes/sqSqueakInfoPlistInterface.m'
		'Common/Classes/sqSqueakMainApp.m'
		'Common/Classes/sqSqueakMainApplication.m'
		'Common/Classes/sqSqueakMainApplication+attributes.m'
		'Common/Classes/sqSqueakAttributesAPI.m'
		'Common/Classes/sqSqueakMainApplication+events.m'
		'Common/Classes/sqSqueakEventsAPI.m'
		'Common/Classes/sqSqueakMainApplication+imageReadWrite.m'
		'Common/Classes/sqSqueakMainApplication+sound.m'
		'Common/Classes/sqSqueakSoundAPI.m'
		'Common/Classes/sqSqueakMainApplication+vmAndImagePath.m'
		'Common/Classes/sqSqueakVmAndImagePathAPI.m'
		'Common/Classes/sqSqueakMainApplication+screen.m'
		'Common/Classes/sqSqueakScreenAPI.m'
		'Common/Classes/sqSqueakScreenAndWindow.m'
		'Common/Classes/sqSqueakCursorAPI.m'
		'Common/Classes/sqSqueakMainApplication+cursor.m'
		'OSX/SqueakOSXAppDelegate.m'
		'OSX/sqMacV2Browser.m'
		'OSX/sqMacUnixExternalPrims.m'
		'OSX/sqSqueakOSXApplication.m'
		'OSX/sqSqueakOSXFileDirectoryInterface.m'
		'OSX/sqSqueakOSXApplication+attributes.m'
		'OSX/sqSqueakOSXInfoPlistInterface.m'
		'OSX/sqSqueakOSXApplication+imageReadWrite.m'
		'OSX/sqSqueakOSXScreenAndWindow.m'
		'OSX/sqSqueakOSXCGView.m'
		'OSX/sqSqueakOSXOpenGLView.m'
		'OSX/SqViewClut.m'
		'OSX/BitMapConversionLogicFromX11.c'
		'OSX/SqViewBitmapConversion.m'
		'OSX/macintoshosxextra.c'
		'OSX/sqSqueakOSXApplication+cursor.m'
		'OSX/sqSqueakOSXApplication+events.m'
		'OSX/keyBoardStrokeDetails.m'
		'OSX/SqueakOSXApplication.m'
		'OSX/sqSqueakOSXClipboardAPI.m'
		'OSX/sqSqueakOSXApplication+clipboard.m'
		'OSX/sqSqueakOSXDropAPI.m'
		'iPhone/sqMacV2Memory.c'
		'iPhone/osExports.c'
	  	'Common/Classes/sqSqueakScreenAPI.m')! !

!SqueakCocoaIOSCogV3FamilyConfig methodsFor: 'accessing' stamp: 'tty 5/22/2014 14:56'!
sdkVersion 
	^'10.6'! !

!SqueakCocoaIOSCogV3FamilyConfig methodsFor: 'settings' stamp: 'tty 5/22/2014 14:56'!
setExtraTargetProperties: maker
	| plist |

	maker addFrameworks: self frameworks.

	" generated and add Info.plist file "
	plist := self plistFile.

	(FileStream forceNewFileNamed: (maker buildDir / 'Info.plist') fullName) 
		nextPutAll: plist; 
		close.

	maker 
		addProperty: 'MACOSX_BUNDLE_INFO_PLIST' 
		value: '${buildDir}/Info.plist'.  

	(FileStream forceNewFileNamed: (maker buildDir / self prefixHeaderFileName) fullName )
		nextPutAll: self precompiledHeaders;
		close.
	maker addXCodeProperty: 'GCC_PREFIX_HEADER' value: '${buildDir}/', self prefixHeaderFileName.

	maker 
		addXCodeProperty: 'PER_ARCH_CFLAGS_i386' value: '-DLSB_FIRST -mfpmath=sse -finline-functions  -fno-gcse -mtune=prescott -march=pentium-m -falign-functions=16'.
		
	"maker 
		addXCodeProperty: 'GCC_VERSION' value: '4.3'."

	maker 
		cmd: 'set_target_properties' 
		params: self executableName, ' PROPERTIES COMPILE_FLAGS "-include \"', (self buildDir / self prefixHeaderFileName) fullName, '\""'. 
		
"	maker set: 'CMAKE_C_COMPILER' to: '/usr/bin/gcc-4.2'.
	maker set: 'CMAKE_CXX_COMPILER' to: '/usr/bin/g++-4.2'.		
"
	maker set: 'EXECUTABLE_OUTPUT_PATH' toString: self outputDir fullName.
	maker set: 'RUNTIME_OUTPUT_DIRECTORY' toString: self outputDir fullName.! !

!SqueakCocoaIOSCogV3FamilyConfig methodsFor: 'settings' stamp: 'tty 5/22/2014 14:56'!
setGlobalOptions: maker

	"set any CMake global options, before declaring a project in cmake file"
	
	maker set: 'CMAKE_C_COMPILER' to: '/usr/bin/gcc'.
	maker set: 'CMAKE_CXX_COMPILER' to: '/usr/bin/g++'.! !

!SqueakCocoaIOSCogV3FamilyConfig methodsFor: 'settings' stamp: 'tty 5/22/2014 14:56'!
setGlobalOptionsAfterDetermineSystem:  maker
	maker set: 'CMAKE_OSX_DEPLOYMENT_TARGET' to: '10.5'.
	maker 
		set: 'CMAKE_OSX_SYSROOT' 
		to: '/Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX', self sdkVersion, '.sdk'! !

!SqueakCocoaIOSCogV3FamilyConfig methodsFor: 'settings' stamp: 'tty 5/22/2014 14:56'!
setResourceProperties: maker
	maker set: 'resourceDir' toString: self resourcesDir, '/ProjectBuilder'.

	maker 
		set: 'resources' 
		to: (String streamContents: [ :stream | 
			self  resources
				do: [ :each | 
					stream 
						nextPut: $";
						nextPutAll: '${resourceDir}/';
						nextPutAll: each;
						nextPut: $"]
				separatedBy: [ stream space ] ]).
		
	maker 
		set: 'resourcesLocaleEnglish' 
		to: '"${resourceDir}/English.lproj/InfoPlist.strings" "${resourceDir}/English.lproj/MainMenu.nib"'.

	maker 
		cmd: 'set_source_files_properties' 
		params: '${resources} PROPERTIES MACOSX_PACKAGE_LOCATION Resources'.

	maker 
		cmd: 'set_source_files_properties' 
		params: '${resourcesLocaleEnglish} PROPERTIES MACOSX_PACKAGE_LOCATION Resources/English.lproj'.

! !

!SqueakCocoaIOSCogV3FamilyConfig methodsFor: 'source files' stamp: 'tty 5/22/2014 14:56'!
standardIncludes
	^#(
	'${srcDir}/vm'
	'${platformsDir}/iOS/vm/OSX'
	'${platformsDir}/unix/vm'
	'${platformsDir}/iOS/vm/Common/Classes'
	'${platformsDir}/iOS/plugins/SoundPlugin'
	'${platformsDir}/iOS/vm/OSX/plugins/SoundPlugin'
	'${crossDir}/plugins/SoundPlugin'
	'${crossDir}/plugins/HostWindowPlugin'
	'${platformsDir}/Cross/plugins/HostWindowPlugin'
	'${platformsDir}/iOS/vm/iPhone/plugins/HostWindowPlugin' "Sources are here :("
	'${crossDir}/plugins/FilePlugin'
	)	
! !

!SqueakCocoaIOSCogV3FamilyConfig methodsFor: 'plugins' stamp: 'tty 5/22/2014 14:56'!
versionExternalPlugins 
	"Cog Version Specific Plugins. Some times you can't use same plugins in a version (for instance, CogMT uses a diferent FFI, and you can't build IA32ABIPlugin in MT for now)"
	^Array 
		with: #FFIPlugin
		with: #IA32ABIPlugin! !

SqueakCocoaIOSCogV3FamilyConfig subclass: #SqueakCocoaIOSSqueakCogV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-IOS'!

!SqueakCocoaIOSSqueakCogV3Config commentStamp: 'tty 6/15/2014 14:07' prior: 0!
This is a concrete class which generates a CogVM for Mac using the Cocoa library

I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


SqueakIOSBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

SqueakCocoaIOSSqueakCogV3Config subclass: #SqueakCocoaIOSCogV3MultiThreadedConfigz
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-IslandOfMisfitToys'!

!SqueakCocoaIOSCogV3MultiThreadedConfigz commentStamp: 'tty 6/7/2014 10:45' prior: 0!
This is a concrete class which generates a thread-aware VM and threaded FFI CogVM for Mac using the Cocoa library. This VM is normally known as CogMTVM.

For more information, check the class comments of all the superclasses.


Usage:
  SqueakCocoaIOSCogV3MultiThreadedConfig generate
Or:
  SqueakCocoaIOSCogV3MultiThreadedConfig generateWithSources
Or:
find my Builder in CMakeVMMakerSqueak-Builder category and use that to query me or invoke me

!

!SqueakCocoaIOSCogV3MultiThreadedConfigz methodsFor: 'settings' stamp: 'tty 5/22/2014 15:36'!
commonCompilerFlags
	^super commonCompilerFlags, #('-DCOGMTVM=1')! !

!SqueakCocoaIOSCogV3MultiThreadedConfigz methodsFor: 'source files' stamp: 'tty 5/22/2014 15:36'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerpmt.c'
		)! !

!SqueakCocoaIOSCogV3MultiThreadedConfigz methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:46'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakCocoaIOSCogV3MultiThreadedConfigz methodsFor: 'accessing' stamp: 'tty 5/22/2014 15:36'!
executableName
	^ 'CogMTVM'! !

!SqueakCocoaIOSCogV3MultiThreadedConfigz methodsFor: 'source generation' stamp: 'tty 5/22/2014 15:36'!
interpreterClass
	"answer an interpreter class for VM source code generation"
	^ CoInterpreterMT! !

!SqueakCocoaIOSCogV3MultiThreadedConfigz methodsFor: 'plugins' stamp: 'tty 5/22/2014 15:37'!
versionExternalPlugins 
	^#()! !

!SqueakCocoaIOSSqueakCogV3Config methodsFor: 'source generation' stamp: 'tty 5/22/2014 14:58'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!SqueakCocoaIOSSqueakCogV3Config methodsFor: 'settings' stamp: 'tty 5/22/2014 14:58'!
commonCompilerFlags
	^super commonCompilerFlags, #('-DCOGVM')! !

!SqueakCocoaIOSSqueakCogV3Config methodsFor: 'source files' stamp: 'tty 5/22/2014 14:58'!
coreSources 
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!SqueakCocoaIOSSqueakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:17'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakCogV3! !

!SqueakCocoaIOSSqueakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:46'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakCocoaIOSSqueakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:05'!
executableName
	^ self vmCogExecutableName! !

!SqueakCocoaIOSSqueakCogV3Config methodsFor: 'source generation' stamp: 'tty 5/22/2014 14:58'!
interpreterClass
	^ CoInterpreter! !

!SqueakCocoaIOSSqueakCogV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 14:58'!
pluginsDir 
	^'${srcDir}/plugins'! !

!SqueakCocoaIOSSqueakCogV3Config methodsFor: 'source generation' stamp: 'tty 5/22/2014 14:58'!
prepareForGeneration
	^ self prepareForCogGeneration
! !

!SqueakCocoaIOSSqueakCogV3Config methodsFor: 'plugins' stamp: 'tty 5/22/2014 14:58'!
versionExternalPlugins 
	^Array 
		with: #ThreadedIA32FFIPlugin
		with: #IA32ABIPlugin! !

SqueakCocoaIOSCogV3FamilyConfig subclass: #SqueakCocoaIOSSqueakStackV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-IOS'!

!SqueakCocoaIOSSqueakStackV3Config commentStamp: 'tty 6/15/2014 14:07' prior: 0!
This is a concrete class which generates a StackVM for Mac using the Cocoa library

For more information, check the class comments of all the superclasses.


I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakIOSBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!SqueakCocoaIOSSqueakStackV3Config methodsFor: 'settings' stamp: 'tty 5/22/2014 15:44'!
commonCompilerFlags 
	^ super commonCompilerFlags! !

!SqueakCocoaIOSSqueakStackV3Config methodsFor: 'source files' stamp: 'tty 5/22/2014 15:44'!
coreSources 
	^ #(
		'gcc3x-interp.c'
		)! !

!SqueakCocoaIOSSqueakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:17'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackV3! !

!SqueakCocoaIOSSqueakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:46'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakCocoaIOSSqueakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:05'!
executableName
	^ self vmStackExecutableName! !

!SqueakCocoaIOSSqueakStackV3Config methodsFor: 'source generation' stamp: 'tty 5/22/2014 15:44'!
interpreterClass
	^ StackInterpreter! !

!SqueakCocoaIOSSqueakStackV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 15:44'!
pluginsDir 
	^'${srcDir}/plugins'! !

!SqueakCocoaIOSSqueakStackV3Config methodsFor: 'source generation' stamp: 'tty 5/22/2014 15:44'!
prepareForGeneration
	^ self prepareForStackVMGeneration
! !

!SqueakCocoaIOSSqueakStackV3Config methodsFor: 'settings' stamp: 'tty 5/22/2014 15:44'!
setGlobalOptions: maker
   super setGlobalOptions: maker.
   maker set: 'CMAKE_C_COMPILER' to: 'clang'.
   maker set: 'CMAKE_CXX_COMPILER' to: 'clang++'.! !

!SqueakCocoaIOSSqueakStackV3Config methodsFor: 'plugins' stamp: 'tty 5/22/2014 15:44'!
versionExternalPlugins 
	^Array 
		with: #ThreadedIA32FFIPlugin
		with: #IA32ABIPlugin! !

SqueakCocoaIOSSqueakStackV3Config subclass: #SqueakCocoaIOSStackV3CLANGConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-IOS'!

!SqueakCocoaIOSStackV3CLANGConfig commentStamp: 'tty 6/15/2014 14:07' prior: 0!
Experimental configuration for compiling using clang compiler

For more information, check the class comments of all the superclasses.


I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakIOSBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!SqueakCocoaIOSStackV3CLANGConfig methodsFor: 'source files' stamp: 'tty 5/22/2014 15:55'!
coreSources 
" can't use GCC stuff "
	^ #(
		'interp.c'
		)! !

!SqueakCocoaIOSStackV3CLANGConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:18'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackV3! !

!SqueakCocoaIOSStackV3CLANGConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:46'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakCocoaIOSStackV3CLANGConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:04'!
executableName
	^ self vmStackExecutableName! !

!SqueakCocoaIOSStackV3CLANGConfig methodsFor: 'settings' stamp: 'tty 5/22/2014 15:55'!
setExtraTargetProperties: maker


	maker set: 'CMAKE_C_COMPILER' to: 'clang'.
	
	super setExtraTargetProperties: maker! !

!SqueakCocoaIOSStackV3CLANGConfig methodsFor: 'settings' stamp: 'tty 5/22/2014 15:55'!
setGlobalOptions: maker
	maker set: 'CMAKE_C_COMPILER' to: '/usr/bin/clang'.
	maker set: 'CMAKE_CXX_COMPILER' to: '/usr/bin/clang++'.! !

SqueakCocoaIOSSqueakStackV3Config subclass: #SqueakIPhoneSqueakStackV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-IOS'!

!SqueakIPhoneSqueakStackV3Config commentStamp: 'tty 6/15/2014 14:07' prior: 0!
A SqueakStackIPhoneConfig 


SqueakIOSBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

SqueakIPhoneSqueakStackV3Config subclass: #SqueakIPhoneSimulatorSqueakStackV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-IOS'!

!SqueakIPhoneSimulatorSqueakStackV3Config commentStamp: 'tty 6/15/2014 14:07' prior: 0!
N.B. tty.

Honestly, I have know idea how to use this (:


SqueakIOSBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!SqueakIPhoneSimulatorSqueakStackV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 16:28'!
architecture 
	^'i386'! !

!SqueakIPhoneSimulatorSqueakStackV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 16:28'!
commonCompilerFlags
	^ super commonCompilerFlags, {
		'-mios-simulator-version-min={1}' format: { self sdkVersion } }! !

!SqueakIPhoneSimulatorSqueakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:18'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackV3! !

!SqueakIPhoneSimulatorSqueakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:47'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakIPhoneSimulatorSqueakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:04'!
executableName
	^ self vmStackExecutableName! !

!SqueakIPhoneSimulatorSqueakStackV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 16:28'!
ft2PluginConfigurationFlags 
	^ {'--without-zlib'.
		'--without-bzip2'.
		'--host=i386-apple-darwin'.
		'--enable-static=yes'. 
		'--enable-shared=no'.
		'CFLAGS=\\"-arch {1} -pipe -std=c99 -Wno-trigraphs -O2 -fpascal-strings -fwrapv -Wreturn-type -Wunused-variable -fvisibility=hidden -fmessage-length=0 -mios-simulator-version-min={3}  -I{2}/usr/include/libxml2 -isysroot {2}\\"'.
		'LDFLAGS=\\"-arch {1} -mios-simulator-version-min={3} -isysroot {2}\\"' }
		collect: [ :each | 
			each format: { 
				self architecture. 
				self sysroot. 
				self sdkVersion } ]! !

!SqueakIPhoneSimulatorSqueakStackV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 16:28'!
sdkTarget 
	^'iphonesimulator', self sdkVersion! !

!SqueakIPhoneSimulatorSqueakStackV3Config methodsFor: 'settings' stamp: 'tty 5/22/2014 16:28'!
setCommonProperties: maker 
	maker set: 'CMAKE_CROSSCOMPILING' to: 'TRUE'.
	maker set: 'CMAKE_SYSTEM_NAME' to: 'Darwin'.
	maker set: 'CMAKE_SYSTEM_PROCESSOR' to: 'i386'.

	maker 
		set: 'SDKVER' 
		toString: self sdkVersion.
	maker 
		set: 'DEVROOT' 
		toString: ('/Applications/Xcode.app/Contents/Developer/Platforms/{1}.platform/Developer' 
			format: { self targetDevice }).
	maker 
		set: 'SDKROOT' 
		toString: ('$\{DEVROOT\}/SDKs/{1}$\{SDKVER\}.sdk' format: { self targetDevice }).

	maker set: 'CMAKE_OSX_SYSROOT' to: self sysroot.
		
	maker set: 'CMAKE_FIND_ROOT_PATH' to: '"${SDKROOT}" "${DEVROOT}"'.
	maker set: 'CMAKE_FIND_ROOT_PATH_MODE_PROGRAM' to: 'ONLY'.
	maker set: 'CMAKE_FIND_ROOT_PATH_MODE_LIBRARY' to: 'ONLY'.
	maker set: 'CMAKE_FIND_ROOT_PATH_MODE_INCLUDE' to: 'ONLY'.
	
	maker 
		set: 'CMAKE_EXE_LINKER_FLAGS' 
		toString: '-mios-simulator-version-min=${SDKVER} --sysroot ${SDKROOT} -L${SDKROOT}/usr/lib -L${SDKROOT}/usr/lib/system'.
	maker 
		set: 'CMAKE_C_FLAGS' 
		toString: '--sysroot ${SDKROOT} -L${SDKROOT}/usr/lib -L${SDKROOT}/usr/lib/system'.
	maker 
		set: 'CMAKE_CXX_FLAGS' 
		toString: '--sysroot ${SDKROOT} -L${SDKROOT}/usr/lib -L${SDKROOT}/usr/lib/system'.

	maker addFrameworks: self frameworks.! !

!SqueakIPhoneSimulatorSqueakStackV3Config methodsFor: 'source files' stamp: 'tty 5/22/2014 16:28'!
standardIncludes 
	^super standardIncludes, {
		'/Applications/Xcode.app/Contents/Developer/Platforms/{1}.platform/Developer/SDKs/{1}{2}.sdk/usr/include/'
			format: { 
				self targetDevice. 
				self sdkVersion} }
		 ! !

!SqueakIPhoneSimulatorSqueakStackV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 16:28'!
targetDevice 
	^'iPhoneSimulator'! !

!SqueakIPhoneSqueakStackV3Config class methodsFor: 'accessing' stamp: 'tty 5/22/2014 16:04'!
deviceIPad 
	^#(2)! !

!SqueakIPhoneSqueakStackV3Config class methodsFor: 'accessing' stamp: 'tty 5/22/2014 16:04'!
deviceIPhone 
	^#(1)! !

!SqueakIPhoneSqueakStackV3Config class methodsFor: 'accessing' stamp: 'tty 5/22/2014 16:04'!
deviceUniversal 
	^#(1 2)! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 16:04'!
CFBundleIconFile 
	"512 x512 icon"
	^'Cog.png'! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 16:04'!
CFBundleIconFile1024
	"1024x1024 icon"
	^'Cog.png'! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 16:04'!
CFBundleIconFile57 
	"57x57 icon"
	^'Cog.png'! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 16:04'!
CFBundleIconFile72
	"72x72 icon"
	^'Cog.png'! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 16:04'!
CFBundleVersion
	^'1.0.0'! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 16:04'!
ImageIsScrollable
	^false! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 16:04'!
ImageIsWritable
	^true! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 16:04'!
UIDeviceFamily
	^self targetedDeviceFamilyAsTemplateString! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 16:04'!
UIFileSharingEnabled
	^false! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 16:04'!
VMMemorySize
	^1024 * 1024 * 64 "64M"! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 16:04'!
WebViewAsUI
	^false! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 16:04'!
WebViewUrl
	^'http://localhost:8080'! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 16:04'!
architecture 
	^'armv7'! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'build script' stamp: 'tty 5/22/2014 16:04'!
buildScript
	"answer the build script for building everything"
	

	^ 
'#!!/usr/bin/env bash

set -e 

if [ !! -e vmVersionInfo.h ]; then
	../scripts/extract-commit-info.sh
fi
cmake .
make 
find ../{1}/{2}.app/Contents -type f -exec mv ''\{\}'' ../{1}/{2}.app \\;
rm -Rf ../{1}/{2}.app/Contents
' format: { self outputDirName. self executableName }! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 16:04'!
codeSignIdentity 
	^'iPhone Developer'! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'settings' stamp: 'tty 5/22/2014 16:04'!
commonCompilerFlags
	"Common compiler flags"
	^{
	'-arch {1}' format: { self architecture }.
	"CLANG >>"
	'-fwrapv'. "Non optimization of stackoverflow (to allow number conversions)"
	'-Wno-return-type'. "to avoid clang to complain about plugins that do not return properly."	
	'-Qunused-arguments'.
	"CLANG <<"	
	'-isysroot {1}' format: { self sysroot }.
	'-x objective-c'.
	'-std=gnu99'.
	'-falign-functions=16'.
	'-fno-gcse'.
	'-fvisibility=hidden'.
	'-funroll-loops'.
	'-finline-functions'.
	'-mno-thumb'.
	'-DSTACKVM=1'.
	'-DCOGMTVM=0'. 
	'-DUSE_GLOBAL_STRUCT=0'. 
	'-DBASE_HEADER_SIZE=4'.
	'-DTARGET_OS_IS_IPHONE'.
	'-DHAVE_UUID_GENERATE'.
	'-DHAVE_SYS_TIME_H'.
	'-DLSB_FIRST'.
	'-DHAVE_NANOSLEEP'.
	'-DISQUEAK_IMAGE={1}' format: { self imageName }.
	'-DISQUEAK_SOURCES=PharoV10'.
	'-DSTACKVM'}! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'settings' stamp: 'tty 5/22/2014 16:04'!
compilerFlagsDebug
	^#('-g3' '-O0' '-DDEBUGVM=1')! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'settings' stamp: 'tty 5/22/2014 16:04'!
compilerFlagsRelease
	^#('-g0' '-O3' '-fomit-frame-pointer' '-DNDEBUG' '-DDEBUGVM=0')! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 16:04'!
configureFT2Plugin: maker
	"extra rules for Freetype plugin.
	a custom rule to build freetype library"
	| lib |

	"add freetype library into loop"
	lib := self addThirdpartyLibrary: 'freetype2'.
	lib configurationFlags: self ft2PluginConfigurationFlags.

	"link plugin with freetype lib"
	maker includeDirectories: lib includeDir. 
	maker addExternalLibrary: '${thirdpartyDir}/out/lib/', lib libraryFileName.
	maker addExternalDependency: 'freetype2'.
! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 16:04'!
configureHostWindowPlugin: maker
	maker includeDirectories: '${platformsDir}/Cross/plugins/HostWindowPlugin'.	
	maker 
		addSources: #('sqMacHostWindow.m' ) 
		prefixed: '${platformsDir}/iOS/vm/iPhone/plugins/HostWindowPlugin/'
! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 16:04'!
configureIOSPlugin: maker
	maker 
		addSources: #('sqTouch.m' ) 
		prefixed: '${platformsDir}/iOS/vm/iPhone/plugins/IOSPlugin/'
	 
! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 16:04'!
configureSocketPlugin: maker
	super configureSocketPlugin: maker.
	maker includeDirectories: '${SDKROOT}/usr/include'.  "for tcp.h"! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'settings' stamp: 'tty 5/22/2014 16:04'!
defaultExternalPlugins 
	^#()! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'settings' stamp: 'tty 5/22/2014 16:07'!
defaultInternalPlugins
	^ #(
		ADPCMCodecPlugin
		BMPReadWriterPlugin 
		BalloonEnginePlugin 
		BitBltSimulation 
		DSAPlugin 
		DeflatePlugin 
		"DropPlugin"
		LocalePlugin 
		FFTPlugin 
		FilePlugin 
		FloatArrayPlugin 
		HostWindowPlugin 
		JPEGReadWriter2Plugin 
		JPEGReaderPlugin 
		LargeIntegersPlugin 
		Matrix2x3Plugin 
		MiscPrimitivePlugin 
		"RePlugin" 
		SecurityPlugin 
		SocketPlugin
		SoundCodecPlugin 
		SoundGenerationPlugin 
		SoundPlugin
		SurfacePlugin
		UUIDPlugin
	"	ObjectiveCPlugin 
		IOSPlugin")! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 16:04'!
deploymentTargetVersion 
	^'4.0'! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:18'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackV3! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:47'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:04'!
executableName
	^ self vmStackExecutableName! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 16:04'!
extraPluginSettings: maker	
	self architecture
		ifNotNil: [ :arch | maker set: 'CMAKE_OSX_ARCHITECTURES' toString: arch ].
		
	self setCommonProperties: maker.

	maker 
		setTargetProperty: 'COMPILE_FLAGS' 
		to: '"-include \"', (self buildDir / self prefixHeaderFileName) fullName, '\""'.  

	maker isExternal ifTrue: [
		"copy result to results dir "
		maker set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir.
		maker set: 'EXECUTABLE_OUTPUT_PATH' toString: self outputDir.
		maker puts: 'list(APPEND linkFlags "-undefined dynamic_lookup")' ].
	
	"maker addXCodeProperty: 'GCC_VERSION' value: '4.3'."
	maker addXCodeProperty: 'GCC_PREFIX_HEADER' value: '${buildDir}/' , self executableName , '_Prefix.pch'.
	
! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'source files' stamp: 'tty 5/22/2014 16:04'!
extraSources
	" mac VM using some unix sources "
	
	^'${buildDir}/', self prefixHeaderFileName, ' 
${resources} ', 
'${buildDir}/', self prefixHeaderFileName, ' 
${resourcesLocaleEnglish} 
${platformsDir}/unix/vm/sqUnixHeartbeat.c  
${platformsDir}/unix/vm/sqUnixThreads.c 
${platformsDir}/unix/vm/aio.c
'! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 16:04'!
frameworks
	^ #(
	CoreAudio
	CoreGraphics
	CoreLocation
	UIKit
	CoreFoundation
	Foundation
	QuartzCore
	OpenGLES
	AudioToolbox
	SystemConfiguration)! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 16:04'!
freetypeLibClass 
	^CMIOSFreetype2! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 16:04'!
ft2PluginConfigurationFlags
	^ {'--without-zlib'.
		'--without-bzip2'.
		'--host=arm-apple-darwin'.
		'--enable-static=yes'. 
		'--enable-shared=no'.
		'CFLAGS=\\"-arch {1} -std=c99 -Wno-trigraphs -O2 -fpascal-strings -fwrapv -Wreturn-type -Wunused-variable -fvisibility=hidden -fmessage-length=0 -miphoneos-version-min={3}  -I{2}/usr/include/libxml2 -isysroot {2}\\"'.
		'LDFLAGS=\\"-arch {1} -miphoneos-version-min={3} -isysroot {2}\\"' }
		collect: [ :each | 
			each format: { 
				self architecture. 
				self sysroot. 
				self sdkVersion } ]! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 16:04'!
imageName
	^'iOS'! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'settings' stamp: 'tty 5/22/2014 16:04'!
imageResources 
	^{
	self imageName, '.changes'.
	'PharoV10.sources' }! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'source files' stamp: 'tty 5/22/2014 16:04'!
platformSources
	"files added from platform/iOS/vm dir "
	^ #(
		'Common/main.m'
		'Common/Classes/Queue.m'
		'Common/Classes/sqMacV2Time.c'
		'Common/Classes/sqSqueakAppDelegate.m'
		'Common/Classes/sqSqueakFileDirectoryAPI.m'
		'Common/Classes/sqSqueakFileDirectoryInterface.m'
		'Common/Classes/sqSqueakInfoPlistInterface.m'
		'Common/Classes/sqSqueakMainApplication.m'
		'Common/Classes/sqSqueakMainApplication+attributes.m'
		'Common/Classes/sqSqueakMainApplication+events.m'
		'Common/Classes/sqSqueakMainApplication+imageReadWrite.m'
		'Common/Classes/sqSqueakMainApplication+sound.m'
		'Common/Classes/sqSqueakMainApplication+vmAndImagePath.m'
		'Common/Classes/sqSqueakMainApplication+screen.m'
		'Common/Classes/sqSqueakMainApplication+cursor.m'
		"'Common/Classes/sqSqueakCursorAPI.m'"
		'Common/Classes/sqSqueakAttributesAPI.m'
		'Common/Classes/sqSqueakSoundAPI.m'
		'Common/Classes/sqSqueakVmAndImagePathAPI.m'
		'Common/Classes/sqSqueakMainApp.m'
		'Common/Classes/sqSqueakEventsAPI.m'
		'Common/Classes/sqSqueakScreenAPI.m'
		'Common/Classes/sqSqueakScreenAndWindow.m'
		'iPhone/Classes/SqueakNoOGLIPhoneAppDelegate.m'
		'iPhone/Classes/sqSqueakIPhoneApplication.m'
		'iPhone/Classes/sqSqueakIPhoneApplication+attributes.m'
		'iPhone/Classes/sqSqueakIPhoneApplication+clipboard.m'
		'iPhone/Classes/sqSqueakIPhoneApplication+imageReadWrite.m'
		'iPhone/Classes/sqSqueakIPhoneApplication+events.m'
		'iPhone/Classes/sqSqueakIPhoneApplication+Network.m'
		'iPhone/Classes/sqSqueakiPhoneApplication+sound.m'
		'iPhone/Classes/sqSqueakIPhoneFileDirectoryInterface.m'
		'iPhone/Classes/sqSqueakIPhoneInfoPlistInterface.m'
		'iPhone/Classes/sqiPhoneScreenAndWindow.m'
		'iPhone/Classes/SqueakUIView.m'
		'iPhone/Classes/SqueakUIViewCALayer.m'
		'iPhone/Classes/SqueakUIViewOpenGL.m'
		'iPhone/Classes/SqueakUIController.m'
		'iPhone/Classes/sqSqueakIPhoneClipboardAPI.m'
		'iPhone/macintoshextra.c'
		'iPhone/osExports.c'
		"'iPhone/sqDummyaio.c'" "I'm using real aio.c from unix (and seems to work)"
		'iPhone/sqMacV2Memory.c'
		'iPhone/sqMacUnixExternalPrims.m'
		)! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 16:04'!
plistKeys 
	^super plistKeys, 
	#(CFBundleIconFile57 
	CFBundleIconFile72 
	CFBundleIconFile1024
	CFBundleVersion
	UIDeviceFamily 
	UIFileSharingEnabled
	VMMemorySize
	ImageIsWritable
	ImageIsScrollable
	WebViewAsUI
	WebViewUrl)
! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 16:04'!
plistTemplate 
	^'<?xml version="1.0" encoding="UTF-8"?>
<!!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
<plist version="1.0">
<dict>
	<key>CFBundleDevelopmentRegion</key>
	<string>en</string>
	<key>CFBundleVersion</key>
	<string>@CFBundleVersion@</string>
	<key>CFBundleDisplayName</key>
	<string>@CFBundleExecutable@</string>
	<key>CFBundleExecutable</key>
	<string>@CFBundleExecutable@</string>
	<key>CFBundleIconFile</key>
	<string>@CFBundleIconFile@</string>
	<key>CFBundleIconFiles</key>
	<array>
		<string>@CFBundleIconFile@</string>
		<string>@CFBundleIconFile57@</string>
		<string>@CFBundleIconFile72@</string>
		<string>@CFBundleIconFile1024@</string>
	</array>	
	<key>CFBundleIdentifier</key>
	<string>@CFBundleIdentifier@</string>
	<key>CFBundleInfoDictionaryVersion</key>
	<string>6.0</string>
	<key>CFBundleName</key>
	<string>@CFBundleName@</string>
	<key>CFBundlePackageType</key>
	<string>APPL</string>
	<key>CFBundleResourceSpecification</key>
	<string>ResourceRules.plist</string>
	<key>CFBundleSignature</key>
	<string>FRAC</string>
	<key>CFBundleSupportedPlatforms</key>
	<array>
		<string>iPhoneOS</string>
	</array>
	<key>LSRequiresIPhoneOS</key>
	<true/>
	<key>MinimumOSVersion</key>
	<string>3.1.3</string>
	<key>NSMainNibFile</key>
	<string>MainWindow</string>
	<key>UIDeviceFamily</key>
	<array>
		@UIDeviceFamily@
	</array>
	<key>UIPrerenderedIcon</key>
	<false/>
	<key>UIStatusBarHidden</key>
	<true/>
	<key>UIFileSharingEnabled</key>
	<@UIFileSharingEnabled@/>
	<key>ImageIsWritable</key>
	<@ImageIsWritable@/>
	<key>ImageIsScrollable</key>
	<@ImageIsScrollable@/>
	<key>VMMemorySize</key>
	<integer>@VMMemorySize@</integer>
	<key>WebViewAsUI</key>
	<@WebViewAsUI@/>
	<key>WebViewUrl</key>
	<string>@WebViewUrl@</string>
</dict>
</plist>
'! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'settings' stamp: 'tty 5/22/2014 16:04'!
precompiledImports 
	^#(
	'Foundation/Foundation.h' 
	'UIKit/UIKit.h')! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'settings' stamp: 'tty 5/22/2014 16:04'!
resources 
	^{
	self CFBundleIconFile.
	self CFBundleIconFile57.
	self CFBundleIconFile72.
	self CFBundleIconFile1024.
	self imageName, '.image'}, 
	self imageResources
		! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 16:04'!
resourcesDir 
	"Answer the value of resourcesDir"
	^ resourcesDir ifNil: [ resourcesDir := (self topDir / 'iosbuild' / 'resources') fullName ]! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 16:04'!
sdkTarget 
	^'iphoneos', self sdkVersion! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 16:04'!
sdkVersion 
	^'7.0'! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'settings' stamp: 'tty 5/22/2014 16:04'!
setCommonProperties: maker 
	maker set: 'CMAKE_CROSSCOMPILING' to: 'TRUE'.
	maker set: 'CMAKE_SYSTEM_NAME' to: 'Darwin'.
	maker set: 'CMAKE_SYSTEM_PROCESSOR' to: 'arm'.

	maker set: 'SDKVER' toString: self sdkVersion.
	maker 
		set: 'DEVROOT' 
		toString: ('/Applications/Xcode.app/Contents/Developer/Platforms/{1}.platform/Developer'
			format: { self targetDevice }).
	maker 
		set: 'SDKROOT' 
		toString: '${DEVROOT}/SDKs/', self targetDevice,'${SDKVER}.sdk'.

	maker set: 'CMAKE_OSX_SYSROOT' to: 'iphoneos${SDKVER}'.
		
	maker set: 'CMAKE_FIND_ROOT_PATH' to: '"${SDKROOT}" "${DEVROOT}"'.
	maker set: 'CMAKE_FIND_ROOT_PATH_MODE_PROGRAM' to: 'ONLY'.
	maker set: 'CMAKE_FIND_ROOT_PATH_MODE_LIBRARY' to: 'ONLY'.
	maker set: 'CMAKE_FIND_ROOT_PATH_MODE_INCLUDE' to: 'ONLY'.
	
	maker set: 'CMAKE_EXE_LINKER_FLAGS' toString: '--sysroot ${SDKROOT} -L${SDKROOT}/usr/lib -L${SDKROOT}/usr/lib/system'.
	maker set: 'CMAKE_C_FLAGS' toString: '--sysroot ${SDKROOT} -L${SDKROOT}/usr/lib -L${SDKROOT}/usr/lib/system'.
	maker set: 'CMAKE_CXX_FLAGS' toString: '--sysroot ${SDKROOT} -L${SDKROOT}/usr/lib -L${SDKROOT}/usr/lib/system'.

	maker addFrameworks: self frameworks.! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'settings' stamp: 'tty 5/22/2014 16:04'!
setExtraTargetProperties: maker
	"super setExtraTargetProperties: maker."

	| precompiledHeaders plist |
	
	precompiledHeaders := (self executableName, '_Prefix.pch').
	(FileStream forceNewFileNamed: (maker buildDir / precompiledHeaders) fullName) 
		nextPutAll: self precompiledHeaders;
		close.
	
	maker addXCodeProperty: 'GCC_PREFIX_HEADER' value: '${buildDir}/', precompiledHeaders.
	
	self setCommonProperties: maker.

	" generated and add Info.plist file "
	plist := self plistFile.
	(FileStream forceNewFileNamed: (maker buildDir / 'Info.plist') fullName) 
		nextPutAll: plist; 
		close.

	maker addProperty: 'MACOSX_BUNDLE_INFO_PLIST' value: '${buildDir}/Info.plist'.  
	maker 
		cmd: 'set_target_properties' 
		params: self executableName, ' PROPERTIES COMPILE_FLAGS "-include \"', (self buildDir / self prefixHeaderFileName) fullName, '\""'. 

	maker 
		set: 'CMAKE_XCODE_ATTRIBUTE_CODE_SIGN_IDENTITY' 
		toString: self codeSignIdentity.
	maker 
		set: 'CMAKE_XCODE_ATTRIBUTE_TARGETED_DEVICE_FAMILY' 
		toString: self targetedDeviceFamilyAsString.
	maker 
		set: 'CMAKE_XCODE_ATTRIBUTE_IPHONEOS_DEPLOYMENT_TARGET' 
		to: self deploymentTargetVersion.
	maker 
		set: 'CMAKE_XCODE_ATTRIBUTE_CONFIGURATION_BUILD_DIR' 
		toString: '$(BUILD_DIR)/$(CONFIGURATION)'.
	maker 
		set: 'CMAKE_XCODE_ATTRIBUTE_CONFIGURATION_TEMP_DIR' 
		toString: '$(BUILD_DIR)/$(CONFIGURATION)'.

	maker set: 'EXECUTABLE_OUTPUT_PATH' toString: self outputDir fullName.
	
	maker puts: 'set_source_files_properties(${srcVMDir}/gcc3x-cointerp.c PROPERTIES COMPILE_FLAGS -O0)'.


! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'settings' stamp: 'tty 5/22/2014 16:04'!
setGlobalOptions: maker
	"set any CMake global options, before declaring a project in cmake file"
	
"	maker 
		set: 'CMAKE_C_COMPILER' 
		to: ('/Applications/Xcode.app/Contents/Developer/Platforms/{target}.platform/Developer/usr/bin/gcc'
			nameFormat: {'target' -> self targetDevice} asDictionary).
	maker 
		set: 'CMAKE_CXX_COMPILER' 
		to: ('/Applications/Xcode.app/Contents/Developer/Platforms/{target}.platform/Developer/usr/bin/g++'
			nameFormat: {'target' -> self targetDevice } asDictionary).	
	self architecture ifNotNil: [
		maker set: 'CMAKE_OSX_ARCHITECTURES' to: self architecture ]."
	! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'utils' stamp: 'tty 5/22/2014 16:04'!
setGlobalOptionsAfterDetermineSystem: maker
	self setGlobalOptions: maker.	
	maker 
		set: 'CMAKE_OSX_SYSROOT' 
		to: ('/Applications/Xcode.app/Contents/Developer/Platforms/{1}.platform/Developer/SDKs/{1}{2}.sdk'
			format: { self targetDevice. self sdkVersion })! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'settings' stamp: 'tty 5/22/2014 16:04'!
setResourceProperties: maker
	maker set: 'resourceDir' toString: self resourcesDir.

	maker 
		set: 'resources' 
		to: (String streamContents: [ :stream | 
			self  resources
				do: [ :each | 
					stream 
						nextPut: $";
						nextPutAll: '${resourceDir}/';
						nextPutAll: each;
						nextPut: $"]
				separatedBy: [ stream space ] ]).
		
	maker 
		set: 'resourcesLocaleEnglish' 
		toString: '${resourceDir}/English.lproj/MainWindow.nib'.

	maker 
		cmd: 'set_source_files_properties' 
		params: '${resources} PROPERTIES MACOSX_PACKAGE_LOCATION Resources'.

	maker 
		cmd: 'set_source_files_properties' 
		params: '${resourcesLocaleEnglish} PROPERTIES MACOSX_PACKAGE_LOCATION Resources'.
! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'source files' stamp: 'tty 5/22/2014 16:04'!
standardIncludes
	^#(
	'${srcDir}/vm'
	'${platformsDir}/iOS/vm/iPhone'
	'${platformsDir}/iOS/vm/iPhone/Classes'
	'${platformsDir}/iOS/vm/OSX'
	'${platformsDir}/unix/vm'
	'${platformsDir}/iOS/vm/Common/Classes'
	'${platformsDir}/iOS/plugins/SoundPlugin'
	'${platformsDir}/iOS/vm/OSX/plugins/SoundPlugin'
	'${crossDir}/plugins/SoundPlugin'
	'${crossDir}/plugins/HostWindowPlugin'
	'${platformsDir}/Cross/plugins/HostWindowPlugin'
	'${platformsDir}/iOS/vm/iPhone/plugins/HostWindowPlugin'
	'${crossDir}/plugins/FilePlugin'
	)	
! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 16:04'!
sysroot 
	^ '/Applications/Xcode.app/Contents/Developer/Platforms/{1}.platform/Developer/SDKs/{1}{2}.sdk' 
	format: { 
		self targetDevice. 
		self sdkVersion }! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 16:04'!
targetDevice 
	^'iPhoneOS'! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 16:04'!
targetedDeviceFamily 
	^self class deviceUniversal ! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'private' stamp: 'tty 5/22/2014 16:04'!
targetedDeviceFamilyAsString 
	^String streamContents: [ :stream | 
		self targetedDeviceFamily 
			do: [ :each | stream nextPutAll: each asString ]
			separatedBy: [ stream nextPut: $, ].
		stream nextPut: Character space ]! !

!SqueakIPhoneSqueakStackV3Config methodsFor: 'private' stamp: 'tty 5/22/2014 16:04'!
targetedDeviceFamilyAsTemplateString 
	^String streamContents: [ :stream | 
		self targetedDeviceFamily do: [ :each | 
			stream 
				nextPutAll: '<integer>';
				nextPutAll: each asString;
				nextPutAll: '</integer>' ] ]! !

!SqueakCocoaIOSConfig methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 14:49'!
CFBundleExecutable
	^ self executableName ! !

!SqueakCocoaIOSConfig methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 14:49'!
CFBundleGetInfoString
	^ self CFBundleShortVersionString
! !

!SqueakCocoaIOSConfig methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 14:49'!
CFBundleIconFile
	"An application icon"
	^ 'Squeak.icns'! !

!SqueakCocoaIOSConfig methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 14:49'!
CFBundleIdentifier
	"A Java package style name (like 'com.myCompany.MyBundle') which is used to uniquely identify bundles."
	^ 'org.squeakfoundation.Squeak'! !

!SqueakCocoaIOSConfig methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 14:49'!
CFBundleName
	"An application name"
	^ self executableName", ' (Cocoa) 32bits'"! !

!SqueakCocoaIOSConfig methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 14:49'!
CFBundleShortVersionString
	"An application version"
	^ self executableName, ' VM ' , self CFBundleVersion! !

!SqueakCocoaIOSConfig methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 14:49'!
CFBundleVersion
	"An application version"
	^ '6.0'! !

!SqueakCocoaIOSConfig methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 14:49'!
NSMainNibFile
	^'MainMenu'! !

!SqueakCocoaIOSConfig methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 14:49'!
SqueakDebug
	^self isGenerateForRelease 
		ifTrue: [ 0 ]
		ifFalse: [ 1 ]! !

!SqueakCocoaIOSConfig methodsFor: 'accessing' stamp: 'tty 5/22/2014 14:49'!
architecture 
	^'i386'! !

!SqueakCocoaIOSConfig methodsFor: 'cmake' stamp: 'tty 6/8/2014 18:50'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder  default  noBuildConfigurations
! !

!SqueakCocoaIOSConfig methodsFor: 'accessing' stamp: 'tty 5/22/2014 14:49'!
commonCompilerFlags
	"Common compiler flags"
	^{
	'-arch i386'. 
	'-mmacosx-version-min=10.5'. 
	'-DHAVE_UUID_GENERATE'. 
	'-DDEFAULT_IMAGE_NAME="', self executableName, '.image"'}! !

!SqueakCocoaIOSConfig methodsFor: 'accessing' stamp: 'tty 5/22/2014 14:49'!
compilerFlagsRelease 
	^#(
	"'-fobjc-direct-dispatch'" 
	'-msse3'
	"'-msse4.1'"
	"'-msse4.2'"
	"'-mdynamic-no-pic'" 
	"'-fwritable-strings'" 
	'-Os' 
	'-fvisibility=default'
	'-funroll-loops' 
	"'-fno-asm'" 
	'-fasm-blocks' 
	'-finline-functions' 
	'-mfpmath=sse' 
	'-fomit-frame-pointer' 
	'-march=pentium-m' 
	'-mtune=prescott' 
	'-falign-functions=16'  
	'-fno-gcse' 
	'-std=gnu99' 
	'-DBUILD_FOR_OSX' 
	"'-DUSE_INLINE_MEMORY_ACCESSORS'" 
	'-DLSB_FIRST' 
	'-DUSE_INLINE_MEMORY_ACCESSORS' 
	'-DHAVE_SYS_TIME_H' 
	'-DHAVE_NANOSLEEP' 
	'-DICC_DEBUG=0'
	'-DICC_OPTLEVEL="speedHLO"' 
	'-DICC_OPT_IPO_FOR_SINGLE_FILE_COMPILATION=1' 
	'-DICC_OPT_PARALLEL=0' 
	'-DICC_OPT_PREFETCH_INSERTION=1' 
	'-DICC_OPT_PROVIDE_FRAME_PTR=0' 
	'-DICC_OPT_USE_ARCH_IA32="SSE42"')! !

!SqueakCocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 14:49'!
configureB3DAcceleratorPlugin: maker
	"extra rules for B3DAcceleratorPlugin"
	
	super configureB3DAcceleratorPlugin: maker. 
	maker addFrameworks: self frameworks.	 
	maker addPlatformSources: #( 'sqMacOpenGL.c' 'sqMacOpenGLInfo.c')! !

!SqueakCocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 14:49'!
configureClipboardExtendedPlugin: maker
	
	maker addPlatformSources: #('sqMacExtendedClipboard.m' ) 
	! !

!SqueakCocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 14:49'!
configureHostWindowPlugin: maker
	super configureHostWindowPlugin: maker.
	maker 
		addSources: #('sqMacHostWindow.m' ) 
		prefixed: '${platformsDir}/iOS/vm/OSX/plugins/HostWindowPlugin/'
! !

!SqueakCocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 14:49'!
configureJoystickTabletPlugin: maker 
	"extra rules for JoystickTabletPlugin"
	
	super configureJoystickTabletPlugin: maker.  
	maker addPlatformSources:
		#( 
			'HID_Error_Handler.c'
			'HID_Name_Lookup.c'
			'HID_Queue_Utilities.c'
			'HID_Utilities.c'
			'sqMacJoystickAndTablet.c'
			)
! !

!SqueakCocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 14:49'!
configureLocalePlugin: maker
	maker addFrameworks: #('CoreFoundation').
	maker addPlatformSources: #( 'sqIOSLocale.c' )	.
! !

!SqueakCocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 14:49'!
configureMIDIPlugin: maker 
	"extra rules for MIDIPlugin"

	maker addPlatformSources: #( 'sqMacMIDI.m')! !

!SqueakCocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 14:49'!
configureMacMenubarPlugin: maker
	maker includeDirectories: '${platformsDir}/iOS/plugins/MacMenubarPlugin'.
	maker 
		addSources: #('MacMenuOS9ToOSX.m') 
		prefixed: '${platformsDir}/iOS/plugins/MacMenubarPlugin/'
! !

!SqueakCocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 14:49'!
configureObjectiveCPlugin: maker 
	"extra rules for ObjectiveCPlugin"

	maker addDefinitions: ' -x objective-c'.
	maker addFrameworks: self frameworks.
	maker includeDirectories: '${platformsDir}/iOS/plugins/SqueakObjectiveC'.
	maker 
		addSources: #('squeakProxy.m' 'squeakSUnitTester.m') 
		prefixed: '${platformsDir}/iOS/plugins/SqueakObjectiveC/'.
	! !

!SqueakCocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 14:49'!
configureSoundPlugin: maker
	super configureSoundPlugin: maker.
	
	maker includeDirectories: '${platformsDir}/Cross/plugins/SoundPlugin ${platformsDir}/iOS/vm/OSX/plugins/SoundPlugin'.
	maker 
		addSources: #('sqSqueakSoundCoreAudio.m' 'sqSqueakSoundCoreAudioAPI.m' ) 
		prefixed: '${platformsDir}/iOS/plugins/SoundPlugin/'.
	maker 
		addSources: #('sqSqueakOSXSoundCoreAudio.m' ) 
		prefixed: '${platformsDir}/iOS/vm/OSX/plugins/SoundPlugin/'! !

!SqueakCocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 14:49'!
configureUUIDPlugin: maker
	super configureUUIDPlugin: maker.
	maker addFrameworks: #(CoreFoundation).  
	maker addDefinitions: '-x objective-c'.  
	maker addPlatformSources: #('sqMacUUID.c' )! !

!SqueakCocoaIOSConfig methodsFor: 'source files' stamp: 'tty 5/22/2014 14:49'!
coreSources
	^#('interp.c')! !

!SqueakCocoaIOSConfig methodsFor: 'source files' stamp: 'tty 5/22/2014 14:49'!
crossSources 
	^#(
		'sqNamedPrims.c'
		'sqVirtualMachine.c')! !

!SqueakCocoaIOSConfig methodsFor: 'plugins' stamp: 'tty 5/22/2014 14:49'!
defaultExternalPlugins
	^#()! !

!SqueakCocoaIOSConfig methodsFor: 'plugins' stamp: 'tty 5/22/2014 14:49'!
defaultInternalPlugins
	^ #(
		ADPCMCodecPlugin
		BMPReadWriterPlugin 
		BalloonEnginePlugin 
		BitBltSimulation 
		ClipboardExtendedPlugin 
		DSAPlugin 
		DeflatePlugin 
		DropPlugin 
		FFIPlugin
		FFTPlugin 
		FilePlugin 
		FloatArrayPlugin 
		GeniePlugin 
		HostWindowPlugin 
		JPEGReadWriter2Plugin 
		JPEGReaderPlugin 
		KlattSynthesizerPlugin 
		LargeIntegersPlugin 
		MacMenubarPlugin 
		Matrix2x3Plugin 
		MiscPrimitivePlugin 
		RePlugin 
		SecurityPlugin 
		SocketPlugin 
		SoundCodecPlugin 
		SoundGenerationPlugin 
		SoundPlugin 
		StarSqueakPlugin 
		SurfacePlugin)! !

!SqueakCocoaIOSConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:46'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakCocoaIOSConfig methodsFor: 'accessing' stamp: 'tty 5/22/2014 14:49'!
executableType
	^ 'MACOSX_BUNDLE'! !

!SqueakCocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 14:49'!
extraPluginSettings: maker	
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'.
	
	maker 
		setTargetProperty: 'COMPILE_FLAGS' 
		to: '"-include \"', (self buildDir / self prefixHeaderFileName) fullName, '\""'.  

	maker isExternal ifTrue: [
		"copy result to results dir "
		
		maker set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir fullName.
		maker set: 'EXECUTABLE_OUTPUT_PATH' toString: self outputDir fullName.
		maker puts: 'list(APPEND linkFlags "-undefined dynamic_lookup")' ].
	
	"maker addXCodeProperty: 'GCC_VERSION' value: '4.3'."
	maker addXCodeProperty: 'GCC_PREFIX_HEADER' value: '${buildDir}/' , self executableName , '_Prefix.pch'.
	
! !

!SqueakCocoaIOSConfig methodsFor: 'source files' stamp: 'tty 5/22/2014 14:49'!
extraSources
	^'${buildDir}/', self prefixHeaderFileName, '
 ${resources} ', 
	'${buildDir}/', self prefixHeaderFileName, '
 ${resourcesLocaleEnglish}'! !

!SqueakCocoaIOSConfig methodsFor: 'settings' stamp: 'tty 5/22/2014 14:49'!
extraVMSettings: maker
	self architecture
		ifNotNil: [ :arch | maker set: 'CMAKE_OSX_ARCHITECTURES' toString: arch ].
	self setResourceProperties: maker.
! !

!SqueakCocoaIOSConfig methodsFor: 'accessing' stamp: 'tty 5/22/2014 14:49'!
frameworks
	^ #(
	Cocoa
	Foundation
	AudioToolbox
	CoreAudio
	SystemConfiguration
	ApplicationServices
	QuartzCore
	OpenGL
	AGL
	QuickTime)! !

!SqueakCocoaIOSConfig methodsFor: 'accessing' stamp: 'tty 5/22/2014 14:49'!
freetypeLibClass 
	^CMOSXFreetype2! !

!SqueakCocoaIOSConfig methodsFor: 'accessing' stamp: 'tty 5/22/2014 14:49'!
platformName 
	^'iOS'! !

!SqueakCocoaIOSConfig methodsFor: 'source files' stamp: 'tty 5/22/2014 14:49'!
platformSources
	"files added from platform/iOS/vm dir "
	^ #(
		'Common/main.m'
		'Common/aio.c'
		'Common/Classes/Queue.m'
		'Common/Classes/sqMacV2Time.c'
		'Common/Classes/sqSqueakAppDelegate.m'
		'Common/Classes/sqSqueakFileDirectoryAPI.m'
		'Common/Classes/sqSqueakFileDirectoryInterface.m'
		'Common/Classes/sqSqueakInfoPlistInterface.m'
		'Common/Classes/sqSqueakMainApp.m'
		'Common/Classes/sqSqueakMainApplication.m'
		'Common/Classes/sqSqueakMainApplication+attributes.m'
		'Common/Classes/sqSqueakAttributesAPI.m'
		'Common/Classes/sqSqueakMainApplication+events.m'
		'Common/Classes/sqSqueakEventsAPI.m'
		'Common/Classes/sqSqueakMainApplication+imageReadWrite.m'
		'Common/Classes/sqSqueakMainApplication+sound.m'
		'Common/Classes/sqSqueakSoundAPI.m'
		'Common/Classes/sqSqueakMainApplication+vmAndImagePath.m'
		'Common/Classes/sqSqueakVmAndImagePathAPI.m'
		'Common/Classes/sqSqueakMainApplication+screen.m'
		'Common/Classes/sqSqueakScreenAPI.m'
		'Common/Classes/sqSqueakScreenAndWindow.m'
		'Common/Classes/sqSqueakCursorAPI.m'
		'Common/Classes/sqSqueakMainApplication+cursor.m'
		'OSX/SqueakOSXAppDelegate.m'
		'OSX/sqMacV2Browser.m'
		'OSX/sqMacUnixExternalPrims.m'
		'OSX/sqSqueakOSXApplication.m'
		'OSX/sqSqueakOSXFileDirectoryInterface.m'
		'OSX/sqSqueakOSXApplication+attributes.m'
		'OSX/sqSqueakOSXInfoPlistInterface.m'
		'OSX/sqSqueakOSXApplication+imageReadWrite.m'
		'OSX/sqSqueakOSXScreenAndWindow.m'
		'OSX/sqSqueakOSXCGView.m'
		'OSX/sqSqueakOSXOpenGLView.m'
		'OSX/SqViewClut.m'
		'OSX/BitMapConversionLogicFromX11.c'
		'OSX/SqViewBitmapConversion.m'
		'OSX/macintoshosxextra.c'
		'OSX/sqSqueakOSXApplication+cursor.m'
		'OSX/sqSqueakOSXApplication+events.m'
		'OSX/keyBoardStrokeDetails.m'
		'OSX/SqueakOSXApplication.m'
		'OSX/sqSqueakOSXClipboardAPI.m'
		'OSX/sqSqueakOSXApplication+clipboard.m'
		'OSX/sqSqueakOSXDropAPI.m'
		'iPhone/sqMacV2Memory.c'
		'iPhone/osExports.c')! !

!SqueakCocoaIOSConfig methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 14:49'!
plistFile
	| plist |
	
	plist := self plistTemplate.	
	self plistKeys
		do: [:key | 
			plist := plist 
				copyReplaceAll: '@' , key , '@' 
				with: (self perform: key) asString ].

	^ self fixLineEndsOf: plist! !

!SqueakCocoaIOSConfig methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 14:49'!
plistKeys 
	^#(
	CFBundleExecutable
	CFBundleGetInfoString
	CFBundleName
	CFBundleShortVersionString
	CFBundleVersion
	CFBundleIconFile
	CFBundleIdentifier
	NSMainNibFile
	SqueakDebug)! !

!SqueakCocoaIOSConfig methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 14:49'!
plistTemplate 
^'<?xml version="1.0" encoding="UTF-8"?>
<!!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
<plist version="1.0">
<dict>
	<key>CFBundleDevelopmentRegion</key>
	<string>English</string>
	<key>CFBundleDocumentTypes</key>
	<array>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>image</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakImage.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Image File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STim</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sources</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakSources.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Sources File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STso</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>changes</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakChanges.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Changes File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STch</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sobj</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakScript.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Script File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SOBJ</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>pr</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakProject.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Project File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STpr</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>JPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>JPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TEXT</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TEXT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ttro</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ttro</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HTML</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HTML</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>RTF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>RTF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TIFF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TIFF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PICT </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PICT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>URL  </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>URL</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ZIP </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ZIP</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>zip </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>zip</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>BINA</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>BINA</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>GIFf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>GIFf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PNGf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PNGf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3 </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>mp3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG2</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG2</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Mp3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>M3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>M3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>SRCS</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SRCS</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Chng</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>Chng</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HPS5</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HPS5</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
	</array>
	<key>CFBundleExecutable</key>
	<string>@CFBundleExecutable@</string>
	<key>CFBundleGetInfoString</key>
	<string>@CFBundleGetInfoString@</string>
	<key>CFBundleIconFile</key>
	<string>@CFBundleIconFile@</string>
	<key>CFBundleIdentifier</key>
	<string>@CFBundleIdentifier@</string>
	<key>CFBundleInfoDictionaryVersion</key>
	<string>6.0</string>
	<key>CFBundleName</key>
	<string>@CFBundleName@</string>
	<key>CFBundlePackageType</key>
	<string>APPL</string>
	<key>CFBundleShortVersionString</key>
	<string>@CFBundleShortVersionString@</string>
	<key>CFBundleSignature</key>
	<string>FAST</string>
	<key>CFBundleVersion</key>
	<string>21.0</string>
	<key>LSBackgroundOnly</key>
	<false/>
	<key>LSMinimumSystemVersion</key>
	<string>${MACOSX_DEPLOYMENT_TARGET}</string>
	<key>NSMainNibFile</key>
	<string>@NSMainNibFile@</string>
	<key>NSPrincipalClass</key>
	<string>SqueakOSXApplication</string>
	<key>SqueakBrowserMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakDebug</key>
	<integer>@SqueakDebug@</integer>
	<key>SqueakExplicitWindowOpenNeeded</key>
	<false/>
	<key>SqueakImageName</key>
	<string>Squeak.image</string>
	<key>SqueakMaxHeapSize</key>
	<integer>536870912</integer>
	<key>SqueakMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakPluginsBuiltInOrLocalOnly</key>
	<false/>
	<key>SqueakQuitOnQuitAppleEvent</key>
	<false/>
	<key>SqueakResourceDirectory</key>
	<string></string>
	<key>SqueakTrustedDirectory</key>
	<string>/foobar/tooBar/forSqueak/bogus/</string>
	<key>SqueakUIFlushPrimaryDeferNMilliseconds</key>
	<integer>20</integer>
	<key>SqueakUnTrustedDirectory</key>
	<string>~/Library/Preferences/Squeak/Internet/My Squeak/</string>
	<key>SqueakUseFileMappedMMAP</key>
	<false/>
	<key>SqueakUIFadeForFullScreenInSeconds</key>
	<real>0.5</real>
	<key>UTExportedTypeDeclarations</key>
	<array>
		<dict>
			<key>UTTypeConformsTo</key>
			<array>
				<string>public.data</string>
			</array>
			<key>UTTypeDescription</key>
			<string>Squeak Image File</string>
			<key>UTTypeIdentifier</key>
			<string>org.squeak.image</string>
			<key>UTTypeTagSpecification</key>
			<dict>
				<key>com.apple.ostype</key>
				<string>STim</string>
				<key>public.filename-extension</key>
				<array>
					<string>image</string>
				</array>
				<key>public.mime-type</key>
				<string>application/squeak-image</string>
			</dict>
		</dict>
		<dict>
			<key>UTTypeConformsTo</key>
			<array>
				<string>public.utf8-plain-text</string>
			</array>
			<key>UTTypeDescription</key>
			<string>Squeak Sources File</string>
			<key>UTTypeIdentifier</key>
			<string>org.squeak.sources</string>
			<key>UTTypeTagSpecification</key>
			<dict>
				<key>com.apple.ostype</key>
				<string>STso</string>
				<key>public.filename-extension</key>
				<array>
					<string>sources</string>
				</array>
				<key>public.mime-type</key>
				<string>application/squeak-sources</string>
			</dict>
		</dict>
		<dict>
			<key>UTTypeConformsTo</key>
			<array>
				<string>public.utf8-plain-text</string>
			</array>
			<key>UTTypeDescription</key>
			<string>Squeak Changes File</string>
			<key>UTTypeIdentifier</key>
			<string>org.squeak.changes</string>
			<key>UTTypeTagSpecification</key>
			<dict>
				<key>com.apple.ostype</key>
				<string>STch</string>
				<key>public.filename-extension</key>
				<array>
					<string>changes</string>
				</array>
				<key>public.mime-type</key>
				<string>application/squeak-changes</string>
			</dict>
		</dict>
		<dict>
			<key>UTTypeConformsTo</key>
			<array>
				<string>public.data</string>
			</array>
			<key>UTTypeDescription</key>
			<string>Squeak Script File</string>
			<key>UTTypeIdentifier</key>
			<string>org.squeak.script</string>
			<key>UTTypeTagSpecification</key>
			<dict>
				<key>com.apple.ostype</key>
				<string>SOBJ</string>
				<key>public.filename-extension</key>
				<array>
					<string>sobj</string>
				</array>
				<key>public.mime-type</key>
				<string>application/squeak-script</string>
			</dict>
		</dict>
		<dict>
			<key>UTTypeConformsTo</key>
			<array>
				<string>public.data</string>
			</array>
			<key>UTTypeDescription</key>
			<string>Squeak Project File</string>
			<key>UTTypeIdentifier</key>
			<string>org.squeak.project</string>
			<key>UTTypeTagSpecification</key>
			<dict>
				<key>com.apple.ostype</key>
				<string>STpr</string>
				<key>public.filename-extension</key>
				<array>
					<string>pr</string>
				</array>
				<key>public.mime-type</key>
				<string>application/x-squeak-project</string>
			</dict>
		</dict>
	</array>
</dict>
</plist>
'! !

!SqueakCocoaIOSConfig methodsFor: 'accessing' stamp: 'tty 5/22/2014 14:49'!
pluginsDir 
	^'${srcDir}/vm/intplugins'! !

!SqueakCocoaIOSConfig methodsFor: 'settings' stamp: 'tty 5/22/2014 14:49'!
precompiledHeaders 
	^
'//
// Prefix header for all source files of the ''', self executableName, ''' target in the ''', self executableName, ''' project
//

#ifdef __OBJC__
	', 
	(String streamContents: [ :stream | 
		self precompiledImports 
			do: [ :each | 
				stream 
					nextPutAll: '#import ';
					nextPut: $<;
					nextPutAll: each; 
					nextPut: $> ]
			separatedBy: [ 
				stream cr ] ]),  '
#endif
'! !

!SqueakCocoaIOSConfig methodsFor: 'settings' stamp: 'tty 5/22/2014 14:49'!
precompiledImports 
	^#('Cocoa/Cocoa.h')! !

!SqueakCocoaIOSConfig methodsFor: 'source files' stamp: 'tty 5/22/2014 14:49'!
preferredIncludes
	^ #(
	'${buildDir}/'
	'${platformsDir}/iOS/vm/iPhone' "config.h is here. Why???"
	)
	! !

!SqueakCocoaIOSConfig methodsFor: 'accessing' stamp: 'tty 5/22/2014 14:49'!
prefixHeaderFileName 
	^self executableName, '_Prefix.pch'! !

!SqueakCocoaIOSConfig methodsFor: 'source generation' stamp: 'tty 5/22/2014 15:00'!
prepareVMMaker
	
	| maker allPlugins |
	
	"In CogVMs (in contrast to Interpreter VM) the generated sources are platform independent, therefore Cross is ok"
	maker := VMMaker forPlatform: 'Cross'.
	
	maker sourceDirectoryName: self srcDir pathName.
	maker platformRootDirectoryName: self platformsDir.
	
	
	allPlugins := self internalPlugins , self externalPlugins.
	
	"touch plugins to force their source generation unconditionally"
	allPlugins do: [:name | (Smalltalk globals at: name) touch ].
	
	" Why we put all plugins as external?   Because the generated sources are not different whether the plugins were defined as internal or external. VMMaker used to need this to to generate plugins.int and plugins.ext files. But since this is achieved in another way with CMakeVMMaker, there is no different at all to put all plugins as internal or as external."
	maker externalModules addAll:  allPlugins.
	
	^ maker! !

!SqueakCocoaIOSConfig methodsFor: 'settings' stamp: 'tty 5/22/2014 14:49'!
resources 
	^#('Squeak VM.r'
	'Cog.icns'
	'Squeak.icns'
	'SqueakChanges.icns'
	'SqueakPlugin.icns'
	'SqueakScript.icns'
	'SqueakGeneric.icns'
	'SqueakProject.icns'
	'SqueakSources.icns')

! !

!SqueakCocoaIOSConfig methodsFor: 'settings' stamp: 'tty 5/22/2014 14:49'!
setExtraTargetProperties: maker
	| plist precompiledHeaders |

	" generated and add Info.plist file "
	plist := self plistFile.	

	(maker buildDir forceNewFileNamed: 'Info.plist') 
		nextPutAll: plist; 
		close.

	maker 
		addProperty: 'MACOSX_BUNDLE_INFO_PLIST' 
		value: '${buildDir}/Info.plist'.  

	maker 
		cmd: 'set_source_files_properties' 
		params: '${resources} PROPERTIES MACOSX_PACKAGE_LOCATION Resources'.
			
	precompiledHeaders := (self executableName, '_Prefix.pch').
	(maker buildDir forceNewFileNamed: precompiledHeaders) 
		nextPutAll: self precompiledHeaders;
		close.

	maker addXCodeProperty: 'GCC_PREFIX_HEADER' value: '${buildDir}/', precompiledHeaders.	

	"maker 
		addXCodeProperty: 'GCC_ENABLE_SSE3_EXTENSIONS' value: 'YES';  
		addXCodeProperty: 'GCC_ENABLE_SSE41_EXTENSIONS' value: 'YES';
		addXCodeProperty: 'GCC_ENABLE_SSE42_EXTENSIONS' value: 'YES';
		addXCodeProperty: 'GCC_GENERATE_DEBUGGING_SYMBOLS' value: 'NO';  
		addXCodeProperty: 'GCC_INLINES_ARE_PRIVATE_EXTERN' value: 'YES';
		addXCodeProperty: 'GCC_UNROLL_LOOPS' value: 'YES'.	"
	
	"Extras"
	maker 
		addXCodeProperty: 'ICC_DEBUG' value: 'NO';
		addXCodeProperty: 'ICC_OPTLEVEL' value: 'speedHLO';
		addXCodeProperty: 'ICC_OPT_IPO_FOR_SINGLE_FILE_COMPILATION' value: 'YES';
		addXCodeProperty: 'ICC_OPT_PARALLEL' value: 'NO';
		addXCodeProperty: 'ICC_OPT_PREFETCH_INSERTION' value: 'YES';
		addXCodeProperty: 'ICC_OPT_PROVIDE_FRAME_PTR' value: 'NO';
		addXCodeProperty: 'ICC_OPT_USE_ARCH_IA32' value: 'SSE41';
		addXCodeProperty: 'PER_ARCH_CFLAGS_i386' value: '-finline-functions -mfpmath=sse -march=pentium-m -mtune=prescott -falign-functions=16  -fno-gcse -DLSB_FIRST';
		addXCodeProperty: 'PER_ARCH_CFLAGS_ppc' value: '-fast -mtune=7450 -mcpu=7450 -D_BSD_SOCKLEN_T_=int'! !

!SqueakCocoaIOSConfig methodsFor: 'accessing' stamp: 'tty 5/22/2014 15:13'!
srcDir 
	^ srcDir ifNil: [ srcDir := (self topDir directoryNamed: 'platforms/iOS/vm/src' )]
! !

!SqueakCocoaIOSConfig methodsFor: 'source files' stamp: 'tty 5/22/2014 14:49'!
standardIncludes
	^ #(
	'${crossDir}/plugins/SerialPlugin'   
	'${targetPlatform}/plugins/FilePlugin'
	'${crossDir}/plugins/FilePlugin'
	'${targetPlatform}/plugins/HostWindowPlugin'
	'${platformsDir}/iOS/vm/iPhone/plugins/HostWindowPlugin' 
	'${crossDir}/plugins/HostWindowPlugin'
	'${crossDir}/plugins/DropPlugin'
	'${crossDir}/plugins/SocketPlugin'
	'${crossDir}/plugins/SoundPlugin'
	'${crossDir}/plugins/AsynchFilePlugin'
	'${platformsDir}/unix/vm'
	'${platformsDir}/iOS/plugins/SoundPlugin'
	'${platformsDir}/iOS/vm/OSX/plugins/SoundPlugin'
	'${platformsDir}/iOS/vm/Common/Classes'
	'${platformsDir}/iOS/vm/OSX'
)
	! !

!SqueakCocoaIOSConfig methodsFor: 'directories' stamp: 'tty 6/2/2014 16:46'!
write: aContents toFile: aFileName
	"write a file to current output directory (buildDir).
	use line end convention appropriate for config platform"

	| bldDir |
	bldDir := self buildDir.
	bldDir isString
		ifTrue: [ bldDir := FileDirectory directoryEntryFor: bldDir ].
	bldDir assureExistence.
	bldDir
		forceNewFileNamed: aFileName
		do: [:s | s
				nextPutAll: (self fixLineEndsOf: aContents)]

! !

SqueakMacOSV3Config subclass: #SqueakMacOSNewspeakCogSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOS'!

!SqueakMacOSNewspeakCogSpurConfig commentStamp: 'tty 6/15/2014 13:47' prior: 0!
This is a concrete configuration for building a CogVM 32 bit on Mac OS.

It is using a Carbon framework , which eventually will be replaced by Cocoa. (see CocoaIOSConfig and its subclasses).

SqueakMacOSBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:42'!
CFBundleExecutable
	^ self executableName ! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:42'!
CFBundleGetInfoString

	^ self CFBundleShortVersionString
! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:42'!
CFBundleIconFile

	"An application icon"
	^ 'Cog.icns'! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:42'!
CFBundleIdentifier

	"A Java package style name (like 'com.myCompany.MyBundle') which is used to uniquely identify bundles."
	
	^ 'org.squeak.Cog'! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:42'!
CFBundleName

	"An application name"
	^ self executableName, ' (Carbon) 32bits'! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:42'!
CFBundleShortVersionString

	"An application version"
	^ self executableName, ' VM ' , self CFBundleVersion! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:42'!
CFBundleVersion

	"An application version"
	^ '4.0.0'! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:42'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'compiler flags' stamp: 'tty 6/9/2014 18:42'!
commonCompilerFlags

	"Common compiler flags"
	
	^ { 
		'-fmessage-length=0'. 
		'-Wno-trigraphs'. 
		'-fpascal-strings'. 
		'-fasm-blocks'. 
		'-DCOGMTVM=0'. 
		'-DUSE_GLOBAL_STRUCT=0'. 
		'-DTARGET_API_MAC_CARBON'. 
		'-DBUILD_FOR_OSX'. 
		'-DHAVE_SYS_TIME_H'. 
		'-mmacosx-version-min=10.5' }	
! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'compiler flags' stamp: 'tty 6/9/2014 18:42'!
compilerFlagsDebug

	^ {
		'-g3'. 
		'-O0'. 
		'-Wmissing-prototypes'. 
		'-Wmissing-braces'. 
		'-Wparentheses'. 
		'-Wunused-function'. 
		'-Wunused-label'. 
		'-Wunused-parameter'. 
		'-Wunused-variable'. 
		'-Wunused-value'. 
		'-Wsign-compare'. 
		'-DDEBUGVM=1'. 
		'-DEXTERNALPRIMSDEBUG=1'. 
		'-gdwarf-2' }! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'compiler flags' stamp: 'tty 6/9/2014 18:42'!
compilerFlagsRelease
" -mdynamic-no-pic "
	^ {
		'-gdwarf-2'. 
		'-O3'. 
		'-funroll-loops'. 
		'-ftree-vectorize'. 
		'-msse3'. 
		'-DDEBUGVM=0'. 
		'-DNDEBUG'. 
		'-Wunused-value'. 
		'-Wuninitialized'. 
		'-falign-functions=16'. 
		'-fno-gcse'. 
		'-mtune=prescott'. 
		'-march=pentium-m'. 
		'-mfpmath=sse'. 
		'-finline-functions'. 
		'-Wall'. 
		'-DUSE_INLINE_MEMORY_ACCESSORS' }! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:42'!
configureDropPlugin: maker
	"extra rules for DropPlugin"
	super configureDropPlugin: maker.  
	maker addPlatformSources: #( 'sqMacDragDrop')
! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:42'!
configureFFIPlugin: maker
	"extra rules for FFIPlugin"

	
	"Never generate this plugin. Because it is a legacy code.
	For Cog FFI, use ReentrantFFIPlugin  (ReentrantIA32FFIPlugin for x86) "
	
	maker doNotGenerate: true.
	
! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:42'!
configureFilePlugin: maker
	"extra rules for FilePlugin"

	super configureFilePlugin: maker.  
	
	maker includeDirectories: '${platformsDir}/unix/vm'.
	maker addPlatformSources: #( 'sqMacUnixFileInterface.c' 'sqMacDirectory.c')! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:42'!
configureHostWindowPlugin: maker
	"extra rules for HostWindowPlugin"

	super configureHostWindowPlugin: maker.  
	maker addPlatformSources: #( 'sqMacHostWindow.c' )
! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:42'!
configureSoundPlugin: maker 
	"extra rules for SoundPlugin"

	super configureSoundPlugin: maker.  
	maker includeDirectories: '${platformsDir}/unix/vm/'.
	maker addPlatformSources:
		#( 
			"This is commented because such file is not commited in the cog blessed commit hash f3fe94c828f66cd0e7c37cfa3434e384ff65915e. For more details see http://forum.world.st/Problem-generating-Mac-VM-td3438466.html "
			"'sqMacAudioDeviceList.c'"
			'sqMacUnixInterfaceSound.c' 
			'sqUnixSoundMacOSXJMM.c'
		)


! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:42'!
configureUUIDPlugin: maker 
	"extra rules for UUIDPlugin"

	super configureUUIDPlugin: maker.    
	maker addPlatformSources:
		#( 'sqMacUUID.c')


! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 18:42'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'plugins' stamp: 'tty 6/9/2014 18:42'!
defaultExternalPlugins

	^ #(
		BochsIA32Plugin
		CroquetPlugin
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
		FloatArrayPlugin
		FloatMathPlugin
		Mpeg3Plugin
		QuicktimePlugin 
"		TestOSAPlugin  - not works"
		"UnixOSProcessPlugin ?? "
		)! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'plugins' stamp: 'tty 6/9/2014 18:42'!
defaultInternalPlugins

	^ #(
		ADPCMCodecPlugin
		AsynchFilePlugin
		B3DAcceleratorPlugin
		BalloonEnginePlugin "B2DPlugin" 
		BitBltSimulation "BitBltPlugin"
		BMPReadWriterPlugin
		DeflatePlugin  "ZipPlugin"
		DropPlugin
		DSAPlugin "DSAPrims"
		FFTPlugin
		FilePlugin
		HostWindowPlugin
		IA32ABIPlugin "IA32ABI"
		InternetConfigPlugin
		JoystickTabletPlugin
		JPEGReaderPlugin
		JPEGReadWriter2Plugin
		KlattSynthesizerPlugin "Klatt"
		LargeIntegersPlugin "LargeIntegers"
		LocalePlugin
		MacMenubarPlugin
		Matrix2x3Plugin
		MIDIPlugin
		MiscPrimitivePlugin
		"QVMProfileMacSupportPlugin"
		RePlugin
		SecurityPlugin
		SerialPlugin
		SocketPlugin
		SoundCodecPlugin "SoundCodecPrims"
		SoundGenerationPlugin
		SoundPlugin
		StarSqueakPlugin
		SurfacePlugin
		UUIDPlugin
		VMProfileMacSupportPlugin
		)! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:10'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. default is squeak.cog.v3"
	^self newspeakCogSpur! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:47'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:09'!
executableName
	^ self vmCogExecutableName! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:42'!
executableType
	^ 'MACOSX_BUNDLE'! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'settings' stamp: 'tty 6/9/2014 18:42'!
extraPluginSettings: maker
	
	"Cog currently runs only in 32 bit mode" 
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 18:42'!
extraSources
	" mac VM using some unix sources"
	
	^ 
	'${platformsDir}/unix/plugins/SocketPlugin/sqUnixSocket.c 
	${platformsDir}/unix/vm/aio.c 
	${platformsDir}/unix/plugins/AsynchFilePlugin/sqUnixAsynchFile.c
	${platformsDir}/unix/vm/sqUnixHeartbeat.c
	${platformsDir}/unix/vm/sqUnixVMProfile.c
	${platformsDir}/unix/vm/sqUnixThreads.c
	${resources}'! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'settings' stamp: 'tty 6/9/2014 18:42'!
extraVMSettings: maker
	
	"Cog currently runs only in 32 bit mode" 
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'.

	maker set: 'resourceDir' toString: self resourcesDir, '/ProjectBuilder'.
	maker set: 'resources' to: 
		'"${resourceDir}/Squeak VM.r"
		"${resourceDir}/Cog.icns"
		"${resourceDir}/Squeak.icns"
		"${resourceDir}/SqueakChanges.icns"
		"${resourceDir}/SqueakImage.icns"
		"${resourceDir}/SqueakPlugin.icns"
		"${resourceDir}/SqueakScript.icns"
		"${resourceDir}/SqueakGeneric.icns"
		"${resourceDir}/SqueakProject.icns"
		"${resourceDir}/SqueakSources.icns"'
! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:42'!
frameworks

	^ #(
	Carbon
	AppKit
	IOKit
	CoreFoundation
	AudioToolbox
	CoreAudio
	OpenGL
	AGL
	QuickTime
	Foundation
	SystemConfiguration
	)! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 18:42'!
generateSourceFiles

	^ CMakeGenScripts generateCogSources: self! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:42'!
interpreterClass
	^ CoInterpreter! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:42'!
platformName
	^ 'Mac OS'! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 18:42'!
platformSources
	"files added from platform/Mac OS/vm dir "
	^ #(
	'NSCursorWrappers.m'
	'nsPoolManagement.m'
	'osExports.c'
	'sqMacEncoding.c'
	'sqMacImageIO.c'
	'sqMacMain.c'
	'sqMacMemory.c'
	'sqMacNSPluginUILogic2.c'
	'sqMacTime.c'
	'sqMacUIAppleEvents.c'
	'sqMacUIClipBoard.c'
	'sqMacUIEventsUniversal.c'  " instead of: sqMacUIEvents.c "
	'sqMacUIMenuBarUniversal.c'
	'sqMacUnixCommandLineInterface.c'
	'sqMacUnixExternalPrims.c'
	'sqMacWindowUniversal.c'
	'version.c'	
	)! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:42'!
plistFile

	| plist |
	
	plist := self plistTemplate.
	
	#(
	CFBundleExecutable
	CFBundleGetInfoString
	CFBundleName
	CFBundleShortVersionString
	CFBundleVersion
	CFBundleIconFile
	CFBundleIdentifier ) do: [:key |
		plist := plist copyReplaceAll: '@' , key , '@' with: (self perform: key)
	].

	^ self fixLineEndsOf: plist! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:42'!
plistTemplate
	^ 
	'<?xml version="1.0" encoding="UTF-8"?>
<!!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
<plist version="1.0">
<dict>
	<key>LSMinimumSystemVersion</key>
	<string>10.5.0</string>
	<key>CFBundleDevelopmentRegion</key>
	<string>English</string>
	<key>CFBundleDocumentTypes</key>
	<array>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>image</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Image File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STim</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sources</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Sources File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STso</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>changes</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Changes File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STch</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sobj</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakScript.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Script File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SOBJ</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>pr</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakProject.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Project File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STpr</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>JPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>JPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TEXT</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TEXT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ttro</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ttro</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HTML</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HTML</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>RTF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>RTF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TIFF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TIFF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PICT </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PICT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>URL  </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>URL</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ZIP </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ZIP</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>zip </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>zip</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>BINA</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>BINA</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>GIFf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>GIFf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PNGf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PNGf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3 </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>mp3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG2</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG2</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Mp3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>M3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>M3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>SRCS</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SRCS</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Chng</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>Chng</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HPS5</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HPS5</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>bundle</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakPlugin.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Plugin</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>BNDL</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
	</array>
	<key>CFBundleExecutable</key>
	<string>@CFBundleExecutable@</string>
	<key>CFBundleGetInfoString</key>
	<string>@CFBundleGetInfoString@</string>
	<key>CFBundleIconFile</key>
	<string>@CFBundleIconFile@</string>
	<key>CFBundleIdentifier</key>
	<string>@CFBundleIdentifier@</string>
	<key>CFBundleInfoDictionaryVersion</key>
	<string>6.0</string>
	<key>CFBundleName</key>
	<string>@CFBundleName@</string>
	<key>CFBundlePackageType</key>
	<string>APPL</string>
	<key>CFBundleShortVersionString</key>
	<string>@CFBundleShortVersionString@</string>
	<key>CFBundleSignature</key>
	<string>????</string>
	<key>CFBundleVersion</key>
	<string>@CFBundleVersion@</string>
	<key>CGDisableCoalescedUpdates</key>
	<true/>
	<key>LSBackgroundOnly</key>
	<false/>
	<key>NSServices</key>
	<array>
		<dict>
			<key>NSMenuItem</key>
			<dict>
				<key>default</key>
				<string>Squeak DoIt</string>
			</dict>
			<key>NSMessage</key>
			<string>doitandreturn</string>
			<key>NSPortName</key>
			<string>Squeak</string>
			<key>NSReturnTypes</key>
			<array>
				<string>NSStringPboardType</string>
			</array>
			<key>NSSendTypes</key>
			<array>
				<string>NSStringPboardType</string>
			</array>
		</dict>
	</array>
	<key>SqueakBrowserMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakDebug</key>
	<integer>0</integer>
	<key>SqueakEncodingType</key>
	<string>UTF-8</string>
	<key>SqueakExplicitWindowOpenNeeded</key>
	<false/>
	<key>SqueakFloatingWindowGetsFocus</key>
	<true/>
	<key>SqueakHasQuitWithoutSaving</key>
	<false/>
	<key>SqueakImageName</key>
	<string>Squeak.image</string>
	<key>SqueakMaxHeapSize</key>
	<integer>536870912</integer>
	<key>SqueakMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakPluginsBuiltInOrLocalOnly</key>
	<false/>
	<key>SqueakUIFlushPrimaryDeferNMilliseconds</key>
	<integer>20</integer>
	<key>SqueakUIFlushSecondaryCheckForPossibleNeedEveryNMilliseconds</key>
	<integer>20</integer>
	<key>SqueakUIFlushSecondaryCleanupDelayMilliseconds</key>
	<integer>25</integer>
	<key>SqueakUIFlushUseHighPercisionClock</key>
	<true/>
	<key>SqueakUnTrustedDirectory</key>
	<string>~/Library/Preferences/Croquet/Internet/Untrusted/</string>
	<key>SqueakWindowAttribute</key>
	<data>ggAAHw==</data>
	<key>SqueakWindowHasTitle</key>
	<true/>
	<key>SqueakWindowType</key>
	<integer>6</integer>
</dict>
</plist>
'! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:42'!
prepareForGeneration
	^ self prepareForCogGeneration
! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'settings' stamp: 'tty 6/9/2014 18:42'!
setExtraTargetProperties: maker

	super setExtraTargetProperties: maker.

	maker addFrameworks: self frameworks.	

	" generated and add Info.plist file "
	self write: self plistFile toFile: 'Info.plist'.
	maker 
		addProperty: 'MACOSX_BUNDLE_INFO_PLIST' 
		value: '${buildDir}/Info.plist'.

	maker cmd: 'set_source_files_properties' params: '${resources} PROPERTIES MACOSX_PACKAGE_LOCATION Resources'.
	
	maker set: 'EXECUTABLE_OUTPUT_PATH' to: '${outputDir}'.! !

!SqueakMacOSNewspeakCogSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 18:42'!
standardIncludes
	^ #(
	'SYSTEM /Developer/Headers/FlatCarbon'
	'${targetPlatform}/vm/Developer'  "for some unknown reason sqGnu.h is put there"
	
	'${crossDir}/plugins/SerialPlugin'   "for platforms/Mac OS/vm/osExports.c to work"
	'${targetPlatform}/plugins/FilePlugin'   "for sqMacFileLogic.h to work"
	'${targetPlatform}/plugins/HostWindowPlugin'  "for sqMacNSPluginUILogic2.c to work"
	'${crossDir}/plugins/HostWindowPlugin' "for same... "
	'${crossDir}/plugins/DropPlugin' "include DropPlugin.h"
	'${crossDir}/plugins/SocketPlugin'
	'${crossDir}/plugins/AsynchFilePlugin'
	'${platformsDir}/unix/vm'  "suppressing following:
		platforms/Mac OS/vm/sqMacMain.c:94:19: error: sqaio.h: No such file or directory
		platforms/Mac OS/vm/sqMacMain.c:96:28: error: sqUnixCharConv.h: No such file or directory"
	)
	! !

SqueakMacOSV3Config subclass: #SqueakMacOSNewspeakCogV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOS'!

!SqueakMacOSNewspeakCogV3Config commentStamp: 'tty 6/15/2014 13:47' prior: 0!
This is a concrete configuration for building a CogVM 32 bit on Mac OS.

It is using a Carbon framework , which eventually will be replaced by Cocoa. (see CocoaIOSConfig and its subclasses).

SqueakMacOSBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!SqueakMacOSNewspeakCogV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:42'!
CFBundleExecutable
	^ self executableName ! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:42'!
CFBundleGetInfoString

	^ self CFBundleShortVersionString
! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:42'!
CFBundleIconFile

	"An application icon"
	^ 'Cog.icns'! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:42'!
CFBundleIdentifier

	"A Java package style name (like 'com.myCompany.MyBundle') which is used to uniquely identify bundles."
	
	^ 'org.squeak.Cog'! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:42'!
CFBundleName

	"An application name"
	^ self executableName, ' (Carbon) 32bits'! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:42'!
CFBundleShortVersionString

	"An application version"
	^ self executableName, ' VM ' , self CFBundleVersion! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:42'!
CFBundleVersion

	"An application version"
	^ '4.0.0'! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:42'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'compiler flags' stamp: 'tty 6/9/2014 18:42'!
commonCompilerFlags

	"Common compiler flags"
	
	^ { 
		'-fmessage-length=0'. 
		'-Wno-trigraphs'. 
		'-fpascal-strings'. 
		'-fasm-blocks'. 
		'-DCOGMTVM=0'. 
		'-DUSE_GLOBAL_STRUCT=0'. 
		'-DTARGET_API_MAC_CARBON'. 
		'-DBUILD_FOR_OSX'. 
		'-DHAVE_SYS_TIME_H'. 
		'-mmacosx-version-min=10.5' }	
! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'compiler flags' stamp: 'tty 6/9/2014 18:42'!
compilerFlagsDebug

	^ {
		'-g3'. 
		'-O0'. 
		'-Wmissing-prototypes'. 
		'-Wmissing-braces'. 
		'-Wparentheses'. 
		'-Wunused-function'. 
		'-Wunused-label'. 
		'-Wunused-parameter'. 
		'-Wunused-variable'. 
		'-Wunused-value'. 
		'-Wsign-compare'. 
		'-DDEBUGVM=1'. 
		'-DEXTERNALPRIMSDEBUG=1'. 
		'-gdwarf-2' }! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'compiler flags' stamp: 'tty 6/9/2014 18:42'!
compilerFlagsRelease
" -mdynamic-no-pic "
	^ {
		'-gdwarf-2'. 
		'-O3'. 
		'-funroll-loops'. 
		'-ftree-vectorize'. 
		'-msse3'. 
		'-DDEBUGVM=0'. 
		'-DNDEBUG'. 
		'-Wunused-value'. 
		'-Wuninitialized'. 
		'-falign-functions=16'. 
		'-fno-gcse'. 
		'-mtune=prescott'. 
		'-march=pentium-m'. 
		'-mfpmath=sse'. 
		'-finline-functions'. 
		'-Wall'. 
		'-DUSE_INLINE_MEMORY_ACCESSORS' }! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:42'!
configureDropPlugin: maker
	"extra rules for DropPlugin"
	super configureDropPlugin: maker.  
	maker addPlatformSources: #( 'sqMacDragDrop')
! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:42'!
configureFFIPlugin: maker
	"extra rules for FFIPlugin"

	
	"Never generate this plugin. Because it is a legacy code.
	For Cog FFI, use ReentrantFFIPlugin  (ReentrantIA32FFIPlugin for x86) "
	
	maker doNotGenerate: true.
	
! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:42'!
configureFilePlugin: maker
	"extra rules for FilePlugin"

	super configureFilePlugin: maker.  
	
	maker includeDirectories: '${platformsDir}/unix/vm'.
	maker addPlatformSources: #( 'sqMacUnixFileInterface.c' 'sqMacDirectory.c')! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:42'!
configureHostWindowPlugin: maker
	"extra rules for HostWindowPlugin"

	super configureHostWindowPlugin: maker.  
	maker addPlatformSources: #( 'sqMacHostWindow.c' )
! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:42'!
configureSoundPlugin: maker 
	"extra rules for SoundPlugin"

	super configureSoundPlugin: maker.  
	maker includeDirectories: '${platformsDir}/unix/vm/'.
	maker addPlatformSources:
		#( 
			"This is commented because such file is not commited in the cog blessed commit hash f3fe94c828f66cd0e7c37cfa3434e384ff65915e. For more details see http://forum.world.st/Problem-generating-Mac-VM-td3438466.html "
			"'sqMacAudioDeviceList.c'"
			'sqMacUnixInterfaceSound.c' 
			'sqUnixSoundMacOSXJMM.c'
		)


! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:42'!
configureUUIDPlugin: maker 
	"extra rules for UUIDPlugin"

	super configureUUIDPlugin: maker.    
	maker addPlatformSources:
		#( 'sqMacUUID.c')


! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'source files' stamp: 'tty 6/9/2014 18:42'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'plugins' stamp: 'tty 6/9/2014 18:42'!
defaultExternalPlugins

	^ #(
		BochsIA32Plugin
		CroquetPlugin
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
		FloatArrayPlugin
		FloatMathPlugin
		Mpeg3Plugin
		QuicktimePlugin 
"		TestOSAPlugin  - not works"
		"UnixOSProcessPlugin ?? "
		)! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'plugins' stamp: 'tty 6/9/2014 18:42'!
defaultInternalPlugins

	^ #(
		ADPCMCodecPlugin
		AsynchFilePlugin
		B3DAcceleratorPlugin
		BalloonEnginePlugin "B2DPlugin" 
		BitBltSimulation "BitBltPlugin"
		BMPReadWriterPlugin
		DeflatePlugin  "ZipPlugin"
		DropPlugin
		DSAPlugin "DSAPrims"
		FFTPlugin
		FilePlugin
		HostWindowPlugin
		IA32ABIPlugin "IA32ABI"
		InternetConfigPlugin
		JoystickTabletPlugin
		JPEGReaderPlugin
		JPEGReadWriter2Plugin
		KlattSynthesizerPlugin "Klatt"
		LargeIntegersPlugin "LargeIntegers"
		LocalePlugin
		MacMenubarPlugin
		Matrix2x3Plugin
		MIDIPlugin
		MiscPrimitivePlugin
		"QVMProfileMacSupportPlugin"
		RePlugin
		SecurityPlugin
		SerialPlugin
		SocketPlugin
		SoundCodecPlugin "SoundCodecPrims"
		SoundGenerationPlugin
		SoundPlugin
		StarSqueakPlugin
		SurfacePlugin
		UUIDPlugin
		VMProfileMacSupportPlugin
		)! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:10'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. default is squeak.cog.v3"
	^self newspeakCogV3! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:47'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:09'!
executableName
	^ self vmCogExecutableName! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:42'!
executableType
	^ 'MACOSX_BUNDLE'! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'settings' stamp: 'tty 6/9/2014 18:42'!
extraPluginSettings: maker
	
	"Cog currently runs only in 32 bit mode" 
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'source files' stamp: 'tty 6/9/2014 18:42'!
extraSources
	" mac VM using some unix sources"
	
	^ 
	'${platformsDir}/unix/plugins/SocketPlugin/sqUnixSocket.c 
	${platformsDir}/unix/vm/aio.c 
	${platformsDir}/unix/plugins/AsynchFilePlugin/sqUnixAsynchFile.c
	${platformsDir}/unix/vm/sqUnixHeartbeat.c
	${platformsDir}/unix/vm/sqUnixVMProfile.c
	${platformsDir}/unix/vm/sqUnixThreads.c
	${resources}'! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'settings' stamp: 'tty 6/9/2014 18:42'!
extraVMSettings: maker
	
	"Cog currently runs only in 32 bit mode" 
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'.

	maker set: 'resourceDir' toString: self resourcesDir, '/ProjectBuilder'.
	maker set: 'resources' to: 
		'"${resourceDir}/Squeak VM.r"
		"${resourceDir}/Cog.icns"
		"${resourceDir}/Squeak.icns"
		"${resourceDir}/SqueakChanges.icns"
		"${resourceDir}/SqueakImage.icns"
		"${resourceDir}/SqueakPlugin.icns"
		"${resourceDir}/SqueakScript.icns"
		"${resourceDir}/SqueakGeneric.icns"
		"${resourceDir}/SqueakProject.icns"
		"${resourceDir}/SqueakSources.icns"'
! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:42'!
frameworks

	^ #(
	Carbon
	AppKit
	IOKit
	CoreFoundation
	AudioToolbox
	CoreAudio
	OpenGL
	AGL
	QuickTime
	Foundation
	SystemConfiguration
	)! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'source files' stamp: 'tty 6/9/2014 18:42'!
generateSourceFiles

	^ CMakeGenScripts generateCogSources: self! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:42'!
interpreterClass
	^ CoInterpreter! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:42'!
platformName
	^ 'Mac OS'! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'source files' stamp: 'tty 6/9/2014 18:42'!
platformSources
	"files added from platform/Mac OS/vm dir "
	^ #(
	'NSCursorWrappers.m'
	'nsPoolManagement.m'
	'osExports.c'
	'sqMacEncoding.c'
	'sqMacImageIO.c'
	'sqMacMain.c'
	'sqMacMemory.c'
	'sqMacNSPluginUILogic2.c'
	'sqMacTime.c'
	'sqMacUIAppleEvents.c'
	'sqMacUIClipBoard.c'
	'sqMacUIEventsUniversal.c'  " instead of: sqMacUIEvents.c "
	'sqMacUIMenuBarUniversal.c'
	'sqMacUnixCommandLineInterface.c'
	'sqMacUnixExternalPrims.c'
	'sqMacWindowUniversal.c'
	'version.c'	
	)! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:42'!
plistFile

	| plist |
	
	plist := self plistTemplate.
	
	#(
	CFBundleExecutable
	CFBundleGetInfoString
	CFBundleName
	CFBundleShortVersionString
	CFBundleVersion
	CFBundleIconFile
	CFBundleIdentifier ) do: [:key |
		plist := plist copyReplaceAll: '@' , key , '@' with: (self perform: key)
	].

	^ self fixLineEndsOf: plist! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:42'!
plistTemplate
	^ 
	'<?xml version="1.0" encoding="UTF-8"?>
<!!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
<plist version="1.0">
<dict>
	<key>LSMinimumSystemVersion</key>
	<string>10.5.0</string>
	<key>CFBundleDevelopmentRegion</key>
	<string>English</string>
	<key>CFBundleDocumentTypes</key>
	<array>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>image</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Image File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STim</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sources</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Sources File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STso</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>changes</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Changes File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STch</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sobj</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakScript.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Script File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SOBJ</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>pr</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakProject.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Project File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STpr</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>JPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>JPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TEXT</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TEXT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ttro</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ttro</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HTML</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HTML</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>RTF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>RTF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TIFF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TIFF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PICT </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PICT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>URL  </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>URL</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ZIP </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ZIP</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>zip </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>zip</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>BINA</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>BINA</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>GIFf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>GIFf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PNGf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PNGf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3 </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>mp3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG2</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG2</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Mp3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>M3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>M3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>SRCS</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SRCS</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Chng</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>Chng</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HPS5</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HPS5</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>bundle</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakPlugin.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Plugin</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>BNDL</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
	</array>
	<key>CFBundleExecutable</key>
	<string>@CFBundleExecutable@</string>
	<key>CFBundleGetInfoString</key>
	<string>@CFBundleGetInfoString@</string>
	<key>CFBundleIconFile</key>
	<string>@CFBundleIconFile@</string>
	<key>CFBundleIdentifier</key>
	<string>@CFBundleIdentifier@</string>
	<key>CFBundleInfoDictionaryVersion</key>
	<string>6.0</string>
	<key>CFBundleName</key>
	<string>@CFBundleName@</string>
	<key>CFBundlePackageType</key>
	<string>APPL</string>
	<key>CFBundleShortVersionString</key>
	<string>@CFBundleShortVersionString@</string>
	<key>CFBundleSignature</key>
	<string>????</string>
	<key>CFBundleVersion</key>
	<string>@CFBundleVersion@</string>
	<key>CGDisableCoalescedUpdates</key>
	<true/>
	<key>LSBackgroundOnly</key>
	<false/>
	<key>NSServices</key>
	<array>
		<dict>
			<key>NSMenuItem</key>
			<dict>
				<key>default</key>
				<string>Squeak DoIt</string>
			</dict>
			<key>NSMessage</key>
			<string>doitandreturn</string>
			<key>NSPortName</key>
			<string>Squeak</string>
			<key>NSReturnTypes</key>
			<array>
				<string>NSStringPboardType</string>
			</array>
			<key>NSSendTypes</key>
			<array>
				<string>NSStringPboardType</string>
			</array>
		</dict>
	</array>
	<key>SqueakBrowserMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakDebug</key>
	<integer>0</integer>
	<key>SqueakEncodingType</key>
	<string>UTF-8</string>
	<key>SqueakExplicitWindowOpenNeeded</key>
	<false/>
	<key>SqueakFloatingWindowGetsFocus</key>
	<true/>
	<key>SqueakHasQuitWithoutSaving</key>
	<false/>
	<key>SqueakImageName</key>
	<string>Squeak.image</string>
	<key>SqueakMaxHeapSize</key>
	<integer>536870912</integer>
	<key>SqueakMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakPluginsBuiltInOrLocalOnly</key>
	<false/>
	<key>SqueakUIFlushPrimaryDeferNMilliseconds</key>
	<integer>20</integer>
	<key>SqueakUIFlushSecondaryCheckForPossibleNeedEveryNMilliseconds</key>
	<integer>20</integer>
	<key>SqueakUIFlushSecondaryCleanupDelayMilliseconds</key>
	<integer>25</integer>
	<key>SqueakUIFlushUseHighPercisionClock</key>
	<true/>
	<key>SqueakUnTrustedDirectory</key>
	<string>~/Library/Preferences/Croquet/Internet/Untrusted/</string>
	<key>SqueakWindowAttribute</key>
	<data>ggAAHw==</data>
	<key>SqueakWindowHasTitle</key>
	<true/>
	<key>SqueakWindowType</key>
	<integer>6</integer>
</dict>
</plist>
'! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:42'!
prepareForGeneration
	^ self prepareForCogGeneration
! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'settings' stamp: 'tty 6/9/2014 18:42'!
setExtraTargetProperties: maker

	super setExtraTargetProperties: maker.

	maker addFrameworks: self frameworks.	

	" generated and add Info.plist file "
	self write: self plistFile toFile: 'Info.plist'.
	maker 
		addProperty: 'MACOSX_BUNDLE_INFO_PLIST' 
		value: '${buildDir}/Info.plist'.

	maker cmd: 'set_source_files_properties' params: '${resources} PROPERTIES MACOSX_PACKAGE_LOCATION Resources'.
	
	maker set: 'EXECUTABLE_OUTPUT_PATH' to: '${outputDir}'.! !

!SqueakMacOSNewspeakCogV3Config methodsFor: 'source files' stamp: 'tty 6/9/2014 18:42'!
standardIncludes
	^ #(
	'SYSTEM /Developer/Headers/FlatCarbon'
	'${targetPlatform}/vm/Developer'  "for some unknown reason sqGnu.h is put there"
	
	'${crossDir}/plugins/SerialPlugin'   "for platforms/Mac OS/vm/osExports.c to work"
	'${targetPlatform}/plugins/FilePlugin'   "for sqMacFileLogic.h to work"
	'${targetPlatform}/plugins/HostWindowPlugin'  "for sqMacNSPluginUILogic2.c to work"
	'${crossDir}/plugins/HostWindowPlugin' "for same... "
	'${crossDir}/plugins/DropPlugin' "include DropPlugin.h"
	'${crossDir}/plugins/SocketPlugin'
	'${crossDir}/plugins/AsynchFilePlugin'
	'${platformsDir}/unix/vm'  "suppressing following:
		platforms/Mac OS/vm/sqMacMain.c:94:19: error: sqaio.h: No such file or directory
		platforms/Mac OS/vm/sqMacMain.c:96:28: error: sqUnixCharConv.h: No such file or directory"
	)
	! !

SqueakMacOSV3Config subclass: #SqueakMacOSNewspeakSistaSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOS'!

!SqueakMacOSNewspeakSistaSpurConfig commentStamp: 'tty 6/15/2014 13:47' prior: 0!
This is a concrete configuration for building a CogVM 32 bit on Mac OS.

It is using a Carbon framework , which eventually will be replaced by Cocoa. (see CocoaIOSConfig and its subclasses).

SqueakMacOSBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:41'!
CFBundleExecutable
	^ self executableName ! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:41'!
CFBundleGetInfoString

	^ self CFBundleShortVersionString
! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:41'!
CFBundleIconFile

	"An application icon"
	^ 'Cog.icns'! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:41'!
CFBundleIdentifier

	"A Java package style name (like 'com.myCompany.MyBundle') which is used to uniquely identify bundles."
	
	^ 'org.squeak.Cog'! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:41'!
CFBundleName

	"An application name"
	^ self executableName, ' (Carbon) 32bits'! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:41'!
CFBundleShortVersionString

	"An application version"
	^ self executableName, ' VM ' , self CFBundleVersion! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:41'!
CFBundleVersion

	"An application version"
	^ '4.0.0'! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:41'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'compiler flags' stamp: 'tty 6/9/2014 18:41'!
commonCompilerFlags

	"Common compiler flags"
	
	^ { 
		'-fmessage-length=0'. 
		'-Wno-trigraphs'. 
		'-fpascal-strings'. 
		'-fasm-blocks'. 
		'-DCOGMTVM=0'. 
		'-DUSE_GLOBAL_STRUCT=0'. 
		'-DTARGET_API_MAC_CARBON'. 
		'-DBUILD_FOR_OSX'. 
		'-DHAVE_SYS_TIME_H'. 
		'-mmacosx-version-min=10.5' }	
! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'compiler flags' stamp: 'tty 6/9/2014 18:41'!
compilerFlagsDebug

	^ {
		'-g3'. 
		'-O0'. 
		'-Wmissing-prototypes'. 
		'-Wmissing-braces'. 
		'-Wparentheses'. 
		'-Wunused-function'. 
		'-Wunused-label'. 
		'-Wunused-parameter'. 
		'-Wunused-variable'. 
		'-Wunused-value'. 
		'-Wsign-compare'. 
		'-DDEBUGVM=1'. 
		'-DEXTERNALPRIMSDEBUG=1'. 
		'-gdwarf-2' }! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'compiler flags' stamp: 'tty 6/9/2014 18:41'!
compilerFlagsRelease
" -mdynamic-no-pic "
	^ {
		'-gdwarf-2'. 
		'-O3'. 
		'-funroll-loops'. 
		'-ftree-vectorize'. 
		'-msse3'. 
		'-DDEBUGVM=0'. 
		'-DNDEBUG'. 
		'-Wunused-value'. 
		'-Wuninitialized'. 
		'-falign-functions=16'. 
		'-fno-gcse'. 
		'-mtune=prescott'. 
		'-march=pentium-m'. 
		'-mfpmath=sse'. 
		'-finline-functions'. 
		'-Wall'. 
		'-DUSE_INLINE_MEMORY_ACCESSORS' }! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:41'!
configureDropPlugin: maker
	"extra rules for DropPlugin"
	super configureDropPlugin: maker.  
	maker addPlatformSources: #( 'sqMacDragDrop')
! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:41'!
configureFFIPlugin: maker
	"extra rules for FFIPlugin"

	
	"Never generate this plugin. Because it is a legacy code.
	For Cog FFI, use ReentrantFFIPlugin  (ReentrantIA32FFIPlugin for x86) "
	
	maker doNotGenerate: true.
	
! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:41'!
configureFilePlugin: maker
	"extra rules for FilePlugin"

	super configureFilePlugin: maker.  
	
	maker includeDirectories: '${platformsDir}/unix/vm'.
	maker addPlatformSources: #( 'sqMacUnixFileInterface.c' 'sqMacDirectory.c')! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:41'!
configureHostWindowPlugin: maker
	"extra rules for HostWindowPlugin"

	super configureHostWindowPlugin: maker.  
	maker addPlatformSources: #( 'sqMacHostWindow.c' )
! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:41'!
configureSoundPlugin: maker 
	"extra rules for SoundPlugin"

	super configureSoundPlugin: maker.  
	maker includeDirectories: '${platformsDir}/unix/vm/'.
	maker addPlatformSources:
		#( 
			"This is commented because such file is not commited in the cog blessed commit hash f3fe94c828f66cd0e7c37cfa3434e384ff65915e. For more details see http://forum.world.st/Problem-generating-Mac-VM-td3438466.html "
			"'sqMacAudioDeviceList.c'"
			'sqMacUnixInterfaceSound.c' 
			'sqUnixSoundMacOSXJMM.c'
		)


! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:41'!
configureUUIDPlugin: maker 
	"extra rules for UUIDPlugin"

	super configureUUIDPlugin: maker.    
	maker addPlatformSources:
		#( 'sqMacUUID.c')


! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 18:41'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'plugins' stamp: 'tty 6/9/2014 18:41'!
defaultExternalPlugins

	^ #(
		BochsIA32Plugin
		CroquetPlugin
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
		FloatArrayPlugin
		FloatMathPlugin
		Mpeg3Plugin
		QuicktimePlugin 
"		TestOSAPlugin  - not works"
		"UnixOSProcessPlugin ?? "
		)! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'plugins' stamp: 'tty 6/9/2014 18:41'!
defaultInternalPlugins

	^ #(
		ADPCMCodecPlugin
		AsynchFilePlugin
		B3DAcceleratorPlugin
		BalloonEnginePlugin "B2DPlugin" 
		BitBltSimulation "BitBltPlugin"
		BMPReadWriterPlugin
		DeflatePlugin  "ZipPlugin"
		DropPlugin
		DSAPlugin "DSAPrims"
		FFTPlugin
		FilePlugin
		HostWindowPlugin
		IA32ABIPlugin "IA32ABI"
		InternetConfigPlugin
		JoystickTabletPlugin
		JPEGReaderPlugin
		JPEGReadWriter2Plugin
		KlattSynthesizerPlugin "Klatt"
		LargeIntegersPlugin "LargeIntegers"
		LocalePlugin
		MacMenubarPlugin
		Matrix2x3Plugin
		MIDIPlugin
		MiscPrimitivePlugin
		"QVMProfileMacSupportPlugin"
		RePlugin
		SecurityPlugin
		SerialPlugin
		SocketPlugin
		SoundCodecPlugin "SoundCodecPrims"
		SoundGenerationPlugin
		SoundPlugin
		StarSqueakPlugin
		SurfacePlugin
		UUIDPlugin
		VMProfileMacSupportPlugin
		)! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:10'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. default is squeak.cog.v3"
	^self newspeakSistaSpur! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:47'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:58'!
executableName
	^ self vmSistaExecutableName! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:41'!
executableType
	^ 'MACOSX_BUNDLE'! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'settings' stamp: 'tty 6/9/2014 18:41'!
extraPluginSettings: maker
	
	"Cog currently runs only in 32 bit mode" 
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 18:41'!
extraSources
	" mac VM using some unix sources"
	
	^ 
	'${platformsDir}/unix/plugins/SocketPlugin/sqUnixSocket.c 
	${platformsDir}/unix/vm/aio.c 
	${platformsDir}/unix/plugins/AsynchFilePlugin/sqUnixAsynchFile.c
	${platformsDir}/unix/vm/sqUnixHeartbeat.c
	${platformsDir}/unix/vm/sqUnixVMProfile.c
	${platformsDir}/unix/vm/sqUnixThreads.c
	${resources}'! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'settings' stamp: 'tty 6/9/2014 18:41'!
extraVMSettings: maker
	
	"Cog currently runs only in 32 bit mode" 
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'.

	maker set: 'resourceDir' toString: self resourcesDir, '/ProjectBuilder'.
	maker set: 'resources' to: 
		'"${resourceDir}/Squeak VM.r"
		"${resourceDir}/Cog.icns"
		"${resourceDir}/Squeak.icns"
		"${resourceDir}/SqueakChanges.icns"
		"${resourceDir}/SqueakImage.icns"
		"${resourceDir}/SqueakPlugin.icns"
		"${resourceDir}/SqueakScript.icns"
		"${resourceDir}/SqueakGeneric.icns"
		"${resourceDir}/SqueakProject.icns"
		"${resourceDir}/SqueakSources.icns"'
! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:41'!
frameworks

	^ #(
	Carbon
	AppKit
	IOKit
	CoreFoundation
	AudioToolbox
	CoreAudio
	OpenGL
	AGL
	QuickTime
	Foundation
	SystemConfiguration
	)! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 18:41'!
generateSourceFiles

	^ CMakeGenScripts generateCogSources: self! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:41'!
interpreterClass
	^ CoInterpreter! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:41'!
platformName
	^ 'Mac OS'! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 18:41'!
platformSources
	"files added from platform/Mac OS/vm dir "
	^ #(
	'NSCursorWrappers.m'
	'nsPoolManagement.m'
	'osExports.c'
	'sqMacEncoding.c'
	'sqMacImageIO.c'
	'sqMacMain.c'
	'sqMacMemory.c'
	'sqMacNSPluginUILogic2.c'
	'sqMacTime.c'
	'sqMacUIAppleEvents.c'
	'sqMacUIClipBoard.c'
	'sqMacUIEventsUniversal.c'  " instead of: sqMacUIEvents.c "
	'sqMacUIMenuBarUniversal.c'
	'sqMacUnixCommandLineInterface.c'
	'sqMacUnixExternalPrims.c'
	'sqMacWindowUniversal.c'
	'version.c'	
	)! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:41'!
plistFile

	| plist |
	
	plist := self plistTemplate.
	
	#(
	CFBundleExecutable
	CFBundleGetInfoString
	CFBundleName
	CFBundleShortVersionString
	CFBundleVersion
	CFBundleIconFile
	CFBundleIdentifier ) do: [:key |
		plist := plist copyReplaceAll: '@' , key , '@' with: (self perform: key)
	].

	^ self fixLineEndsOf: plist! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:41'!
plistTemplate
	^ 
	'<?xml version="1.0" encoding="UTF-8"?>
<!!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
<plist version="1.0">
<dict>
	<key>LSMinimumSystemVersion</key>
	<string>10.5.0</string>
	<key>CFBundleDevelopmentRegion</key>
	<string>English</string>
	<key>CFBundleDocumentTypes</key>
	<array>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>image</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Image File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STim</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sources</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Sources File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STso</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>changes</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Changes File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STch</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sobj</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakScript.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Script File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SOBJ</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>pr</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakProject.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Project File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STpr</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>JPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>JPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TEXT</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TEXT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ttro</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ttro</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HTML</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HTML</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>RTF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>RTF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TIFF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TIFF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PICT </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PICT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>URL  </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>URL</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ZIP </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ZIP</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>zip </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>zip</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>BINA</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>BINA</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>GIFf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>GIFf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PNGf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PNGf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3 </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>mp3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG2</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG2</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Mp3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>M3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>M3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>SRCS</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SRCS</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Chng</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>Chng</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HPS5</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HPS5</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>bundle</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakPlugin.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Plugin</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>BNDL</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
	</array>
	<key>CFBundleExecutable</key>
	<string>@CFBundleExecutable@</string>
	<key>CFBundleGetInfoString</key>
	<string>@CFBundleGetInfoString@</string>
	<key>CFBundleIconFile</key>
	<string>@CFBundleIconFile@</string>
	<key>CFBundleIdentifier</key>
	<string>@CFBundleIdentifier@</string>
	<key>CFBundleInfoDictionaryVersion</key>
	<string>6.0</string>
	<key>CFBundleName</key>
	<string>@CFBundleName@</string>
	<key>CFBundlePackageType</key>
	<string>APPL</string>
	<key>CFBundleShortVersionString</key>
	<string>@CFBundleShortVersionString@</string>
	<key>CFBundleSignature</key>
	<string>????</string>
	<key>CFBundleVersion</key>
	<string>@CFBundleVersion@</string>
	<key>CGDisableCoalescedUpdates</key>
	<true/>
	<key>LSBackgroundOnly</key>
	<false/>
	<key>NSServices</key>
	<array>
		<dict>
			<key>NSMenuItem</key>
			<dict>
				<key>default</key>
				<string>Squeak DoIt</string>
			</dict>
			<key>NSMessage</key>
			<string>doitandreturn</string>
			<key>NSPortName</key>
			<string>Squeak</string>
			<key>NSReturnTypes</key>
			<array>
				<string>NSStringPboardType</string>
			</array>
			<key>NSSendTypes</key>
			<array>
				<string>NSStringPboardType</string>
			</array>
		</dict>
	</array>
	<key>SqueakBrowserMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakDebug</key>
	<integer>0</integer>
	<key>SqueakEncodingType</key>
	<string>UTF-8</string>
	<key>SqueakExplicitWindowOpenNeeded</key>
	<false/>
	<key>SqueakFloatingWindowGetsFocus</key>
	<true/>
	<key>SqueakHasQuitWithoutSaving</key>
	<false/>
	<key>SqueakImageName</key>
	<string>Squeak.image</string>
	<key>SqueakMaxHeapSize</key>
	<integer>536870912</integer>
	<key>SqueakMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakPluginsBuiltInOrLocalOnly</key>
	<false/>
	<key>SqueakUIFlushPrimaryDeferNMilliseconds</key>
	<integer>20</integer>
	<key>SqueakUIFlushSecondaryCheckForPossibleNeedEveryNMilliseconds</key>
	<integer>20</integer>
	<key>SqueakUIFlushSecondaryCleanupDelayMilliseconds</key>
	<integer>25</integer>
	<key>SqueakUIFlushUseHighPercisionClock</key>
	<true/>
	<key>SqueakUnTrustedDirectory</key>
	<string>~/Library/Preferences/Croquet/Internet/Untrusted/</string>
	<key>SqueakWindowAttribute</key>
	<data>ggAAHw==</data>
	<key>SqueakWindowHasTitle</key>
	<true/>
	<key>SqueakWindowType</key>
	<integer>6</integer>
</dict>
</plist>
'! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:41'!
prepareForGeneration
	^ self prepareForCogGeneration
! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'settings' stamp: 'tty 6/9/2014 18:41'!
setExtraTargetProperties: maker

	super setExtraTargetProperties: maker.

	maker addFrameworks: self frameworks.	

	" generated and add Info.plist file "
	self write: self plistFile toFile: 'Info.plist'.
	maker 
		addProperty: 'MACOSX_BUNDLE_INFO_PLIST' 
		value: '${buildDir}/Info.plist'.

	maker cmd: 'set_source_files_properties' params: '${resources} PROPERTIES MACOSX_PACKAGE_LOCATION Resources'.
	
	maker set: 'EXECUTABLE_OUTPUT_PATH' to: '${outputDir}'.! !

!SqueakMacOSNewspeakSistaSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 18:41'!
standardIncludes
	^ #(
	'SYSTEM /Developer/Headers/FlatCarbon'
	'${targetPlatform}/vm/Developer'  "for some unknown reason sqGnu.h is put there"
	
	'${crossDir}/plugins/SerialPlugin'   "for platforms/Mac OS/vm/osExports.c to work"
	'${targetPlatform}/plugins/FilePlugin'   "for sqMacFileLogic.h to work"
	'${targetPlatform}/plugins/HostWindowPlugin'  "for sqMacNSPluginUILogic2.c to work"
	'${crossDir}/plugins/HostWindowPlugin' "for same... "
	'${crossDir}/plugins/DropPlugin' "include DropPlugin.h"
	'${crossDir}/plugins/SocketPlugin'
	'${crossDir}/plugins/AsynchFilePlugin'
	'${platformsDir}/unix/vm'  "suppressing following:
		platforms/Mac OS/vm/sqMacMain.c:94:19: error: sqaio.h: No such file or directory
		platforms/Mac OS/vm/sqMacMain.c:96:28: error: sqUnixCharConv.h: No such file or directory"
	)
	! !

SqueakMacOSV3Config subclass: #SqueakMacOSNewspeakSistaV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOS'!

!SqueakMacOSNewspeakSistaV3Config commentStamp: 'tty 6/15/2014 13:47' prior: 0!
This is a concrete configuration for building a CogVM 32 bit on Mac OS.

It is using a Carbon framework , which eventually will be replaced by Cocoa. (see CocoaIOSConfig and its subclasses).

SqueakMacOSBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:41'!
CFBundleExecutable
	^ self executableName ! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:41'!
CFBundleGetInfoString

	^ self CFBundleShortVersionString
! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:41'!
CFBundleIconFile

	"An application icon"
	^ 'Cog.icns'! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:41'!
CFBundleIdentifier

	"A Java package style name (like 'com.myCompany.MyBundle') which is used to uniquely identify bundles."
	
	^ 'org.squeak.Cog'! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:41'!
CFBundleName

	"An application name"
	^ self executableName, ' (Carbon) 32bits'! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:41'!
CFBundleShortVersionString

	"An application version"
	^ self executableName, ' VM ' , self CFBundleVersion! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:41'!
CFBundleVersion

	"An application version"
	^ '4.0.0'! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:41'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'compiler flags' stamp: 'tty 6/9/2014 18:41'!
commonCompilerFlags

	"Common compiler flags"
	
	^ { 
		'-fmessage-length=0'. 
		'-Wno-trigraphs'. 
		'-fpascal-strings'. 
		'-fasm-blocks'. 
		'-DCOGMTVM=0'. 
		'-DUSE_GLOBAL_STRUCT=0'. 
		'-DTARGET_API_MAC_CARBON'. 
		'-DBUILD_FOR_OSX'. 
		'-DHAVE_SYS_TIME_H'. 
		'-mmacosx-version-min=10.5' }	
! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'compiler flags' stamp: 'tty 6/9/2014 18:41'!
compilerFlagsDebug

	^ {
		'-g3'. 
		'-O0'. 
		'-Wmissing-prototypes'. 
		'-Wmissing-braces'. 
		'-Wparentheses'. 
		'-Wunused-function'. 
		'-Wunused-label'. 
		'-Wunused-parameter'. 
		'-Wunused-variable'. 
		'-Wunused-value'. 
		'-Wsign-compare'. 
		'-DDEBUGVM=1'. 
		'-DEXTERNALPRIMSDEBUG=1'. 
		'-gdwarf-2' }! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'compiler flags' stamp: 'tty 6/9/2014 18:41'!
compilerFlagsRelease
" -mdynamic-no-pic "
	^ {
		'-gdwarf-2'. 
		'-O3'. 
		'-funroll-loops'. 
		'-ftree-vectorize'. 
		'-msse3'. 
		'-DDEBUGVM=0'. 
		'-DNDEBUG'. 
		'-Wunused-value'. 
		'-Wuninitialized'. 
		'-falign-functions=16'. 
		'-fno-gcse'. 
		'-mtune=prescott'. 
		'-march=pentium-m'. 
		'-mfpmath=sse'. 
		'-finline-functions'. 
		'-Wall'. 
		'-DUSE_INLINE_MEMORY_ACCESSORS' }! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:41'!
configureDropPlugin: maker
	"extra rules for DropPlugin"
	super configureDropPlugin: maker.  
	maker addPlatformSources: #( 'sqMacDragDrop')
! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:41'!
configureFFIPlugin: maker
	"extra rules for FFIPlugin"

	
	"Never generate this plugin. Because it is a legacy code.
	For Cog FFI, use ReentrantFFIPlugin  (ReentrantIA32FFIPlugin for x86) "
	
	maker doNotGenerate: true.
	
! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:41'!
configureFilePlugin: maker
	"extra rules for FilePlugin"

	super configureFilePlugin: maker.  
	
	maker includeDirectories: '${platformsDir}/unix/vm'.
	maker addPlatformSources: #( 'sqMacUnixFileInterface.c' 'sqMacDirectory.c')! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:41'!
configureHostWindowPlugin: maker
	"extra rules for HostWindowPlugin"

	super configureHostWindowPlugin: maker.  
	maker addPlatformSources: #( 'sqMacHostWindow.c' )
! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:41'!
configureSoundPlugin: maker 
	"extra rules for SoundPlugin"

	super configureSoundPlugin: maker.  
	maker includeDirectories: '${platformsDir}/unix/vm/'.
	maker addPlatformSources:
		#( 
			"This is commented because such file is not commited in the cog blessed commit hash f3fe94c828f66cd0e7c37cfa3434e384ff65915e. For more details see http://forum.world.st/Problem-generating-Mac-VM-td3438466.html "
			"'sqMacAudioDeviceList.c'"
			'sqMacUnixInterfaceSound.c' 
			'sqUnixSoundMacOSXJMM.c'
		)


! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:41'!
configureUUIDPlugin: maker 
	"extra rules for UUIDPlugin"

	super configureUUIDPlugin: maker.    
	maker addPlatformSources:
		#( 'sqMacUUID.c')


! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'source files' stamp: 'tty 6/9/2014 18:41'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'plugins' stamp: 'tty 6/9/2014 18:41'!
defaultExternalPlugins

	^ #(
		BochsIA32Plugin
		CroquetPlugin
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
		FloatArrayPlugin
		FloatMathPlugin
		Mpeg3Plugin
		QuicktimePlugin 
"		TestOSAPlugin  - not works"
		"UnixOSProcessPlugin ?? "
		)! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'plugins' stamp: 'tty 6/9/2014 18:41'!
defaultInternalPlugins

	^ #(
		ADPCMCodecPlugin
		AsynchFilePlugin
		B3DAcceleratorPlugin
		BalloonEnginePlugin "B2DPlugin" 
		BitBltSimulation "BitBltPlugin"
		BMPReadWriterPlugin
		DeflatePlugin  "ZipPlugin"
		DropPlugin
		DSAPlugin "DSAPrims"
		FFTPlugin
		FilePlugin
		HostWindowPlugin
		IA32ABIPlugin "IA32ABI"
		InternetConfigPlugin
		JoystickTabletPlugin
		JPEGReaderPlugin
		JPEGReadWriter2Plugin
		KlattSynthesizerPlugin "Klatt"
		LargeIntegersPlugin "LargeIntegers"
		LocalePlugin
		MacMenubarPlugin
		Matrix2x3Plugin
		MIDIPlugin
		MiscPrimitivePlugin
		"QVMProfileMacSupportPlugin"
		RePlugin
		SecurityPlugin
		SerialPlugin
		SocketPlugin
		SoundCodecPlugin "SoundCodecPrims"
		SoundGenerationPlugin
		SoundPlugin
		StarSqueakPlugin
		SurfacePlugin
		UUIDPlugin
		VMProfileMacSupportPlugin
		)! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:11'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. default is squeak.cog.v3"
	^self newspeakSistaV3! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:47'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:58'!
executableName
	^ self vmSistaExecutableName! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:41'!
executableType
	^ 'MACOSX_BUNDLE'! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'settings' stamp: 'tty 6/9/2014 18:41'!
extraPluginSettings: maker
	
	"Cog currently runs only in 32 bit mode" 
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'source files' stamp: 'tty 6/9/2014 18:41'!
extraSources
	" mac VM using some unix sources"
	
	^ 
	'${platformsDir}/unix/plugins/SocketPlugin/sqUnixSocket.c 
	${platformsDir}/unix/vm/aio.c 
	${platformsDir}/unix/plugins/AsynchFilePlugin/sqUnixAsynchFile.c
	${platformsDir}/unix/vm/sqUnixHeartbeat.c
	${platformsDir}/unix/vm/sqUnixVMProfile.c
	${platformsDir}/unix/vm/sqUnixThreads.c
	${resources}'! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'settings' stamp: 'tty 6/9/2014 18:41'!
extraVMSettings: maker
	
	"Cog currently runs only in 32 bit mode" 
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'.

	maker set: 'resourceDir' toString: self resourcesDir, '/ProjectBuilder'.
	maker set: 'resources' to: 
		'"${resourceDir}/Squeak VM.r"
		"${resourceDir}/Cog.icns"
		"${resourceDir}/Squeak.icns"
		"${resourceDir}/SqueakChanges.icns"
		"${resourceDir}/SqueakImage.icns"
		"${resourceDir}/SqueakPlugin.icns"
		"${resourceDir}/SqueakScript.icns"
		"${resourceDir}/SqueakGeneric.icns"
		"${resourceDir}/SqueakProject.icns"
		"${resourceDir}/SqueakSources.icns"'
! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:41'!
frameworks

	^ #(
	Carbon
	AppKit
	IOKit
	CoreFoundation
	AudioToolbox
	CoreAudio
	OpenGL
	AGL
	QuickTime
	Foundation
	SystemConfiguration
	)! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'source files' stamp: 'tty 6/9/2014 18:41'!
generateSourceFiles

	^ CMakeGenScripts generateCogSources: self! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:41'!
interpreterClass
	^ CoInterpreter! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:41'!
platformName
	^ 'Mac OS'! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'source files' stamp: 'tty 6/9/2014 18:41'!
platformSources
	"files added from platform/Mac OS/vm dir "
	^ #(
	'NSCursorWrappers.m'
	'nsPoolManagement.m'
	'osExports.c'
	'sqMacEncoding.c'
	'sqMacImageIO.c'
	'sqMacMain.c'
	'sqMacMemory.c'
	'sqMacNSPluginUILogic2.c'
	'sqMacTime.c'
	'sqMacUIAppleEvents.c'
	'sqMacUIClipBoard.c'
	'sqMacUIEventsUniversal.c'  " instead of: sqMacUIEvents.c "
	'sqMacUIMenuBarUniversal.c'
	'sqMacUnixCommandLineInterface.c'
	'sqMacUnixExternalPrims.c'
	'sqMacWindowUniversal.c'
	'version.c'	
	)! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:41'!
plistFile

	| plist |
	
	plist := self plistTemplate.
	
	#(
	CFBundleExecutable
	CFBundleGetInfoString
	CFBundleName
	CFBundleShortVersionString
	CFBundleVersion
	CFBundleIconFile
	CFBundleIdentifier ) do: [:key |
		plist := plist copyReplaceAll: '@' , key , '@' with: (self perform: key)
	].

	^ self fixLineEndsOf: plist! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:41'!
plistTemplate
	^ 
	'<?xml version="1.0" encoding="UTF-8"?>
<!!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
<plist version="1.0">
<dict>
	<key>LSMinimumSystemVersion</key>
	<string>10.5.0</string>
	<key>CFBundleDevelopmentRegion</key>
	<string>English</string>
	<key>CFBundleDocumentTypes</key>
	<array>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>image</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Image File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STim</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sources</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Sources File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STso</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>changes</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Changes File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STch</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sobj</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakScript.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Script File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SOBJ</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>pr</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakProject.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Project File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STpr</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>JPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>JPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TEXT</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TEXT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ttro</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ttro</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HTML</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HTML</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>RTF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>RTF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TIFF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TIFF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PICT </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PICT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>URL  </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>URL</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ZIP </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ZIP</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>zip </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>zip</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>BINA</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>BINA</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>GIFf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>GIFf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PNGf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PNGf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3 </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>mp3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG2</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG2</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Mp3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>M3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>M3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>SRCS</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SRCS</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Chng</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>Chng</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HPS5</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HPS5</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>bundle</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakPlugin.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Plugin</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>BNDL</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
	</array>
	<key>CFBundleExecutable</key>
	<string>@CFBundleExecutable@</string>
	<key>CFBundleGetInfoString</key>
	<string>@CFBundleGetInfoString@</string>
	<key>CFBundleIconFile</key>
	<string>@CFBundleIconFile@</string>
	<key>CFBundleIdentifier</key>
	<string>@CFBundleIdentifier@</string>
	<key>CFBundleInfoDictionaryVersion</key>
	<string>6.0</string>
	<key>CFBundleName</key>
	<string>@CFBundleName@</string>
	<key>CFBundlePackageType</key>
	<string>APPL</string>
	<key>CFBundleShortVersionString</key>
	<string>@CFBundleShortVersionString@</string>
	<key>CFBundleSignature</key>
	<string>????</string>
	<key>CFBundleVersion</key>
	<string>@CFBundleVersion@</string>
	<key>CGDisableCoalescedUpdates</key>
	<true/>
	<key>LSBackgroundOnly</key>
	<false/>
	<key>NSServices</key>
	<array>
		<dict>
			<key>NSMenuItem</key>
			<dict>
				<key>default</key>
				<string>Squeak DoIt</string>
			</dict>
			<key>NSMessage</key>
			<string>doitandreturn</string>
			<key>NSPortName</key>
			<string>Squeak</string>
			<key>NSReturnTypes</key>
			<array>
				<string>NSStringPboardType</string>
			</array>
			<key>NSSendTypes</key>
			<array>
				<string>NSStringPboardType</string>
			</array>
		</dict>
	</array>
	<key>SqueakBrowserMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakDebug</key>
	<integer>0</integer>
	<key>SqueakEncodingType</key>
	<string>UTF-8</string>
	<key>SqueakExplicitWindowOpenNeeded</key>
	<false/>
	<key>SqueakFloatingWindowGetsFocus</key>
	<true/>
	<key>SqueakHasQuitWithoutSaving</key>
	<false/>
	<key>SqueakImageName</key>
	<string>Squeak.image</string>
	<key>SqueakMaxHeapSize</key>
	<integer>536870912</integer>
	<key>SqueakMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakPluginsBuiltInOrLocalOnly</key>
	<false/>
	<key>SqueakUIFlushPrimaryDeferNMilliseconds</key>
	<integer>20</integer>
	<key>SqueakUIFlushSecondaryCheckForPossibleNeedEveryNMilliseconds</key>
	<integer>20</integer>
	<key>SqueakUIFlushSecondaryCleanupDelayMilliseconds</key>
	<integer>25</integer>
	<key>SqueakUIFlushUseHighPercisionClock</key>
	<true/>
	<key>SqueakUnTrustedDirectory</key>
	<string>~/Library/Preferences/Croquet/Internet/Untrusted/</string>
	<key>SqueakWindowAttribute</key>
	<data>ggAAHw==</data>
	<key>SqueakWindowHasTitle</key>
	<true/>
	<key>SqueakWindowType</key>
	<integer>6</integer>
</dict>
</plist>
'! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:41'!
prepareForGeneration
	^ self prepareForCogGeneration
! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'settings' stamp: 'tty 6/9/2014 18:41'!
setExtraTargetProperties: maker

	super setExtraTargetProperties: maker.

	maker addFrameworks: self frameworks.	

	" generated and add Info.plist file "
	self write: self plistFile toFile: 'Info.plist'.
	maker 
		addProperty: 'MACOSX_BUNDLE_INFO_PLIST' 
		value: '${buildDir}/Info.plist'.

	maker cmd: 'set_source_files_properties' params: '${resources} PROPERTIES MACOSX_PACKAGE_LOCATION Resources'.
	
	maker set: 'EXECUTABLE_OUTPUT_PATH' to: '${outputDir}'.! !

!SqueakMacOSNewspeakSistaV3Config methodsFor: 'source files' stamp: 'tty 6/9/2014 18:41'!
standardIncludes
	^ #(
	'SYSTEM /Developer/Headers/FlatCarbon'
	'${targetPlatform}/vm/Developer'  "for some unknown reason sqGnu.h is put there"
	
	'${crossDir}/plugins/SerialPlugin'   "for platforms/Mac OS/vm/osExports.c to work"
	'${targetPlatform}/plugins/FilePlugin'   "for sqMacFileLogic.h to work"
	'${targetPlatform}/plugins/HostWindowPlugin'  "for sqMacNSPluginUILogic2.c to work"
	'${crossDir}/plugins/HostWindowPlugin' "for same... "
	'${crossDir}/plugins/DropPlugin' "include DropPlugin.h"
	'${crossDir}/plugins/SocketPlugin'
	'${crossDir}/plugins/AsynchFilePlugin'
	'${platformsDir}/unix/vm'  "suppressing following:
		platforms/Mac OS/vm/sqMacMain.c:94:19: error: sqaio.h: No such file or directory
		platforms/Mac OS/vm/sqMacMain.c:96:28: error: sqUnixCharConv.h: No such file or directory"
	)
	! !

SqueakMacOSV3Config subclass: #SqueakMacOSNewspeakStackSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOS'!

!SqueakMacOSNewspeakStackSpurConfig commentStamp: 'tty 6/15/2014 13:47' prior: 0!
This is a concrete class which generates a StackVM for Mac using the Carbon library.

This configuration generates sources/build files for building Stack-based interpreter on Mac OS X.
It is using a Carbon framework , which will be replaced by Cocoa soon. (see CocoaIOSConfig and its subclasses).

SqueakMacOSBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp

!

!SqueakMacOSNewspeakStackSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 18:41'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!SqueakMacOSNewspeakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:11'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. default is squeak.cog.v3"
	^self newspeakStackSpur! !

!SqueakMacOSNewspeakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:48'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSNewspeakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:02'!
executableName
	^ self vmStackExecutableName! !

!SqueakMacOSNewspeakStackSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:41'!
interpreterClass
	^ StackInterpreter! !

!SqueakMacOSNewspeakStackSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:41'!
prepareForGeneration
	^ self prepareForStackVMGeneration
! !

SqueakMacOSV3Config subclass: #SqueakMacOSNewspeakStackV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOS'!

!SqueakMacOSNewspeakStackV3Config commentStamp: 'tty 6/15/2014 13:47' prior: 0!
This is a concrete class which generates a StackVM for Mac using the Carbon library.

This configuration generates sources/build files for building Stack-based interpreter on Mac OS X.
It is using a Carbon framework , which will be replaced by Cocoa soon. (see CocoaIOSConfig and its subclasses).

SqueakMacOSBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!SqueakMacOSNewspeakStackV3Config methodsFor: 'source files' stamp: 'tty 6/9/2014 18:41'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!SqueakMacOSNewspeakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:11'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. default is squeak.cog.v3"
	^self newspeakStackV3! !

!SqueakMacOSNewspeakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:48'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSNewspeakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:02'!
executableName
	^ self vmStackExecutableName! !

!SqueakMacOSNewspeakStackV3Config methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:41'!
interpreterClass
	^ StackInterpreter! !

!SqueakMacOSNewspeakStackV3Config methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:41'!
prepareForGeneration
	^ self prepareForStackVMGeneration
! !

SqueakMacOSV3Config subclass: #SqueakMacOSSqueakCogSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOS'!

!SqueakMacOSSqueakCogSpurConfig commentStamp: 'tty 6/15/2014 13:47' prior: 0!
This is a concrete configuration for building a CogVM 32 bit on Mac OS.

It is using a Carbon framework , which eventually will be replaced by Cocoa. (see CocoaIOSConfig and its subclasses).

SqueakMacOSBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
CFBundleExecutable
	^ self executableName ! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
CFBundleGetInfoString

	^ self CFBundleShortVersionString
! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
CFBundleIconFile

	"An application icon"
	^ 'Cog.icns'! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
CFBundleIdentifier

	"A Java package style name (like 'com.myCompany.MyBundle') which is used to uniquely identify bundles."
	
	^ 'org.squeak.Cog'! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
CFBundleName

	"An application name"
	^ self executableName, ' (Carbon) 32bits'! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
CFBundleShortVersionString

	"An application version"
	^ self executableName, ' VM ' , self CFBundleVersion! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
CFBundleVersion

	"An application version"
	^ '4.0.0'! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:40'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'compiler flags' stamp: 'tty 6/9/2014 18:40'!
commonCompilerFlags

	"Common compiler flags"
	
	^ { 
		'-fmessage-length=0'. 
		'-Wno-trigraphs'. 
		'-fpascal-strings'. 
		'-fasm-blocks'. 
		'-DCOGMTVM=0'. 
		'-DUSE_GLOBAL_STRUCT=0'. 
		'-DTARGET_API_MAC_CARBON'. 
		'-DBUILD_FOR_OSX'. 
		'-DHAVE_SYS_TIME_H'. 
		'-mmacosx-version-min=10.5' }	
! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'compiler flags' stamp: 'tty 6/9/2014 18:40'!
compilerFlagsDebug

	^ {
		'-g3'. 
		'-O0'. 
		'-Wmissing-prototypes'. 
		'-Wmissing-braces'. 
		'-Wparentheses'. 
		'-Wunused-function'. 
		'-Wunused-label'. 
		'-Wunused-parameter'. 
		'-Wunused-variable'. 
		'-Wunused-value'. 
		'-Wsign-compare'. 
		'-DDEBUGVM=1'. 
		'-DEXTERNALPRIMSDEBUG=1'. 
		'-gdwarf-2' }! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'compiler flags' stamp: 'tty 6/9/2014 18:40'!
compilerFlagsRelease
" -mdynamic-no-pic "
	^ {
		'-gdwarf-2'. 
		'-O3'. 
		'-funroll-loops'. 
		'-ftree-vectorize'. 
		'-msse3'. 
		'-DDEBUGVM=0'. 
		'-DNDEBUG'. 
		'-Wunused-value'. 
		'-Wuninitialized'. 
		'-falign-functions=16'. 
		'-fno-gcse'. 
		'-mtune=prescott'. 
		'-march=pentium-m'. 
		'-mfpmath=sse'. 
		'-finline-functions'. 
		'-Wall'. 
		'-DUSE_INLINE_MEMORY_ACCESSORS' }! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:40'!
configureDropPlugin: maker
	"extra rules for DropPlugin"
	super configureDropPlugin: maker.  
	maker addPlatformSources: #( 'sqMacDragDrop')
! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:40'!
configureFFIPlugin: maker
	"extra rules for FFIPlugin"

	
	"Never generate this plugin. Because it is a legacy code.
	For Cog FFI, use ReentrantFFIPlugin  (ReentrantIA32FFIPlugin for x86) "
	
	maker doNotGenerate: true.
	
! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:40'!
configureFilePlugin: maker
	"extra rules for FilePlugin"

	super configureFilePlugin: maker.  
	
	maker includeDirectories: '${platformsDir}/unix/vm'.
	maker addPlatformSources: #( 'sqMacUnixFileInterface.c' 'sqMacDirectory.c')! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:40'!
configureHostWindowPlugin: maker
	"extra rules for HostWindowPlugin"

	super configureHostWindowPlugin: maker.  
	maker addPlatformSources: #( 'sqMacHostWindow.c' )
! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:40'!
configureSoundPlugin: maker 
	"extra rules for SoundPlugin"

	super configureSoundPlugin: maker.  
	maker includeDirectories: '${platformsDir}/unix/vm/'.
	maker addPlatformSources:
		#( 
			"This is commented because such file is not commited in the cog blessed commit hash f3fe94c828f66cd0e7c37cfa3434e384ff65915e. For more details see http://forum.world.st/Problem-generating-Mac-VM-td3438466.html "
			"'sqMacAudioDeviceList.c'"
			'sqMacUnixInterfaceSound.c' 
			'sqUnixSoundMacOSXJMM.c'
		)


! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:40'!
configureUUIDPlugin: maker 
	"extra rules for UUIDPlugin"

	super configureUUIDPlugin: maker.    
	maker addPlatformSources:
		#( 'sqMacUUID.c')


! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 18:40'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'plugins' stamp: 'tty 6/9/2014 18:40'!
defaultExternalPlugins

	^ #(
		BochsIA32Plugin
		CroquetPlugin
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
		FloatArrayPlugin
		FloatMathPlugin
		Mpeg3Plugin
		QuicktimePlugin 
"		TestOSAPlugin  - not works"
		"UnixOSProcessPlugin ?? "
		)! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'plugins' stamp: 'tty 6/9/2014 18:40'!
defaultInternalPlugins

	^ #(
		ADPCMCodecPlugin
		AsynchFilePlugin
		B3DAcceleratorPlugin
		BalloonEnginePlugin "B2DPlugin" 
		BitBltSimulation "BitBltPlugin"
		BMPReadWriterPlugin
		DeflatePlugin  "ZipPlugin"
		DropPlugin
		DSAPlugin "DSAPrims"
		FFTPlugin
		FilePlugin
		HostWindowPlugin
		IA32ABIPlugin "IA32ABI"
		InternetConfigPlugin
		JoystickTabletPlugin
		JPEGReaderPlugin
		JPEGReadWriter2Plugin
		KlattSynthesizerPlugin "Klatt"
		LargeIntegersPlugin "LargeIntegers"
		LocalePlugin
		MacMenubarPlugin
		Matrix2x3Plugin
		MIDIPlugin
		MiscPrimitivePlugin
		"QVMProfileMacSupportPlugin"
		RePlugin
		SecurityPlugin
		SerialPlugin
		SocketPlugin
		SoundCodecPlugin "SoundCodecPrims"
		SoundGenerationPlugin
		SoundPlugin
		StarSqueakPlugin
		SurfacePlugin
		UUIDPlugin
		VMProfileMacSupportPlugin
		)! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:11'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. default is squeak.cog.v3"
	^self squeakCogSpur! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:48'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:09'!
executableName
	^ self vmCogExecutableName! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:40'!
executableType
	^ 'MACOSX_BUNDLE'! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'settings' stamp: 'tty 6/9/2014 18:40'!
extraPluginSettings: maker
	
	"Cog currently runs only in 32 bit mode" 
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 18:40'!
extraSources
	" mac VM using some unix sources"
	
	^ 
	'${platformsDir}/unix/plugins/SocketPlugin/sqUnixSocket.c 
	${platformsDir}/unix/vm/aio.c 
	${platformsDir}/unix/plugins/AsynchFilePlugin/sqUnixAsynchFile.c
	${platformsDir}/unix/vm/sqUnixHeartbeat.c
	${platformsDir}/unix/vm/sqUnixVMProfile.c
	${platformsDir}/unix/vm/sqUnixThreads.c
	${resources}'! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'settings' stamp: 'tty 6/9/2014 18:40'!
extraVMSettings: maker
	
	"Cog currently runs only in 32 bit mode" 
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'.

	maker set: 'resourceDir' toString: self resourcesDir, '/ProjectBuilder'.
	maker set: 'resources' to: 
		'"${resourceDir}/Squeak VM.r"
		"${resourceDir}/Cog.icns"
		"${resourceDir}/Squeak.icns"
		"${resourceDir}/SqueakChanges.icns"
		"${resourceDir}/SqueakImage.icns"
		"${resourceDir}/SqueakPlugin.icns"
		"${resourceDir}/SqueakScript.icns"
		"${resourceDir}/SqueakGeneric.icns"
		"${resourceDir}/SqueakProject.icns"
		"${resourceDir}/SqueakSources.icns"'
! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:40'!
frameworks

	^ #(
	Carbon
	AppKit
	IOKit
	CoreFoundation
	AudioToolbox
	CoreAudio
	OpenGL
	AGL
	QuickTime
	Foundation
	SystemConfiguration
	)! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 18:40'!
generateSourceFiles

	^ CMakeGenScripts generateCogSources: self! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:40'!
interpreterClass
	^ CoInterpreter! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:40'!
platformName
	^ 'Mac OS'! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 18:40'!
platformSources
	"files added from platform/Mac OS/vm dir "
	^ #(
	'NSCursorWrappers.m'
	'nsPoolManagement.m'
	'osExports.c'
	'sqMacEncoding.c'
	'sqMacImageIO.c'
	'sqMacMain.c'
	'sqMacMemory.c'
	'sqMacNSPluginUILogic2.c'
	'sqMacTime.c'
	'sqMacUIAppleEvents.c'
	'sqMacUIClipBoard.c'
	'sqMacUIEventsUniversal.c'  " instead of: sqMacUIEvents.c "
	'sqMacUIMenuBarUniversal.c'
	'sqMacUnixCommandLineInterface.c'
	'sqMacUnixExternalPrims.c'
	'sqMacWindowUniversal.c'
	'version.c'	
	)! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
plistFile

	| plist |
	
	plist := self plistTemplate.
	
	#(
	CFBundleExecutable
	CFBundleGetInfoString
	CFBundleName
	CFBundleShortVersionString
	CFBundleVersion
	CFBundleIconFile
	CFBundleIdentifier ) do: [:key |
		plist := plist copyReplaceAll: '@' , key , '@' with: (self perform: key)
	].

	^ self fixLineEndsOf: plist! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
plistTemplate
	^ 
	'<?xml version="1.0" encoding="UTF-8"?>
<!!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
<plist version="1.0">
<dict>
	<key>LSMinimumSystemVersion</key>
	<string>10.5.0</string>
	<key>CFBundleDevelopmentRegion</key>
	<string>English</string>
	<key>CFBundleDocumentTypes</key>
	<array>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>image</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Image File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STim</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sources</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Sources File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STso</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>changes</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Changes File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STch</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sobj</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakScript.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Script File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SOBJ</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>pr</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakProject.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Project File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STpr</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>JPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>JPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TEXT</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TEXT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ttro</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ttro</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HTML</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HTML</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>RTF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>RTF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TIFF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TIFF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PICT </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PICT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>URL  </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>URL</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ZIP </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ZIP</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>zip </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>zip</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>BINA</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>BINA</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>GIFf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>GIFf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PNGf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PNGf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3 </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>mp3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG2</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG2</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Mp3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>M3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>M3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>SRCS</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SRCS</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Chng</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>Chng</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HPS5</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HPS5</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>bundle</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakPlugin.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Plugin</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>BNDL</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
	</array>
	<key>CFBundleExecutable</key>
	<string>@CFBundleExecutable@</string>
	<key>CFBundleGetInfoString</key>
	<string>@CFBundleGetInfoString@</string>
	<key>CFBundleIconFile</key>
	<string>@CFBundleIconFile@</string>
	<key>CFBundleIdentifier</key>
	<string>@CFBundleIdentifier@</string>
	<key>CFBundleInfoDictionaryVersion</key>
	<string>6.0</string>
	<key>CFBundleName</key>
	<string>@CFBundleName@</string>
	<key>CFBundlePackageType</key>
	<string>APPL</string>
	<key>CFBundleShortVersionString</key>
	<string>@CFBundleShortVersionString@</string>
	<key>CFBundleSignature</key>
	<string>????</string>
	<key>CFBundleVersion</key>
	<string>@CFBundleVersion@</string>
	<key>CGDisableCoalescedUpdates</key>
	<true/>
	<key>LSBackgroundOnly</key>
	<false/>
	<key>NSServices</key>
	<array>
		<dict>
			<key>NSMenuItem</key>
			<dict>
				<key>default</key>
				<string>Squeak DoIt</string>
			</dict>
			<key>NSMessage</key>
			<string>doitandreturn</string>
			<key>NSPortName</key>
			<string>Squeak</string>
			<key>NSReturnTypes</key>
			<array>
				<string>NSStringPboardType</string>
			</array>
			<key>NSSendTypes</key>
			<array>
				<string>NSStringPboardType</string>
			</array>
		</dict>
	</array>
	<key>SqueakBrowserMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakDebug</key>
	<integer>0</integer>
	<key>SqueakEncodingType</key>
	<string>UTF-8</string>
	<key>SqueakExplicitWindowOpenNeeded</key>
	<false/>
	<key>SqueakFloatingWindowGetsFocus</key>
	<true/>
	<key>SqueakHasQuitWithoutSaving</key>
	<false/>
	<key>SqueakImageName</key>
	<string>Squeak.image</string>
	<key>SqueakMaxHeapSize</key>
	<integer>536870912</integer>
	<key>SqueakMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakPluginsBuiltInOrLocalOnly</key>
	<false/>
	<key>SqueakUIFlushPrimaryDeferNMilliseconds</key>
	<integer>20</integer>
	<key>SqueakUIFlushSecondaryCheckForPossibleNeedEveryNMilliseconds</key>
	<integer>20</integer>
	<key>SqueakUIFlushSecondaryCleanupDelayMilliseconds</key>
	<integer>25</integer>
	<key>SqueakUIFlushUseHighPercisionClock</key>
	<true/>
	<key>SqueakUnTrustedDirectory</key>
	<string>~/Library/Preferences/Croquet/Internet/Untrusted/</string>
	<key>SqueakWindowAttribute</key>
	<data>ggAAHw==</data>
	<key>SqueakWindowHasTitle</key>
	<true/>
	<key>SqueakWindowType</key>
	<integer>6</integer>
</dict>
</plist>
'! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:40'!
prepareForGeneration
	^ self prepareForCogGeneration
! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'settings' stamp: 'tty 6/9/2014 18:40'!
setExtraTargetProperties: maker

	super setExtraTargetProperties: maker.

	maker addFrameworks: self frameworks.	

	" generated and add Info.plist file "
	self write: self plistFile toFile: 'Info.plist'.
	maker 
		addProperty: 'MACOSX_BUNDLE_INFO_PLIST' 
		value: '${buildDir}/Info.plist'.

	maker cmd: 'set_source_files_properties' params: '${resources} PROPERTIES MACOSX_PACKAGE_LOCATION Resources'.
	
	maker set: 'EXECUTABLE_OUTPUT_PATH' to: '${outputDir}'.! !

!SqueakMacOSSqueakCogSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 18:40'!
standardIncludes
	^ #(
	'SYSTEM /Developer/Headers/FlatCarbon'
	'${targetPlatform}/vm/Developer'  "for some unknown reason sqGnu.h is put there"
	
	'${crossDir}/plugins/SerialPlugin'   "for platforms/Mac OS/vm/osExports.c to work"
	'${targetPlatform}/plugins/FilePlugin'   "for sqMacFileLogic.h to work"
	'${targetPlatform}/plugins/HostWindowPlugin'  "for sqMacNSPluginUILogic2.c to work"
	'${crossDir}/plugins/HostWindowPlugin' "for same... "
	'${crossDir}/plugins/DropPlugin' "include DropPlugin.h"
	'${crossDir}/plugins/SocketPlugin'
	'${crossDir}/plugins/AsynchFilePlugin'
	'${platformsDir}/unix/vm'  "suppressing following:
		platforms/Mac OS/vm/sqMacMain.c:94:19: error: sqaio.h: No such file or directory
		platforms/Mac OS/vm/sqMacMain.c:96:28: error: sqUnixCharConv.h: No such file or directory"
	)
	! !

SqueakMacOSV3Config subclass: #SqueakMacOSSqueakCogV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOS'!

!SqueakMacOSSqueakCogV3Config commentStamp: 'tty 6/15/2014 13:47' prior: 0!
This is a concrete configuration for building a CogVM 32 bit on Mac OS.

It is using a Carbon framework , which eventually will be replaced by Cocoa. (see CocoaIOSConfig and its subclasses).

SqueakMacOSBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

SqueakMacOSSqueakCogV3Config subclass: #SqueakMacOSCogV3DebugConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-IslandOfMisfitToys'!

!SqueakMacOSCogV3DebugConfig commentStamp: 'tty 5/22/2014 14:32' prior: 0!
This is a concrete class which generates a DEBUG CogVM for Mac using Carbon library. This VM is normally known as a debug CogVM. The debug means that it is compiled with all the necessary symbolic symbols for debugging and can be debugged, for example, with GDB.

For more information, check the class comments of all the superclasses.


Usage:
SqueakCogMacOSDebugConfig generateWithSources.
or:
SqueakCogMacOSDebugConfig generate.!

!SqueakMacOSCogV3DebugConfig methodsFor: 'accessing' stamp: 'tty 6/16/2014 20:14'!
compilerFlags
	|d commonFlags flags|
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self compilerFlagsBuild];
		at: #buildAssert  put: [self compilerFlagsAssert];
		at: #buildAssertITimerHeartbeat  put: [self compilerFlagsAssertITimerHeartbeat];
            at:#buildDebug  put: [self compilerFlagsDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self compilerFlagsDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self compilerFlagsIHeartbeatTimer];
		at: #buildMultiThreaded  put: [self compilerFlagsMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self compilerFlagsMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self compilerFlagsMultiThreadedDebug ];
		at: #buildNone put:[self compilerFlagsNoBuildType].

    flags:= String streamContents: [ :stream |
	 (((d at:  buildType) value)  collect: #withBlanksTrimmed as: Set)
		asStringOn: stream 
		delimiter:' '].

    commonFlags:=String streamContents: [ :stream |
		((self commonCompilerFlags) collect: #withBlanksTrimmed as: Set)
			asStringOn: stream 
			delimiter: ' ' ].
	^ commonFlags, ' ' ,flags.! !

!SqueakMacOSCogV3DebugConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:47'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

SqueakMacOSSqueakCogV3Config subclass: #SqueakMacOSCogV3MultiThreadedConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-IslandOfMisfitToys'!

!SqueakMacOSCogV3MultiThreadedConfig commentStamp: 'tty 5/22/2014 14:37' prior: 0!
This is a concrete class which generates a thread-aware VM and threaded FFI CogVM for Mac using the Carbon library. This VM is normally known as CogMTVM.

Fore more information, check the class comments of all the superclasses.
!

!SqueakMacOSCogV3MultiThreadedConfig methodsFor: 'compiler flags' stamp: 'tty 5/22/2014 14:37'!
commonCompilerFlags

	"Common compiler flags"
	
	^ { 
		'-fmessage-length=0'.
		'-Wno-trigraphs'. 
		'-fpascal-strings'. 
		'-fasm-blocks'. 
		'-DCOGMTVM=1'.
		'-DUSE_GLOBAL_STRUCT=0'.
		'-DTARGET_API_MAC_CARBON'.
		'-DHAVE_SYS_TIME_H'.
		'-mmacosx-version-min=10.5' }! !

!SqueakMacOSCogV3MultiThreadedConfig methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 14:37'!
configureReentrantIA32FFIPlugin: maker
	self error: 'use ThreadedIA32FFIPlugin instead'
! !

!SqueakMacOSCogV3MultiThreadedConfig methodsFor: 'source files' stamp: 'tty 5/22/2014 14:37'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerpmt.c'
		)! !

!SqueakMacOSCogV3MultiThreadedConfig methodsFor: 'plugins' stamp: 'tty 5/22/2014 14:38'!
defaultExternalPlugins

	^ #(
		BochsIA32Plugin
		CroquetPlugin
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
		FloatArrayPlugin
		FloatMathPlugin
		Mpeg3Plugin
		"UnixOSProcessPlugin ?? "
	)! !

!SqueakMacOSCogV3MultiThreadedConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:47'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSCogV3MultiThreadedConfig methodsFor: 'accessing' stamp: 'tty 5/22/2014 14:37'!
executableName
	^ 'CogMTVM'! !

!SqueakMacOSCogV3MultiThreadedConfig methodsFor: 'source generation' stamp: 'tty 5/22/2014 14:38'!
interpreterClass
	^ CoInterpreterMT! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 12:31'!
CFBundleExecutable
	^ self executableName ! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 12:31'!
CFBundleGetInfoString

	^ self CFBundleShortVersionString
! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 12:31'!
CFBundleIconFile

	"An application icon"
	^ 'Cog.icns'! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 12:31'!
CFBundleIdentifier

	"A Java package style name (like 'com.myCompany.MyBundle') which is used to uniquely identify bundles."
	
	^ 'org.squeak.Cog'! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 12:31'!
CFBundleName

	"An application name"
	^ self executableName, ' (Carbon) 32bits'! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 12:31'!
CFBundleShortVersionString

	"An application version"
	^ self executableName, ' VM ' , self CFBundleVersion! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 12:31'!
CFBundleVersion

	"An application version"
	^ '4.0.0'! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'source generation' stamp: 'tty 5/22/2014 12:31'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'compiler flags' stamp: 'tty 5/22/2014 12:31'!
commonCompilerFlags

	"Common compiler flags"
	
	^ { 
		'-fmessage-length=0'. 
		'-Wno-trigraphs'. 
		'-fpascal-strings'. 
		'-fasm-blocks'. 
		'-DCOGMTVM=0'. 
		'-DUSE_GLOBAL_STRUCT=0'. 
		'-DTARGET_API_MAC_CARBON'. 
		'-DBUILD_FOR_OSX'. 
		'-DHAVE_SYS_TIME_H'. 
		'-mmacosx-version-min=10.5' }	
! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'compiler flags' stamp: 'tty 5/22/2014 12:31'!
compilerFlagsDebug

	^ {
		'-g3'. 
		'-O0'. 
		'-Wmissing-prototypes'. 
		'-Wmissing-braces'. 
		'-Wparentheses'. 
		'-Wunused-function'. 
		'-Wunused-label'. 
		'-Wunused-parameter'. 
		'-Wunused-variable'. 
		'-Wunused-value'. 
		'-Wsign-compare'. 
		'-DDEBUGVM=1'. 
		'-DEXTERNALPRIMSDEBUG=1'. 
		'-gdwarf-2' }! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'compiler flags' stamp: 'tty 5/22/2014 12:31'!
compilerFlagsRelease
" -mdynamic-no-pic "
	^ {
		'-gdwarf-2'. 
		'-O3'. 
		'-funroll-loops'. 
		'-ftree-vectorize'. 
		'-msse3'. 
		'-DDEBUGVM=0'. 
		'-DNDEBUG'. 
		'-Wunused-value'. 
		'-Wuninitialized'. 
		'-falign-functions=16'. 
		'-fno-gcse'. 
		'-mtune=prescott'. 
		'-march=pentium-m'. 
		'-mfpmath=sse'. 
		'-finline-functions'. 
		'-Wall'. 
		'-DUSE_INLINE_MEMORY_ACCESSORS' }! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 12:31'!
configureDropPlugin: maker
	"extra rules for DropPlugin"
	super configureDropPlugin: maker.  
	maker addPlatformSources: #( 'sqMacDragDrop')
! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 12:31'!
configureFFIPlugin: maker
	"extra rules for FFIPlugin"

	
	"Never generate this plugin. Because it is a legacy code.
	For Cog FFI, use ReentrantFFIPlugin  (ReentrantIA32FFIPlugin for x86) "
	
	maker doNotGenerate: true.
	
! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 12:31'!
configureFilePlugin: maker
	"extra rules for FilePlugin"

	super configureFilePlugin: maker.  
	
	maker includeDirectories: '${platformsDir}/unix/vm'.
	maker addPlatformSources: #( 'sqMacUnixFileInterface.c' 'sqMacDirectory.c')! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 12:31'!
configureHostWindowPlugin: maker
	"extra rules for HostWindowPlugin"

	super configureHostWindowPlugin: maker.  
	maker addPlatformSources: #( 'sqMacHostWindow.c' )
! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 12:31'!
configureSoundPlugin: maker 
	"extra rules for SoundPlugin"

	super configureSoundPlugin: maker.  
	maker includeDirectories: '${platformsDir}/unix/vm/'.
	maker addPlatformSources:
		#( 
			"This is commented because such file is not commited in the cog blessed commit hash f3fe94c828f66cd0e7c37cfa3434e384ff65915e. For more details see http://forum.world.st/Problem-generating-Mac-VM-td3438466.html "
			"'sqMacAudioDeviceList.c'"
			'sqMacUnixInterfaceSound.c' 
			'sqUnixSoundMacOSXJMM.c'
		)


! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 12:31'!
configureUUIDPlugin: maker 
	"extra rules for UUIDPlugin"

	super configureUUIDPlugin: maker.    
	maker addPlatformSources:
		#( 'sqMacUUID.c')


! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'source files' stamp: 'tty 5/22/2014 12:31'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'plugins' stamp: 'tty 5/22/2014 14:28'!
defaultExternalPlugins

	^ #(
		BochsIA32Plugin
		CroquetPlugin
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
		FloatArrayPlugin
		FloatMathPlugin
		Mpeg3Plugin
		QuicktimePlugin 
"		TestOSAPlugin  - not works"
		"UnixOSProcessPlugin ?? "
		)! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'plugins' stamp: 'tty 6/2/2014 17:45'!
defaultInternalPlugins

	^ #(
		ADPCMCodecPlugin
		AsynchFilePlugin
		B3DAcceleratorPlugin
		BalloonEnginePlugin "B2DPlugin" 
		BitBltSimulation "BitBltPlugin"
		BMPReadWriterPlugin
		DeflatePlugin  "ZipPlugin"
		DropPlugin
		DSAPlugin "DSAPrims"
		FFTPlugin
		FilePlugin
		HostWindowPlugin
		IA32ABIPlugin "IA32ABI"
		InternetConfigPlugin
		JoystickTabletPlugin
		JPEGReaderPlugin
		JPEGReadWriter2Plugin
		KlattSynthesizerPlugin "Klatt"
		LargeIntegersPlugin "LargeIntegers"
		LocalePlugin
		MacMenubarPlugin
		Matrix2x3Plugin
		MIDIPlugin
		MiscPrimitivePlugin
		"QVMProfileMacSupportPlugin"
		RePlugin
		SecurityPlugin
		SerialPlugin
		SocketPlugin
		SoundCodecPlugin "SoundCodecPrims"
		SoundGenerationPlugin
		SoundPlugin
		StarSqueakPlugin
		SurfacePlugin
		UUIDPlugin
		VMProfileMacSupportPlugin
		)! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:11'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. default is squeak.cog.v3"
	^self squeakCogV3! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:48'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:09'!
executableName
	^ self vmCogExecutableName! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 12:31'!
executableType
	^ 'MACOSX_BUNDLE'! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'settings' stamp: 'tty 5/22/2014 12:31'!
extraPluginSettings: maker
	
	"Cog currently runs only in 32 bit mode" 
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'source files' stamp: 'tty 5/22/2014 12:31'!
extraSources
	" mac VM using some unix sources"
	
	^ 
	'${platformsDir}/unix/plugins/SocketPlugin/sqUnixSocket.c 
	${platformsDir}/unix/vm/aio.c 
	${platformsDir}/unix/plugins/AsynchFilePlugin/sqUnixAsynchFile.c
	${platformsDir}/unix/vm/sqUnixHeartbeat.c
	${platformsDir}/unix/vm/sqUnixVMProfile.c
	${platformsDir}/unix/vm/sqUnixThreads.c
	${resources}'! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'settings' stamp: 'tty 5/22/2014 12:31'!
extraVMSettings: maker
	
	"Cog currently runs only in 32 bit mode" 
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'.

	maker set: 'resourceDir' toString: self resourcesDir, '/ProjectBuilder'.
	maker set: 'resources' to: 
		'"${resourceDir}/Squeak VM.r"
		"${resourceDir}/Cog.icns"
		"${resourceDir}/Squeak.icns"
		"${resourceDir}/SqueakChanges.icns"
		"${resourceDir}/SqueakImage.icns"
		"${resourceDir}/SqueakPlugin.icns"
		"${resourceDir}/SqueakScript.icns"
		"${resourceDir}/SqueakGeneric.icns"
		"${resourceDir}/SqueakProject.icns"
		"${resourceDir}/SqueakSources.icns"'
! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 12:31'!
frameworks

	^ #(
	Carbon
	AppKit
	IOKit
	CoreFoundation
	AudioToolbox
	CoreAudio
	OpenGL
	AGL
	QuickTime
	Foundation
	SystemConfiguration
	)! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'source files' stamp: 'tty 5/22/2014 12:31'!
generateSourceFiles

	^ CMakeGenScripts generateCogSources: self! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'source generation' stamp: 'tty 5/22/2014 12:31'!
interpreterClass
	^ CoInterpreter! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 12:31'!
platformName
	^ 'Mac OS'! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'source files' stamp: 'tty 5/22/2014 12:31'!
platformSources
	"files added from platform/Mac OS/vm dir "
	^ #(
	'NSCursorWrappers.m'
	'nsPoolManagement.m'
	'osExports.c'
	'sqMacEncoding.c'
	'sqMacImageIO.c'
	'sqMacMain.c'
	'sqMacMemory.c'
	'sqMacNSPluginUILogic2.c'
	'sqMacTime.c'
	'sqMacUIAppleEvents.c'
	'sqMacUIClipBoard.c'
	'sqMacUIEventsUniversal.c'  " instead of: sqMacUIEvents.c "
	'sqMacUIMenuBarUniversal.c'
	'sqMacUnixCommandLineInterface.c'
	'sqMacUnixExternalPrims.c'
	'sqMacWindowUniversal.c'
	'version.c'	
	)! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 12:31'!
plistFile

	| plist |
	
	plist := self plistTemplate.
	
	#(
	CFBundleExecutable
	CFBundleGetInfoString
	CFBundleName
	CFBundleShortVersionString
	CFBundleVersion
	CFBundleIconFile
	CFBundleIdentifier ) do: [:key |
		plist := plist copyReplaceAll: '@' , key , '@' with: (self perform: key)
	].

	^ self fixLineEndsOf: plist! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'bundle strings' stamp: 'tty 5/22/2014 12:31'!
plistTemplate
	^ 
	'<?xml version="1.0" encoding="UTF-8"?>
<!!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
<plist version="1.0">
<dict>
	<key>LSMinimumSystemVersion</key>
	<string>10.5.0</string>
	<key>CFBundleDevelopmentRegion</key>
	<string>English</string>
	<key>CFBundleDocumentTypes</key>
	<array>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>image</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Image File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STim</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sources</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Sources File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STso</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>changes</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Changes File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STch</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sobj</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakScript.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Script File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SOBJ</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>pr</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakProject.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Project File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STpr</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>JPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>JPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TEXT</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TEXT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ttro</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ttro</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HTML</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HTML</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>RTF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>RTF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TIFF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TIFF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PICT </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PICT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>URL  </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>URL</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ZIP </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ZIP</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>zip </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>zip</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>BINA</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>BINA</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>GIFf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>GIFf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PNGf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PNGf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3 </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>mp3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG2</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG2</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Mp3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>M3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>M3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>SRCS</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SRCS</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Chng</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>Chng</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HPS5</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HPS5</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>bundle</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakPlugin.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Plugin</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>BNDL</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
	</array>
	<key>CFBundleExecutable</key>
	<string>@CFBundleExecutable@</string>
	<key>CFBundleGetInfoString</key>
	<string>@CFBundleGetInfoString@</string>
	<key>CFBundleIconFile</key>
	<string>@CFBundleIconFile@</string>
	<key>CFBundleIdentifier</key>
	<string>@CFBundleIdentifier@</string>
	<key>CFBundleInfoDictionaryVersion</key>
	<string>6.0</string>
	<key>CFBundleName</key>
	<string>@CFBundleName@</string>
	<key>CFBundlePackageType</key>
	<string>APPL</string>
	<key>CFBundleShortVersionString</key>
	<string>@CFBundleShortVersionString@</string>
	<key>CFBundleSignature</key>
	<string>????</string>
	<key>CFBundleVersion</key>
	<string>@CFBundleVersion@</string>
	<key>CGDisableCoalescedUpdates</key>
	<true/>
	<key>LSBackgroundOnly</key>
	<false/>
	<key>NSServices</key>
	<array>
		<dict>
			<key>NSMenuItem</key>
			<dict>
				<key>default</key>
				<string>Squeak DoIt</string>
			</dict>
			<key>NSMessage</key>
			<string>doitandreturn</string>
			<key>NSPortName</key>
			<string>Squeak</string>
			<key>NSReturnTypes</key>
			<array>
				<string>NSStringPboardType</string>
			</array>
			<key>NSSendTypes</key>
			<array>
				<string>NSStringPboardType</string>
			</array>
		</dict>
	</array>
	<key>SqueakBrowserMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakDebug</key>
	<integer>0</integer>
	<key>SqueakEncodingType</key>
	<string>UTF-8</string>
	<key>SqueakExplicitWindowOpenNeeded</key>
	<false/>
	<key>SqueakFloatingWindowGetsFocus</key>
	<true/>
	<key>SqueakHasQuitWithoutSaving</key>
	<false/>
	<key>SqueakImageName</key>
	<string>Squeak.image</string>
	<key>SqueakMaxHeapSize</key>
	<integer>536870912</integer>
	<key>SqueakMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakPluginsBuiltInOrLocalOnly</key>
	<false/>
	<key>SqueakUIFlushPrimaryDeferNMilliseconds</key>
	<integer>20</integer>
	<key>SqueakUIFlushSecondaryCheckForPossibleNeedEveryNMilliseconds</key>
	<integer>20</integer>
	<key>SqueakUIFlushSecondaryCleanupDelayMilliseconds</key>
	<integer>25</integer>
	<key>SqueakUIFlushUseHighPercisionClock</key>
	<true/>
	<key>SqueakUnTrustedDirectory</key>
	<string>~/Library/Preferences/Croquet/Internet/Untrusted/</string>
	<key>SqueakWindowAttribute</key>
	<data>ggAAHw==</data>
	<key>SqueakWindowHasTitle</key>
	<true/>
	<key>SqueakWindowType</key>
	<integer>6</integer>
</dict>
</plist>
'! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'source generation' stamp: 'tty 5/22/2014 12:31'!
prepareForGeneration
	^ self prepareForCogGeneration
! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'settings' stamp: 'tty 5/22/2014 12:31'!
setExtraTargetProperties: maker

	super setExtraTargetProperties: maker.

	maker addFrameworks: self frameworks.	

	" generated and add Info.plist file "
	self write: self plistFile toFile: 'Info.plist'.
	maker 
		addProperty: 'MACOSX_BUNDLE_INFO_PLIST' 
		value: '${buildDir}/Info.plist'.

	maker cmd: 'set_source_files_properties' params: '${resources} PROPERTIES MACOSX_PACKAGE_LOCATION Resources'.
	
	maker set: 'EXECUTABLE_OUTPUT_PATH' to: '${outputDir}'.! !

!SqueakMacOSSqueakCogV3Config methodsFor: 'source files' stamp: 'tty 5/22/2014 12:31'!
standardIncludes
	^ #(
	'SYSTEM /Developer/Headers/FlatCarbon'
	'${targetPlatform}/vm/Developer'  "for some unknown reason sqGnu.h is put there"
	
	'${crossDir}/plugins/SerialPlugin'   "for platforms/Mac OS/vm/osExports.c to work"
	'${targetPlatform}/plugins/FilePlugin'   "for sqMacFileLogic.h to work"
	'${targetPlatform}/plugins/HostWindowPlugin'  "for sqMacNSPluginUILogic2.c to work"
	'${crossDir}/plugins/HostWindowPlugin' "for same... "
	'${crossDir}/plugins/DropPlugin' "include DropPlugin.h"
	'${crossDir}/plugins/SocketPlugin'
	'${crossDir}/plugins/AsynchFilePlugin'
	'${platformsDir}/unix/vm'  "suppressing following:
		platforms/Mac OS/vm/sqMacMain.c:94:19: error: sqaio.h: No such file or directory
		platforms/Mac OS/vm/sqMacMain.c:96:28: error: sqUnixCharConv.h: No such file or directory"
	)
	! !

SqueakMacOSV3Config subclass: #SqueakMacOSSqueakSistaSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOS'!

!SqueakMacOSSqueakSistaSpurConfig commentStamp: 'tty 6/15/2014 13:47' prior: 0!
This is a concrete configuration for building a CogVM 32 bit on Mac OS.

It is using a Carbon framework , which eventually will be replaced by Cocoa. (see CocoaIOSConfig and its subclasses).

SqueakMacOSBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
CFBundleExecutable
	^ self executableName ! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
CFBundleGetInfoString

	^ self CFBundleShortVersionString
! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
CFBundleIconFile

	"An application icon"
	^ 'Cog.icns'! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
CFBundleIdentifier

	"A Java package style name (like 'com.myCompany.MyBundle') which is used to uniquely identify bundles."
	
	^ 'org.squeak.Cog'! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
CFBundleName

	"An application name"
	^ self executableName, ' (Carbon) 32bits'! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
CFBundleShortVersionString

	"An application version"
	^ self executableName, ' VM ' , self CFBundleVersion! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
CFBundleVersion

	"An application version"
	^ '4.0.0'! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:40'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'compiler flags' stamp: 'tty 6/9/2014 18:40'!
commonCompilerFlags

	"Common compiler flags"
	
	^ { 
		'-fmessage-length=0'. 
		'-Wno-trigraphs'. 
		'-fpascal-strings'. 
		'-fasm-blocks'. 
		'-DCOGMTVM=0'. 
		'-DUSE_GLOBAL_STRUCT=0'. 
		'-DTARGET_API_MAC_CARBON'. 
		'-DBUILD_FOR_OSX'. 
		'-DHAVE_SYS_TIME_H'. 
		'-mmacosx-version-min=10.5' }	
! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'compiler flags' stamp: 'tty 6/9/2014 18:40'!
compilerFlagsDebug

	^ {
		'-g3'. 
		'-O0'. 
		'-Wmissing-prototypes'. 
		'-Wmissing-braces'. 
		'-Wparentheses'. 
		'-Wunused-function'. 
		'-Wunused-label'. 
		'-Wunused-parameter'. 
		'-Wunused-variable'. 
		'-Wunused-value'. 
		'-Wsign-compare'. 
		'-DDEBUGVM=1'. 
		'-DEXTERNALPRIMSDEBUG=1'. 
		'-gdwarf-2' }! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'compiler flags' stamp: 'tty 6/9/2014 18:40'!
compilerFlagsRelease
" -mdynamic-no-pic "
	^ {
		'-gdwarf-2'. 
		'-O3'. 
		'-funroll-loops'. 
		'-ftree-vectorize'. 
		'-msse3'. 
		'-DDEBUGVM=0'. 
		'-DNDEBUG'. 
		'-Wunused-value'. 
		'-Wuninitialized'. 
		'-falign-functions=16'. 
		'-fno-gcse'. 
		'-mtune=prescott'. 
		'-march=pentium-m'. 
		'-mfpmath=sse'. 
		'-finline-functions'. 
		'-Wall'. 
		'-DUSE_INLINE_MEMORY_ACCESSORS' }! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:40'!
configureDropPlugin: maker
	"extra rules for DropPlugin"
	super configureDropPlugin: maker.  
	maker addPlatformSources: #( 'sqMacDragDrop')
! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:40'!
configureFFIPlugin: maker
	"extra rules for FFIPlugin"

	
	"Never generate this plugin. Because it is a legacy code.
	For Cog FFI, use ReentrantFFIPlugin  (ReentrantIA32FFIPlugin for x86) "
	
	maker doNotGenerate: true.
	
! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:40'!
configureFilePlugin: maker
	"extra rules for FilePlugin"

	super configureFilePlugin: maker.  
	
	maker includeDirectories: '${platformsDir}/unix/vm'.
	maker addPlatformSources: #( 'sqMacUnixFileInterface.c' 'sqMacDirectory.c')! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:40'!
configureHostWindowPlugin: maker
	"extra rules for HostWindowPlugin"

	super configureHostWindowPlugin: maker.  
	maker addPlatformSources: #( 'sqMacHostWindow.c' )
! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:40'!
configureSoundPlugin: maker 
	"extra rules for SoundPlugin"

	super configureSoundPlugin: maker.  
	maker includeDirectories: '${platformsDir}/unix/vm/'.
	maker addPlatformSources:
		#( 
			"This is commented because such file is not commited in the cog blessed commit hash f3fe94c828f66cd0e7c37cfa3434e384ff65915e. For more details see http://forum.world.st/Problem-generating-Mac-VM-td3438466.html "
			"'sqMacAudioDeviceList.c'"
			'sqMacUnixInterfaceSound.c' 
			'sqUnixSoundMacOSXJMM.c'
		)


! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:40'!
configureUUIDPlugin: maker 
	"extra rules for UUIDPlugin"

	super configureUUIDPlugin: maker.    
	maker addPlatformSources:
		#( 'sqMacUUID.c')


! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 18:40'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'plugins' stamp: 'tty 6/9/2014 18:40'!
defaultExternalPlugins

	^ #(
		BochsIA32Plugin
		CroquetPlugin
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
		FloatArrayPlugin
		FloatMathPlugin
		Mpeg3Plugin
		QuicktimePlugin 
"		TestOSAPlugin  - not works"
		"UnixOSProcessPlugin ?? "
		)! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'plugins' stamp: 'tty 6/9/2014 18:40'!
defaultInternalPlugins

	^ #(
		ADPCMCodecPlugin
		AsynchFilePlugin
		B3DAcceleratorPlugin
		BalloonEnginePlugin "B2DPlugin" 
		BitBltSimulation "BitBltPlugin"
		BMPReadWriterPlugin
		DeflatePlugin  "ZipPlugin"
		DropPlugin
		DSAPlugin "DSAPrims"
		FFTPlugin
		FilePlugin
		HostWindowPlugin
		IA32ABIPlugin "IA32ABI"
		InternetConfigPlugin
		JoystickTabletPlugin
		JPEGReaderPlugin
		JPEGReadWriter2Plugin
		KlattSynthesizerPlugin "Klatt"
		LargeIntegersPlugin "LargeIntegers"
		LocalePlugin
		MacMenubarPlugin
		Matrix2x3Plugin
		MIDIPlugin
		MiscPrimitivePlugin
		"QVMProfileMacSupportPlugin"
		RePlugin
		SecurityPlugin
		SerialPlugin
		SocketPlugin
		SoundCodecPlugin "SoundCodecPrims"
		SoundGenerationPlugin
		SoundPlugin
		StarSqueakPlugin
		SurfacePlugin
		UUIDPlugin
		VMProfileMacSupportPlugin
		)! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:11'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. default is squeak.cog.v3"
	^self squeakSistaSpur! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:48'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:58'!
executableName
	^ self vmSistaExecutableName! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:40'!
executableType
	^ 'MACOSX_BUNDLE'! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'settings' stamp: 'tty 6/9/2014 18:40'!
extraPluginSettings: maker
	
	"Cog currently runs only in 32 bit mode" 
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 18:40'!
extraSources
	" mac VM using some unix sources"
	
	^ 
	'${platformsDir}/unix/plugins/SocketPlugin/sqUnixSocket.c 
	${platformsDir}/unix/vm/aio.c 
	${platformsDir}/unix/plugins/AsynchFilePlugin/sqUnixAsynchFile.c
	${platformsDir}/unix/vm/sqUnixHeartbeat.c
	${platformsDir}/unix/vm/sqUnixVMProfile.c
	${platformsDir}/unix/vm/sqUnixThreads.c
	${resources}'! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'settings' stamp: 'tty 6/9/2014 18:40'!
extraVMSettings: maker
	
	"Cog currently runs only in 32 bit mode" 
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'.

	maker set: 'resourceDir' toString: self resourcesDir, '/ProjectBuilder'.
	maker set: 'resources' to: 
		'"${resourceDir}/Squeak VM.r"
		"${resourceDir}/Cog.icns"
		"${resourceDir}/Squeak.icns"
		"${resourceDir}/SqueakChanges.icns"
		"${resourceDir}/SqueakImage.icns"
		"${resourceDir}/SqueakPlugin.icns"
		"${resourceDir}/SqueakScript.icns"
		"${resourceDir}/SqueakGeneric.icns"
		"${resourceDir}/SqueakProject.icns"
		"${resourceDir}/SqueakSources.icns"'
! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:40'!
frameworks

	^ #(
	Carbon
	AppKit
	IOKit
	CoreFoundation
	AudioToolbox
	CoreAudio
	OpenGL
	AGL
	QuickTime
	Foundation
	SystemConfiguration
	)! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 18:40'!
generateSourceFiles

	^ CMakeGenScripts generateCogSources: self! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:40'!
interpreterClass
	^ CoInterpreter! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:40'!
platformName
	^ 'Mac OS'! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 18:40'!
platformSources
	"files added from platform/Mac OS/vm dir "
	^ #(
	'NSCursorWrappers.m'
	'nsPoolManagement.m'
	'osExports.c'
	'sqMacEncoding.c'
	'sqMacImageIO.c'
	'sqMacMain.c'
	'sqMacMemory.c'
	'sqMacNSPluginUILogic2.c'
	'sqMacTime.c'
	'sqMacUIAppleEvents.c'
	'sqMacUIClipBoard.c'
	'sqMacUIEventsUniversal.c'  " instead of: sqMacUIEvents.c "
	'sqMacUIMenuBarUniversal.c'
	'sqMacUnixCommandLineInterface.c'
	'sqMacUnixExternalPrims.c'
	'sqMacWindowUniversal.c'
	'version.c'	
	)! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
plistFile

	| plist |
	
	plist := self plistTemplate.
	
	#(
	CFBundleExecutable
	CFBundleGetInfoString
	CFBundleName
	CFBundleShortVersionString
	CFBundleVersion
	CFBundleIconFile
	CFBundleIdentifier ) do: [:key |
		plist := plist copyReplaceAll: '@' , key , '@' with: (self perform: key)
	].

	^ self fixLineEndsOf: plist! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
plistTemplate
	^ 
	'<?xml version="1.0" encoding="UTF-8"?>
<!!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
<plist version="1.0">
<dict>
	<key>LSMinimumSystemVersion</key>
	<string>10.5.0</string>
	<key>CFBundleDevelopmentRegion</key>
	<string>English</string>
	<key>CFBundleDocumentTypes</key>
	<array>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>image</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Image File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STim</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sources</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Sources File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STso</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>changes</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Changes File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STch</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sobj</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakScript.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Script File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SOBJ</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>pr</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakProject.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Project File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STpr</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>JPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>JPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TEXT</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TEXT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ttro</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ttro</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HTML</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HTML</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>RTF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>RTF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TIFF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TIFF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PICT </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PICT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>URL  </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>URL</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ZIP </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ZIP</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>zip </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>zip</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>BINA</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>BINA</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>GIFf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>GIFf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PNGf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PNGf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3 </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>mp3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG2</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG2</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Mp3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>M3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>M3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>SRCS</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SRCS</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Chng</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>Chng</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HPS5</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HPS5</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>bundle</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakPlugin.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Plugin</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>BNDL</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
	</array>
	<key>CFBundleExecutable</key>
	<string>@CFBundleExecutable@</string>
	<key>CFBundleGetInfoString</key>
	<string>@CFBundleGetInfoString@</string>
	<key>CFBundleIconFile</key>
	<string>@CFBundleIconFile@</string>
	<key>CFBundleIdentifier</key>
	<string>@CFBundleIdentifier@</string>
	<key>CFBundleInfoDictionaryVersion</key>
	<string>6.0</string>
	<key>CFBundleName</key>
	<string>@CFBundleName@</string>
	<key>CFBundlePackageType</key>
	<string>APPL</string>
	<key>CFBundleShortVersionString</key>
	<string>@CFBundleShortVersionString@</string>
	<key>CFBundleSignature</key>
	<string>????</string>
	<key>CFBundleVersion</key>
	<string>@CFBundleVersion@</string>
	<key>CGDisableCoalescedUpdates</key>
	<true/>
	<key>LSBackgroundOnly</key>
	<false/>
	<key>NSServices</key>
	<array>
		<dict>
			<key>NSMenuItem</key>
			<dict>
				<key>default</key>
				<string>Squeak DoIt</string>
			</dict>
			<key>NSMessage</key>
			<string>doitandreturn</string>
			<key>NSPortName</key>
			<string>Squeak</string>
			<key>NSReturnTypes</key>
			<array>
				<string>NSStringPboardType</string>
			</array>
			<key>NSSendTypes</key>
			<array>
				<string>NSStringPboardType</string>
			</array>
		</dict>
	</array>
	<key>SqueakBrowserMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakDebug</key>
	<integer>0</integer>
	<key>SqueakEncodingType</key>
	<string>UTF-8</string>
	<key>SqueakExplicitWindowOpenNeeded</key>
	<false/>
	<key>SqueakFloatingWindowGetsFocus</key>
	<true/>
	<key>SqueakHasQuitWithoutSaving</key>
	<false/>
	<key>SqueakImageName</key>
	<string>Squeak.image</string>
	<key>SqueakMaxHeapSize</key>
	<integer>536870912</integer>
	<key>SqueakMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakPluginsBuiltInOrLocalOnly</key>
	<false/>
	<key>SqueakUIFlushPrimaryDeferNMilliseconds</key>
	<integer>20</integer>
	<key>SqueakUIFlushSecondaryCheckForPossibleNeedEveryNMilliseconds</key>
	<integer>20</integer>
	<key>SqueakUIFlushSecondaryCleanupDelayMilliseconds</key>
	<integer>25</integer>
	<key>SqueakUIFlushUseHighPercisionClock</key>
	<true/>
	<key>SqueakUnTrustedDirectory</key>
	<string>~/Library/Preferences/Croquet/Internet/Untrusted/</string>
	<key>SqueakWindowAttribute</key>
	<data>ggAAHw==</data>
	<key>SqueakWindowHasTitle</key>
	<true/>
	<key>SqueakWindowType</key>
	<integer>6</integer>
</dict>
</plist>
'! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:40'!
prepareForGeneration
	^ self prepareForCogGeneration
! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'settings' stamp: 'tty 6/9/2014 18:40'!
setExtraTargetProperties: maker

	super setExtraTargetProperties: maker.

	maker addFrameworks: self frameworks.	

	" generated and add Info.plist file "
	self write: self plistFile toFile: 'Info.plist'.
	maker 
		addProperty: 'MACOSX_BUNDLE_INFO_PLIST' 
		value: '${buildDir}/Info.plist'.

	maker cmd: 'set_source_files_properties' params: '${resources} PROPERTIES MACOSX_PACKAGE_LOCATION Resources'.
	
	maker set: 'EXECUTABLE_OUTPUT_PATH' to: '${outputDir}'.! !

!SqueakMacOSSqueakSistaSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 18:40'!
standardIncludes
	^ #(
	'SYSTEM /Developer/Headers/FlatCarbon'
	'${targetPlatform}/vm/Developer'  "for some unknown reason sqGnu.h is put there"
	
	'${crossDir}/plugins/SerialPlugin'   "for platforms/Mac OS/vm/osExports.c to work"
	'${targetPlatform}/plugins/FilePlugin'   "for sqMacFileLogic.h to work"
	'${targetPlatform}/plugins/HostWindowPlugin'  "for sqMacNSPluginUILogic2.c to work"
	'${crossDir}/plugins/HostWindowPlugin' "for same... "
	'${crossDir}/plugins/DropPlugin' "include DropPlugin.h"
	'${crossDir}/plugins/SocketPlugin'
	'${crossDir}/plugins/AsynchFilePlugin'
	'${platformsDir}/unix/vm'  "suppressing following:
		platforms/Mac OS/vm/sqMacMain.c:94:19: error: sqaio.h: No such file or directory
		platforms/Mac OS/vm/sqMacMain.c:96:28: error: sqUnixCharConv.h: No such file or directory"
	)
	! !

SqueakMacOSV3Config subclass: #SqueakMacOSSqueakSistaV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOS'!

!SqueakMacOSSqueakSistaV3Config commentStamp: 'tty 6/15/2014 13:47' prior: 0!
This is a concrete configuration for building a CogVM 32 bit on Mac OS.

It is using a Carbon framework , which eventually will be replaced by Cocoa. (see CocoaIOSConfig and its subclasses).

SqueakMacOSBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!SqueakMacOSSqueakSistaV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
CFBundleExecutable
	^ self executableName ! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
CFBundleGetInfoString

	^ self CFBundleShortVersionString
! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
CFBundleIconFile

	"An application icon"
	^ 'Cog.icns'! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
CFBundleIdentifier

	"A Java package style name (like 'com.myCompany.MyBundle') which is used to uniquely identify bundles."
	
	^ 'org.squeak.Cog'! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
CFBundleName

	"An application name"
	^ self executableName, ' (Carbon) 32bits'! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
CFBundleShortVersionString

	"An application version"
	^ self executableName, ' VM ' , self CFBundleVersion! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
CFBundleVersion

	"An application version"
	^ '4.0.0'! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:40'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'compiler flags' stamp: 'tty 6/9/2014 18:40'!
commonCompilerFlags

	"Common compiler flags"
	
	^ { 
		'-fmessage-length=0'. 
		'-Wno-trigraphs'. 
		'-fpascal-strings'. 
		'-fasm-blocks'. 
		'-DCOGMTVM=0'. 
		'-DUSE_GLOBAL_STRUCT=0'. 
		'-DTARGET_API_MAC_CARBON'. 
		'-DBUILD_FOR_OSX'. 
		'-DHAVE_SYS_TIME_H'. 
		'-mmacosx-version-min=10.5' }	
! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'compiler flags' stamp: 'tty 6/9/2014 18:40'!
compilerFlagsDebug

	^ {
		'-g3'. 
		'-O0'. 
		'-Wmissing-prototypes'. 
		'-Wmissing-braces'. 
		'-Wparentheses'. 
		'-Wunused-function'. 
		'-Wunused-label'. 
		'-Wunused-parameter'. 
		'-Wunused-variable'. 
		'-Wunused-value'. 
		'-Wsign-compare'. 
		'-DDEBUGVM=1'. 
		'-DEXTERNALPRIMSDEBUG=1'. 
		'-gdwarf-2' }! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'compiler flags' stamp: 'tty 6/9/2014 18:40'!
compilerFlagsRelease
" -mdynamic-no-pic "
	^ {
		'-gdwarf-2'. 
		'-O3'. 
		'-funroll-loops'. 
		'-ftree-vectorize'. 
		'-msse3'. 
		'-DDEBUGVM=0'. 
		'-DNDEBUG'. 
		'-Wunused-value'. 
		'-Wuninitialized'. 
		'-falign-functions=16'. 
		'-fno-gcse'. 
		'-mtune=prescott'. 
		'-march=pentium-m'. 
		'-mfpmath=sse'. 
		'-finline-functions'. 
		'-Wall'. 
		'-DUSE_INLINE_MEMORY_ACCESSORS' }! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:40'!
configureDropPlugin: maker
	"extra rules for DropPlugin"
	super configureDropPlugin: maker.  
	maker addPlatformSources: #( 'sqMacDragDrop')
! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:40'!
configureFFIPlugin: maker
	"extra rules for FFIPlugin"

	
	"Never generate this plugin. Because it is a legacy code.
	For Cog FFI, use ReentrantFFIPlugin  (ReentrantIA32FFIPlugin for x86) "
	
	maker doNotGenerate: true.
	
! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:40'!
configureFilePlugin: maker
	"extra rules for FilePlugin"

	super configureFilePlugin: maker.  
	
	maker includeDirectories: '${platformsDir}/unix/vm'.
	maker addPlatformSources: #( 'sqMacUnixFileInterface.c' 'sqMacDirectory.c')! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:40'!
configureHostWindowPlugin: maker
	"extra rules for HostWindowPlugin"

	super configureHostWindowPlugin: maker.  
	maker addPlatformSources: #( 'sqMacHostWindow.c' )
! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:40'!
configureSoundPlugin: maker 
	"extra rules for SoundPlugin"

	super configureSoundPlugin: maker.  
	maker includeDirectories: '${platformsDir}/unix/vm/'.
	maker addPlatformSources:
		#( 
			"This is commented because such file is not commited in the cog blessed commit hash f3fe94c828f66cd0e7c37cfa3434e384ff65915e. For more details see http://forum.world.st/Problem-generating-Mac-VM-td3438466.html "
			"'sqMacAudioDeviceList.c'"
			'sqMacUnixInterfaceSound.c' 
			'sqUnixSoundMacOSXJMM.c'
		)


! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:40'!
configureUUIDPlugin: maker 
	"extra rules for UUIDPlugin"

	super configureUUIDPlugin: maker.    
	maker addPlatformSources:
		#( 'sqMacUUID.c')


! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'source files' stamp: 'tty 6/9/2014 18:40'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'plugins' stamp: 'tty 6/9/2014 18:40'!
defaultExternalPlugins

	^ #(
		BochsIA32Plugin
		CroquetPlugin
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
		FloatArrayPlugin
		FloatMathPlugin
		Mpeg3Plugin
		QuicktimePlugin 
"		TestOSAPlugin  - not works"
		"UnixOSProcessPlugin ?? "
		)! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'plugins' stamp: 'tty 6/9/2014 18:40'!
defaultInternalPlugins

	^ #(
		ADPCMCodecPlugin
		AsynchFilePlugin
		B3DAcceleratorPlugin
		BalloonEnginePlugin "B2DPlugin" 
		BitBltSimulation "BitBltPlugin"
		BMPReadWriterPlugin
		DeflatePlugin  "ZipPlugin"
		DropPlugin
		DSAPlugin "DSAPrims"
		FFTPlugin
		FilePlugin
		HostWindowPlugin
		IA32ABIPlugin "IA32ABI"
		InternetConfigPlugin
		JoystickTabletPlugin
		JPEGReaderPlugin
		JPEGReadWriter2Plugin
		KlattSynthesizerPlugin "Klatt"
		LargeIntegersPlugin "LargeIntegers"
		LocalePlugin
		MacMenubarPlugin
		Matrix2x3Plugin
		MIDIPlugin
		MiscPrimitivePlugin
		"QVMProfileMacSupportPlugin"
		RePlugin
		SecurityPlugin
		SerialPlugin
		SocketPlugin
		SoundCodecPlugin "SoundCodecPrims"
		SoundGenerationPlugin
		SoundPlugin
		StarSqueakPlugin
		SurfacePlugin
		UUIDPlugin
		VMProfileMacSupportPlugin
		)! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:11'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. default is squeak.cog.v3"
	^self squeakSistaV3! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:48'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:58'!
executableName
	^ self vmSistaExecutableName! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:40'!
executableType
	^ 'MACOSX_BUNDLE'! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'settings' stamp: 'tty 6/9/2014 18:40'!
extraPluginSettings: maker
	
	"Cog currently runs only in 32 bit mode" 
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'source files' stamp: 'tty 6/9/2014 18:40'!
extraSources
	" mac VM using some unix sources"
	
	^ 
	'${platformsDir}/unix/plugins/SocketPlugin/sqUnixSocket.c 
	${platformsDir}/unix/vm/aio.c 
	${platformsDir}/unix/plugins/AsynchFilePlugin/sqUnixAsynchFile.c
	${platformsDir}/unix/vm/sqUnixHeartbeat.c
	${platformsDir}/unix/vm/sqUnixVMProfile.c
	${platformsDir}/unix/vm/sqUnixThreads.c
	${resources}'! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'settings' stamp: 'tty 6/9/2014 18:40'!
extraVMSettings: maker
	
	"Cog currently runs only in 32 bit mode" 
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'.

	maker set: 'resourceDir' toString: self resourcesDir, '/ProjectBuilder'.
	maker set: 'resources' to: 
		'"${resourceDir}/Squeak VM.r"
		"${resourceDir}/Cog.icns"
		"${resourceDir}/Squeak.icns"
		"${resourceDir}/SqueakChanges.icns"
		"${resourceDir}/SqueakImage.icns"
		"${resourceDir}/SqueakPlugin.icns"
		"${resourceDir}/SqueakScript.icns"
		"${resourceDir}/SqueakGeneric.icns"
		"${resourceDir}/SqueakProject.icns"
		"${resourceDir}/SqueakSources.icns"'
! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:40'!
frameworks

	^ #(
	Carbon
	AppKit
	IOKit
	CoreFoundation
	AudioToolbox
	CoreAudio
	OpenGL
	AGL
	QuickTime
	Foundation
	SystemConfiguration
	)! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'source files' stamp: 'tty 6/9/2014 18:40'!
generateSourceFiles

	^ CMakeGenScripts generateCogSources: self! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:40'!
interpreterClass
	^ CoInterpreter! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:40'!
platformName
	^ 'Mac OS'! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'source files' stamp: 'tty 6/9/2014 18:40'!
platformSources
	"files added from platform/Mac OS/vm dir "
	^ #(
	'NSCursorWrappers.m'
	'nsPoolManagement.m'
	'osExports.c'
	'sqMacEncoding.c'
	'sqMacImageIO.c'
	'sqMacMain.c'
	'sqMacMemory.c'
	'sqMacNSPluginUILogic2.c'
	'sqMacTime.c'
	'sqMacUIAppleEvents.c'
	'sqMacUIClipBoard.c'
	'sqMacUIEventsUniversal.c'  " instead of: sqMacUIEvents.c "
	'sqMacUIMenuBarUniversal.c'
	'sqMacUnixCommandLineInterface.c'
	'sqMacUnixExternalPrims.c'
	'sqMacWindowUniversal.c'
	'version.c'	
	)! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
plistFile

	| plist |
	
	plist := self plistTemplate.
	
	#(
	CFBundleExecutable
	CFBundleGetInfoString
	CFBundleName
	CFBundleShortVersionString
	CFBundleVersion
	CFBundleIconFile
	CFBundleIdentifier ) do: [:key |
		plist := plist copyReplaceAll: '@' , key , '@' with: (self perform: key)
	].

	^ self fixLineEndsOf: plist! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'bundle strings' stamp: 'tty 6/9/2014 18:40'!
plistTemplate
	^ 
	'<?xml version="1.0" encoding="UTF-8"?>
<!!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
<plist version="1.0">
<dict>
	<key>LSMinimumSystemVersion</key>
	<string>10.5.0</string>
	<key>CFBundleDevelopmentRegion</key>
	<string>English</string>
	<key>CFBundleDocumentTypes</key>
	<array>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>image</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Image File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STim</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sources</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Sources File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STso</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>changes</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Changes File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STch</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sobj</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakScript.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Script File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SOBJ</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>pr</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakProject.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Project File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STpr</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>JPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>JPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TEXT</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TEXT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ttro</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ttro</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HTML</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HTML</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>RTF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>RTF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TIFF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TIFF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PICT </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PICT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>URL  </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>URL</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ZIP </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ZIP</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>zip </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>zip</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>BINA</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>BINA</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>GIFf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>GIFf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PNGf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PNGf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3 </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>mp3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG2</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG2</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Mp3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>M3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>M3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>SRCS</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SRCS</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Chng</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>Chng</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HPS5</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HPS5</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>bundle</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakPlugin.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Plugin</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>BNDL</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
	</array>
	<key>CFBundleExecutable</key>
	<string>@CFBundleExecutable@</string>
	<key>CFBundleGetInfoString</key>
	<string>@CFBundleGetInfoString@</string>
	<key>CFBundleIconFile</key>
	<string>@CFBundleIconFile@</string>
	<key>CFBundleIdentifier</key>
	<string>@CFBundleIdentifier@</string>
	<key>CFBundleInfoDictionaryVersion</key>
	<string>6.0</string>
	<key>CFBundleName</key>
	<string>@CFBundleName@</string>
	<key>CFBundlePackageType</key>
	<string>APPL</string>
	<key>CFBundleShortVersionString</key>
	<string>@CFBundleShortVersionString@</string>
	<key>CFBundleSignature</key>
	<string>????</string>
	<key>CFBundleVersion</key>
	<string>@CFBundleVersion@</string>
	<key>CGDisableCoalescedUpdates</key>
	<true/>
	<key>LSBackgroundOnly</key>
	<false/>
	<key>NSServices</key>
	<array>
		<dict>
			<key>NSMenuItem</key>
			<dict>
				<key>default</key>
				<string>Squeak DoIt</string>
			</dict>
			<key>NSMessage</key>
			<string>doitandreturn</string>
			<key>NSPortName</key>
			<string>Squeak</string>
			<key>NSReturnTypes</key>
			<array>
				<string>NSStringPboardType</string>
			</array>
			<key>NSSendTypes</key>
			<array>
				<string>NSStringPboardType</string>
			</array>
		</dict>
	</array>
	<key>SqueakBrowserMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakDebug</key>
	<integer>0</integer>
	<key>SqueakEncodingType</key>
	<string>UTF-8</string>
	<key>SqueakExplicitWindowOpenNeeded</key>
	<false/>
	<key>SqueakFloatingWindowGetsFocus</key>
	<true/>
	<key>SqueakHasQuitWithoutSaving</key>
	<false/>
	<key>SqueakImageName</key>
	<string>Squeak.image</string>
	<key>SqueakMaxHeapSize</key>
	<integer>536870912</integer>
	<key>SqueakMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakPluginsBuiltInOrLocalOnly</key>
	<false/>
	<key>SqueakUIFlushPrimaryDeferNMilliseconds</key>
	<integer>20</integer>
	<key>SqueakUIFlushSecondaryCheckForPossibleNeedEveryNMilliseconds</key>
	<integer>20</integer>
	<key>SqueakUIFlushSecondaryCleanupDelayMilliseconds</key>
	<integer>25</integer>
	<key>SqueakUIFlushUseHighPercisionClock</key>
	<true/>
	<key>SqueakUnTrustedDirectory</key>
	<string>~/Library/Preferences/Croquet/Internet/Untrusted/</string>
	<key>SqueakWindowAttribute</key>
	<data>ggAAHw==</data>
	<key>SqueakWindowHasTitle</key>
	<true/>
	<key>SqueakWindowType</key>
	<integer>6</integer>
</dict>
</plist>
'! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:40'!
prepareForGeneration
	^ self prepareForCogGeneration
! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'settings' stamp: 'tty 6/9/2014 18:40'!
setExtraTargetProperties: maker

	super setExtraTargetProperties: maker.

	maker addFrameworks: self frameworks.	

	" generated and add Info.plist file "
	self write: self plistFile toFile: 'Info.plist'.
	maker 
		addProperty: 'MACOSX_BUNDLE_INFO_PLIST' 
		value: '${buildDir}/Info.plist'.

	maker cmd: 'set_source_files_properties' params: '${resources} PROPERTIES MACOSX_PACKAGE_LOCATION Resources'.
	
	maker set: 'EXECUTABLE_OUTPUT_PATH' to: '${outputDir}'.! !

!SqueakMacOSSqueakSistaV3Config methodsFor: 'source files' stamp: 'tty 6/9/2014 18:40'!
standardIncludes
	^ #(
	'SYSTEM /Developer/Headers/FlatCarbon'
	'${targetPlatform}/vm/Developer'  "for some unknown reason sqGnu.h is put there"
	
	'${crossDir}/plugins/SerialPlugin'   "for platforms/Mac OS/vm/osExports.c to work"
	'${targetPlatform}/plugins/FilePlugin'   "for sqMacFileLogic.h to work"
	'${targetPlatform}/plugins/HostWindowPlugin'  "for sqMacNSPluginUILogic2.c to work"
	'${crossDir}/plugins/HostWindowPlugin' "for same... "
	'${crossDir}/plugins/DropPlugin' "include DropPlugin.h"
	'${crossDir}/plugins/SocketPlugin'
	'${crossDir}/plugins/AsynchFilePlugin'
	'${platformsDir}/unix/vm'  "suppressing following:
		platforms/Mac OS/vm/sqMacMain.c:94:19: error: sqaio.h: No such file or directory
		platforms/Mac OS/vm/sqMacMain.c:96:28: error: sqUnixCharConv.h: No such file or directory"
	)
	! !

SqueakMacOSV3Config subclass: #SqueakMacOSSqueakStackSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOS'!

!SqueakMacOSSqueakStackSpurConfig commentStamp: 'tty 6/15/2014 13:48' prior: 0!
This is a concrete class which generates a StackVM for Mac using the Carbon library.

This configuration generates sources/build files for building Stack-based interpreter on Mac OS X.
It is using a Carbon framework , which will be replaced by Cocoa soon. (see CocoaIOSConfig and its subclasses).

SqueakMacOSBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!SqueakMacOSSqueakStackSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 18:40'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!SqueakMacOSSqueakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:11'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. default is squeak.cog.v3"
	^self squeakStackSpur! !

!SqueakMacOSSqueakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:48'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSSqueakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:02'!
executableName
	^ self vmStackExecutableName! !

!SqueakMacOSSqueakStackSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:40'!
interpreterClass
	^ StackInterpreter! !

!SqueakMacOSSqueakStackSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:40'!
prepareForGeneration
	^ self prepareForStackVMGeneration
! !

SqueakMacOSV3Config subclass: #SqueakMacOSSqueakStackV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOS'!

!SqueakMacOSSqueakStackV3Config commentStamp: 'tty 6/15/2014 13:48' prior: 0!
This is a concrete class which generates a StackVM for Mac using the Carbon library.

This configuration generates sources/build files for building Stack-based interpreter on Mac OS X.
It is using a Carbon framework , which will be replaced by Cocoa soon. (see CocoaIOSConfig and its subclasses).

SqueakMacOSBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!SqueakMacOSSqueakStackV3Config methodsFor: 'source files' stamp: 'tty 5/22/2014 14:42'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!SqueakMacOSSqueakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:12'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. default is squeak.cog.v3"
	^self squeakStackV3! !

!SqueakMacOSSqueakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:48'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSSqueakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:02'!
executableName
	^ self vmStackExecutableName! !

!SqueakMacOSSqueakStackV3Config methodsFor: 'source generation' stamp: 'tty 5/22/2014 14:43'!
interpreterClass
	^ StackInterpreter! !

!SqueakMacOSSqueakStackV3Config methodsFor: 'source generation' stamp: 'tty 5/22/2014 14:43'!
prepareForGeneration
	^ self prepareForStackVMGeneration
! !

SqueakMacOSSqueakStackV3Config subclass: #SqueakMacOSStackV3DebugConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-IslandOfMisfitToys'!

!SqueakMacOSStackV3DebugConfig commentStamp: 'tty 6/7/2014 10:27' prior: 0!
This is a concrete class which generates a DEBUG StackVM for Mac using Carbon library. This VM is normally known as a debug StackVM. The debug means that it is compiled with all the necessary symbolic symbols for debugging and can be debugged, for example, with GDB.

For more information, check the class comments of all the superclasses.

Usage:
SqueakMacOSStackV3DebugConfig generateWithSources.
Or:
SqueakMacOSStackV3DebugConfig generate.
Or:
find my Builder in CMakeVMMakerSqueak-Builder category and use that to query me or invoke me



!

!SqueakMacOSStackV3DebugConfig methodsFor: 'accessing' stamp: 'tty 6/16/2014 20:15'!
compilerFlags
	|d commonFlags flags|
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self compilerFlagsBuild];
		at: #buildAssert  put: [self compilerFlagsAssert];
		at: #buildAssertITimerHeartbeat  put: [self compilerFlagsAssertITimerHeartbeat];
            at:#buildDebug  put: [self compilerFlagsDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self compilerFlagsDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self compilerFlagsIHeartbeatTimer];
		at: #buildMultiThreaded  put: [self compilerFlagsMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self compilerFlagsMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self compilerFlagsMultiThreadedDebug ];
		at: #buildNone put:[self compilerFlagsNoBuildType].

    flags:= String streamContents: [ :stream |
	 (((d at:  buildType) value)  collect: #withBlanksTrimmed as: Set)
		asStringOn: stream 
		delimiter:' '].

    commonFlags:=String streamContents: [ :stream |
		((self commonCompilerFlags) collect: #withBlanksTrimmed as: Set)
			asStringOn: stream 
			delimiter: ' ' ].
	^ commonFlags, ' ' ,flags.! !

!SqueakMacOSStackV3DebugConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:48'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSV3Config class methodsFor: 'as yet unclassified' stamp: 'tty 5/22/2014 13:54'!
licenseTemplate
	^'Squeak  {1} license information
==============================

About Squeak
-----------


Squeak is a modern, open source, full-featured implementation of the powerful Smalltalk programming language and environment. Squeak is highly-portable, running on almost any platform you could name and you can really truly write once run anywhere.  Squeak is the vehicle for a wide range of projects from multimedia applications and educational platforms to commercial web application development. Read on and join in!!

http://www.squeak.org


LIcense

Note: The current release of Squeak is a combination of source code originating from it''s origins at Apple which Apple agreed to license under the Apache license and more recent contributions licensed under the MIT license. The vast majority of the code is under the MIT license.
MIT License

Copyright (c) The individual, corporate, and institutional contributors who have collectively contributed elements to this software ("The Squeak Community"), 1996-2010 All rights reserved.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
Portions of Squeak are covered by the following license:
Apache License, Version 2.0

Copyright (c) Xerox Corp. 1981, 1982 All rights reserved. Copyright (c) Apple Computer, Inc. 1985-1996 All rights reserved.

Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.


About Cog
---------

Cog is a virtual machine designed for Smalltalk and other similar dynamic languages.  Cog builds on the
Squeak virtual machine adding a stack-to-register-mapping just-in-time compiler, aggressive in-line message
cacheing and effective optimization of Smalltalk’s first-class activation records.  Cog is the virtual machine
underlying Teleplace''s Croquet-based enterprise virtual collaboration spaces software, the fastest virtual
machine for Squeak, and for Gilad Bracha''s Newspeak modular language inspired by Beta and Smalltalk.  
Like the original Squeak VM, Cog is implemented and developed in Smalltalk, and translated into a lower-level
language to produce the production VM.  Being a Smalltalk program it is a delight to develop.  Cog is
available under the MIT open source license and is unencumbered for commercial deployment.

Cog''s performance relative to the existing Squeak interpreter varies, depending on the benchmark chosen.
As of early-2011, the Cog JIT uses strong inline cacheing techniques and stack-to-register mapping that
results in a register-based calling convention for low-arity methods.  Due to the complexity of the Squeak
object representation it has a limited set of primitives implemented in machine code that, for example,
exclude object allocation.  Performance of the early-2011 JIT for the nbody, binarytrees and chameneos
redux benchmarks from the computer language shootout is in the range of 4 to 6 times faster than the
interpreter.
'! !

!SqueakMacOSV3Config class methodsFor: 'as yet unclassified' stamp: 'tty 5/22/2014 13:55'!
pluginsTemplate
	^'Squeak {1} ships with the following plugins already built:
		
Internal: 
=========
{2}

External: 
=========
{3}

'! !

!SqueakMacOSV3Config methodsFor: 'directories' stamp: 'tty 5/22/2014 13:49'!
buildDir
	^ buildDir ifNil: [ buildDir := ( self topDir / self buildDirName) assureExistence].! !

!SqueakMacOSV3Config methodsFor: 'build script' stamp: 'tty 5/25/2014 19:53'!
buildScript
	"answer the build script for building everything"
	

	^ 
'#!!/usr/bin/env bash

cmake .
make
make install

'! !

!SqueakMacOSV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 13:46'!
cMakeMacros 
	^'macro(add_framework appname fwname)
    find_library(FRAMEWORK_${fwname}
        NAMES ${fwname}
        PATHS ${CMAKE_OSX_SYSROOT}/System/Library
        PATH_SUFFIXES Frameworks
        NO_DEFAULT_PATH)
    if( ${FRAMEWORK_${fwname}} STREQUAL FRAMEWORK_${fwname}-NOTFOUND)
        message(ERROR ": Framework ${fwname} not found")
    else()
	  include_directories(SYSTEM /System/Library/Frameworks/${fwname}.framework/Headers)
	  target_link_libraries(${appname} ${FRAMEWORK_${fwname}})
    endif()
endmacro(add_framework)'  ! !

!SqueakMacOSV3Config methodsFor: 'accessing' stamp: 'tty 6/16/2014 20:15'!
compilerFlags
	|d commonFlags flags|
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self compilerFlagsBuild];
		at: #buildAssert  put: [self compilerFlagsAssert];
		at: #buildAssertITimerHeartbeat  put: [self compilerFlagsAssertITimerHeartbeat];
            at:#buildDebug  put: [self compilerFlagsDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self compilerFlagsDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self compilerFlagsIHeartbeatTimer];
		at: #buildMultiThreaded  put: [self compilerFlagsMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self compilerFlagsMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self compilerFlagsMultiThreadedDebug ];
		at: #buildNone put:[self compilerFlagsNoBuildType].

    flags:= String streamContents: [ :stream |
	 (((d at:  buildType) value)  collect: #withBlanksTrimmed as: Set)
		asStringOn: stream 
		delimiter:' '].

    commonFlags:=String streamContents: [ :stream |
		((self commonCompilerFlags) collect: #withBlanksTrimmed as: Set)
			asStringOn: stream 
			delimiter: ' ' ].
	^ commonFlags, ' ' ,flags.! !

!SqueakMacOSV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 13:46'!
configureB3DAcceleratorPlugin: maker
	"extra rules for B3DAcceleratorPlugin"
	
	super configureB3DAcceleratorPlugin: maker.  
	
	maker 
		includeDirectories: '/usr/X11/include';  "for GL.h"
		addPlatformSources: #( 'sqMacOpenGL.c' 'sqMacOpenGLInfo.c')
! !

!SqueakMacOSV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 13:46'!
configureClipboardExtendedPlugin: maker
	! !

!SqueakMacOSV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 13:46'!
configureCroquetPlugin: maker 
	"extra rules for CroquetPlugin"

	super configureCroquetPlugin: maker.  
	maker addPlatformSources: #('sqMacCroquet.c').
! !

!SqueakMacOSV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 13:46'!
configureFFIPlugin: maker
	super configureFFIPlugin: maker.
	maker addPlatformSources: #( "'sqMacIntel-Win32.c'"
		'x86-sysv-MacIntel.c'
		'x86-sysv-asm-MacIntel.S'
	)! !

!SqueakMacOSV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 13:46'!
configureFT2Plugin: maker
	"extra rules for Freetype plugin.
	a custom rule to build freetype library"
	| lib |
	
	maker isExternal ifFalse: [
		self error: 'building internal FT2Plugin is not supported yet'  	
	].

	"add freetype library into loop"
	lib := self addThirdpartyLibrary: 'freetype2'.

	"link plugin with freetype lib"
	maker addExternalLibrary: lib targetForLinking.
	maker includeDirectories: lib includeDir.
! !

!SqueakMacOSV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 13:46'!
configureInternetConfigPlugin: maker
	"extra rules for InternetConfigPlugin"
	
	super configureInternetConfigPlugin: maker.  
	maker addPlatformSources: #( 'sqMacInternetConfiguration.c')
! !

!SqueakMacOSV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 13:46'!
configureJoystickTabletPlugin: maker 
	"extra rules for JoystickTabletPlugin"
	
	super configureJoystickTabletPlugin: maker.  
	maker addPlatformSources:
		#( 
			'HID_Error_Handler.c'
			'HID_Name_Lookup.c'
			'HID_Queue_Utilities.c'
			'HID_Utilities.c'
			'sqMacJoystickAndTablet.c'
			)
! !

!SqueakMacOSV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 13:46'!
configureLocalePlugin: maker 
	"extra rules for LocalePlugin"

	super configureLocalePlugin: maker.  
	maker addPlatformSources: #( 'sqMacLocaleCarbon.c' )
! !

!SqueakMacOSV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 13:46'!
configureMIDIPlugin: maker 
	"extra rules for MIDIPlugin"

	super configureMIDIPlugin: maker.  
	maker addPlatformSources: #( 'sqMacMIDI.c')! !

!SqueakMacOSV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 13:46'!
configureMpeg3Plugin: maker

	super configureMpeg3Plugin: maker.
	
	maker addPlatformSources: #(	
		'sqMacFileBits.c')
	! !

!SqueakMacOSV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 13:46'!
configureObjectiveCPlugin: maker
	maker doNotGenerate: true! !

!SqueakMacOSV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 13:46'!
configurePlugin: aPlugin with: generator

	generator isExternal ifTrue: [
		" set output directory for dynamic library to Resources subdir in .app bundle location "
		generator 
			set: 'CMAKE_LIBRARY_OUTPUT_DIRECTORY' 
			toString: '${externalModulesDir}'
		].
	^ super configurePlugin: aPlugin with: generator
! !

!SqueakMacOSV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 13:46'!
configureQuicktimePlugin: maker
	
	maker includeDirectories: '${pluginPlatform}'.
	maker includeDirectories: '${crossDir}/plugins/SurfacePlugin'.
	
	" yes, this is not a typo , a file is named 'inteface' instead of 'interface' "

	maker addPlatformSources: #( 'sqMacQuicktimeInteface.c' ).
	
	maker addFrameworks: #( 'Carbon' 'QuickTime' ).! !

!SqueakMacOSV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 13:46'!
configureSecurityPlugin: maker 
	"extra rules for SecurityPlugin"

	super configureSecurityPlugin: maker.  
	maker includeDirectories: '${crossDir}/plugins/FilePlugin'.
	maker addPlatformSources: #( 'sqMacSecurity.c' )! !

!SqueakMacOSV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 13:46'!
configureSerialPlugin: maker 
	"extra rules for SerialPlugin"

	super configureSoundPlugin: maker.  
	maker includeDirectories: '${platformsDir}/unix/plugins/SerialPlugin'.
	maker 
		addSources: #('sqUnixSerial.c') 
		prefixed: '${platformsDir}/unix/plugins/SerialPlugin/'


! !

!SqueakMacOSV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 13:46'!
configureSocketPlugin: maker 
	"extra rules for SoundPlugin"

	super configureSoundPlugin: maker.  
	maker includeDirectories: '${platformsDir}/unix/plugins/SocketPlugin'.
	maker 
		addSources: #('sqUnixSocket.c') 
		prefixed: '${platformsDir}/unix/plugins/SocketPlugin/'


! !

!SqueakMacOSV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 13:46'!
configureSoundGenerationPlugin: maker 
	"extra rules for SoundPlugin"

	maker doNotGenerate: true. 
	" The sources in platforms/Cross/plugins/SoundGenerationPlugin/sqOldSoundPrims.c 
	are out of date and need to be fixed before it can be built 
	
	
	maker 
		addCrossSources: #('sqOldSoundPrims.c') 

	"
! !

!SqueakMacOSV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 13:46'!
configureTestOSAPlugin: maker
		
	maker addFrameworks: #( 'Carbon'  'ApplicationServices' ).! !

!SqueakMacOSV3Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 13:46'!
configureUnixOSProcessPlugin: maker 
	"extra rules for UnixOSProcessPlugin"

	maker includeDirectories: '${crossDir}/plugins/FilePlugin'.
! !

!SqueakMacOSV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 13:46'!
defaultDirectoriesFromGitDir: gitRepository
	"Set the default values for all necessary directories taking into account the Git repostiory. An example to use this method is:
	MTCocoaIOSCogJitDebugConfig new
	defaultDirectoriesFromGitDir: '/Users/mariano/Pharo/vm/git/cogVM/blessed';
	generateSources; 
	generate.
	"
	| gitRepositoryString |
	gitRepositoryString :=  gitRepository, '/'.
	self srcDir: gitRepositoryString, self srcDirName.
    	self platformsDir: gitRepositoryString, self platformsDirName.
    	self buildDir: gitRepositoryString, self buildDirName.
	self resourcesDir: gitRepositoryString, self resourcesDirName.
	self outputDir: gitRepositoryString, self outputDirName.
	
	
	! !

!SqueakMacOSV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:09'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. default is squeak.cog.v3"
	^self required! !

!SqueakMacOSV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:48'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 13:56'!
executableName
	^ 'CogVM'! !

!SqueakMacOSV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 13:46'!
externalModulesDir
	"answer the location in VM bundle, where plugins and rest of dynamic libs will be copied,
	by default, it is Framerowks subdir. i.e: 
	
		Cog.app/Contents/Frameworks
		
	"
	
	^ '${outputDir}/', self executableName, '.app/Contents/MacOS/Plugins'! !

!SqueakMacOSV3Config methodsFor: 'utils' stamp: 'tty 5/22/2014 13:46'!
fixLibsTemplate

^
'include(GetPrerequisites)

message("Fixing library references in: ${externalModulesDir}")

FILE(GLOB libs  "${externalModulesDir}/*.dylib")

set(all_imports "")

foreach(lib ${libs})
	get_filename_component(libName "${lib}" NAME)
	list(APPEND libNames "${libName}")
	
	set(prereq "")
	get_prerequisites(${lib} prereq 1 0 "${bundlePath}" "")


	list(APPEND all_imports ${prereq})

endforeach(lib)

list(REMOVE_DUPLICATES all_imports)
set(replacements "")
message ( "Found imports: ${all_imports} " )

foreach(import ${all_imports})
	foreach(lib ${libNames})
		set(match "^.*${lib}$")
		if(import MATCHES ${match})
			set(replacement "${pluginsRelPath}/${lib}")
			message("Will replace: ${import} with: ${replacement}")
			set(replacements ${replacements} "-change" "${import}" "${replacement}")
		endif(import MATCHES ${match})
	endforeach(lib)
endforeach(import)

foreach(lib ${libs})
	get_filename_component(name ${lib} NAME)
	set(fixedName "${pluginsRelPath}/${name}")
	message("Fixing up: ${name}")

 	execute_process(COMMAND install_name_tool -id "${fixedName}" "${lib}" )

 	execute_process(COMMAND install_name_tool  ${replacements} ${lib} )

endforeach(lib)
'

! !

!SqueakMacOSV3Config methodsFor: 'utils' stamp: 'tty 5/22/2014 13:46'!
fixLineEndsOf: string
	^ string copyReplaceAll: String cr with: String lf! !

!SqueakMacOSV3Config methodsFor: 'public' stamp: 'tty 5/22/2014 13:51'!
generate 
	self generatePluginsList. 
	self generateLicense. 
	"^super generate"
	^CMakeVMGeneratorForSqueak generate:self    "Bypass CPlatformConfig generate to invoke our compatibility class"! !

!SqueakMacOSV3Config methodsFor: 'as yet unclassified' stamp: 'tty 5/22/2014 13:55'!
generateLicense 
	self 
		write:  (self class licenseTemplate 
			format: { self version })
		toFile: 'LICENSE.txt'
	! !

!SqueakMacOSV3Config methodsFor: 'as yet unclassified' stamp: 'tty 5/22/2014 13:51'!
generatePluginsList 
	self 
		write:  (self class pluginsTemplate 
			format: {
				self version. 
				String streamContents: [ :stream | self internalPlugins asStringOn: stream delimiter: String cr ].
				String streamContents: [ :stream | self externalPlugins asStringOn: stream delimiter: String cr ].
				self executableName })
		toFile: 'PLUGINS.txt'
	! !

!SqueakMacOSV3Config methodsFor: 'accessing' stamp: 'tty 6/14/2014 15:42'!
outputDir

	"the directory where built binaries will be stored"
	^ outputDir ifNil: [ outputDir := (self topDir / self dirOutput/ self dirInstall) ]	

! !

!SqueakMacOSV3Config methodsFor: 'utils' stamp: 'tty 5/22/2014 13:46'!
postBuildActions: gen

	" override to add custom rules after all targets is defined "
	
	self write: self fixLibsTemplate toFile: 'fix_libs.cmake'.
	
	
	gen
		set: #bundlePath toString: '${outputDir}/', self executableName, '.app';
		set: #pluginsRelPath toString: '@executable_path/Plugins'.

	gen
		puts: '
		INSTALL(CODE "
			set(externalModulesDir \"${externalModulesDir}\")
			set(bundlePath \"${bundlePath}\")
			set(pluginsRelPath \"${pluginsRelPath}\")
			
			include(fix_libs.cmake)
		")'
			
"					FILE(GLOB_RECURSE bLibs /${externalModulesDir}/*.*)
"! !

!SqueakMacOSV3Config methodsFor: 'source generation' stamp: 'tty 5/22/2014 13:46'!
prepareForGeneration
	! !

!SqueakMacOSV3Config methodsFor: 'source generation' stamp: 'tty 5/22/2014 13:49'!
prepareVMMaker
	
	| maker allPlugins |
	
	"In CogVMs (in contrast to Interpreter VM) the generated sources are platform independent, therefore Cross is ok"
	maker := VMMaker forPlatform: 'Cross'.
	
	maker sourceDirectoryName: self srcDir pathName.
	maker platformRootDirectoryName: self platformsDir.
	
	
	allPlugins := self internalPlugins , self externalPlugins.
	
	"touch plugins to force their source generation unconditionally"
	allPlugins do: [:name | (Smalltalk globals at: name) touch ].
	
	" Why we put all plugins as external?   Because the generated sources are not different whether the plugins were defined as internal or external. VMMaker used to need this to to generate plugins.int and plugins.ext files. But since this is achieved in another way with CMakeVMMaker, there is no different at all to put all plugins as internal or as external."
	maker externalModules addAll:  allPlugins.
	
	^ maker! !

!SqueakMacOSV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 13:46'!
resourcesDir 
	"Answer the value of resourcesDir"

	^ resourcesDir ifNil: [ resourcesDir := (self topDir / 'macbuild/resources') fullName ]
	! !

!SqueakMacOSV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 13:46'!
resourcesDir: anObject
	"Set the value of platformsDir"

	resourcesDir := anObject! !

!SqueakMacOSV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 13:46'!
resourcesDirName
	^ 'macbuild/resources'! !

!SqueakMacOSV3Config methodsFor: 'source generation' stamp: 'tty 5/22/2014 14:03'!
setupDirectories: gen
	| dirsInclude |

	" write the directories in separate include file"
	dirsInclude := gen captureOutputDuring: [
		gen
			set: #topDir toString: (self topDir fullName); 
			set: #buildDir toString: (self buildDir ifNil: ['${topDir}/build'] ifNotNil: [self buildDir fullName] );
			set: #thirdpartyDir toString: '${buildDir}/thirdParty';
			set: #platformsDir toString: self platformsDir;
			set: #srcDir toString: self srcDir pathName;
			set: #srcPluginsDir toString: (pluginsDir ifNil: [ '${srcDir}/plugins' ]);
			set: #srcVMDir toString: '${srcDir}/vm';
			set: #platformName toString: self platformName;
			set: #targetPlatform to: '${platformsDir}/${platformName}';
			set: #crossDir toString: '${platformsDir}/Cross';
			set: #platformVMDir toString: '${targetPlatform}/vm';
			set: #outputDir toString: self outputDir fullName.
	].

	self write: dirsInclude toFile: 'directories.cmake'.
	
	gen include: 'directories.cmake'.
! !

!SqueakMacOSV3Config methodsFor: 'accessing' stamp: 'tty 6/7/2014 18:04'!
srcDir
		^ srcDir ifNil: [ srcDir := (self topDir directoryNamed: 'src' )]! !

!SqueakMacOSV3Config methodsFor: 'directories' stamp: 'tty 6/7/2014 16:58'!
topDir
		^ topDir ifNil: [ topDir := FileDirectory default directoryNamed: self oscogvm ]! !

!SqueakMacOSV3Config methodsFor: 'source generation' stamp: 'tty 5/22/2014 13:47'!
validateSourcesPresent
	| sources |
	sources := Smalltalk sourcesName.
	
	(sources == nil)
		ifTrue: [	self error: 'VM source code cannot be generated without .sources file'.]		! !

!SqueakMacOSV3Config methodsFor: 'as yet unclassified' stamp: 'tty 5/22/2014 13:57'!
version
	^ ''! !

SqueakMacOSConfig subclass: #SqueakMacOSX32x86Config
	instanceVariableNames: 'resourcesDir'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOSX32x86'!

!SqueakMacOSX32x86Config commentStamp: 'tty 6/15/2014 13:42' prior: 0!
tty. Don't use me until I am refactored for this platform

I am not sure what this does yet. I have put this here to keep a consistent pattern of top level configuration per platform.
I need to be configured for the job I am advertised to do.


I am not meant to be built.

SqueakMacOSX32x86Builder 
	configureABuildFor: #ONE OF MY SUBCLASSES NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

SqueakMacOSX32x86Config subclass: #MacOSX32x86NewspeakCogSpur
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOSX32x86'!

!MacOSX32x86NewspeakCogSpur commentStamp: 'tty 6/15/2014 13:42' prior: 0!
A MacOSX32x86NewspeakCogSpur configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


SqueakMacOSX32x86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!MacOSX32x86NewspeakCogSpur methodsFor: 'cmake' stamp: 'tty 6/8/2014 19:16'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!MacOSX32x86NewspeakCogSpur methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:24'!
dirBuildLanguageVMMM
	^self newspeakCogSpur! !

!MacOSX32x86NewspeakCogSpur methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:45'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!MacOSX32x86NewspeakCogSpur methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:10'!
executableName
	^ self vmCogExecutableName! !

SqueakMacOSX32x86Config subclass: #MacOSX32x86NewspeakCogV3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOSX32x86'!

!MacOSX32x86NewspeakCogV3 commentStamp: 'tty 6/15/2014 13:42' prior: 0!
A MacOSX32x86NewspeakCogV3  configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


SqueakMacOSX32x86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!MacOSX32x86NewspeakCogV3 methodsFor: 'cmake' stamp: 'tty 6/8/2014 19:16'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!MacOSX32x86NewspeakCogV3 methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:24'!
dirBuildLanguageVMMM
	^self newspeakCogV3! !

!MacOSX32x86NewspeakCogV3 methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:46'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!MacOSX32x86NewspeakCogV3 methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:10'!
executableName
	^ self vmCogExecutableName! !

SqueakMacOSX32x86Config subclass: #MacOSX32x86NewspeakSistaSpur
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOSX32x86'!

!MacOSX32x86NewspeakSistaSpur commentStamp: 'tty 6/15/2014 13:43' prior: 0!
A MacOSX32x86NewspeakStackSpur  configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakMacOSX32x86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!MacOSX32x86NewspeakSistaSpur methodsFor: 'cmake' stamp: 'tty 6/9/2014 17:30'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!MacOSX32x86NewspeakSistaSpur methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:24'!
dirBuildLanguageVMMM
	^self newspeakSistaSpur! !

!MacOSX32x86NewspeakSistaSpur methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:46'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!MacOSX32x86NewspeakSistaSpur methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:59'!
executableName
	^ self vmSistaExecutableName! !

SqueakMacOSX32x86Config subclass: #MacOSX32x86NewspeakSistaV3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOSX32x86'!

!MacOSX32x86NewspeakSistaV3 commentStamp: 'tty 6/15/2014 13:43' prior: 0!
A MacOSX32x86NewspeakStackV3  configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakMacOSX32x86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!MacOSX32x86NewspeakSistaV3 methodsFor: 'cmake' stamp: 'tty 6/9/2014 17:30'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!MacOSX32x86NewspeakSistaV3 methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:24'!
dirBuildLanguageVMMM
	^self newspeakSistaV3! !

!MacOSX32x86NewspeakSistaV3 methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:46'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!MacOSX32x86NewspeakSistaV3 methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:01'!
executableName
	^ self vmStackExecutableName! !

SqueakMacOSX32x86Config subclass: #MacOSX32x86NewspeakStackSpur
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOSX32x86'!

!MacOSX32x86NewspeakStackSpur commentStamp: 'tty 6/15/2014 13:43' prior: 0!
A MacOSX32x86NewspeakStackSpur  configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakMacOSX32x86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!MacOSX32x86NewspeakStackSpur methodsFor: 'cmake' stamp: 'tty 6/8/2014 19:16'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!MacOSX32x86NewspeakStackSpur methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:24'!
dirBuildLanguageVMMM
	^self newspeakStackSpur! !

!MacOSX32x86NewspeakStackSpur methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:46'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!MacOSX32x86NewspeakStackSpur methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:01'!
executableName
	^ self vmStackExecutableName! !

SqueakMacOSX32x86Config subclass: #MacOSX32x86NewspeakStackV3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOSX32x86'!

!MacOSX32x86NewspeakStackV3 commentStamp: 'tty 6/15/2014 13:43' prior: 0!
A MacOSX32x86NewspeakStackV3  configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakMacOSX32x86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!MacOSX32x86NewspeakStackV3 methodsFor: 'cmake' stamp: 'tty 6/8/2014 19:16'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!MacOSX32x86NewspeakStackV3 methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:24'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackV3! !

!MacOSX32x86NewspeakStackV3 methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:46'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

SqueakMacOSX32x86Config subclass: #MacOSX32x86SqueakCogSpur
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOSX32x86'!

!MacOSX32x86SqueakCogSpur commentStamp: 'tty 6/15/2014 13:43' prior: 0!
A MacOSX32x86SqueakCogSpur  configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakMacOSX32x86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!MacOSX32x86SqueakCogSpur methodsFor: 'cmake' stamp: 'tty 6/8/2014 19:16'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!MacOSX32x86SqueakCogSpur methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:25'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakCogSpur! !

!MacOSX32x86SqueakCogSpur methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:46'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!MacOSX32x86SqueakCogSpur methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:10'!
executableName
	^ self vmCogExecutableName! !

SqueakMacOSX32x86Config subclass: #MacOSX32x86SqueakCogV3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOSX32x86'!

!MacOSX32x86SqueakCogV3 commentStamp: 'tty 6/15/2014 13:43' prior: 0!
A MacOSX32x86SqueakCogV3  configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakMacOSX32x86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!MacOSX32x86SqueakCogV3 methodsFor: 'cmake' stamp: 'tty 6/8/2014 19:17'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!MacOSX32x86SqueakCogV3 methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:25'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakCogV3! !

!MacOSX32x86SqueakCogV3 methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:46'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!MacOSX32x86SqueakCogV3 methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:11'!
executableName
	^ self vmCogExecutableName! !

SqueakMacOSX32x86Config subclass: #MacOSX32x86SqueakSistaSpur
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOSX32x86'!

!MacOSX32x86SqueakSistaSpur commentStamp: 'tty 6/15/2014 13:43' prior: 0!
A MacOSX32x86SqueakSistaSpur  configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakMacOSX32x86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!MacOSX32x86SqueakSistaSpur methodsFor: 'cmake' stamp: 'tty 6/8/2014 19:17'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!MacOSX32x86SqueakSistaSpur methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:25'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakSistaSpur! !

!MacOSX32x86SqueakSistaSpur methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:46'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!MacOSX32x86SqueakSistaSpur methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:59'!
executableName
	^ self vmSistaExecutableName! !

SqueakMacOSX32x86Config subclass: #MacOSX32x86SqueakSistaV3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOSX32x86'!

!MacOSX32x86SqueakSistaV3 commentStamp: 'tty 6/15/2014 13:43' prior: 0!
A MacOSX32x86SqueakSistaV3  configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakMacOSX32x86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!MacOSX32x86SqueakSistaV3 methodsFor: 'cmake' stamp: 'tty 6/8/2014 19:17'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!MacOSX32x86SqueakSistaV3 methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:25'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakSistaV3! !

!MacOSX32x86SqueakSistaV3 methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:46'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!MacOSX32x86SqueakSistaV3 methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:59'!
executableName
	^ self vmSistaExecutableName! !

SqueakMacOSX32x86Config subclass: #MacOSX32x86SqueakStackSpur
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOSX32x86'!

!MacOSX32x86SqueakStackSpur commentStamp: 'tty 6/15/2014 13:43' prior: 0!
A MacOSX32x86SqueakStackSpur  configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakMacOSX32x86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!MacOSX32x86SqueakStackSpur methodsFor: 'cmake' stamp: 'tty 6/8/2014 19:17'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!MacOSX32x86SqueakStackSpur methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:25'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackSpur! !

!MacOSX32x86SqueakStackSpur methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:46'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!MacOSX32x86SqueakStackSpur methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:01'!
executableName
	^ self vmStackExecutableName! !

SqueakMacOSX32x86Config subclass: #MacOSX32x86SqueakStackV3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOSX32x86'!

!MacOSX32x86SqueakStackV3 commentStamp: 'tty 6/15/2014 13:43' prior: 0!
A MacOSX32x86SqueakStackV3  configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakMacOSX32x86Builder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!MacOSX32x86SqueakStackV3 methodsFor: 'cmake' stamp: 'tty 6/8/2014 19:17'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!MacOSX32x86SqueakStackV3 methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:25'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackV3! !

!MacOSX32x86SqueakStackV3 methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:46'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!MacOSX32x86SqueakStackV3 methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:01'!
executableName
	^ self vmStackExecutableName! !

!SqueakMacOSX32x86Config class methodsFor: 'as yet unclassified' stamp: 'tty 6/9/2014 18:50'!
licenseTemplate
	^'Squeak  {1} license information
==============================

About Squeak
-----------


Squeak is a modern, open source, full-featured implementation of the powerful Smalltalk programming language and environment. Squeak is highly-portable, running on almost any platform you could name and you can really truly write once run anywhere.  Squeak is the vehicle for a wide range of projects from multimedia applications and educational platforms to commercial web application development. Read on and join in!!

http://www.squeak.org


LIcense

Note: The current release of Squeak is a combination of source code originating from it''s origins at Apple which Apple agreed to license under the Apache license and more recent contributions licensed under the MIT license. The vast majority of the code is under the MIT license.
MIT License

Copyright (c) The individual, corporate, and institutional contributors who have collectively contributed elements to this software ("The Squeak Community"), 1996-2010 All rights reserved.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
Portions of Squeak are covered by the following license:
Apache License, Version 2.0

Copyright (c) Xerox Corp. 1981, 1982 All rights reserved. Copyright (c) Apple Computer, Inc. 1985-1996 All rights reserved.

Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.


About Cog
---------

Cog is a virtual machine designed for Smalltalk and other similar dynamic languages.  Cog builds on the
Squeak virtual machine adding a stack-to-register-mapping just-in-time compiler, aggressive in-line message
cacheing and effective optimization of Smalltalk’s first-class activation records.  Cog is the virtual machine
underlying Teleplace''s Croquet-based enterprise virtual collaboration spaces software, the fastest virtual
machine for Squeak, and for Gilad Bracha''s Newspeak modular language inspired by Beta and Smalltalk.  
Like the original Squeak VM, Cog is implemented and developed in Smalltalk, and translated into a lower-level
language to produce the production VM.  Being a Smalltalk program it is a delight to develop.  Cog is
available under the MIT open source license and is unencumbered for commercial deployment.

Cog''s performance relative to the existing Squeak interpreter varies, depending on the benchmark chosen.
As of early-2011, the Cog JIT uses strong inline cacheing techniques and stack-to-register mapping that
results in a register-based calling convention for low-arity methods.  Due to the complexity of the Squeak
object representation it has a limited set of primitives implemented in machine code that, for example,
exclude object allocation.  Performance of the early-2011 JIT for the nbody, binarytrees and chameneos
redux benchmarks from the computer language shootout is in the range of 4 to 6 times faster than the
interpreter.
'! !

!SqueakMacOSX32x86Config class methodsFor: 'as yet unclassified' stamp: 'tty 6/9/2014 18:50'!
pluginsTemplate
	^'Squeak {1} ships with the following plugins already built:
		
Internal: 
=========
{2}

External: 
=========
{3}

'! !

!SqueakMacOSX32x86Config methodsFor: 'directories' stamp: 'tty 6/9/2014 18:50'!
buildDir
	^ buildDir ifNil: [ buildDir := ( self topDir / self buildDirName) assureExistence].! !

!SqueakMacOSX32x86Config methodsFor: 'directories' stamp: 'tty 6/12/2014 12:15'!
buildDirName
	buildType isNil
		ifTrue:[^self dirBuildPlatform, FileDirectory slash, self dirBuildLanguageVMMM, FileDirectory slash, 'build']
		ifFalse:[^self dirBuildPlatform, FileDirectory slash, self dirBuildLanguageVMMM, FileDirectory slash, buildType asString]! !

!SqueakMacOSX32x86Config methodsFor: 'build script' stamp: 'tty 6/9/2014 18:50'!
buildScript
	"answer the build script for building everything"
	

	^ 
'#!!/usr/bin/env bash

cmake .
make
make install

'! !

!SqueakMacOSX32x86Config methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:50'!
cMakeMacros 
	^'macro(add_framework appname fwname)
    find_library(FRAMEWORK_${fwname}
        NAMES ${fwname}
        PATHS ${CMAKE_OSX_SYSROOT}/System/Library
        PATH_SUFFIXES Frameworks
        NO_DEFAULT_PATH)
    if( ${FRAMEWORK_${fwname}} STREQUAL FRAMEWORK_${fwname}-NOTFOUND)
        message(ERROR ": Framework ${fwname} not found")
    else()
	  include_directories(SYSTEM /System/Library/Frameworks/${fwname}.framework/Headers)
	  target_link_libraries(${appname} ${FRAMEWORK_${fwname}})
    endif()
endmacro(add_framework)'  ! !

!SqueakMacOSX32x86Config methodsFor: 'accessing' stamp: 'tty 6/16/2014 20:16'!
compilerFlags
	|d commonFlags flags|
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self compilerFlagsBuild];
		at: #buildAssert  put: [self compilerFlagsAssert];
		at: #buildAssertITimerHeartbeat  put: [self compilerFlagsAssertITimerHeartbeat];
            at:#buildDebug  put: [self compilerFlagsDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self compilerFlagsDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self compilerFlagsIHeartbeatTimer];
		at: #buildMultiThreaded  put: [self compilerFlagsMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self compilerFlagsMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self compilerFlagsMultiThreadedDebug ];
		at: #buildNone put:[self compilerFlagsNoBuildType].

    flags:= String streamContents: [ :stream |
	 (((d at:  buildType) value)  collect: #withBlanksTrimmed as: Set)
		asStringOn: stream 
		delimiter:' '].

    commonFlags:=String streamContents: [ :stream |
		((self commonCompilerFlags) collect: #withBlanksTrimmed as: Set)
			asStringOn: stream 
			delimiter: ' ' ].
	^ commonFlags, ' ' ,flags.! !

!SqueakMacOSX32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:50'!
configureB3DAcceleratorPlugin: maker
	"extra rules for B3DAcceleratorPlugin"
	
	super configureB3DAcceleratorPlugin: maker.  
	
	maker 
		includeDirectories: '/usr/X11/include';  "for GL.h"
		addPlatformSources: #( 'sqMacOpenGL.c' 'sqMacOpenGLInfo.c')
! !

!SqueakMacOSX32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:50'!
configureClipboardExtendedPlugin: maker
	! !

!SqueakMacOSX32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:50'!
configureCroquetPlugin: maker 
	"extra rules for CroquetPlugin"

	super configureCroquetPlugin: maker.  
	maker addPlatformSources: #('sqMacCroquet.c').
! !

!SqueakMacOSX32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:50'!
configureFFIPlugin: maker
	super configureFFIPlugin: maker.
	maker addPlatformSources: #( "'sqMacIntel-Win32.c'"
		'x86-sysv-MacIntel.c'
		'x86-sysv-asm-MacIntel.S'
	)! !

!SqueakMacOSX32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:50'!
configureFT2Plugin: maker
	"extra rules for Freetype plugin.
	a custom rule to build freetype library"
	| lib |
	
	maker isExternal ifFalse: [
		self error: 'building internal FT2Plugin is not supported yet'  	
	].

	"add freetype library into loop"
	lib := self addThirdpartyLibrary: 'freetype2'.

	"link plugin with freetype lib"
	maker addExternalLibrary: lib targetForLinking.
	maker includeDirectories: lib includeDir.
! !

!SqueakMacOSX32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:50'!
configureInternetConfigPlugin: maker
	"extra rules for InternetConfigPlugin"
	
	super configureInternetConfigPlugin: maker.  
	maker addPlatformSources: #( 'sqMacInternetConfiguration.c')
! !

!SqueakMacOSX32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:50'!
configureJoystickTabletPlugin: maker 
	"extra rules for JoystickTabletPlugin"
	
	super configureJoystickTabletPlugin: maker.  
	maker addPlatformSources:
		#( 
			'HID_Error_Handler.c'
			'HID_Name_Lookup.c'
			'HID_Queue_Utilities.c'
			'HID_Utilities.c'
			'sqMacJoystickAndTablet.c'
			)
! !

!SqueakMacOSX32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:50'!
configureLocalePlugin: maker 
	"extra rules for LocalePlugin"

	super configureLocalePlugin: maker.  
	maker addPlatformSources: #( 'sqMacLocaleCarbon.c' )
! !

!SqueakMacOSX32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:50'!
configureMIDIPlugin: maker 
	"extra rules for MIDIPlugin"

	super configureMIDIPlugin: maker.  
	maker addPlatformSources: #( 'sqMacMIDI.c')! !

!SqueakMacOSX32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:50'!
configureMpeg3Plugin: maker

	super configureMpeg3Plugin: maker.
	
	maker addPlatformSources: #(	
		'sqMacFileBits.c')
	! !

!SqueakMacOSX32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:50'!
configureObjectiveCPlugin: maker
	maker doNotGenerate: true! !

!SqueakMacOSX32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:50'!
configurePlugin: aPlugin with: generator

	generator isExternal ifTrue: [
		" set output directory for dynamic library to Resources subdir in .app bundle location "
		generator 
			set: 'CMAKE_LIBRARY_OUTPUT_DIRECTORY' 
			toString: '${externalModulesDir}'
		].
	^ super configurePlugin: aPlugin with: generator
! !

!SqueakMacOSX32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:50'!
configureQuicktimePlugin: maker
	
	maker includeDirectories: '${pluginPlatform}'.
	maker includeDirectories: '${crossDir}/plugins/SurfacePlugin'.
	
	" yes, this is not a typo , a file is named 'inteface' instead of 'interface' "

	maker addPlatformSources: #( 'sqMacQuicktimeInteface.c' ).
	
	maker addFrameworks: #( 'Carbon' 'QuickTime' ).! !

!SqueakMacOSX32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:50'!
configureSecurityPlugin: maker 
	"extra rules for SecurityPlugin"

	super configureSecurityPlugin: maker.  
	maker includeDirectories: '${crossDir}/plugins/FilePlugin'.
	maker addPlatformSources: #( 'sqMacSecurity.c' )! !

!SqueakMacOSX32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:50'!
configureSerialPlugin: maker 
	"extra rules for SerialPlugin"

	super configureSoundPlugin: maker.  
	maker includeDirectories: '${platformsDir}/unix/plugins/SerialPlugin'.
	maker 
		addSources: #('sqUnixSerial.c') 
		prefixed: '${platformsDir}/unix/plugins/SerialPlugin/'


! !

!SqueakMacOSX32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:50'!
configureSocketPlugin: maker 
	"extra rules for SoundPlugin"

	super configureSoundPlugin: maker.  
	maker includeDirectories: '${platformsDir}/unix/plugins/SocketPlugin'.
	maker 
		addSources: #('sqUnixSocket.c') 
		prefixed: '${platformsDir}/unix/plugins/SocketPlugin/'


! !

!SqueakMacOSX32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:50'!
configureSoundGenerationPlugin: maker 
	"extra rules for SoundPlugin"

	maker doNotGenerate: true. 
	" The sources in platforms/Cross/plugins/SoundGenerationPlugin/sqOldSoundPrims.c 
	are out of date and need to be fixed before it can be built 
	
	
	maker 
		addCrossSources: #('sqOldSoundPrims.c') 

	"
! !

!SqueakMacOSX32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:50'!
configureTestOSAPlugin: maker
		
	maker addFrameworks: #( 'Carbon'  'ApplicationServices' ).! !

!SqueakMacOSX32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:50'!
configureUnixOSProcessPlugin: maker 
	"extra rules for UnixOSProcessPlugin"

	maker includeDirectories: '${crossDir}/plugins/FilePlugin'.
! !

!SqueakMacOSX32x86Config methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:50'!
defaultDirectoriesFromGitDir: gitRepository
	"Set the default values for all necessary directories taking into account the Git repostiory. An example to use this method is:
	MTCocoaIOSCogJitDebugConfig new
	defaultDirectoriesFromGitDir: '/Users/mariano/Pharo/vm/git/cogVM/blessed';
	generateSources; 
	generate.
	"
	| gitRepositoryString |
	gitRepositoryString :=  gitRepository, '/'.
	self srcDir: gitRepositoryString, self srcDirName.
    	self platformsDir: gitRepositoryString, self platformsDirName.
    	self buildDir: gitRepositoryString, self buildDirName.
	self resourcesDir: gitRepositoryString, self resourcesDirName.
	self outputDir: gitRepositoryString, self outputDirName.
	
	
	! !

!SqueakMacOSX32x86Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:24'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self required! !

!SqueakMacOSX32x86Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:48'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSX32x86Config methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:50'!
executableName
	^ 'CogVM'! !

!SqueakMacOSX32x86Config methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:50'!
externalModulesDir
	"answer the location in VM bundle, where plugins and rest of dynamic libs will be copied,
	by default, it is Framerowks subdir. i.e: 
	
		Cog.app/Contents/Frameworks
		
	"
	
	^ '${outputDir}/', self executableName, '.app/Contents/MacOS/Plugins'! !

!SqueakMacOSX32x86Config methodsFor: 'utils' stamp: 'tty 6/9/2014 18:50'!
fixLibsTemplate

^
'include(GetPrerequisites)

message("Fixing library references in: ${externalModulesDir}")

FILE(GLOB libs  "${externalModulesDir}/*.dylib")

set(all_imports "")

foreach(lib ${libs})
	get_filename_component(libName "${lib}" NAME)
	list(APPEND libNames "${libName}")
	
	set(prereq "")
	get_prerequisites(${lib} prereq 1 0 "${bundlePath}" "")


	list(APPEND all_imports ${prereq})

endforeach(lib)

list(REMOVE_DUPLICATES all_imports)
set(replacements "")
message ( "Found imports: ${all_imports} " )

foreach(import ${all_imports})
	foreach(lib ${libNames})
		set(match "^.*${lib}$")
		if(import MATCHES ${match})
			set(replacement "${pluginsRelPath}/${lib}")
			message("Will replace: ${import} with: ${replacement}")
			set(replacements ${replacements} "-change" "${import}" "${replacement}")
		endif(import MATCHES ${match})
	endforeach(lib)
endforeach(import)

foreach(lib ${libs})
	get_filename_component(name ${lib} NAME)
	set(fixedName "${pluginsRelPath}/${name}")
	message("Fixing up: ${name}")

 	execute_process(COMMAND install_name_tool -id "${fixedName}" "${lib}" )

 	execute_process(COMMAND install_name_tool  ${replacements} ${lib} )

endforeach(lib)
'

! !

!SqueakMacOSX32x86Config methodsFor: 'utils' stamp: 'tty 6/9/2014 18:50'!
fixLineEndsOf: string
	^ string copyReplaceAll: String cr with: String lf! !

!SqueakMacOSX32x86Config methodsFor: 'public' stamp: 'tty 6/9/2014 18:50'!
generate 
	self generatePluginsList. 
	self generateLicense. 
	"^super generate"
	^CMakeVMGeneratorForSqueak generate:self    "Bypass CPlatformConfig generate to invoke our compatibility class"! !

!SqueakMacOSX32x86Config methodsFor: 'as yet unclassified' stamp: 'tty 6/9/2014 18:50'!
generateLicense 
	self 
		write:  (self class licenseTemplate 
			format: { self version })
		toFile: 'LICENSE.txt'
	! !

!SqueakMacOSX32x86Config methodsFor: 'as yet unclassified' stamp: 'tty 6/9/2014 18:50'!
generatePluginsList 
	self 
		write:  (self class pluginsTemplate 
			format: {
				self version. 
				String streamContents: [ :stream | self internalPlugins asStringOn: stream delimiter: String cr ].
				String streamContents: [ :stream | self externalPlugins asStringOn: stream delimiter: String cr ].
				self executableName })
		toFile: 'PLUGINS.txt'
	! !

!SqueakMacOSX32x86Config methodsFor: 'accessing' stamp: 'tty 6/14/2014 15:42'!
outputDir

	"the directory where built binaries will be stored"
	^ outputDir ifNil: [ outputDir := (self topDir / self dirOutput/ self dirInstall) ]	

! !

!SqueakMacOSX32x86Config methodsFor: 'utils' stamp: 'tty 6/9/2014 18:50'!
postBuildActions: gen

	" override to add custom rules after all targets is defined "
	
	self write: self fixLibsTemplate toFile: 'fix_libs.cmake'.
	
	
	gen
		set: #bundlePath toString: '${outputDir}/', self executableName, '.app';
		set: #pluginsRelPath toString: '@executable_path/Plugins'.

	gen
		puts: '
		INSTALL(CODE "
			set(externalModulesDir \"${externalModulesDir}\")
			set(bundlePath \"${bundlePath}\")
			set(pluginsRelPath \"${pluginsRelPath}\")
			
			include(fix_libs.cmake)
		")'
			
"					FILE(GLOB_RECURSE bLibs /${externalModulesDir}/*.*)
"! !

!SqueakMacOSX32x86Config methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:50'!
prepareForGeneration
	! !

!SqueakMacOSX32x86Config methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:50'!
prepareVMMaker
	
	| maker allPlugins |
	
	"In CogVMs (in contrast to Interpreter VM) the generated sources are platform independent, therefore Cross is ok"
	maker := VMMaker forPlatform: 'Cross'.
	
	maker sourceDirectoryName: self srcDir pathName.
	maker platformRootDirectoryName: self platformsDir.
	
	
	allPlugins := self internalPlugins , self externalPlugins.
	
	"touch plugins to force their source generation unconditionally"
	allPlugins do: [:name | (Smalltalk globals at: name) touch ].
	
	" Why we put all plugins as external?   Because the generated sources are not different whether the plugins were defined as internal or external. VMMaker used to need this to to generate plugins.int and plugins.ext files. But since this is achieved in another way with CMakeVMMaker, there is no different at all to put all plugins as internal or as external."
	maker externalModules addAll:  allPlugins.
	
	^ maker! !

!SqueakMacOSX32x86Config methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:50'!
resourcesDir 
	"Answer the value of resourcesDir"

	^ resourcesDir ifNil: [ resourcesDir := (self topDir / 'macbuild/resources') fullName ]
	! !

!SqueakMacOSX32x86Config methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:50'!
resourcesDir: anObject
	"Set the value of platformsDir"

	resourcesDir := anObject! !

!SqueakMacOSX32x86Config methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:50'!
resourcesDirName
	^ 'macbuild/resources'! !

!SqueakMacOSX32x86Config methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:50'!
setupDirectories: gen
	| dirsInclude |

	" write the directories in separate include file"
	dirsInclude := gen captureOutputDuring: [
		gen
			set: #topDir toString: (self topDir fullName); 
			set: #buildDir toString: (self buildDir ifNil: ['${topDir}/build'] ifNotNil: [self buildDir fullName] );
			set: #thirdpartyDir toString: '${buildDir}/thirdParty';
			set: #platformsDir toString: self platformsDir;
			set: #srcDir toString: self srcDir pathName;
			set: #srcPluginsDir toString: (pluginsDir ifNil: [ '${srcDir}/plugins' ]);
			set: #srcVMDir toString: '${srcDir}/vm';
			set: #platformName toString: self platformName;
			set: #targetPlatform to: '${platformsDir}/${platformName}';
			set: #crossDir toString: '${platformsDir}/Cross';
			set: #platformVMDir toString: '${targetPlatform}/vm';
			set: #outputDir toString: self outputDir fullName.
	].

	self write: dirsInclude toFile: 'directories.cmake'.
	
	gen include: 'directories.cmake'.
! !

!SqueakMacOSX32x86Config methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:50'!
srcDir
		^ srcDir ifNil: [ srcDir := (self topDir directoryNamed: 'src' )]! !

!SqueakMacOSX32x86Config methodsFor: 'directories' stamp: 'tty 6/9/2014 18:50'!
topDir
		^ topDir ifNil: [ topDir := FileDirectory default directoryNamed: self oscogvm ]! !

!SqueakMacOSX32x86Config methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:50'!
validateSourcesPresent
	| sources |
	sources := Smalltalk sourcesName.
	
	(sources == nil)
		ifTrue: [	self error: 'VM source code cannot be generated without .sources file'.]		! !

!SqueakMacOSX32x86Config methodsFor: 'as yet unclassified' stamp: 'tty 6/9/2014 18:50'!
version
	^ ''! !

SqueakMacOSConfig subclass: #SqueakMacOSXPowerPCConfig
	instanceVariableNames: 'resourcesDir'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOSPowerPC'!

!SqueakMacOSXPowerPCConfig commentStamp: 'tty 6/15/2014 13:44' prior: 0!
tty. Don't use me until I am refactored for this platform

I am not sure what this does yet. I have put this here to keep a consistent pattern of top level configuration per platform.
I need to be configured for the job I am advertised to do.

I am not meant to be built.

SqueakMacOSPowerPCBuilder 
	configureABuildFor: #ONE OF MY SUBCLASSES NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!SqueakMacOSXPowerPCConfig class methodsFor: 'as yet unclassified' stamp: 'tty 6/9/2014 18:43'!
licenseTemplate
	^'Squeak  {1} license information
==============================

About Squeak
-----------


Squeak is a modern, open source, full-featured implementation of the powerful Smalltalk programming language and environment. Squeak is highly-portable, running on almost any platform you could name and you can really truly write once run anywhere.  Squeak is the vehicle for a wide range of projects from multimedia applications and educational platforms to commercial web application development. Read on and join in!!

http://www.squeak.org


LIcense

Note: The current release of Squeak is a combination of source code originating from it''s origins at Apple which Apple agreed to license under the Apache license and more recent contributions licensed under the MIT license. The vast majority of the code is under the MIT license.
MIT License

Copyright (c) The individual, corporate, and institutional contributors who have collectively contributed elements to this software ("The Squeak Community"), 1996-2010 All rights reserved.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
Portions of Squeak are covered by the following license:
Apache License, Version 2.0

Copyright (c) Xerox Corp. 1981, 1982 All rights reserved. Copyright (c) Apple Computer, Inc. 1985-1996 All rights reserved.

Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.


About Cog
---------

Cog is a virtual machine designed for Smalltalk and other similar dynamic languages.  Cog builds on the
Squeak virtual machine adding a stack-to-register-mapping just-in-time compiler, aggressive in-line message
cacheing and effective optimization of Smalltalk’s first-class activation records.  Cog is the virtual machine
underlying Teleplace''s Croquet-based enterprise virtual collaboration spaces software, the fastest virtual
machine for Squeak, and for Gilad Bracha''s Newspeak modular language inspired by Beta and Smalltalk.  
Like the original Squeak VM, Cog is implemented and developed in Smalltalk, and translated into a lower-level
language to produce the production VM.  Being a Smalltalk program it is a delight to develop.  Cog is
available under the MIT open source license and is unencumbered for commercial deployment.

Cog''s performance relative to the existing Squeak interpreter varies, depending on the benchmark chosen.
As of early-2011, the Cog JIT uses strong inline cacheing techniques and stack-to-register mapping that
results in a register-based calling convention for low-arity methods.  Due to the complexity of the Squeak
object representation it has a limited set of primitives implemented in machine code that, for example,
exclude object allocation.  Performance of the early-2011 JIT for the nbody, binarytrees and chameneos
redux benchmarks from the computer language shootout is in the range of 4 to 6 times faster than the
interpreter.
'! !

!SqueakMacOSXPowerPCConfig class methodsFor: 'as yet unclassified' stamp: 'tty 6/9/2014 18:43'!
pluginsTemplate
	^'Squeak {1} ships with the following plugins already built:
		
Internal: 
=========
{2}

External: 
=========
{3}

'! !

!SqueakMacOSXPowerPCConfig methodsFor: 'directories' stamp: 'tty 6/9/2014 18:43'!
buildDir
	^ buildDir ifNil: [ buildDir := ( self topDir / self buildDirName) assureExistence].! !

!SqueakMacOSXPowerPCConfig methodsFor: 'directories' stamp: 'tty 6/12/2014 12:14'!
buildDirName
	buildType isNil
		ifTrue:[^self dirBuildPlatform, FileDirectory slash, self dirBuildLanguageVMMM, FileDirectory slash, 'build']
		ifFalse:[^self dirBuildPlatform, FileDirectory slash, self dirBuildLanguageVMMM, FileDirectory slash, buildType asString]! !

!SqueakMacOSXPowerPCConfig methodsFor: 'build script' stamp: 'tty 6/9/2014 18:43'!
buildScript
	"answer the build script for building everything"
	

	^ 
'#!!/usr/bin/env bash

cmake .
make
make install

'! !

!SqueakMacOSXPowerPCConfig methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:43'!
cMakeMacros 
	^'macro(add_framework appname fwname)
    find_library(FRAMEWORK_${fwname}
        NAMES ${fwname}
        PATHS ${CMAKE_OSX_SYSROOT}/System/Library
        PATH_SUFFIXES Frameworks
        NO_DEFAULT_PATH)
    if( ${FRAMEWORK_${fwname}} STREQUAL FRAMEWORK_${fwname}-NOTFOUND)
        message(ERROR ": Framework ${fwname} not found")
    else()
	  include_directories(SYSTEM /System/Library/Frameworks/${fwname}.framework/Headers)
	  target_link_libraries(${appname} ${FRAMEWORK_${fwname}})
    endif()
endmacro(add_framework)'  ! !

!SqueakMacOSXPowerPCConfig methodsFor: 'accessing' stamp: 'tty 6/16/2014 20:16'!
compilerFlags
	|d commonFlags flags|
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self compilerFlagsBuild];
		at: #buildAssert  put: [self compilerFlagsAssert];
		at: #buildAssertITimerHeartbeat  put: [self compilerFlagsAssertITimerHeartbeat];
            at:#buildDebug  put: [self compilerFlagsDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self compilerFlagsDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self compilerFlagsIHeartbeatTimer];
		at: #buildMultiThreaded  put: [self compilerFlagsMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self compilerFlagsMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self compilerFlagsMultiThreadedDebug ];
		at: #buildNone put:[self compilerFlagsNoBuildType].

    flags:= String streamContents: [ :stream |
	 (((d at:  buildType) value)  collect: #withBlanksTrimmed as: Set)
		asStringOn: stream 
		delimiter:' '].

    commonFlags:=String streamContents: [ :stream |
		((self commonCompilerFlags) collect: #withBlanksTrimmed as: Set)
			asStringOn: stream 
			delimiter: ' ' ].
	^ commonFlags, ' ' ,flags.! !

!SqueakMacOSXPowerPCConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:43'!
configureB3DAcceleratorPlugin: maker
	"extra rules for B3DAcceleratorPlugin"
	
	super configureB3DAcceleratorPlugin: maker.  
	
	maker 
		includeDirectories: '/usr/X11/include';  "for GL.h"
		addPlatformSources: #( 'sqMacOpenGL.c' 'sqMacOpenGLInfo.c')
! !

!SqueakMacOSXPowerPCConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:43'!
configureClipboardExtendedPlugin: maker
	! !

!SqueakMacOSXPowerPCConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:43'!
configureCroquetPlugin: maker 
	"extra rules for CroquetPlugin"

	super configureCroquetPlugin: maker.  
	maker addPlatformSources: #('sqMacCroquet.c').
! !

!SqueakMacOSXPowerPCConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:43'!
configureFFIPlugin: maker
	super configureFFIPlugin: maker.
	maker addPlatformSources: #( "'sqMacIntel-Win32.c'"
		'x86-sysv-MacIntel.c'
		'x86-sysv-asm-MacIntel.S'
	)! !

!SqueakMacOSXPowerPCConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:43'!
configureFT2Plugin: maker
	"extra rules for Freetype plugin.
	a custom rule to build freetype library"
	| lib |
	
	maker isExternal ifFalse: [
		self error: 'building internal FT2Plugin is not supported yet'  	
	].

	"add freetype library into loop"
	lib := self addThirdpartyLibrary: 'freetype2'.

	"link plugin with freetype lib"
	maker addExternalLibrary: lib targetForLinking.
	maker includeDirectories: lib includeDir.
! !

!SqueakMacOSXPowerPCConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:43'!
configureInternetConfigPlugin: maker
	"extra rules for InternetConfigPlugin"
	
	super configureInternetConfigPlugin: maker.  
	maker addPlatformSources: #( 'sqMacInternetConfiguration.c')
! !

!SqueakMacOSXPowerPCConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:43'!
configureJoystickTabletPlugin: maker 
	"extra rules for JoystickTabletPlugin"
	
	super configureJoystickTabletPlugin: maker.  
	maker addPlatformSources:
		#( 
			'HID_Error_Handler.c'
			'HID_Name_Lookup.c'
			'HID_Queue_Utilities.c'
			'HID_Utilities.c'
			'sqMacJoystickAndTablet.c'
			)
! !

!SqueakMacOSXPowerPCConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:43'!
configureLocalePlugin: maker 
	"extra rules for LocalePlugin"

	super configureLocalePlugin: maker.  
	maker addPlatformSources: #( 'sqMacLocaleCarbon.c' )
! !

!SqueakMacOSXPowerPCConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:43'!
configureMIDIPlugin: maker 
	"extra rules for MIDIPlugin"

	super configureMIDIPlugin: maker.  
	maker addPlatformSources: #( 'sqMacMIDI.c')! !

!SqueakMacOSXPowerPCConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:43'!
configureMpeg3Plugin: maker

	super configureMpeg3Plugin: maker.
	
	maker addPlatformSources: #(	
		'sqMacFileBits.c')
	! !

!SqueakMacOSXPowerPCConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:43'!
configureObjectiveCPlugin: maker
	maker doNotGenerate: true! !

!SqueakMacOSXPowerPCConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:43'!
configurePlugin: aPlugin with: generator

	generator isExternal ifTrue: [
		" set output directory for dynamic library to Resources subdir in .app bundle location "
		generator 
			set: 'CMAKE_LIBRARY_OUTPUT_DIRECTORY' 
			toString: '${externalModulesDir}'
		].
	^ super configurePlugin: aPlugin with: generator
! !

!SqueakMacOSXPowerPCConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:43'!
configureQuicktimePlugin: maker
	
	maker includeDirectories: '${pluginPlatform}'.
	maker includeDirectories: '${crossDir}/plugins/SurfacePlugin'.
	
	" yes, this is not a typo , a file is named 'inteface' instead of 'interface' "

	maker addPlatformSources: #( 'sqMacQuicktimeInteface.c' ).
	
	maker addFrameworks: #( 'Carbon' 'QuickTime' ).! !

!SqueakMacOSXPowerPCConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:43'!
configureSecurityPlugin: maker 
	"extra rules for SecurityPlugin"

	super configureSecurityPlugin: maker.  
	maker includeDirectories: '${crossDir}/plugins/FilePlugin'.
	maker addPlatformSources: #( 'sqMacSecurity.c' )! !

!SqueakMacOSXPowerPCConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:43'!
configureSerialPlugin: maker 
	"extra rules for SerialPlugin"

	super configureSoundPlugin: maker.  
	maker includeDirectories: '${platformsDir}/unix/plugins/SerialPlugin'.
	maker 
		addSources: #('sqUnixSerial.c') 
		prefixed: '${platformsDir}/unix/plugins/SerialPlugin/'


! !

!SqueakMacOSXPowerPCConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:43'!
configureSocketPlugin: maker 
	"extra rules for SoundPlugin"

	super configureSoundPlugin: maker.  
	maker includeDirectories: '${platformsDir}/unix/plugins/SocketPlugin'.
	maker 
		addSources: #('sqUnixSocket.c') 
		prefixed: '${platformsDir}/unix/plugins/SocketPlugin/'


! !

!SqueakMacOSXPowerPCConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:43'!
configureSoundGenerationPlugin: maker 
	"extra rules for SoundPlugin"

	maker doNotGenerate: true. 
	" The sources in platforms/Cross/plugins/SoundGenerationPlugin/sqOldSoundPrims.c 
	are out of date and need to be fixed before it can be built 
	
	
	maker 
		addCrossSources: #('sqOldSoundPrims.c') 

	"
! !

!SqueakMacOSXPowerPCConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:43'!
configureTestOSAPlugin: maker
		
	maker addFrameworks: #( 'Carbon'  'ApplicationServices' ).! !

!SqueakMacOSXPowerPCConfig methodsFor: 'plugin extra rules' stamp: 'tty 6/9/2014 18:43'!
configureUnixOSProcessPlugin: maker 
	"extra rules for UnixOSProcessPlugin"

	maker includeDirectories: '${crossDir}/plugins/FilePlugin'.
! !

!SqueakMacOSXPowerPCConfig methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:43'!
defaultDirectoriesFromGitDir: gitRepository
	"Set the default values for all necessary directories taking into account the Git repostiory. An example to use this method is:
	MTCocoaIOSCogJitDebugConfig new
	defaultDirectoriesFromGitDir: '/Users/mariano/Pharo/vm/git/cogVM/blessed';
	generateSources; 
	generate.
	"
	| gitRepositoryString |
	gitRepositoryString :=  gitRepository, '/'.
	self srcDir: gitRepositoryString, self srcDirName.
    	self platformsDir: gitRepositoryString, self platformsDirName.
    	self buildDir: gitRepositoryString, self buildDirName.
	self resourcesDir: gitRepositoryString, self resourcesDirName.
	self outputDir: gitRepositoryString, self outputDirName.
	
	
	! !

!SqueakMacOSXPowerPCConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:22'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self required! !

!SqueakMacOSXPowerPCConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:48'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSXPowerPCConfig methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:43'!
executableName
	^ 'CogVM'! !

!SqueakMacOSXPowerPCConfig methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:43'!
externalModulesDir
	"answer the location in VM bundle, where plugins and rest of dynamic libs will be copied,
	by default, it is Framerowks subdir. i.e: 
	
		Cog.app/Contents/Frameworks
		
	"
	
	^ '${outputDir}/', self executableName, '.app/Contents/MacOS/Plugins'! !

!SqueakMacOSXPowerPCConfig methodsFor: 'utils' stamp: 'tty 6/9/2014 18:43'!
fixLibsTemplate

^
'include(GetPrerequisites)

message("Fixing library references in: ${externalModulesDir}")

FILE(GLOB libs  "${externalModulesDir}/*.dylib")

set(all_imports "")

foreach(lib ${libs})
	get_filename_component(libName "${lib}" NAME)
	list(APPEND libNames "${libName}")
	
	set(prereq "")
	get_prerequisites(${lib} prereq 1 0 "${bundlePath}" "")


	list(APPEND all_imports ${prereq})

endforeach(lib)

list(REMOVE_DUPLICATES all_imports)
set(replacements "")
message ( "Found imports: ${all_imports} " )

foreach(import ${all_imports})
	foreach(lib ${libNames})
		set(match "^.*${lib}$")
		if(import MATCHES ${match})
			set(replacement "${pluginsRelPath}/${lib}")
			message("Will replace: ${import} with: ${replacement}")
			set(replacements ${replacements} "-change" "${import}" "${replacement}")
		endif(import MATCHES ${match})
	endforeach(lib)
endforeach(import)

foreach(lib ${libs})
	get_filename_component(name ${lib} NAME)
	set(fixedName "${pluginsRelPath}/${name}")
	message("Fixing up: ${name}")

 	execute_process(COMMAND install_name_tool -id "${fixedName}" "${lib}" )

 	execute_process(COMMAND install_name_tool  ${replacements} ${lib} )

endforeach(lib)
'

! !

!SqueakMacOSXPowerPCConfig methodsFor: 'utils' stamp: 'tty 6/9/2014 18:43'!
fixLineEndsOf: string
	^ string copyReplaceAll: String cr with: String lf! !

!SqueakMacOSXPowerPCConfig methodsFor: 'public' stamp: 'tty 6/9/2014 18:43'!
generate 
	self generatePluginsList. 
	self generateLicense. 
	"^super generate"
	^CMakeVMGeneratorForSqueak generate:self    "Bypass CPlatformConfig generate to invoke our compatibility class"! !

!SqueakMacOSXPowerPCConfig methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:43'!
generateLicense 
	self 
		write:  (self class licenseTemplate 
			format: { self version })
		toFile: 'LICENSE.txt'
	! !

!SqueakMacOSXPowerPCConfig methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:43'!
generatePluginsList 
	self 
		write:  (self class pluginsTemplate 
			format: {
				self version. 
				String streamContents: [ :stream | self internalPlugins asStringOn: stream delimiter: String cr ].
				String streamContents: [ :stream | self externalPlugins asStringOn: stream delimiter: String cr ].
				self executableName })
		toFile: 'PLUGINS.txt'
	! !

!SqueakMacOSXPowerPCConfig methodsFor: 'accessing' stamp: 'tty 6/14/2014 15:43'!
outputDir

	"the directory where built binaries will be stored"
	^ outputDir ifNil: [ outputDir := (self topDir / self dirOutput/ self dirInstall) ]	

! !

!SqueakMacOSXPowerPCConfig methodsFor: 'utils' stamp: 'tty 6/9/2014 18:43'!
postBuildActions: gen

	" override to add custom rules after all targets is defined "
	
	self write: self fixLibsTemplate toFile: 'fix_libs.cmake'.
	
	
	gen
		set: #bundlePath toString: '${outputDir}/', self executableName, '.app';
		set: #pluginsRelPath toString: '@executable_path/Plugins'.

	gen
		puts: '
		INSTALL(CODE "
			set(externalModulesDir \"${externalModulesDir}\")
			set(bundlePath \"${bundlePath}\")
			set(pluginsRelPath \"${pluginsRelPath}\")
			
			include(fix_libs.cmake)
		")'
			
"					FILE(GLOB_RECURSE bLibs /${externalModulesDir}/*.*)
"! !

!SqueakMacOSXPowerPCConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:43'!
prepareForGeneration
	! !

!SqueakMacOSXPowerPCConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:43'!
prepareVMMaker
	
	| maker allPlugins |
	
	"In CogVMs (in contrast to Interpreter VM) the generated sources are platform independent, therefore Cross is ok"
	maker := VMMaker forPlatform: 'Cross'.
	
	maker sourceDirectoryName: self srcDir pathName.
	maker platformRootDirectoryName: self platformsDir.
	
	
	allPlugins := self internalPlugins , self externalPlugins.
	
	"touch plugins to force their source generation unconditionally"
	allPlugins do: [:name | (Smalltalk globals at: name) touch ].
	
	" Why we put all plugins as external?   Because the generated sources are not different whether the plugins were defined as internal or external. VMMaker used to need this to to generate plugins.int and plugins.ext files. But since this is achieved in another way with CMakeVMMaker, there is no different at all to put all plugins as internal or as external."
	maker externalModules addAll:  allPlugins.
	
	^ maker! !

!SqueakMacOSXPowerPCConfig methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:43'!
resourcesDir 
	"Answer the value of resourcesDir"

	^ resourcesDir ifNil: [ resourcesDir := (self topDir / 'macbuild/resources') fullName ]
	! !

!SqueakMacOSXPowerPCConfig methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:43'!
resourcesDir: anObject
	"Set the value of platformsDir"

	resourcesDir := anObject! !

!SqueakMacOSXPowerPCConfig methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:43'!
resourcesDirName
	^ 'macbuild/resources'! !

!SqueakMacOSXPowerPCConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:43'!
setupDirectories: gen
	| dirsInclude |

	" write the directories in separate include file"
	dirsInclude := gen captureOutputDuring: [
		gen
			set: #topDir toString: (self topDir fullName); 
			set: #buildDir toString: (self buildDir ifNil: ['${topDir}/build'] ifNotNil: [self buildDir fullName] );
			set: #thirdpartyDir toString: '${buildDir}/thirdParty';
			set: #platformsDir toString: self platformsDir;
			set: #srcDir toString: self srcDir pathName;
			set: #srcPluginsDir toString: (pluginsDir ifNil: [ '${srcDir}/plugins' ]);
			set: #srcVMDir toString: '${srcDir}/vm';
			set: #platformName toString: self platformName;
			set: #targetPlatform to: '${platformsDir}/${platformName}';
			set: #crossDir toString: '${platformsDir}/Cross';
			set: #platformVMDir toString: '${targetPlatform}/vm';
			set: #outputDir toString: self outputDir fullName.
	].

	self write: dirsInclude toFile: 'directories.cmake'.
	
	gen include: 'directories.cmake'.
! !

!SqueakMacOSXPowerPCConfig methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:43'!
srcDir
		^ srcDir ifNil: [ srcDir := (self topDir directoryNamed: 'src' )]! !

!SqueakMacOSXPowerPCConfig methodsFor: 'directories' stamp: 'tty 6/9/2014 18:43'!
topDir
		^ topDir ifNil: [ topDir := FileDirectory default directoryNamed: self oscogvm ]! !

!SqueakMacOSXPowerPCConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 18:43'!
validateSourcesPresent
	| sources |
	sources := Smalltalk sourcesName.
	
	(sources == nil)
		ifTrue: [	self error: 'VM source code cannot be generated without .sources file'.]		! !

!SqueakMacOSXPowerPCConfig methodsFor: 'accessing' stamp: 'tty 6/9/2014 18:43'!
version
	^ ''! !

SqueakMacOSXPowerPCConfig subclass: #SqueakMacOSXPowerPCNewspeakCogSpur
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOSPowerPC'!

!SqueakMacOSXPowerPCNewspeakCogSpur commentStamp: 'tty 6/15/2014 13:44' prior: 0!
A MacOSXPowerPCSqueakCogSpur  configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakMacOSPowerPCBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!SqueakMacOSXPowerPCNewspeakCogSpur class methodsFor: 'as yet unclassified' stamp: 'tty 6/9/2014 18:48'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder  default   allBuildConfigurations! !

!SqueakMacOSXPowerPCNewspeakCogSpur methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:48'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!SqueakMacOSXPowerPCNewspeakCogSpur methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:22'!
dirBuildLanguageVMMM
	^self newspeakCogSpur! !

!SqueakMacOSXPowerPCNewspeakCogSpur methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:48'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSXPowerPCNewspeakCogSpur methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:10'!
executableName
	^ self vmCogExecutableName! !

SqueakMacOSXPowerPCConfig subclass: #SqueakMacOSXPowerPCNewspeakCogV3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOSPowerPC'!

!SqueakMacOSXPowerPCNewspeakCogV3 commentStamp: 'tty 6/15/2014 13:44' prior: 0!
A MacOSXPowerPCSqueakCogSpur  configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakMacOSPowerPCBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!SqueakMacOSXPowerPCNewspeakCogV3 class methodsFor: 'as yet unclassified' stamp: 'tty 6/9/2014 18:48'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder  default   allBuildConfigurations! !

!SqueakMacOSXPowerPCNewspeakCogV3 methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:48'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!SqueakMacOSXPowerPCNewspeakCogV3 methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:22'!
dirBuildLanguageVMMM
	^self newspeakCogV3! !

!SqueakMacOSXPowerPCNewspeakCogV3 methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:48'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSXPowerPCNewspeakCogV3 methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:10'!
executableName
	^ self vmCogExecutableName! !

SqueakMacOSXPowerPCConfig subclass: #SqueakMacOSXPowerPCNewspeakSistaSpur
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOSPowerPC'!

!SqueakMacOSXPowerPCNewspeakSistaSpur commentStamp: 'tty 6/15/2014 13:44' prior: 0!
A MacOSXPowerPCSqueakCogSpur  configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakMacOSPowerPCBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!SqueakMacOSXPowerPCNewspeakSistaSpur class methodsFor: 'as yet unclassified' stamp: 'tty 6/9/2014 18:48'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder  default   allBuildConfigurations! !

!SqueakMacOSXPowerPCNewspeakSistaSpur methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:48'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!SqueakMacOSXPowerPCNewspeakSistaSpur methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:22'!
dirBuildLanguageVMMM
	^self newspeakSistaSpur! !

!SqueakMacOSXPowerPCNewspeakSistaSpur methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:48'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSXPowerPCNewspeakSistaSpur methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:58'!
executableName
	^ self vmSistaExecutableName! !

SqueakMacOSXPowerPCConfig subclass: #SqueakMacOSXPowerPCNewspeakSistaV3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOSPowerPC'!

!SqueakMacOSXPowerPCNewspeakSistaV3 commentStamp: 'tty 6/15/2014 13:44' prior: 0!
A MacOSXPowerPCSqueakCogSpur  configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakMacOSPowerPCBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!SqueakMacOSXPowerPCNewspeakSistaV3 class methodsFor: 'as yet unclassified' stamp: 'tty 6/9/2014 18:48'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder  default   allBuildConfigurations! !

!SqueakMacOSXPowerPCNewspeakSistaV3 methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:48'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!SqueakMacOSXPowerPCNewspeakSistaV3 methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:22'!
dirBuildLanguageVMMM
	^self newspeakSistaV3! !

!SqueakMacOSXPowerPCNewspeakSistaV3 methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:48'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSXPowerPCNewspeakSistaV3 methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:58'!
executableName
	^ self vmSistaExecutableName! !

SqueakMacOSXPowerPCConfig subclass: #SqueakMacOSXPowerPCNewspeakStackSpur
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOSPowerPC'!

!SqueakMacOSXPowerPCNewspeakStackSpur commentStamp: 'tty 6/15/2014 13:44' prior: 0!
A MacOSXPowerPCSqueakCogSpur  configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


SqueakMacOSPowerPCBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!SqueakMacOSXPowerPCNewspeakStackSpur class methodsFor: 'as yet unclassified' stamp: 'tty 6/9/2014 18:49'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder  default   allBuildConfigurations! !

!SqueakMacOSXPowerPCNewspeakStackSpur methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:49'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!SqueakMacOSXPowerPCNewspeakStackSpur methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:22'!
dirBuildLanguageVMMM
	^self newspeakStackSpur! !

!SqueakMacOSXPowerPCNewspeakStackSpur methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:48'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSXPowerPCNewspeakStackSpur methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:02'!
executableName
	^ self vmStackExecutableName! !

SqueakMacOSXPowerPCConfig subclass: #SqueakMacOSXPowerPCNewspeakStackV3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOSPowerPC'!

!SqueakMacOSXPowerPCNewspeakStackV3 commentStamp: 'tty 6/15/2014 13:44' prior: 0!
A MacOSXPowerPCSqueakCogSpur  configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakMacOSPowerPCBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!SqueakMacOSXPowerPCNewspeakStackV3 class methodsFor: 'as yet unclassified' stamp: 'tty 6/9/2014 18:49'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder  default   allBuildConfigurations! !

!SqueakMacOSXPowerPCNewspeakStackV3 methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:49'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!SqueakMacOSXPowerPCNewspeakStackV3 methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:23'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackV3! !

!SqueakMacOSXPowerPCNewspeakStackV3 methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:48'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSXPowerPCNewspeakStackV3 methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:01'!
executableName
	^ self vmStackExecutableName! !

SqueakMacOSXPowerPCConfig subclass: #SqueakMacOSXPowerPCSqueakCogSpur
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOSPowerPC'!

!SqueakMacOSXPowerPCSqueakCogSpur commentStamp: 'tty 6/15/2014 13:45' prior: 0!
A MacOSXPowerPCSqueakCogSpur  configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakMacOSPowerPCBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!SqueakMacOSXPowerPCSqueakCogSpur class methodsFor: 'as yet unclassified' stamp: 'tty 6/8/2014 14:24'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder  default   allBuildConfigurations! !

!SqueakMacOSXPowerPCSqueakCogSpur methodsFor: 'cmake' stamp: 'tty 6/8/2014 19:16'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!SqueakMacOSXPowerPCSqueakCogSpur methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:23'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakCogSpur! !

!SqueakMacOSXPowerPCSqueakCogSpur methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:49'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSXPowerPCSqueakCogSpur methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:10'!
executableName
	^ self vmCogExecutableName! !

SqueakMacOSXPowerPCConfig subclass: #SqueakMacOSXPowerPCSqueakCogV3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOSPowerPC'!

!SqueakMacOSXPowerPCSqueakCogV3 commentStamp: 'tty 6/15/2014 13:45' prior: 0!
A MacOSXPowerPCSqueakCogSpur  configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakMacOSPowerPCBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!SqueakMacOSXPowerPCSqueakCogV3 class methodsFor: 'as yet unclassified' stamp: 'tty 6/9/2014 18:46'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder  default   allBuildConfigurations! !

!SqueakMacOSXPowerPCSqueakCogV3 methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:46'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!SqueakMacOSXPowerPCSqueakCogV3 methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:23'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakCogV3! !

!SqueakMacOSXPowerPCSqueakCogV3 methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:49'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSXPowerPCSqueakCogV3 methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:10'!
executableName
	^ self vmCogExecutableName! !

SqueakMacOSXPowerPCConfig subclass: #SqueakMacOSXPowerPCSqueakSistaSpur
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOSPowerPC'!

!SqueakMacOSXPowerPCSqueakSistaSpur commentStamp: 'tty 6/15/2014 13:45' prior: 0!
A MacOSXPowerPCSqueakCogSpur  configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakMacOSPowerPCBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!SqueakMacOSXPowerPCSqueakSistaSpur class methodsFor: 'as yet unclassified' stamp: 'tty 6/9/2014 18:45'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder  default   allBuildConfigurations! !

!SqueakMacOSXPowerPCSqueakSistaSpur methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:45'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!SqueakMacOSXPowerPCSqueakSistaSpur methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:23'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakSistaSpur! !

!SqueakMacOSXPowerPCSqueakSistaSpur methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:49'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSXPowerPCSqueakSistaSpur methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:59'!
executableName
	^ self vmSistaExecutableName! !

SqueakMacOSXPowerPCConfig subclass: #SqueakMacOSXPowerPCSqueakSistaV3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOSPowerPC'!

!SqueakMacOSXPowerPCSqueakSistaV3 commentStamp: 'tty 6/15/2014 13:45' prior: 0!
A MacOSXPowerPCSqueakCogSpur  configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakMacOSPowerPCBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!SqueakMacOSXPowerPCSqueakSistaV3 class methodsFor: 'as yet unclassified' stamp: 'tty 6/9/2014 18:46'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder  default   allBuildConfigurations! !

!SqueakMacOSXPowerPCSqueakSistaV3 methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:46'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!SqueakMacOSXPowerPCSqueakSistaV3 methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:23'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakSistaV3! !

!SqueakMacOSXPowerPCSqueakSistaV3 methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:49'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSXPowerPCSqueakSistaV3 methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:59'!
executableName
	^ self vmSistaExecutableName! !

SqueakMacOSXPowerPCConfig subclass: #SqueakMacOSXPowerPCSqueakStackSpur
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOSPowerPC'!

!SqueakMacOSXPowerPCSqueakStackSpur commentStamp: 'tty 6/15/2014 13:45' prior: 0!
A MacOSXPowerPCSqueakCogSpur  configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakMacOSPowerPCBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!SqueakMacOSXPowerPCSqueakStackSpur class methodsFor: 'as yet unclassified' stamp: 'tty 6/9/2014 18:45'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder  default   allBuildConfigurations! !

!SqueakMacOSXPowerPCSqueakStackSpur methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:45'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!SqueakMacOSXPowerPCSqueakStackSpur methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:23'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackSpur! !

!SqueakMacOSXPowerPCSqueakStackSpur methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:49'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSXPowerPCSqueakStackSpur methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:01'!
executableName
	^ self vmStackExecutableName! !

SqueakMacOSXPowerPCConfig subclass: #SqueakMacOSXPowerPCSqueakStackV3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-MacOSPowerPC'!

!SqueakMacOSXPowerPCSqueakStackV3 commentStamp: 'tty 6/15/2014 13:45' prior: 0!
A MacOSXPowerPCSqueakStackV3  configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakMacOSPowerPCBuilder 
	configureABuildFor: #MY NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!SqueakMacOSXPowerPCSqueakStackV3 class methodsFor: 'as yet unclassified' stamp: 'tty 6/9/2014 18:46'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder  default   allBuildConfigurations! !

!SqueakMacOSXPowerPCSqueakStackV3 methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:46'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!SqueakMacOSXPowerPCSqueakStackV3 methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:23'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackV3! !

!SqueakMacOSXPowerPCSqueakStackV3 methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:49'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!SqueakMacOSXPowerPCSqueakStackV3 methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:01'!
executableName
	^ self vmStackExecutableName! !

CPlatformConfig subclass: #SqueakSunOS32x86Config
	uses: TCPlatformConfigForSqueak
	instanceVariableNames: 'buildType generateBuild generateBuildAssert generateBuildAssertITimerHeartbeat generateBuildDebug generateBuildDebugITimerHeartbeat generateBuildDebugMultiThreaded generateBuildIHeartbeatTimer generateBuildMultiThreaded generateBuildMultiThreadedAssert generateBuildMultiThreadedDebug'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-SunOS32x86'!

!SqueakSunOS32x86Config commentStamp: 'tty 6/15/2014 13:41' prior: 0!
A SqueakSunOS32x86CogConfig provides common informatin for my subclasses.

I am not meant to be built.

SqueakSunOS32x86Builder 
	configureABuildFor: #ONE OF MY SUBCLASSES NAME HERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

SqueakSunOS32x86Config class
	uses: TCPlatformConfigForSqueak classTrait
	instanceVariableNames: ''!

!SqueakSunOS32x86Config methodsFor: 'cmake' stamp: 'tty 6/8/2014 19:17'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder  default  noBuildConfigurations
! !

!SqueakSunOS32x86Config methodsFor: 'squeak compatibility' stamp: 'tty 6/7/2014 17:00'!
buildDir
	^ buildDir ifNil: [ buildDir := ( self topDir / self buildDirName) assureExistence].! !

!SqueakSunOS32x86Config methodsFor: 'squeak compatibility' stamp: 'tty 6/12/2014 12:15'!
buildDirName
	buildType isNil
		ifTrue:[^self dirBuildPlatform, FileDirectory slash, self dirBuildLanguageVMMM, FileDirectory slash, 'build']
		ifFalse:[^self dirBuildPlatform, FileDirectory slash, self dirBuildLanguageVMMM, FileDirectory slash, buildType asString]! !

!SqueakSunOS32x86Config methodsFor: 'squeak compatibility' stamp: 'tty 6/7/2014 15:17'!
buildType: aSymbol
	buildType:= aSymbol! !

!SqueakSunOS32x86Config methodsFor: 'compiler flags' stamp: 'tty 6/16/2014 20:16'!
compilerFlags
	|d commonFlags flags|
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self compilerFlagsBuild];
		at: #buildAssert  put: [self compilerFlagsAssert];
		at: #buildAssertITimerHeartbeat  put: [self compilerFlagsAssertITimerHeartbeat];
            at:#buildDebug  put: [self compilerFlagsDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self compilerFlagsDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self compilerFlagsIHeartbeatTimer];
		at: #buildMultiThreaded  put: [self compilerFlagsMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self compilerFlagsMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self compilerFlagsMultiThreadedDebug ];
		at: #buildNone put:[self compilerFlagsNoBuildType].

    flags:= String streamContents: [ :stream |
	 (((d at:  buildType) value)  collect: #withBlanksTrimmed as: Set)
		asStringOn: stream 
		delimiter:' '].

    commonFlags:=String streamContents: [ :stream |
		((self commonCompilerFlags) collect: #withBlanksTrimmed as: Set)
			asStringOn: stream 
			delimiter: ' ' ].
	^ commonFlags, ' ' ,flags.! !

!SqueakSunOS32x86Config methodsFor: 'cmake configuration' stamp: 'tty 6/16/2014 20:59'!
configureBuild
	"configure this Configuration for a buildType #build"
	self 
		preferredIncludesBuild;
		standardIncludesBuild;
		compilerFlagsBuild;
		internalPluginsBuild;
		externalPluginsBuild;
		thirdpartyLibsBuild


		
		
		! !

!SqueakSunOS32x86Config methodsFor: 'cmake configuration' stamp: 'tty 6/16/2014 20:16'!
configureForBuildType: aSymbol
	| d |
	"provide a concrete builder with the buildType and configureBuildX method to invoke"
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	self configureNoBuildType.                "reset all internal flags"
	d 
		at: #build 
		put: [self buildType:#build.  self configureBuild];

		at: #buildAssert 
		put: [self buildType: #buildAssert.  	self configureBuildAssert];

		at: #buildAssertITimerHeartbeat 
		put:     [ self buildType: #buildAssertITimerHeartbeat.   self configureBuildAssertITimerHeartbeat];

            at:#buildDebug 
		put: [self buildType: #buildDebug.  self configureBuildDebug];

		at: #buildDebugITimerHeartbeat 
		put:  [self buildType: #buildDebugITimerHeartbeat.   self configureBuildDebugITimerHeartbeat];

		at: #buildITimerHeartbeat 
		put: [self buildType:#buildITimerHeartbeat.    self configureBuildIHeartbeatTimer];

		at: #buildMultiThreaded 
		put:  [self buildType:#buildMultiThreaded . self configureBuildMultiThreaded];

		at: #buildMultiThreadedAssert 
		put: [self buildType: #buildMultiThreadedAssert. self configureBuildMultiThreadedAssert];

		at: #buildMultiThreadedDebug  
		put: [self buildType: #buildMultiThreadedDebug. self configureBuildMultiThreadedDebug].

     ^(d at: aSymbol).! !

!SqueakSunOS32x86Config methodsFor: 'cmake' stamp: 'tty 6/12/2014 17:08'!
configureNoBuildType
			generateBuild:=generateBuildAssert:=generateBuildAssertITimerHeartbeat:=generateBuildDebug:=generateBuildDebugITimerHeartbeat:= generateBuildDebugMultiThreaded:= generateBuildIHeartbeatTimer:= generateBuildMultiThreaded:= generateBuildMultiThreadedAssert:= generateBuildMultiThreadedDebug:=false.! !

!SqueakSunOS32x86Config methodsFor: 'plugins' stamp: 'tty 6/7/2014 17:35'!
defaultExternalPlugins
	^#(	)! !

!SqueakSunOS32x86Config methodsFor: 'plugins' stamp: 'tty 6/7/2014 17:35'!
defaultInternalPlugins
	^#(	)! !

!SqueakSunOS32x86Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:26'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self required! !

!SqueakSunOS32x86Config methodsFor: 'cmake' stamp: 'tty 6/7/2014 16:26'!
dirBuildPlatform
	"the directory for the platform. example: build.linux32x86"
	^self dirSunOS32x86! !

!SqueakSunOS32x86Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:24'!
dirInstall
	"the directory of the finished product.. the place where 'make install' puts stuff.
	SystemNavigation default browseMethodsWhoseNamesContain: 'dirInstall'
      "
self required.
! !

!SqueakSunOS32x86Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:53'!
excludeFromBuild
	^true
! !

!SqueakSunOS32x86Config methodsFor: 'headers generation' stamp: 'tty 6/16/2014 18:03'!
generateConfigH
	"	
	used to be: 	
		self write: self configH toFile: 'config.h'
      but with variable buildTypes we need:
"
	self write: (self generateConfigH: buildType) toFile: 'config.h'   
! !

!SqueakSunOS32x86Config methodsFor: 'headers generation' stamp: 'tty 6/16/2014 20:16'!
generateConfigH: aBuildType
	"self write: self configH toFile: 'config.h'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self configHBuild];
		at: #buildAssert  put: [self configHBuildAssert];
		at: #buildAssertITimerHeartbeat  put: [self configHBuildAssertITimerHeartbeat];
            at:#buildDebug  put: [self configHBuildDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self configHBuildDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self configHBuildITimerHeartbeat];
		at: #buildMultiThreaded  put: [self configHBuildMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self configHBuildMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self configHBuildMultiThreadedDebug ];
		at: #buildNone put:[self configHNoBuildType].


	 ^(d at: ( aBuildType)) value



! !

!SqueakSunOS32x86Config methodsFor: 'initialize-release' stamp: 'tty 6/9/2014 12:21'!
initialize
	super initialize.
	"this should be in my superclass, but I do not have permission to modify it. tty"
	 generateForAssert:= generateForAssertHeartbeatTimer:= generateForDebug :=generateForDebugWithHeartbeatTimer:= generateForDebugMultiThreadedFFI:= generateForReleaseHeartbeatTimer:= generateForReleaseMultiThreadedFFI:=false! !

!SqueakSunOS32x86Config methodsFor: 'squeak compatibility' stamp: 'tty 6/14/2014 15:43'!
outputDir

	"the directory where built binaries will be stored"
	^ outputDir ifNil: [ outputDir := (self topDir / self dirOutput/ self dirInstall) ]	

! !

!SqueakSunOS32x86Config methodsFor: 'utils' stamp: 'tty 6/16/2014 20:16'!
setGlobalOptionsAfterDetermineSystem: aMaker buildType: aBuildType
	"invoke correct setGlobalOptions for this buildType to allow per-buildType customization'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self setGlobalOptionsAfterDetermineSystemBuild: aMaker];
		at: #buildAssert  put: [self setGlobalOptionsAfterDetermineSystemBuildAssert: aMaker];
		at: #buildAssertITimerHeartbeat  put: [self setGlobalOptionsAfterDetermineSystemBuildAssertITimerHeartbeat: aMaker];
            at:#buildDebug  put: [self setGlobalOptionsAfterDetermineSystemBuildDebug: aMaker];   
		at: #buildITimerHeartbeat  put: [self setGlobalOptionsAfterDetermineSystemBuildITimerHeartbeat: aMaker];
		at: #buildMultiThreaded  put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreaded: aMaker ];
		at: #buildMultiThreadedAssert  put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreadedAssert: aMaker];
		at: #buildMultiThreadedDebug   put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreadedDebug: aMaker ];
		at: #buildNone put:[self setGlobalOptionsBuildNone: aMaker].

	 ^(d at: ( aBuildType)) value
! !

!SqueakSunOS32x86Config methodsFor: 'squeak compatibility' stamp: 'tty 6/7/2014 18:04'!
srcDir
		^ srcDir ifNil: [ srcDir := (self topDir directoryNamed: 'src' )]! !

!SqueakSunOS32x86Config methodsFor: 'squeak compatibility' stamp: 'tty 6/7/2014 16:58'!
topDir
		^ topDir ifNil: [ topDir := FileDirectory default directoryNamed: self oscogvm ]! !

SqueakSunOS32x86Config subclass: #SqueakSunOS32x86NewspeakCogSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-SunOS32x86'!

!SqueakSunOS32x86NewspeakCogSpurConfig commentStamp: 'tty 6/15/2014 13:40' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakSunOS32x86Builder 
	configureABuildFor: #MYCLASSNAMEHERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!SqueakSunOS32x86NewspeakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:54'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!SqueakSunOS32x86NewspeakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:26'!
dirBuildLanguageVMMM
	^self newspeakCogSpur! !

!SqueakSunOS32x86NewspeakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:29'!
dirInstall
	"the directory of the finished product.. the place where 'make install' puts stuff.
	SystemNavigation default browseMethodsWhoseNamesContain: 'outputDir'
      "
	^self newspeakCogSpur! !

!SqueakSunOS32x86NewspeakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:54'!
excludeFromBuild
	^false
! !

!SqueakSunOS32x86NewspeakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:11'!
executableName
	^ self vmCogExecutableName! !

SqueakSunOS32x86Config subclass: #SqueakSunOS32x86NewspeakCogV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-SunOS32x86'!

!SqueakSunOS32x86NewspeakCogV3Config commentStamp: 'tty 6/15/2014 13:40' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakSunOS32x86Builder 
	configureABuildFor: #MYCLASSNAMEHERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!SqueakSunOS32x86NewspeakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:55'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!SqueakSunOS32x86NewspeakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:26'!
dirBuildLanguageVMMM
	^self newspeakCogV3! !

!SqueakSunOS32x86NewspeakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:29'!
dirInstall
	"the directory of the finished product.. the place where 'make install' puts stuff.
	SystemNavigation default browseMethodsWhoseNamesContain: 'outputDir'
      "
	^self newspeakCogV3! !

!SqueakSunOS32x86NewspeakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:55'!
excludeFromBuild
	^false
! !

!SqueakSunOS32x86NewspeakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:11'!
executableName
	^ self vmCogExecutableName! !

SqueakSunOS32x86Config subclass: #SqueakSunOS32x86NewspeakSistaSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-SunOS32x86'!

!SqueakSunOS32x86NewspeakSistaSpurConfig commentStamp: 'tty 6/15/2014 13:40' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakSunOS32x86Builder 
	configureABuildFor: #MYCLASSNAMEHERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!SqueakSunOS32x86NewspeakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:55'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!SqueakSunOS32x86NewspeakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:26'!
dirBuildLanguageVMMM
	^self newspeakSistaSpur! !

!SqueakSunOS32x86NewspeakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:29'!
dirInstall
	"the directory of the finished product.. the place where 'make install' puts stuff.
	SystemNavigation default browseMethodsWhoseNamesContain: 'outputDir'
      "
	^self newspeakSistaSpur! !

!SqueakSunOS32x86NewspeakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:55'!
excludeFromBuild
	^false
! !

!SqueakSunOS32x86NewspeakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:59'!
executableName
	^ self vmSistaExecutableName! !

SqueakSunOS32x86Config subclass: #SqueakSunOS32x86NewspeakSistaV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-SunOS32x86'!

!SqueakSunOS32x86NewspeakSistaV3Config commentStamp: 'tty 6/15/2014 13:40' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakSunOS32x86Builder 
	configureABuildFor: #MYCLASSNAMEHERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!SqueakSunOS32x86NewspeakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:55'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!SqueakSunOS32x86NewspeakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:26'!
dirBuildLanguageVMMM
	^self newspeakSistaV3! !

!SqueakSunOS32x86NewspeakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:29'!
dirInstall
	"the directory of the finished product.. the place where 'make install' puts stuff.
	SystemNavigation default browseMethodsWhoseNamesContain: 'outputDir'
      "
	^self newspeakSistaV3! !

!SqueakSunOS32x86NewspeakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:55'!
excludeFromBuild
	^false
! !

!SqueakSunOS32x86NewspeakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:59'!
executableName
	^ self vmSistaExecutableName! !

SqueakSunOS32x86Config subclass: #SqueakSunOS32x86NewspeakStackSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-SunOS32x86'!

!SqueakSunOS32x86NewspeakStackSpurConfig commentStamp: 'tty 6/15/2014 13:39' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakSunOS32x86Builder 
	configureABuildFor: #MYCLASSNAMEHERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!SqueakSunOS32x86NewspeakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:55'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!SqueakSunOS32x86NewspeakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:26'!
dirBuildLanguageVMMM
	^self newspeakStackSpur! !

!SqueakSunOS32x86NewspeakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:28'!
dirInstall
	"the directory of the finished product.. the place where 'make install' puts stuff.
	SystemNavigation default browseMethodsWhoseNamesContain: 'outputDir'
      "
	^self newspeakStackSpur! !

!SqueakSunOS32x86NewspeakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:55'!
excludeFromBuild
	^false
! !

!SqueakSunOS32x86NewspeakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:01'!
executableName
	^ self vmStackExecutableName! !

SqueakSunOS32x86Config subclass: #SqueakSunOS32x86NewspeakStackV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-SunOS32x86'!

!SqueakSunOS32x86NewspeakStackV3Config commentStamp: 'tty 6/15/2014 13:39' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakSunOS32x86Builder 
	configureABuildFor: #MYCLASSNAMEHERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!SqueakSunOS32x86NewspeakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:55'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!SqueakSunOS32x86NewspeakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:26'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackV3! !

!SqueakSunOS32x86NewspeakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:28'!
dirInstall
	"the directory of the finished product.. the place where 'make install' puts stuff.
	SystemNavigation default browseMethodsWhoseNamesContain: 'outputDir'
      "
	^self newspeakStackV3! !

!SqueakSunOS32x86NewspeakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:55'!
excludeFromBuild
	^false
! !

!SqueakSunOS32x86NewspeakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:01'!
executableName
	^ self vmStackExecutableName! !

SqueakSunOS32x86Config subclass: #SqueakSunOS32x86SqueakCogSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-SunOS32x86'!

!SqueakSunOS32x86SqueakCogSpurConfig commentStamp: 'tty 6/15/2014 13:39' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakSunOS32x86Builder 
	configureABuildFor: #MYCLASSNAMEHERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!SqueakSunOS32x86SqueakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:56'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!SqueakSunOS32x86SqueakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:27'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakCogSpur! !

!SqueakSunOS32x86SqueakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:28'!
dirInstall
	"the directory of the finished product.. the place where 'make install' puts stuff.
	SystemNavigation default browseMethodsWhoseNamesContain: 'outputDir'
      "
	^self squeakCogSpur! !

!SqueakSunOS32x86SqueakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:56'!
excludeFromBuild
	^false
! !

!SqueakSunOS32x86SqueakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:11'!
executableName
	^ self vmCogExecutableName! !

SqueakSunOS32x86Config subclass: #SqueakSunOS32x86SqueakCogV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-SunOS32x86'!

!SqueakSunOS32x86SqueakCogV3Config commentStamp: 'tty 6/15/2014 13:39' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakSunOS32x86Builder 
	configureABuildFor: #MYCLASSNAMEHERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!SqueakSunOS32x86SqueakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:56'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!SqueakSunOS32x86SqueakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:27'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakCogV3! !

!SqueakSunOS32x86SqueakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:28'!
dirInstall
	"the directory of the finished product.. the place where 'make install' puts stuff.
	SystemNavigation default browseMethodsWhoseNamesContain: 'outputDir'
      "
	^self squeakCogV3! !

!SqueakSunOS32x86SqueakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:56'!
excludeFromBuild
	^false
! !

!SqueakSunOS32x86SqueakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:11'!
executableName
	^ self vmCogExecutableName! !

SqueakSunOS32x86Config subclass: #SqueakSunOS32x86SqueakSistaSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-SunOS32x86'!

!SqueakSunOS32x86SqueakSistaSpurConfig commentStamp: 'tty 6/15/2014 13:39' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakSunOS32x86Builder 
	configureABuildFor: #MYCLASSNAMEHERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!SqueakSunOS32x86SqueakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:56'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!SqueakSunOS32x86SqueakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:27'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakSistaSpur! !

!SqueakSunOS32x86SqueakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:28'!
dirInstall
	"the directory of the finished product.. the place where 'make install' puts stuff.
	SystemNavigation default browseMethodsWhoseNamesContain: 'outputDir'
      "
	^self squeakSistaSpur! !

!SqueakSunOS32x86SqueakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:56'!
excludeFromBuild
	^false
! !

!SqueakSunOS32x86SqueakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:00'!
executableName
	^ self vmSistaExecutableName! !

SqueakSunOS32x86Config subclass: #SqueakSunOS32x86SqueakSistaV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-SunOS32x86'!

!SqueakSunOS32x86SqueakSistaV3Config commentStamp: 'tty 6/15/2014 13:38' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakSunOS32x86Builder 
	configureABuildFor: #MYCLASSNAMEHERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!SqueakSunOS32x86SqueakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:56'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!SqueakSunOS32x86SqueakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:27'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakSistaV3! !

!SqueakSunOS32x86SqueakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:27'!
dirInstall
	"the directory of the finished product.. the place where 'make install' puts stuff.
	SystemNavigation default browseMethodsWhoseNamesContain: 'outputDir'
      "
	^self squeakSistaV3! !

!SqueakSunOS32x86SqueakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:56'!
excludeFromBuild
	^false
! !

!SqueakSunOS32x86SqueakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:00'!
executableName
	^ self vmSistaExecutableName! !

SqueakSunOS32x86Config subclass: #SqueakSunOS32x86SqueakStackSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-SunOS32x86'!

!SqueakSunOS32x86SqueakStackSpurConfig commentStamp: 'tty 6/15/2014 13:38' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakSunOS32x86Builder 
	configureABuildFor: #MYCLASSNAMEHERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!SqueakSunOS32x86SqueakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:57'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!SqueakSunOS32x86SqueakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:27'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackSpur! !

!SqueakSunOS32x86SqueakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:27'!
dirInstall
	"the directory of the finished product.. the place where 'make install' puts stuff.
	SystemNavigation default browseMethodsWhoseNamesContain: 'outputDir'
      "
	^self squeakStackSpur! !

!SqueakSunOS32x86SqueakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:57'!
excludeFromBuild
	^false
! !

!SqueakSunOS32x86SqueakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:01'!
executableName
	^ self vmStackExecutableName! !

SqueakSunOS32x86Config subclass: #SqueakSunOS32x86SqueakStackV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-SunOS32x86'!

!SqueakSunOS32x86SqueakStackV3Config commentStamp: 'tty 6/15/2014 13:38' prior: 0!
I  configures a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf


SqueakSunOS32x86Builder 
	configureABuildFor: #MYCLASSNAMEHERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!SqueakSunOS32x86SqueakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:57'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default noBuildConfigurations! !

!SqueakSunOS32x86SqueakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:27'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackV3! !

!SqueakSunOS32x86SqueakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 07:27'!
dirInstall
	"the directory of the finished product.. the place where 'make install' puts stuff.
	SystemNavigation default browseMethodsWhoseNamesContain: 'outputDir'
      "
	^self squeakStackV3! !

!SqueakSunOS32x86SqueakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 18:57'!
excludeFromBuild
	^false
! !

!SqueakSunOS32x86SqueakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:01'!
executableName
	^ self vmStackExecutableName! !

CPlatformConfig subclass: #SqueakWin32x86Config
	uses: TCPlatformConfigForSqueak
	instanceVariableNames: 'buildType generateBuild generateBuildAssert generateBuildAssertITimerHeartbeat generateBuildDebug generateBuildDebugITimerHeartbeat generateBuildDebugMultiThreaded generateBuildIHeartbeatTimer generateBuildMultiThreaded generateBuildMultiThreadedAssert generateBuildMultiThreadedDebug'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Win32x86'!

!SqueakWin32x86Config commentStamp: 'tty 6/15/2014 13:37' prior: 0!
N.B. tty.  This class comment is from my pharo parent..

This is an abstract class and it is the root configuration for building all types of Cog VMs on MS-Windows platform.


What you need to get started:

Download and install Msys, with C/C++ compiler support:
	http://www.mingw.org/wiki/msys
	
Download and install Git:
	http://code.google.com/p/msysgit/
	

///
Optional: add git to the PATH variable:

Add path to git for msys:
Control panel -> System -> System Properies / Advanced  [ Environment Variables ]

There should be already:
C:\Program Files\Git\cmd

add:

C:\Program Files\Git\bin

/// For automated builds, add SQUEAKVM environment variable and set it to the full path to squeak executable.

(Control panel -> System -> System Properies / Advanced  [ Environment Variables ])

in windows shell you can use it then to run squeak: %SQUEAKVM%  , and in mingw bash shell, use $SQUEAKVM

/// Install CMake:
http://www.cmake.org/cmake/resources/software.html

(during installation, in install options , make sure that you choose to add CMake to PATH)


Note, to run cmake under msys shell, you have to explicitly specify the msys makefiles generator, because default one is MS:

cmake . -G"MSYS Makefiles"


Fore more information, check the class comments of all the superclasses.
!

SqueakWin32x86Config class
	uses: TCPlatformConfigForSqueak classTrait
	instanceVariableNames: ''!

!SqueakWin32x86Config class methodsFor: 'as yet unclassified' stamp: 'tty 5/22/2014 16:59'!
licenseTemplate
	^'Squeak  {1} license information
==============================

About Squeak
-----------


Squeak is a modern, open source, full-featured implementation of the powerful Smalltalk programming language and environment. Squeak is highly-portable, running on almost any platform you could name and you can really truly write once run anywhere.  Squeak is the vehicle for a wide range of projects from multimedia applications and educational platforms to commercial web application development. Read on and join in!!

http://www.squeak.org


LIcense

Note: The current release of Squeak is a combination of source code originating from it''s origins at Apple which Apple agreed to license under the Apache license and more recent contributions licensed under the MIT license. The vast majority of the code is under the MIT license.
MIT License

Copyright (c) The individual, corporate, and institutional contributors who have collectively contributed elements to this software ("The Squeak Community"), 1996-2010 All rights reserved.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
Portions of Squeak are covered by the following license:
Apache License, Version 2.0

Copyright (c) Xerox Corp. 1981, 1982 All rights reserved. Copyright (c) Apple Computer, Inc. 1985-1996 All rights reserved.

Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.


About Cog
---------

Cog is a virtual machine designed for Smalltalk and other similar dynamic languages.  Cog builds on the
Squeak virtual machine adding a stack-to-register-mapping just-in-time compiler, aggressive in-line message
cacheing and effective optimization of Smalltalk’s first-class activation records.  Cog is the virtual machine
underlying Teleplace''s Croquet-based enterprise virtual collaboration spaces software, the fastest virtual
machine for Squeak, and for Gilad Bracha''s Newspeak modular language inspired by Beta and Smalltalk.  
Like the original Squeak VM, Cog is implemented and developed in Smalltalk, and translated into a lower-level
language to produce the production VM.  Being a Smalltalk program it is a delight to develop.  Cog is
available under the MIT open source license and is unencumbered for commercial deployment.

Cog''s performance relative to the existing Squeak interpreter varies, depending on the benchmark chosen.
As of early-2011, the Cog JIT uses strong inline cacheing techniques and stack-to-register mapping that
results in a register-based calling convention for low-arity methods.  Due to the complexity of the Squeak
object representation it has a limited set of primitives implemented in machine code that, for example,
exclude object allocation.  Performance of the early-2011 JIT for the nbody, binarytrees and chameneos
redux benchmarks from the computer language shootout is in the range of 4 to 6 times faster than the
interpreter.
'! !

!SqueakWin32x86Config class methodsFor: 'as yet unclassified' stamp: 'tty 5/22/2014 16:58'!
pluginsTemplate
	^'Squeak {1} ships with the following plugins already built:
		
Internal: 
=========
{2}

External: 
=========
{3}

'! !

!SqueakWin32x86Config methodsFor: 'thirdparty libs' stamp: 'tty 5/26/2014 13:08'!
addThirdpartyLibrary: libName
	| libs lib |
	
	libs := self thirdpartyLibs.
	
	lib :=  libs 
		detect: [:each | each canonicalName = libName ] 
		ifNone: [ nil ].
		
	lib ifNil: [ 
		lib := SqueakCMThirdpartyLibrary named: libName config: self.
		"add dependencies first, so thirpartyLibs collection will be naturally dependency sorted"
		lib dependencies do: [:dep | self addThirdpartyLibrary: dep ].
		libs add: lib ].

	^ lib! !

!SqueakWin32x86Config methodsFor: 'cmake' stamp: 'tty 6/8/2014 19:19'!
availableBuilds
	^SqueakCMakeVMMakerAbstractBuilder default allBuildConfigurations copyWithoutAll:#(#assert #assertWithHeartbeatTimer #debugMultiThreadedFFI #debugWithHeartbeatTimer #release #releaseHeartbeatTimer)


! !

!SqueakWin32x86Config methodsFor: 'directories' stamp: 'tty 5/22/2014 16:41'!
buildDir
	^ buildDir ifNil: [ buildDir := ( self topDir / self buildDirName) assureExistence].! !

!SqueakWin32x86Config methodsFor: 'directories' stamp: 'tty 6/12/2014 12:15'!
buildDirName
	buildType isNil
		ifTrue:[^self dirBuildPlatform, FileDirectory slash, self dirBuildLanguageVMMM, FileDirectory slash, 'build']
		ifFalse:[^self dirBuildPlatform, FileDirectory slash, self dirBuildLanguageVMMM, FileDirectory slash, buildType asString]! !

!SqueakWin32x86Config methodsFor: 'build script' stamp: 'tty 5/25/2014 19:53'!
buildScript
	"answer the build script for building everything"
	

	^ 
'#!!/usr/bin/env bash

cmake -G "MSYS Makefiles" .
make

'! !

!SqueakWin32x86Config methodsFor: 'squeak compatibility' stamp: 'tty 6/7/2014 15:15'!
buildType: aSymbol
	buildType:=aSymbol! !

!SqueakWin32x86Config methodsFor: 'compiler flags' stamp: 'tty 5/22/2014 16:36'!
commonCompilerFlags
	"omit -ggdb2 to prevent generating debug info"
	"Some flags explanation: 
	
	STACK_ALIGN_BYTES=16 is needed in mingw and FFI (and I suppose on other modules too).
	DALLOCA_LIES_SO_USE_GETSP=0 Some compilers return the stack address+4 on alloca function, 
	then FFI module needs to adjust that. It is NOT the case of mingw.
	For more information see this thread: http://forum.world.st/There-are-something-fishy-with-FFI-plugin-td4584226.html
	"
	^ {  
		'-march=pentium4'.
		'-mwindows'.
		'-D_MT'.
		'-msse2'. 
		'-mthreads'. 
		'-mwin32'.
		'-mno-rtd'. 
		'-mms-bitfields'. 
		'-mno-accumulate-outgoing-args ', self winVer.
		'-DWIN32'. 
		'-DWIN32_FILE_SUPPORT'. 
		'-DNO_ISNAN'.
		'-DNO_SERVICE'. 
		'-DNO_STD_FILE_SUPPORT'.
		'-DLSB_FIRST'. 
		'-DVM_NAME="', self executableName,'"'.
		'-DX86 '.
		'-DSTACK_ALIGN_BYTES=16'. 
		'-DALLOCA_LIES_SO_USE_GETSP=0'. 
		'-DENABLE_FAST_BLT ' }! !

!SqueakWin32x86Config methodsFor: 'directories' stamp: 'tty 6/16/2014 20:16'!
compilerFlags
	|d commonFlags flags|
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self compilerFlagsBuild];
		at: #buildAssert  put: [self compilerFlagsAssert];
		at: #buildAssertITimerHeartbeat  put: [self compilerFlagsAssertITimerHeartbeat];
            at:#buildDebug  put: [self compilerFlagsDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self compilerFlagsDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self compilerFlagsIHeartbeatTimer];
		at: #buildMultiThreaded  put: [self compilerFlagsMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self compilerFlagsMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self compilerFlagsMultiThreadedDebug ];
		at: #buildNone put:[self compilerFlagsNoBuildType].

    flags:= String streamContents: [ :stream |
	 (((d at:  buildType) value)  collect: #withBlanksTrimmed as: Set)
		asStringOn: stream 
		delimiter:' '].

    commonFlags:=String streamContents: [ :stream |
		((self commonCompilerFlags) collect: #withBlanksTrimmed as: Set)
			asStringOn: stream 
			delimiter: ' ' ].
	^ commonFlags, ' ' ,flags.! !

!SqueakWin32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 16:36'!
configureAsynchFilePlugin:  maker 
	"extra rules for AsynchFilePlugin "

	super configureAsynchFilePlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32AsyncFilePrims.c')


! !

!SqueakWin32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 16:36'!
configureB3DAcceleratorPlugin:  maker 
	"extra rules for B3DAcceleratorPlugin "

	super configureB3DAcceleratorPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32DualB3DX.c' 'sqWin32D3D.c' 'sqWin32OpenGL.c')


! !

!SqueakWin32x86Config methodsFor: 'cmake configuration' stamp: 'tty 6/16/2014 21:00'!
configureBuild
	"configure this Configuration for a buildType #build"
	self 
		preferredIncludesBuild;
		standardIncludesBuild;
		compilerFlagsBuild;
		internalPluginsBuild;
		externalPluginsBuild;
		thirdpartyLibsBuild
		


		
		
		! !

!SqueakWin32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 16:36'!
configureCroquetPlugin:  maker 
	"extra rules for CroquetPlugin "

	super configureCroquetPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32CroquetPlugin.c')


! !

!SqueakWin32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 16:36'!
configureDropPlugin:  maker 
	"extra rules for DropPlugin "

	super configureDropPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32Drop')


! !

!SqueakWin32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 16:36'!
configureFT2Plugin: maker
	"extra rules for Freetype plugin.
	a custom rule to build freetype library"
	| lib |
	
"	maker isExternal ifFalse: [
		self error: 'building internal FT2Plugin is not supported yet'  	
	].
"
	"add freetype library into loop"
	lib := self addThirdpartyLibrary: 'freetype2'.

	"link plugin with freetype lib"
	maker addExternalLibrary: lib targetForLinking.
	maker includeDirectories: lib includeDir.

! !

!SqueakWin32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 16:36'!
configureFilePlugin: maker 
	
	super configureFilePlugin: maker.
	
	maker addPlatformSources:
		#( 'sqWin32FilePrims.c')


! !

!SqueakWin32x86Config methodsFor: 'cmake configuration' stamp: 'tty 6/16/2014 20:17'!
configureForBuildType: aSymbol
	| d |
	"provide a concrete builder with the buildType and configureBuildX method to invoke"
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	self configureNoBuildType.                "reset all internal flags"
	d 
		at: #build 
		put: [self buildType:#build.  self configureBuild];

		at: #buildAssert 
		put: [self buildType: #buildAssert.  	self configureBuildAssert];

		at: #buildAssertITimerHeartbeat 
		put:     [ self buildType: #buildAssertITimerHeartbeat.   self configureBuildAssertITimerHeartbeat];

            at:#buildDebug 
		put: [self buildType: #buildDebug.  self configureBuildDebug];

		at: #buildDebugITimerHeartbeat 
		put:  [self buildType: #buildDebugITimerHeartbeat.   self configureBuildDebugITimerHeartbeat];

		at: #buildITimerHeartbeat 
		put: [self buildType:#buildITimerHeartbeat.    self configureBuildIHeartbeatTimer];

		at: #buildMultiThreaded 
		put:  [self buildType:#buildMultiThreaded . self configureBuildMultiThreaded];

		at: #buildMultiThreadedAssert 
		put: [self buildType: #buildMultiThreadedAssert. self configureBuildMultiThreadedAssert];

		at: #buildMultiThreadedDebug  
		put: [self buildType: #buildMultiThreadedDebug. self configureBuildMultiThreadedDebug].

     ^(d at: aSymbol).! !

!SqueakWin32x86Config methodsFor: 'cmake' stamp: 'tty 6/12/2014 17:07'!
configureForNoBuildType
		generateBuild:=generateBuildAssert:=generateBuildAssertITimerHeartbeat:=generateBuildDebug:=generateBuildDebugITimerHeartbeat:= generateBuildDebugMultiThreaded:= generateBuildIHeartbeatTimer:= generateBuildMultiThreaded:= generateBuildMultiThreadedAssert:= generateBuildMultiThreadedDebug:=false.! !

!SqueakWin32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 16:36'!
configureHostWindowPlugin:    maker 
	"extra rules for HostWindowPlugin "

	super configureHostWindowPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32HostWindowPlugin.c')


! !

!SqueakWin32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 16:36'!
configureJoystickTabletPlugin:  maker 
	
	super configureJoystickTabletPlugin:  maker.
	
	maker addPlatformSources:
		#( 'sqWin32Joystick.c')


! !

!SqueakWin32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 16:36'!
configureLocalePlugin:   maker 
	"extra rules for LocalePlugin "

	super configureLocalePlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32Locale.c')


! !

!SqueakWin32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 16:36'!
configureMIDIPlugin:  maker 
	"extra rules for MIDIPlugin "

	super configureMIDIPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32MIDI.c')


! !

!SqueakWin32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 16:36'!
configureMpeg3Plugin:  maker 
	"extra rules for Mpeg3Plugin "

	super configureMpeg3Plugin:  maker.
	
	maker addDefinitions: '-DNOPTHREADS'.

	maker addPlatformSources: #( 'sqOpenFile.c')! !

!SqueakWin32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 16:36'!
configureSecurityPlugin: maker 
	"extra rules for SecurityPlugin"

	super configureSecurityPlugin: maker.
	
	maker addPlatformSources: #( 'sqWin32Security')


! !

!SqueakWin32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 16:36'!
configureSerialPlugin:     maker 
	"extra rules for SerialPlugin "

	super configureSerialPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32SerialPort.c')


! !

!SqueakWin32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 16:36'!
configureSocketPlugin:  maker 
	"extra rules for SocketPlugin "

	super configureSocketPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32NewNet.c')


! !

!SqueakWin32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 16:36'!
configureSoundPlugin: maker 
	"extra rules for SoundPlugin"
	
	maker addPlatformSources: #( 'sqWin32Sound' )! !

!SqueakWin32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 16:36'!
configureSqueakSSLPlugin: maker
	| lib |
	maker addPlatformSources: #('sqUnixOpenSSL.c').
	
	lib := self addThirdpartyLibrary: 'openssl'.

	maker includeDirectories: lib includeDir.
	maker linkDirectories: '${outputDir}'.
	
	maker addExternalLibraries: 
		#( 
			'libeay32.dll' 
			'ssleay32.dll'
		).
		
	maker addDependency: lib buildTarget
! !

!SqueakWin32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 16:36'!
configureUUIDPlugin: maker 
	"extra rules for UUIDPlugin"
	
	maker addPlatformSources:
		#( 'sqWin32UUID.c')


! !

!SqueakWin32x86Config methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 16:36'!
configureWin32OSProcessPlugin: maker 
	"extra rules for Win32OSProcessPlugin"

	maker includeDirectories: '${crossDir}/plugins/FilePlugin'.
	maker includeDirectories: '${crossDir}/plugins/SocketPlugin'.
! !

!SqueakWin32x86Config methodsFor: 'plugins' stamp: 'tty 6/7/2014 18:07'!
defaultExternalPlugins
	"expertly cut-n-pasted from Cog/cygwinbuild/plugins.ext"
	^#(
		BochsIA32Plugin 
		SqueakFFIPrims 
		Win32OSProcessPlugin
	)! !

!SqueakWin32x86Config methodsFor: 'plugins' stamp: 'tty 6/7/2014 18:08'!
defaultInternalPlugins
	"expertly cut-n-pasted from Cog/cygwinbuild/plugins.int"
	^#(
		ADPCMCodecPlugin 
		AsynchFilePlugin 
		B3DAcceleratorPlugin 
		B2DPlugin 
		BitBltPlugin 
		BMPReadWriterPlugin 
		CroquetPlugin 
		ZipPlugin 
		DropPlugin 
		DSAPrims 
		FFTPlugin 
		FilePlugin 
		FloatArrayPlugin 
		FloatMathPlugin 
		HostWindowPlugin 
		IA32ABI 
		JoystickTabletPlugin 
		JPEGReaderPlugin 
		JPEGReadWriter2Plugin 
		Klatt 
		LargeIntegers 
		LocalePlugin 
		Matrix2x3Plugin 
		MIDIPlugin 
		MiscPrimitivePlugin 
		Mpeg3Plugin 
		RePlugin 
		SecurityPlugin 
		SerialPlugin 
		SocketPlugin 
		SoundCodecPrims 
		SoundGenerationPlugin 
		SoundPlugin 
		StarSqueakPlugin 
		SurfacePlugin 
		UUIDPlugin
	)! !

!SqueakWin32x86Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:27'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self required! !

!SqueakWin32x86Config methodsFor: 'cmake' stamp: 'tty 6/7/2014 16:27'!
dirBuildPlatform
	"the directory for the platform. example: build.linux32x86"
	^self dirWin32x86! !

!SqueakWin32x86Config methodsFor: 'cmake' stamp: 'tty 6/9/2014 17:31'!
excludeFromBuild
	^true
! !

!SqueakWin32x86Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 16:36'!
executableType
	^ 'WIN32'! !

!SqueakWin32x86Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 16:36'!
externalModulesDir
	"answer the location in VM bundle, where plugins and rest of dynamic libs will be copied,
	"
	^ '${outputDir}'! !

!SqueakWin32x86Config methodsFor: 'utils' stamp: 'tty 5/22/2014 16:36'!
fixLineEndsOf: string
	^ string copyReplaceAll: String cr with: String crlf! !

!SqueakWin32x86Config methodsFor: 'public' stamp: 'tty 5/22/2014 16:57'!
generate 
	self generatePluginsList. 
	self generateLicense. 
	"^super generate"
	^CMakeVMGeneratorForSqueak generate:self    "Bypass CPlatformConfig generate to invoke our compatibility class"! !

!SqueakWin32x86Config methodsFor: 'headers generation' stamp: 'tty 6/16/2014 18:03'!
generateConfigH
	"	
	used to be: 	
		self write: self configH toFile: 'config.h'
      but with variable buildTypes we need:
"
	self write: (self generateConfigH: buildType) toFile: 'config.h'   
! !

!SqueakWin32x86Config methodsFor: 'headers generation' stamp: 'tty 6/16/2014 20:17'!
generateConfigH: aBuildType
	"self write: self configH toFile: 'config.h'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self configHBuild];
		at: #buildAssert  put: [self configHBuildAssert];
		at: #buildAssertITimerHeartbeat  put: [self configHBuildAssertITimerHeartbeat];
            at:#buildDebug  put: [self configHBuildDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self configHBuildDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self configHBuildITimerHeartbeat];
		at: #buildMultiThreaded  put: [self configHBuildMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self configHBuildMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self configHBuildMultiThreadedDebug ];
		at: #buildNone put:[self configHNoBuildType].


	 ^(d at: ( aBuildType)) value



! !

!SqueakWin32x86Config methodsFor: 'as yet unclassified' stamp: 'tty 5/22/2014 16:59'!
generateLicense 
	self 
		write:  (self class licenseTemplate 
			format: { self version })
		toFile: 'LICENSE.txt'
	! !

!SqueakWin32x86Config methodsFor: 'as yet unclassified' stamp: 'tty 5/22/2014 16:59'!
generatePluginsList 
	self 
		write:  (self class pluginsTemplate 
			format: {
				self version. 
				String streamContents: [ :stream | self internalPlugins asStringOn: stream delimiter: String cr ].
				String streamContents: [ :stream | self externalPlugins asStringOn: stream delimiter: String cr ].
				self executableName })
		toFile: 'PLUGINS.txt'
	! !

!SqueakWin32x86Config methodsFor: 'initialize-release' stamp: 'tty 6/9/2014 12:24'!
initialize
	super initialize.
	"this should be in my superclass, but I do not have permission to modify it. tty"
	 generateForAssert:= generateForAssertHeartbeatTimer:= generateForDebug :=generateForDebugWithHeartbeatTimer:= generateForDebugMultiThreadedFFI:= generateForReleaseHeartbeatTimer:= generateForReleaseMultiThreadedFFI:=false! !

!SqueakWin32x86Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 16:55'!
msysPathFor: aPath
	| path |
	self flag:'tty'. "code smell alert"
	^aPath isString
		ifTrue:[	path := aPath  copyReplaceAll: '\' with: '/'.]
		ifFalse:[	path := aPath pathName copyReplaceAll: '\' with: '/'.]

	
! !

!SqueakWin32x86Config methodsFor: 'directories' stamp: 'tty 6/14/2014 15:43'!
outputDir

	"the directory where built binaries will be stored"
	^ outputDir ifNil: [ outputDir := (self topDir / self dirOutput/ self dirInstall) ]	

! !

!SqueakWin32x86Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 16:36'!
platformName
	^ 'win32'! !

!SqueakWin32x86Config methodsFor: 'source generation' stamp: 'tty 5/22/2014 16:44'!
prepareVMMaker
	
	| maker allPlugins |
	
	"In CogVMs (in contrast to Interpreter VM) the generated sources are platform independent, therefore Cross is ok"
	maker := VMMaker forPlatform: 'Cross'.
	
	maker sourceDirectoryName: self srcDir pathName.
	maker platformRootDirectoryName: self platformsDir.
	
	
	allPlugins := self internalPlugins , self externalPlugins.
	
	"touch plugins to force their source generation unconditionally"
	allPlugins do: [:name | (Smalltalk globals at: name) touch ].
	
	" Why we put all plugins as external?   Because the generated sources are not different whether the plugins were defined as internal or external. VMMaker used to need this to to generate plugins.int and plugins.ext files. But since this is achieved in another way with CMakeVMMaker, there is no different at all to put all plugins as internal or as external."
	maker externalModules addAll:  allPlugins.
	
	^ maker! !

!SqueakWin32x86Config methodsFor: 'utils' stamp: 'tty 6/16/2014 20:17'!
setGlobalOptionsAfterDetermineSystem: aMaker buildType: aBuildType
	"invoke correct setGlobalOptions for this buildType to allow per-buildType customization'"

	|d |
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self setGlobalOptionsAfterDetermineSystemBuild: aMaker];
		at: #buildAssert  put: [self setGlobalOptionsAfterDetermineSystemBuildAssert: aMaker];
		at: #buildAssertITimerHeartbeat  put: [self setGlobalOptionsAfterDetermineSystemBuildAssertITimerHeartbeat: aMaker];
            at:#buildDebug  put: [self setGlobalOptionsAfterDetermineSystemBuildDebug: aMaker];   
		at: #buildITimerHeartbeat  put: [self setGlobalOptionsAfterDetermineSystemBuildITimerHeartbeat: aMaker];
		at: #buildMultiThreaded  put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreaded: aMaker ];
		at: #buildMultiThreadedAssert  put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreadedAssert: aMaker];
		at: #buildMultiThreadedDebug   put: [self setGlobalOptionsAfterDetermineSystemBuildMultiThreadedDebug: aMaker ];
		at: #buildNone put:[self setGlobalOptionsBuildNone: aMaker].

	 ^(d at: ( aBuildType)) value
! !

!SqueakWin32x86Config methodsFor: 'directories' stamp: 'tty 5/22/2014 16:36'!
setupDirectories: gen
	"we have to override that, because we need to convert windoze paths to msys ones"
	| dirsInclude |
	
	" write the directories in separate include file"
	dirsInclude := gen captureOutputDuring: [
		gen
			set: #topDir toString: (self msysPathFor: self topDir fullName); 
			set: #buildDir toString: (self buildDir ifNil: ['${topDir}/build'] ifNotNil:[ self msysPathFor: self buildDir fullName ]);
			set: #thirdpartyDir toString: '${buildDir}/thirdparty';
			set: #platformsDir toString: (self msysPathFor: self platformsDir);
			set: #srcDir toString: (self msysPathFor: self srcDir);
			set: #srcPluginsDir toString: (pluginsDir ifNil: [ '${srcDir}/plugins' ]);
			set: #srcVMDir toString: '${srcDir}/vm';
			set: #platformName toString: self platformName;
			set: #targetPlatform to: '${platformsDir}/${platformName}';
			set: #crossDir toString: '${platformsDir}/Cross';
			set: #platformVMDir toString: '${targetPlatform}/vm';
			set: #outputDir toString: (self msysPathFor: self outputDir).
	].

	self write: dirsInclude toFile: 'directories.cmake'.
	
	gen include: 'directories.cmake'.
	
	gen set: #externalModulesDir toString: self externalModulesDir.
! !

!SqueakWin32x86Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 16:43'!
srcDir
		^ srcDir ifNil: [ srcDir := (self topDir directoryNamed: 'src' )]! !

!SqueakWin32x86Config methodsFor: 'directories' stamp: 'tty 6/7/2014 16:58'!
topDir
		^ topDir ifNil: [ topDir := FileDirectory default directoryNamed: self oscogvm ]! !

!SqueakWin32x86Config methodsFor: 'source generation' stamp: 'tty 5/22/2014 16:37'!
validateSourcesPresent
	| sources |
	sources := Smalltalk sourcesName.
	
	(sources == nil)
		ifTrue: [	self error: 'VM source code cannot be generated without .sources file'.]		! !

!SqueakWin32x86Config methodsFor: 'as yet unclassified' stamp: 'tty 5/22/2014 17:00'!
version
	^ ''! !

!SqueakWin32x86Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 16:36'!
winVer
	"Set minimum version to WindowsXP (see /cygwin/usr/include//w32api/w32api.h)"
	
	^ '-D_WIN32_WINNT=0x0501 -DWINVER=0x0501'! !

SqueakWin32x86Config subclass: #Win32x86NewspeakCogSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Win32x86'!

!Win32x86NewspeakCogSpurConfig commentStamp: 'tty 6/15/2014 13:37' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakWin32x86Builder 
	configureABuildFor: #MYCLASSNAMEHERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!Win32x86NewspeakCogSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 17:36'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!Win32x86NewspeakCogSpurConfig methodsFor: 'plugins' stamp: 'tty 6/9/2014 17:36'!
compilerFlagsDebug
	"Define NDEBUG for production to exclude asserts "
	^ {
		'-g3'. 
		'-O0'. 
		'-march=pentium4'. 
		'-momit-leaf-frame-pointer'. 
		'-maccumulate-outgoing-args'. 
		'-funroll-loops'. 
		'-DDEBUGVM=1' }! !

!Win32x86NewspeakCogSpurConfig methodsFor: 'compiler flags' stamp: 'tty 6/9/2014 17:36'!
compilerFlagsRelease
	"Define NDEBUG for production to exclude asserts "
	^ {
		'-g0'. 
		'-O2'. 
		'-march=pentium4'. 
		'-momit-leaf-frame-pointer'. 
		'-maccumulate-outgoing-args'. 
		'-funroll-loops'.
		'-DNDEBUG -DDEBUGVM=0'}! !

!Win32x86NewspeakCogSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 17:36'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!Win32x86NewspeakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:28'!
dirBuildLanguageVMMM
	^self newspeakCogSpur! !

!Win32x86NewspeakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:49'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Win32x86NewspeakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:11'!
executableName
	^ self vmCogExecutableName! !

!Win32x86NewspeakCogSpurConfig methodsFor: 'accessing' stamp: 'tty 6/9/2014 17:36'!
externalLibraries
	
	^ #( 
		ddraw dinput opengl32 wsock32 comdlg32 ole32 winmm
		version wininet user32 gdi32 psapi kernel32 crtdll dsound secur32
	).! !

!Win32x86NewspeakCogSpurConfig methodsFor: 'plugins' stamp: 'tty 6/9/2014 17:36'!
extraPluginSettings: maker


	maker isExternal ifTrue: [
		"copy result to results dir "
		maker set: 'LIBRARY_OUTPUT_PATH' toString: '${outputDir}'.
		
		maker cmd: 'set_target_properties' params:  maker moduleName , ' PROPERTIES PREFIX "" '
	]! !

!Win32x86NewspeakCogSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 17:36'!
extraSources

	^ 
	'${resources}'! !

!Win32x86NewspeakCogSpurConfig methodsFor: 'settings' stamp: 'tty 6/9/2014 17:36'!
extraVMSettings: maker

	| res |
	
	res := '"${buildDir}/resource.o"'.
	
	self write: self resourceFile toFile: 'Cog.rc'.
		
	maker cmd: 'add_custom_command' params: 'OUTPUT ', res ,
	'
		COMMAND 	windres --include-dir ${targetPlatform}/misc -D_WIN32 -i ${buildDir}/Cog.rc -o ', res , '
		COMMENT "Generating resource file..."
	'.
	
	maker set:  #resources to: res.
	
	maker includeDirectories: '${targetPlatform}/third-party/dx9sdk/Include'.
	! !

!Win32x86NewspeakCogSpurConfig methodsFor: 'resources' stamp: 'tty 6/9/2014 17:36'!
iconFileName
	^ 'Cog.ico'! !

!Win32x86NewspeakCogSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 17:36'!
interpreterClass
	^ CoInterpreter! !

!Win32x86NewspeakCogSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 17:36'!
platformSources
	"files added from platform/win32/vm dir "
	^ #(
		'sqWin32Alloc.c'
		'sqWin32Directory.c'
		'sqWin32Heartbeat.c'
		'sqWin32Service.c'
		'sqWin32VMProfile.c'
		'sqWin32Args.c'
		'sqWin32Exports.c'
		'sqWin32Intel.c'
		'sqWin32Stubs.c'
		'sqWin32Window.c'
		'sqWin32Backtrace.c'
		'sqWin32ExternalPrims.c'
		'sqWin32PluginSupport.c'
		'sqWin32Threads.c'
		'version.c'
		'sqWin32DirectInput.c'
		'sqWin32GUID.c'
		'sqWin32Prefs.c'
		'sqWin32Utils.c'
	)! !

!Win32x86NewspeakCogSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 17:36'!
prepareForGeneration
	^ self prepareForCogGeneration! !

!Win32x86NewspeakCogSpurConfig methodsFor: 'resources' stamp: 'tty 6/9/2014 17:36'!
resourceFile

	^ self resourceFileTemplate
		copyReplaceAll: '@ICON@' with: self iconFileName! !

!Win32x86NewspeakCogSpurConfig methodsFor: 'resources' stamp: 'tty 6/9/2014 17:36'!
resourceFileTemplate

	^ '
#ifdef _WIN32
1                       ICON    DISCARDABLE     "@ICON@"
2                       ICON    DISCARDABLE     "@ICON@"
3                       ICON    DISCARDABLE     "@ICON@"
#endif
'! !

!Win32x86NewspeakCogSpurConfig methodsFor: 'utils' stamp: 'tty 6/9/2014 17:36'!
setExtraTargetProperties: maker

	maker addExternalLibraries: self externalLibraries.
	maker set: 'EXECUTABLE_OUTPUT_PATH' toString: '${outputDir}'.

"	maker puts: 'set_source_files_properties(${srcVMDir}/cogit.c PROPERTIES COMPILE_FLAGS -O1)'."
	maker puts: 'set_source_files_properties(${srcVMDir}/gcc3x-cointerp.c PROPERTIES COMPILE_FLAGS -O1)'
! !

SqueakWin32x86Config subclass: #Win32x86NewspeakCogV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Win32x86'!

!Win32x86NewspeakCogV3Config commentStamp: 'tty 6/15/2014 13:37' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakWin32x86Builder 
	configureABuildFor: #MYCLASSNAMEHERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!Win32x86NewspeakCogV3Config methodsFor: 'source generation' stamp: 'tty 6/9/2014 17:38'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!Win32x86NewspeakCogV3Config methodsFor: 'plugins' stamp: 'tty 6/9/2014 17:38'!
compilerFlagsDebug
	"Define NDEBUG for production to exclude asserts "
	^ {
		'-g3'. 
		'-O0'. 
		'-march=pentium4'. 
		'-momit-leaf-frame-pointer'. 
		'-maccumulate-outgoing-args'. 
		'-funroll-loops'. 
		'-DDEBUGVM=1' }! !

!Win32x86NewspeakCogV3Config methodsFor: 'compiler flags' stamp: 'tty 6/9/2014 17:38'!
compilerFlagsRelease
	"Define NDEBUG for production to exclude asserts "
	^ {
		'-g0'. 
		'-O2'. 
		'-march=pentium4'. 
		'-momit-leaf-frame-pointer'. 
		'-maccumulate-outgoing-args'. 
		'-funroll-loops'.
		'-DNDEBUG -DDEBUGVM=0'}! !

!Win32x86NewspeakCogV3Config methodsFor: 'source files' stamp: 'tty 6/9/2014 17:38'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!Win32x86NewspeakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:28'!
dirBuildLanguageVMMM
	^self newspeakCogV3! !

!Win32x86NewspeakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:49'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Win32x86NewspeakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:11'!
executableName
	^ self vmCogExecutableName! !

!Win32x86NewspeakCogV3Config methodsFor: 'accessing' stamp: 'tty 6/9/2014 17:38'!
externalLibraries
	
	^ #( 
		ddraw dinput opengl32 wsock32 comdlg32 ole32 winmm
		version wininet user32 gdi32 psapi kernel32 crtdll dsound secur32
	).! !

!Win32x86NewspeakCogV3Config methodsFor: 'plugins' stamp: 'tty 6/9/2014 17:38'!
extraPluginSettings: maker


	maker isExternal ifTrue: [
		"copy result to results dir "
		maker set: 'LIBRARY_OUTPUT_PATH' toString: '${outputDir}'.
		
		maker cmd: 'set_target_properties' params:  maker moduleName , ' PROPERTIES PREFIX "" '
	]! !

!Win32x86NewspeakCogV3Config methodsFor: 'source files' stamp: 'tty 6/9/2014 17:38'!
extraSources

	^ 
	'${resources}'! !

!Win32x86NewspeakCogV3Config methodsFor: 'settings' stamp: 'tty 6/9/2014 17:38'!
extraVMSettings: maker

	| res |
	
	res := '"${buildDir}/resource.o"'.
	
	self write: self resourceFile toFile: 'Cog.rc'.
		
	maker cmd: 'add_custom_command' params: 'OUTPUT ', res ,
	'
		COMMAND 	windres --include-dir ${targetPlatform}/misc -D_WIN32 -i ${buildDir}/Cog.rc -o ', res , '
		COMMENT "Generating resource file..."
	'.
	
	maker set:  #resources to: res.
	
	maker includeDirectories: '${targetPlatform}/third-party/dx9sdk/Include'.
	! !

!Win32x86NewspeakCogV3Config methodsFor: 'resources' stamp: 'tty 6/9/2014 17:38'!
iconFileName
	^ 'Cog.ico'! !

!Win32x86NewspeakCogV3Config methodsFor: 'source generation' stamp: 'tty 6/9/2014 17:38'!
interpreterClass
	^ CoInterpreter! !

!Win32x86NewspeakCogV3Config methodsFor: 'source files' stamp: 'tty 6/9/2014 17:38'!
platformSources
	"files added from platform/win32/vm dir "
	^ #(
		'sqWin32Alloc.c'
		'sqWin32Directory.c'
		'sqWin32Heartbeat.c'
		'sqWin32Service.c'
		'sqWin32VMProfile.c'
		'sqWin32Args.c'
		'sqWin32Exports.c'
		'sqWin32Intel.c'
		'sqWin32Stubs.c'
		'sqWin32Window.c'
		'sqWin32Backtrace.c'
		'sqWin32ExternalPrims.c'
		'sqWin32PluginSupport.c'
		'sqWin32Threads.c'
		'version.c'
		'sqWin32DirectInput.c'
		'sqWin32GUID.c'
		'sqWin32Prefs.c'
		'sqWin32Utils.c'
	)! !

!Win32x86NewspeakCogV3Config methodsFor: 'source generation' stamp: 'tty 6/9/2014 17:38'!
prepareForGeneration
	^ self prepareForCogGeneration! !

!Win32x86NewspeakCogV3Config methodsFor: 'resources' stamp: 'tty 6/9/2014 17:38'!
resourceFile

	^ self resourceFileTemplate
		copyReplaceAll: '@ICON@' with: self iconFileName! !

!Win32x86NewspeakCogV3Config methodsFor: 'resources' stamp: 'tty 6/9/2014 17:38'!
resourceFileTemplate

	^ '
#ifdef _WIN32
1                       ICON    DISCARDABLE     "@ICON@"
2                       ICON    DISCARDABLE     "@ICON@"
3                       ICON    DISCARDABLE     "@ICON@"
#endif
'! !

!Win32x86NewspeakCogV3Config methodsFor: 'utils' stamp: 'tty 6/9/2014 17:38'!
setExtraTargetProperties: maker

	maker addExternalLibraries: self externalLibraries.
	maker set: 'EXECUTABLE_OUTPUT_PATH' toString: '${outputDir}'.

"	maker puts: 'set_source_files_properties(${srcVMDir}/cogit.c PROPERTIES COMPILE_FLAGS -O1)'."
	maker puts: 'set_source_files_properties(${srcVMDir}/gcc3x-cointerp.c PROPERTIES COMPILE_FLAGS -O1)'
! !

SqueakWin32x86Config subclass: #Win32x86NewspeakSistaSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Win32x86'!

!Win32x86NewspeakSistaSpurConfig commentStamp: 'tty 6/15/2014 13:36' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakWin32x86Builder 
	configureABuildFor: #MYCLASSNAMEHERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!Win32x86NewspeakSistaSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 17:38'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!Win32x86NewspeakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:28'!
dirBuildLanguageVMMM
	^self newspeakSistaSpur! !

!Win32x86NewspeakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:49'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Win32x86NewspeakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:00'!
executableName
	^ self vmSistaExecutableName! !

!Win32x86NewspeakSistaSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 17:38'!
interpreterClass
	"answer an interpreter class for VM source code generation"
	^ StackInterpreter! !

!Win32x86NewspeakSistaSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 17:38'!
prepareForGeneration
	^ self prepareForStackVMGeneration! !

SqueakWin32x86Config subclass: #Win32x86NewspeakSistaV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Win32x86'!

!Win32x86NewspeakSistaV3Config commentStamp: 'tty 6/15/2014 13:36' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakWin32x86Builder 
	configureABuildFor: #MYCLASSNAMEHERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp
!

!Win32x86NewspeakSistaV3Config methodsFor: 'source files' stamp: 'tty 6/9/2014 17:37'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!Win32x86NewspeakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:28'!
dirBuildLanguageVMMM
	^self newspeakSistaV3! !

!Win32x86NewspeakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:49'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Win32x86NewspeakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:00'!
executableName
	^ self vmSistaExecutableName! !

!Win32x86NewspeakSistaV3Config methodsFor: 'source generation' stamp: 'tty 6/9/2014 17:37'!
interpreterClass
	"answer an interpreter class for VM source code generation"
	^ StackInterpreter! !

!Win32x86NewspeakSistaV3Config methodsFor: 'source generation' stamp: 'tty 6/9/2014 17:37'!
prepareForGeneration
	^ self prepareForStackVMGeneration! !

SqueakWin32x86Config subclass: #Win32x86NewspeakStackSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Win32x86'!

!Win32x86NewspeakStackSpurConfig commentStamp: 'tty 6/15/2014 13:36' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakWin32x86Builder 
	configureABuildFor: #MYCLASSNAMEHERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!Win32x86NewspeakStackSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 17:37'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!Win32x86NewspeakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:28'!
dirBuildLanguageVMMM
	^self newspeakStackSpur! !

!Win32x86NewspeakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:49'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Win32x86NewspeakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:00'!
executableName
	^ self vmStackExecutableName! !

!Win32x86NewspeakStackSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 17:37'!
interpreterClass
	"answer an interpreter class for VM source code generation"
	^ StackInterpreter! !

!Win32x86NewspeakStackSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 17:37'!
prepareForGeneration
	^ self prepareForStackVMGeneration! !

SqueakWin32x86Config subclass: #Win32x86NewspeakStackV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Win32x86'!

!Win32x86NewspeakStackV3Config commentStamp: 'tty 6/15/2014 13:36' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakWin32x86Builder 
	configureABuildFor: #MYCLASSNAMEHERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!Win32x86NewspeakStackV3Config methodsFor: 'source files' stamp: 'tty 6/9/2014 17:37'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!Win32x86NewspeakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:28'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackV3! !

!Win32x86NewspeakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:49'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Win32x86NewspeakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:00'!
executableName
	^ self vmStackExecutableName! !

!Win32x86NewspeakStackV3Config methodsFor: 'source generation' stamp: 'tty 6/9/2014 17:37'!
interpreterClass
	"answer an interpreter class for VM source code generation"
	^ StackInterpreter! !

!Win32x86NewspeakStackV3Config methodsFor: 'source generation' stamp: 'tty 6/9/2014 17:37'!
prepareForGeneration
	^ self prepareForStackVMGeneration! !

SqueakWin32x86Config subclass: #Win32x86SqueakCogSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Win32x86'!

!Win32x86SqueakCogSpurConfig commentStamp: 'tty 6/15/2014 13:36' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakWin32x86Builder 
	configureABuildFor: #MYCLASSNAMEHERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!Win32x86SqueakCogSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 17:35'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!Win32x86SqueakCogSpurConfig methodsFor: 'plugins' stamp: 'tty 6/9/2014 17:35'!
compilerFlagsDebug
	"Define NDEBUG for production to exclude asserts "
	^ {
		'-g3'. 
		'-O0'. 
		'-march=pentium4'. 
		'-momit-leaf-frame-pointer'. 
		'-maccumulate-outgoing-args'. 
		'-funroll-loops'. 
		'-DDEBUGVM=1' }! !

!Win32x86SqueakCogSpurConfig methodsFor: 'compiler flags' stamp: 'tty 6/9/2014 17:35'!
compilerFlagsRelease
	"Define NDEBUG for production to exclude asserts "
	^ {
		'-g0'. 
		'-O2'. 
		'-march=pentium4'. 
		'-momit-leaf-frame-pointer'. 
		'-maccumulate-outgoing-args'. 
		'-funroll-loops'.
		'-DNDEBUG -DDEBUGVM=0'}! !

!Win32x86SqueakCogSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 17:35'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!Win32x86SqueakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:29'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakCogSpur! !

!Win32x86SqueakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:49'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Win32x86SqueakCogSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:11'!
executableName
	^ self vmCogExecutableName! !

!Win32x86SqueakCogSpurConfig methodsFor: 'accessing' stamp: 'tty 6/9/2014 17:35'!
externalLibraries
	
	^ #( 
		ddraw dinput opengl32 wsock32 comdlg32 ole32 winmm
		version wininet user32 gdi32 psapi kernel32 crtdll dsound secur32
	).! !

!Win32x86SqueakCogSpurConfig methodsFor: 'plugins' stamp: 'tty 6/9/2014 17:35'!
extraPluginSettings: maker


	maker isExternal ifTrue: [
		"copy result to results dir "
		maker set: 'LIBRARY_OUTPUT_PATH' toString: '${outputDir}'.
		
		maker cmd: 'set_target_properties' params:  maker moduleName , ' PROPERTIES PREFIX "" '
	]! !

!Win32x86SqueakCogSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 17:35'!
extraSources

	^ 
	'${resources}'! !

!Win32x86SqueakCogSpurConfig methodsFor: 'settings' stamp: 'tty 6/9/2014 17:35'!
extraVMSettings: maker

	| res |
	
	res := '"${buildDir}/resource.o"'.
	
	self write: self resourceFile toFile: 'Cog.rc'.
		
	maker cmd: 'add_custom_command' params: 'OUTPUT ', res ,
	'
		COMMAND 	windres --include-dir ${targetPlatform}/misc -D_WIN32 -i ${buildDir}/Cog.rc -o ', res , '
		COMMENT "Generating resource file..."
	'.
	
	maker set:  #resources to: res.
	
	maker includeDirectories: '${targetPlatform}/third-party/dx9sdk/Include'.
	! !

!Win32x86SqueakCogSpurConfig methodsFor: 'resources' stamp: 'tty 6/9/2014 17:35'!
iconFileName
	^ 'Cog.ico'! !

!Win32x86SqueakCogSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 17:35'!
interpreterClass
	^ CoInterpreter! !

!Win32x86SqueakCogSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 17:35'!
platformSources
	"files added from platform/win32/vm dir "
	^ #(
		'sqWin32Alloc.c'
		'sqWin32Directory.c'
		'sqWin32Heartbeat.c'
		'sqWin32Service.c'
		'sqWin32VMProfile.c'
		'sqWin32Args.c'
		'sqWin32Exports.c'
		'sqWin32Intel.c'
		'sqWin32Stubs.c'
		'sqWin32Window.c'
		'sqWin32Backtrace.c'
		'sqWin32ExternalPrims.c'
		'sqWin32PluginSupport.c'
		'sqWin32Threads.c'
		'version.c'
		'sqWin32DirectInput.c'
		'sqWin32GUID.c'
		'sqWin32Prefs.c'
		'sqWin32Utils.c'
	)! !

!Win32x86SqueakCogSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 17:35'!
prepareForGeneration
	^ self prepareForCogGeneration! !

!Win32x86SqueakCogSpurConfig methodsFor: 'resources' stamp: 'tty 6/9/2014 17:35'!
resourceFile

	^ self resourceFileTemplate
		copyReplaceAll: '@ICON@' with: self iconFileName! !

!Win32x86SqueakCogSpurConfig methodsFor: 'resources' stamp: 'tty 6/9/2014 17:35'!
resourceFileTemplate

	^ '
#ifdef _WIN32
1                       ICON    DISCARDABLE     "@ICON@"
2                       ICON    DISCARDABLE     "@ICON@"
3                       ICON    DISCARDABLE     "@ICON@"
#endif
'! !

!Win32x86SqueakCogSpurConfig methodsFor: 'utils' stamp: 'tty 6/9/2014 17:35'!
setExtraTargetProperties: maker

	maker addExternalLibraries: self externalLibraries.
	maker set: 'EXECUTABLE_OUTPUT_PATH' toString: '${outputDir}'.

"	maker puts: 'set_source_files_properties(${srcVMDir}/cogit.c PROPERTIES COMPILE_FLAGS -O1)'."
	maker puts: 'set_source_files_properties(${srcVMDir}/gcc3x-cointerp.c PROPERTIES COMPILE_FLAGS -O1)'
! !

SqueakWin32x86Config subclass: #Win32x86SqueakCogV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Win32x86'!

!Win32x86SqueakCogV3Config commentStamp: 'tty 6/15/2014 13:36' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakWin32x86Builder 
	configureABuildFor: #MYCLASSNAMEHERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!Win32x86SqueakCogV3Config methodsFor: 'source generation' stamp: 'tty 5/22/2014 16:39'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!Win32x86SqueakCogV3Config methodsFor: 'plugins' stamp: 'tty 5/22/2014 16:39'!
compilerFlagsDebug
	"Define NDEBUG for production to exclude asserts "
	^ {
		'-g3'. 
		'-O0'. 
		'-march=pentium4'. 
		'-momit-leaf-frame-pointer'. 
		'-maccumulate-outgoing-args'. 
		'-funroll-loops'. 
		'-DDEBUGVM=1' }! !

!Win32x86SqueakCogV3Config methodsFor: 'compiler flags' stamp: 'tty 5/22/2014 16:39'!
compilerFlagsRelease
	"Define NDEBUG for production to exclude asserts "
	^ {
		'-g0'. 
		'-O2'. 
		'-march=pentium4'. 
		'-momit-leaf-frame-pointer'. 
		'-maccumulate-outgoing-args'. 
		'-funroll-loops'.
		'-DNDEBUG -DDEBUGVM=0'}! !

!Win32x86SqueakCogV3Config methodsFor: 'source files' stamp: 'tty 5/22/2014 16:39'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!Win32x86SqueakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:29'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakCogV3! !

!Win32x86SqueakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:49'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Win32x86SqueakCogV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:11'!
executableName
	^ self vmCogExecutableName! !

!Win32x86SqueakCogV3Config methodsFor: 'accessing' stamp: 'tty 5/22/2014 16:39'!
externalLibraries
	
	^ #( 
		ddraw dinput opengl32 wsock32 comdlg32 ole32 winmm
		version wininet user32 gdi32 psapi kernel32 crtdll dsound secur32
	).! !

!Win32x86SqueakCogV3Config methodsFor: 'plugins' stamp: 'tty 5/22/2014 16:39'!
extraPluginSettings: maker


	maker isExternal ifTrue: [
		"copy result to results dir "
		maker set: 'LIBRARY_OUTPUT_PATH' toString: '${outputDir}'.
		
		maker cmd: 'set_target_properties' params:  maker moduleName , ' PROPERTIES PREFIX "" '
	]! !

!Win32x86SqueakCogV3Config methodsFor: 'source files' stamp: 'tty 5/22/2014 16:39'!
extraSources

	^ 
	'${resources}'! !

!Win32x86SqueakCogV3Config methodsFor: 'settings' stamp: 'tty 5/22/2014 16:39'!
extraVMSettings: maker

	| res |
	
	res := '"${buildDir}/resource.o"'.
	
	self write: self resourceFile toFile: 'Cog.rc'.
		
	maker cmd: 'add_custom_command' params: 'OUTPUT ', res ,
	'
		COMMAND 	windres --include-dir ${targetPlatform}/misc -D_WIN32 -i ${buildDir}/Cog.rc -o ', res , '
		COMMENT "Generating resource file..."
	'.
	
	maker set:  #resources to: res.
	
	maker includeDirectories: '${targetPlatform}/third-party/dx9sdk/Include'.
	! !

!Win32x86SqueakCogV3Config methodsFor: 'resources' stamp: 'tty 5/22/2014 16:39'!
iconFileName
	^ 'Cog.ico'! !

!Win32x86SqueakCogV3Config methodsFor: 'source generation' stamp: 'tty 5/22/2014 16:39'!
interpreterClass
	^ CoInterpreter! !

!Win32x86SqueakCogV3Config methodsFor: 'source files' stamp: 'tty 5/22/2014 16:39'!
platformSources
	"files added from platform/win32/vm dir "
	^ #(
		'sqWin32Alloc.c'
		'sqWin32Directory.c'
		'sqWin32Heartbeat.c'
		'sqWin32Service.c'
		'sqWin32VMProfile.c'
		'sqWin32Args.c'
		'sqWin32Exports.c'
		'sqWin32Intel.c'
		'sqWin32Stubs.c'
		'sqWin32Window.c'
		'sqWin32Backtrace.c'
		'sqWin32ExternalPrims.c'
		'sqWin32PluginSupport.c'
		'sqWin32Threads.c'
		'version.c'
		'sqWin32DirectInput.c'
		'sqWin32GUID.c'
		'sqWin32Prefs.c'
		'sqWin32Utils.c'
	)! !

!Win32x86SqueakCogV3Config methodsFor: 'source generation' stamp: 'tty 5/22/2014 16:39'!
prepareForGeneration
	^ self prepareForCogGeneration! !

!Win32x86SqueakCogV3Config methodsFor: 'resources' stamp: 'tty 5/22/2014 16:39'!
resourceFile

	^ self resourceFileTemplate
		copyReplaceAll: '@ICON@' with: self iconFileName! !

!Win32x86SqueakCogV3Config methodsFor: 'resources' stamp: 'tty 5/22/2014 16:39'!
resourceFileTemplate

	^ '
#ifdef _WIN32
1                       ICON    DISCARDABLE     "@ICON@"
2                       ICON    DISCARDABLE     "@ICON@"
3                       ICON    DISCARDABLE     "@ICON@"
#endif
'! !

!Win32x86SqueakCogV3Config methodsFor: 'utils' stamp: 'tty 5/22/2014 16:39'!
setExtraTargetProperties: maker

	maker addExternalLibraries: self externalLibraries.
	maker set: 'EXECUTABLE_OUTPUT_PATH' toString: '${outputDir}'.

"	maker puts: 'set_source_files_properties(${srcVMDir}/cogit.c PROPERTIES COMPILE_FLAGS -O1)'."
	maker puts: 'set_source_files_properties(${srcVMDir}/gcc3x-cointerp.c PROPERTIES COMPILE_FLAGS -O1)'
! !

Win32x86SqueakCogV3Config subclass: #Win32x86SqueakCogV3DebugConfigz
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-IslandOfMisfitToys'!

!Win32x86SqueakCogV3DebugConfigz commentStamp: 'tty 6/7/2014 10:19' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

Usage:
Win32x86SqueakCogV3DebugConfig generateWithSources
Or:
Win32x86SqueakCogV3DebugConfig generate
Or: 
find my Builder in CMakeVMMakerSqueak-Builder category and use that to invoke me.
!

!Win32x86SqueakCogV3DebugConfigz methodsFor: 'directories' stamp: 'tty 6/16/2014 20:18'!
compilerFlags
	|d commonFlags flags|
	d:= SqueakCMakeVMMakerAbstractBuilder default buildTypeAndDirectoryInfo copy.
	d 
		at: #build put: [self compilerFlagsBuild];
		at: #buildAssert  put: [self compilerFlagsAssert];
		at: #buildAssertITimerHeartbeat  put: [self compilerFlagsAssertITimerHeartbeat];
            at:#buildDebug  put: [self compilerFlagsDebug];   "located in CMakeVMMaker CPlatformConfig"
		at: #buildDebugITimerHeartbeat  put: [self compilerFlagsDebugITimerHeartbeat ];
		at: #buildITimerHeartbeat  put: [self compilerFlagsIHeartbeatTimer];
		at: #buildMultiThreaded  put: [self compilerFlagsMultiThreaded ];
		at: #buildMultiThreadedAssert  put: [self compilerFlagsMultiThreadedAssert];
		at: #buildMultiThreadedDebug   put: [self compilerFlagsMultiThreadedDebug ];
		at: #buildNone put:[self compilerFlagsNoBuildType].

    flags:= String streamContents: [ :stream |
	 (((d at:  buildType) value)  collect: #withBlanksTrimmed as: Set)
		asStringOn: stream 
		delimiter:' '].

    commonFlags:=String streamContents: [ :stream |
		((self commonCompilerFlags) collect: #withBlanksTrimmed as: Set)
			asStringOn: stream 
			delimiter: ' ' ].
	^ commonFlags, ' ' ,flags.! !

!Win32x86SqueakCogV3DebugConfigz methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:49'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Win32x86SqueakCogV3DebugConfigz methodsFor: 'utils' stamp: 'tty 5/22/2014 17:05'!
setExtraTargetProperties: maker

	maker addExternalLibraries: self externalLibraries.
	maker set: 'EXECUTABLE_OUTPUT_PATH' toString: '${outputDir}'.

! !

Win32x86SqueakCogV3Config subclass: #Win32x86SqueakCogV3MultiThreadedConfigz
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-IslandOfMisfitToys'!

!Win32x86SqueakCogV3MultiThreadedConfigz commentStamp: 'tty 6/7/2014 10:20' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

This is a concrete class which generates a thread-aware VM and threaded FFI CogVM for Win32. This VM is normally known as CogMTVM.


For more information, check the class comments of all the superclasses.

Usage:
Win32x86SqueakCogV3MultiThreadedConfig generateWithSources
Or:
Win32x86SqueakCogV3MultiThreadedConfig generate
Or: 
find my Builder in CMakeVMMakerSqueak-Builder category and use that to invoke me.!

!Win32x86SqueakCogV3MultiThreadedConfigz methodsFor: 'compiler flags' stamp: 'tty 5/22/2014 17:03'!
compilerFlags
	^ super compilerFlags, ' -DCOGMTVM=1'! !

!Win32x86SqueakCogV3MultiThreadedConfigz methodsFor: 'plugin extra rules' stamp: 'tty 5/22/2014 17:03'!
configureReentrantIA32FFIPlugin: maker
	self error: 'use ThreadedIA32FFIPlugin instead'
! !

!Win32x86SqueakCogV3MultiThreadedConfigz methodsFor: 'source files' stamp: 'tty 5/22/2014 17:03'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerpmt.c'
		)! !

!Win32x86SqueakCogV3MultiThreadedConfigz methodsFor: 'plugins' stamp: 'tty 5/22/2014 17:03'!
defaultExternalPlugins

	^ #(
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
	
		"Win32OSProcessPlugin"
	)! !

!Win32x86SqueakCogV3MultiThreadedConfigz methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:49'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Win32x86SqueakCogV3MultiThreadedConfigz methodsFor: 'accessing' stamp: 'tty 5/22/2014 17:03'!
executableName
	^ 'CogMTVM'! !

!Win32x86SqueakCogV3MultiThreadedConfigz methodsFor: 'source generation' stamp: 'tty 5/22/2014 17:03'!
interpreterClass
	"answer an interpreter class for VM source code generation"
	^ CoInterpreterMT! !

SqueakWin32x86Config subclass: #Win32x86SqueakSistaSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Win32x86'!

!Win32x86SqueakSistaSpurConfig commentStamp: 'tty 6/15/2014 13:36' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakWin32x86Builder 
	configureABuildFor: #MYCLASSNAMEHERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!Win32x86SqueakSistaSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 17:35'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!Win32x86SqueakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:29'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakSistaSpur! !

!Win32x86SqueakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:49'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Win32x86SqueakSistaSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:00'!
executableName
	^ self vmSistaExecutableName! !

!Win32x86SqueakSistaSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 17:35'!
interpreterClass
	"answer an interpreter class for VM source code generation"
	^ StackInterpreter! !

!Win32x86SqueakSistaSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 17:35'!
prepareForGeneration
	^ self prepareForStackVMGeneration! !

SqueakWin32x86Config subclass: #Win32x86SqueakSistaV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Win32x86'!

!Win32x86SqueakSistaV3Config commentStamp: 'tty 6/15/2014 13:36' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakWin32x86Builder 
	configureABuildFor: #MYCLASSNAMEHERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!Win32x86SqueakSistaV3Config methodsFor: 'source files' stamp: 'tty 6/9/2014 17:36'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!Win32x86SqueakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:29'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakSistaV3! !

!Win32x86SqueakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:50'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Win32x86SqueakSistaV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:00'!
executableName
	^ self vmSistaExecutableName! !

!Win32x86SqueakSistaV3Config methodsFor: 'source generation' stamp: 'tty 6/9/2014 17:36'!
interpreterClass
	"answer an interpreter class for VM source code generation"
	^ StackInterpreter! !

!Win32x86SqueakSistaV3Config methodsFor: 'source generation' stamp: 'tty 6/9/2014 17:36'!
prepareForGeneration
	^ self prepareForStackVMGeneration! !

SqueakWin32x86Config subclass: #Win32x86SqueakStackSpurConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Win32x86'!

!Win32x86SqueakStackSpurConfig commentStamp: 'tty 6/15/2014 13:36' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakWin32x86Builder 
	configureABuildFor: #MYCLASSNAMEHERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!Win32x86SqueakStackSpurConfig methodsFor: 'source files' stamp: 'tty 6/9/2014 17:35'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!Win32x86SqueakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:29'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackSpur! !

!Win32x86SqueakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:50'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Win32x86SqueakStackSpurConfig methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:00'!
executableName
	^ self vmStackExecutableName! !

!Win32x86SqueakStackSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 17:35'!
interpreterClass
	"answer an interpreter class for VM source code generation"
	^ StackInterpreter! !

!Win32x86SqueakStackSpurConfig methodsFor: 'source generation' stamp: 'tty 6/9/2014 17:35'!
prepareForGeneration
	^ self prepareForStackVMGeneration! !

SqueakWin32x86Config subclass: #Win32x86SqueakStackV3Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Win32x86'!

!Win32x86SqueakStackV3Config commentStamp: 'tty 6/15/2014 13:36' prior: 0!
I configure a VM according to my name's form: [Operating System] [WordSize] [Processor Language][VM MemoryManager][BuildType]Conf

SqueakWin32x86Builder 
	configureABuildFor: #MYCLASSNAMEHERE withBuildType: #build;
	generateSources;
	generate.  

HelpBrowser openOn: CMakeVMMakerSqueakEndUserHelp
HelpBrowser openOn: CMakeVMMakerSqueakDeveloperHelp!

!Win32x86SqueakStackV3Config methodsFor: 'source files' stamp: 'tty 5/22/2014 17:08'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!Win32x86SqueakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/10/2014 11:29'!
dirBuildLanguageVMMM
	"the directory under buildPlatformDir  example: newspeak.cog.spur. use squeak.cog.v3 as default"
	^self squeakStackV3! !

!Win32x86SqueakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/15/2014 11:50'!
excludeFromBuild
	"over-ride to exclude yourself from a build or not"
	^true! !

!Win32x86SqueakStackV3Config methodsFor: 'cmake' stamp: 'tty 6/16/2014 08:00'!
executableName
	^ self vmStackExecutableName! !

!Win32x86SqueakStackV3Config methodsFor: 'source generation' stamp: 'tty 5/22/2014 17:08'!
interpreterClass
	"answer an interpreter class for VM source code generation"
	^ StackInterpreter! !

!Win32x86SqueakStackV3Config methodsFor: 'source generation' stamp: 'tty 5/22/2014 17:08'!
prepareForGeneration
	^ self prepareForStackVMGeneration! !

CMThirdpartyLibrary subclass: #SqueakCMThirdpartyLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Libs'!

!SqueakCMThirdpartyLibrary commentStamp: 'tty 5/26/2014 12:51' prior: 0!
A SqueakCMThirdpartyLibrary is the root library for copies of classes in CMakeVMMaker-Libs.  
I replace only the Squeak incompatible methods of my parent

!

SqueakCMThirdpartyLibrary subclass: #SqueakCMFreetype2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Libs'!

!SqueakCMFreetype2 commentStamp: '<historical>' prior: 0!
This is a configuration for building freetype2 library!

!SqueakCMFreetype2 class methodsFor: 'accessing' stamp: 'tty 5/26/2014 12:53'!
canonicalName
	^ 'freetype2'! !

!SqueakCMFreetype2 methodsFor: 'package properties' stamp: 'tty 5/26/2014 12:53'!
archiveMD5Sum

	^ 'c15f6dc8ed190d67b89ae09aaf7896b4'! !

!SqueakCMFreetype2 methodsFor: 'generating actions' stamp: 'tty 5/26/2014 12:53'!
build

	gen 
		puts:
'
add_custom_command(OUTPUT "${ft2config}"
	COMMAND ./configure --prefix=''${installPrefix}'' ', self configurationFlags, '
	WORKING_DIRECTORY "${libSourcesDir}"
	DEPENDS "${unpackTarget}"
)
add_custom_command(OUTPUT "${ft2libInstalled}"
	COMMAND make
	COMMAND make install
	WORKING_DIRECTORY "${libSourcesDir}"
	DEPENDS "${ft2config}"
	COMMENT "Building ${libName}"
)
'
! !

!SqueakCMFreetype2 methodsFor: 'generating actions' stamp: 'tty 5/26/2014 12:53'!
copyArtefacts

	self 
		copy: '${ft2libInstalled}' 
		to: '${externalModulesDir}/${libraryFileName}'.! !

!SqueakCMFreetype2 methodsFor: 'generating actions' stamp: 'tty 5/26/2014 12:53'!
defineAsTarget

	gen puts:
	
'
add_custom_target(${libName} 
	DEPENDS ${externalModulesDir}/${libraryFileName}
	)
'

! !

!SqueakCMFreetype2 methodsFor: 'generating actions' stamp: 'tty 5/26/2014 12:53'!
defineGlobalTargets
	| var |
	var := self canonicalName , '_LIB'.
	vmGen set: var toString: self targetForLinking.
"
define a library as imported one
and make it depend from it's build target
"
	vmGen
		puts: 
('add_library("{1}" SHARED IMPORTED GLOBAL)
	set_target_properties("{1}" PROPERTIES IMPORTED_LOCATION "{1}")
add_dependencies("{1}" "{2}")
' format: { '${',var, '}' . self buildTarget }
).

	vmGen cmd: 'add_dependencies' params:
		vmGen moduleName , ' ' , self buildTarget! !

!SqueakCMFreetype2 methodsFor: 'package properties' stamp: 'tty 5/26/2014 12:53'!
downloadURL
	^ 'http://ftp.igh.cnrs.fr/pub/nongnu/freetype/freetype-2.4.9.tar.gz'
! !

!SqueakCMFreetype2 methodsFor: 'accessing' stamp: 'tty 5/26/2014 12:53'!
includeDir
	"see setVariables"

" `<prefix>/include/freetype2' must be in your current inclusion path "


	^ '"${thirdpartyDir}/out/include" "${thirdpartyDir}/out/include/freetype2"'! !

!SqueakCMFreetype2 methodsFor: 'package properties' stamp: 'tty 5/26/2014 12:53'!
libraryFileName
	^ 'libfreetype.6.dylib'! !

!SqueakCMFreetype2 methodsFor: 'generating actions' stamp: 'tty 5/26/2014 12:53'!
setVariables
	super setVariables.
	
"add include path"
	gen 
		set: #freetype2_includeDir toString: '${installPrefix}/include';
		set: #libraryFileName to: self libraryFileName;
		set: #freetype2_location toString: '${externalModulesDir}/${libraryFileName}';
		set: #ft2config toString: '${libSourcesDir}/builds/unix/config.status';
	 	set: #ft2libInstalled toString: '${installPrefix}/lib/${libraryFileName}'! !

!SqueakCMFreetype2 methodsFor: 'package properties' stamp: 'tty 5/26/2014 12:53'!
unpackedDirName

	^ 'freetype-2.4.9'! !

SqueakCMFreetype2 subclass: #SqueakCMWin32Freetype2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Libs'!

!SqueakCMWin32Freetype2 commentStamp: '<historical>' prior: 0!
Some overrides to make freetype build on windows:

Two artifacts to copy:

libfreetype.dll.a
libfreetype-6.dll

the first one is used at link time with FTPlugin to 
designate the exported symbols of .dll as well as .dll file name.

The second one is ready to use library produced by freetype makefiles.

We pass

 -march=i686

instead of

 -arch i386

to freetype configure, because MSYS GCC on windows don't understands the -arch option.
!

!SqueakCMWin32Freetype2 class methodsFor: 'as yet unclassified' stamp: 'tty 5/26/2014 12:54'!
platformName 
	^'win32'! !

!SqueakCMWin32Freetype2 methodsFor: 'generating actions' stamp: 'tty 5/26/2014 12:54'!
copyArtefacts

	gen puts:
'add_custom_command(
	OUTPUT "${externalModulesDir}/${libraryFileName}"
	COMMAND cp "${ft2libInstalled}" "${externalModulesDir}"
	COMMAND cp "${ft2binInstalled}" "${externalModulesDir}"
	DEPENDS "${ft2libInstalled}"
)'! !

!SqueakCMWin32Freetype2 methodsFor: 'settings' stamp: 'tty 5/26/2014 12:54'!
defaultConfigurationFlags 
	^#(
		'CFLAGS=''-march=i686''' 
		'LDFLAGS=''-march=i686''')! !

!SqueakCMWin32Freetype2 methodsFor: 'generating actions' stamp: 'tty 5/26/2014 12:54'!
defineGlobalTargets
	| var |
	var := self canonicalName , '_LIB'.
	vmGen set: var toString: self targetForLinking.
"
define a library as imported one
and make it depend from it's build target
"
	vmGen
		puts: 
('add_library("{1}" STATIC IMPORTED GLOBAL)
	set_target_properties("{1}" PROPERTIES IMPORTED_LOCATION "{1}")
add_dependencies("{1}" "{2}")
' format: { '${',var, '}' . self buildTarget }
).

	vmGen cmd: 'add_dependencies' params:
		vmGen moduleName , ' ' , self buildTarget! !

!SqueakCMWin32Freetype2 methodsFor: 'package properties' stamp: 'tty 5/26/2014 12:54'!
libraryFileName
	^ 'libfreetype.dll.a'! !

!SqueakCMWin32Freetype2 methodsFor: 'generating actions' stamp: 'tty 5/26/2014 12:54'!
setVariables
	super setVariables.
	
"add include path"
	gen 
		set: #freetype2_includeDir toString: '${installPrefix}/include';
		set: #libraryFileName to: self libraryFileName;
		set: #freetype2_location toString: '${externalModulesDir}/${libraryFileName}';
		set: #ft2config toString: '${libSourcesDir}/builds/unix/config.status';
	 	set: #ft2libInstalled toString: '${installPrefix}/lib/${libraryFileName}';
	 	set: #ft2binInstalled toString: '${installPrefix}/bin/libfreetype-6.dll'.
		! !

SqueakCMThirdpartyLibrary subclass: #SqueakCMOpenSSL
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Libs'!

!SqueakCMOpenSSL class methodsFor: 'as yet unclassified' stamp: 'tty 5/26/2014 13:09'!
canonicalName
	^ 'openssl'! !

SqueakCMOpenSSL subclass: #SqueakCMWin32OpenSSL
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMakerSqueak-Libs'!

!SqueakCMWin32OpenSSL class methodsFor: 'as yet unclassified' stamp: 'tty 5/26/2014 13:10'!
platformName 
	^'win32'! !

!SqueakCMWin32OpenSSL methodsFor: 'as yet unclassified' stamp: 'tty 5/26/2014 13:10'!
archiveMD5Sum
	"answer the MD5 checksum (in string) for downloaded library archive 
	(to check that downloaded file is not corrupt).
	
	You can take this sum by issuing:
	  md5 filename
	from command line
	"
	^ 'ae412727c8c15b67880aef7bd2999b2e'! !

!SqueakCMWin32OpenSSL methodsFor: 'as yet unclassified' stamp: 'tty 5/26/2014 13:10'!
build

	gen 
		puts:
'
add_custom_command(OUTPUT "${libSourcesDir}/Makefile"
	COMMAND ./config shared --prefix=''${installPrefix}'' 
	WORKING_DIRECTORY "${libSourcesDir}"
	DEPENDS "${unpackTarget}"
)

add_custom_command(OUTPUT "${installPrefix}/bin/libeay32.dll" "${installPrefix}/bin/ssleay32.dll"
	COMMAND make
	COMMAND make install
	WORKING_DIRECTORY "${libSourcesDir}"
	DEPENDS "${libSourcesDir}/Makefile"
	COMMENT "Building ${libName}"
)
'
! !

!SqueakCMWin32OpenSSL methodsFor: 'as yet unclassified' stamp: 'tty 5/26/2014 13:10'!
configurationFlags
	^ 'shared'! !

!SqueakCMWin32OpenSSL methodsFor: 'as yet unclassified' stamp: 'tty 5/26/2014 13:10'!
copyArtefacts 

	self copy: '${installPrefix}/bin/libeay32.dll' to: '${externalModulesDir}/libeay32.dll'.
	self copy: '${installPrefix}/bin/ssleay32.dll' to: '${externalModulesDir}/ssleay32.dll'.
"	self copy: '${installPrefix}/lib/libssl.dll.a' to: '${externalModulesDir}/libssl.dll.a'.
	self copy: '${installPrefix}/lib/libcrypto.dll.a' to: '${externalModulesDir}/libcrypto.dll.a'.
"
"
'libcrypto.dll.a' 'libssl.dll.a'.
"! !

!SqueakCMWin32OpenSSL methodsFor: 'as yet unclassified' stamp: 'tty 5/26/2014 13:10'!
defineAsTarget 
	
	gen puts:
	'add_custom_target(', self buildTarget , '
		DEPENDS 
		"${externalModulesDir}/libeay32.dll"
		"${externalModulesDir}/ssleay32.dll"
	)'
	
		"${externalModulesDir}/${libraryFileName}"
! !

!SqueakCMWin32OpenSSL methodsFor: 'as yet unclassified' stamp: 'tty 5/26/2014 13:10'!
defineGlobalTargets 

! !

!SqueakCMWin32OpenSSL methodsFor: 'as yet unclassified' stamp: 'tty 5/26/2014 13:10'!
downloadURL 
	^'http://www.openssl.org/source/openssl-1.0.1c.tar.gz'! !

!SqueakCMWin32OpenSSL methodsFor: 'as yet unclassified' stamp: 'tty 5/26/2014 13:10'!
includeDir

	^ '"${thirdpartyDir}/out/include"'! !

!SqueakCMWin32OpenSSL methodsFor: 'as yet unclassified' stamp: 'tty 5/26/2014 13:10'!
libraryFileName
	^ 'libssl.dll.a'! !

!SqueakCMWin32OpenSSL methodsFor: 'as yet unclassified' stamp: 'tty 5/26/2014 13:10'!
setVariables 
	super setVariables.
	
	gen
		set: #libraryFileName to: self libraryFileName;
		set: #libInstalled to: '${installPrefix}/lib/${libraryFileName}'! !

!SqueakCMWin32OpenSSL methodsFor: 'as yet unclassified' stamp: 'tty 5/26/2014 13:10'!
unpackedDirName
	^ 'openssl-1.0.1c'! !

!SqueakCMThirdpartyLibrary class methodsFor: 'as yet unclassified' stamp: 'tty 5/26/2014 13:03'!
canonicalName
	"answer the library canonical name, like 
		'freetype2'
		or 'cairo' 
		etc.
		
	Note , this method is used to find the corresponding library
	from all subclasses of CMThirdpartyLibrary	
	"
	^ self subclassResponsibility! !

!SqueakCMThirdpartyLibrary class methodsFor: 'as yet unclassified' stamp: 'tty 5/26/2014 13:04'!
named: aName config: aCPlatformConfig

	^ (self allSubclasses detect: [:cls | 
		cls canonicalName = aName and: [ cls supports: aCPlatformConfig ] ])
		new! !

!SqueakCMThirdpartyLibrary class methodsFor: 'as yet unclassified' stamp: 'tty 5/26/2014 13:04'!
platformName 
	^nil! !

!SqueakCMThirdpartyLibrary class methodsFor: 'as yet unclassified' stamp: 'tty 5/26/2014 13:05'!
supports: aConfig
	"default implementation"
	^ self platformName = aConfig platformName ! !

!SqueakCMThirdpartyLibrary methodsFor: 'as yet unclassified' stamp: 'tty 5/26/2014 13:21'!
generateFor: aVMGenerator

	| libDir stream contents |
	
	vmGen := aVMGenerator.
	
	gen := CMakeGenerator new
		output: (String new writeStream).
	
	libDir := (aVMGenerator thirdpartyDir / self canonicalName) assureExistence.

	stream := String new writeStream.
	
	self generate.

	stream nextPutAll: (vmGen config fixLineEndsOf: gen output contents).

	contents := stream contents. 
	
	(self isFile: (libDir  / gen outputFileName) fullName hasContents: contents) ifFalse: [
		"contents changed, update the file. Because fucking cmake will force rebuild everything if we change its modification date
		without changing its contents"
		(FileStream forceNewFileNamed: (libDir  / gen outputFileName) pathName) nextPutAll: contents; close.
		].
	

	vmGen addSubdirectory:  vmGen thirdpartyDirName , '/' , self canonicalName.
	self defineGlobalTargets.
	! !
